/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
'use strict';

var Prism = require('prismjs');
require('prismjs/components/prism-clike');
require('prismjs/components/prism-javascript');
require('prismjs/components/prism-markup');
require('prismjs/components/prism-markdown');
require('prismjs/components/prism-c');
require('prismjs/components/prism-css');
require('prismjs/components/prism-objectivec');
require('prismjs/components/prism-sql');
require('prismjs/components/prism-python');
require('prismjs/components/prism-rust');
require('prismjs/components/prism-swift');
require('prismjs/components/prism-typescript');
require('prismjs/components/prism-java');
require('prismjs/components/prism-cpp');
var utils = require('@emailsenderlab/utils');

var Lexical_dev = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
function createCommand(type) {
  return {
    type
  };
}
const SELECTION_CHANGE_COMMAND = createCommand('SELECTION_CHANGE_COMMAND');
const SELECTION_INSERT_CLIPBOARD_NODES_COMMAND = createCommand('SELECTION_INSERT_CLIPBOARD_NODES_COMMAND');
const CLICK_COMMAND = createCommand('CLICK_COMMAND');
const DELETE_CHARACTER_COMMAND = createCommand('DELETE_CHARACTER_COMMAND');
const INSERT_LINE_BREAK_COMMAND = createCommand('INSERT_LINE_BREAK_COMMAND');
const INSERT_PARAGRAPH_COMMAND = createCommand('INSERT_PARAGRAPH_COMMAND');
const CONTROLLED_TEXT_INSERTION_COMMAND = createCommand('CONTROLLED_TEXT_INSERTION_COMMAND');
const PASTE_COMMAND = createCommand('PASTE_COMMAND');
const REMOVE_TEXT_COMMAND = createCommand('REMOVE_TEXT_COMMAND');
const DELETE_WORD_COMMAND = createCommand('DELETE_WORD_COMMAND');
const DELETE_LINE_COMMAND = createCommand('DELETE_LINE_COMMAND');
const FORMAT_TEXT_COMMAND = createCommand('FORMAT_TEXT_COMMAND');
const UNDO_COMMAND = createCommand('UNDO_COMMAND');
const REDO_COMMAND = createCommand('REDO_COMMAND');
const KEY_DOWN_COMMAND = createCommand('KEYDOWN_COMMAND');
const KEY_ARROW_RIGHT_COMMAND = createCommand('KEY_ARROW_RIGHT_COMMAND');
const MOVE_TO_END = createCommand('MOVE_TO_END');
const KEY_ARROW_LEFT_COMMAND = createCommand('KEY_ARROW_LEFT_COMMAND');
const MOVE_TO_START = createCommand('MOVE_TO_START');
const KEY_ARROW_UP_COMMAND = createCommand('KEY_ARROW_UP_COMMAND');
const KEY_ARROW_DOWN_COMMAND = createCommand('KEY_ARROW_DOWN_COMMAND');
const KEY_ENTER_COMMAND = createCommand('KEY_ENTER_COMMAND');
const KEY_SPACE_COMMAND = createCommand('KEY_SPACE_COMMAND');
const KEY_BACKSPACE_COMMAND = createCommand('KEY_BACKSPACE_COMMAND');
const KEY_ESCAPE_COMMAND = createCommand('KEY_ESCAPE_COMMAND');
const KEY_DELETE_COMMAND = createCommand('KEY_DELETE_COMMAND');
const KEY_TAB_COMMAND = createCommand('KEY_TAB_COMMAND');
const INSERT_TAB_COMMAND = createCommand('INSERT_TAB_COMMAND');
const INDENT_CONTENT_COMMAND = createCommand('INDENT_CONTENT_COMMAND');
const OUTDENT_CONTENT_COMMAND = createCommand('OUTDENT_CONTENT_COMMAND');
const DROP_COMMAND = createCommand('DROP_COMMAND');
const FORMAT_ELEMENT_COMMAND = createCommand('FORMAT_ELEMENT_COMMAND');
const DRAGSTART_COMMAND = createCommand('DRAGSTART_COMMAND');
const DRAGOVER_COMMAND = createCommand('DRAGOVER_COMMAND');
const DRAGEND_COMMAND = createCommand('DRAGEND_COMMAND');
const COPY_COMMAND = createCommand('COPY_COMMAND');
const CUT_COMMAND = createCommand('CUT_COMMAND');
const SELECT_ALL_COMMAND = createCommand('SELECT_ALL_COMMAND');
const CLEAR_EDITOR_COMMAND = createCommand('CLEAR_EDITOR_COMMAND');
const CLEAR_HISTORY_COMMAND = createCommand('CLEAR_HISTORY_COMMAND');
const CAN_REDO_COMMAND = createCommand('CAN_REDO_COMMAND');
const CAN_UNDO_COMMAND = createCommand('CAN_UNDO_COMMAND');
const FOCUS_COMMAND = createCommand('FOCUS_COMMAND');
const BLUR_COMMAND = createCommand('BLUR_COMMAND');
const KEY_MODIFIER_COMMAND = createCommand('KEY_MODIFIER_COMMAND');

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

const CAN_USE_DOM = typeof window !== 'undefined' && typeof window.document !== 'undefined' && typeof window.document.createElement !== 'undefined';

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
const documentMode = CAN_USE_DOM && 'documentMode' in document ? document.documentMode : null;
const IS_APPLE = CAN_USE_DOM && /Mac|iPod|iPhone|iPad/.test(navigator.platform);
const IS_FIREFOX = CAN_USE_DOM && /^(?!.*Seamonkey)(?=.*Firefox).*/i.test(navigator.userAgent);
const CAN_USE_BEFORE_INPUT = CAN_USE_DOM && 'InputEvent' in window && !documentMode ? 'getTargetRanges' in new window.InputEvent('input') : false;
const IS_SAFARI = CAN_USE_DOM && /Version\/[\d.]+.*Safari/.test(navigator.userAgent);
const IS_IOS = CAN_USE_DOM && /iPad|iPhone|iPod/.test(navigator.userAgent) && !window.MSStream;
const IS_ANDROID = CAN_USE_DOM && /Android/.test(navigator.userAgent);

// Keep these in case we need to use them in the future.
// export const IS_WINDOWS: boolean = CAN_USE_DOM && /Win/.test(navigator.platform);
const IS_CHROME = CAN_USE_DOM && /^(?=.*Chrome).*/i.test(navigator.userAgent);
// export const canUseTextInputEvent: boolean = CAN_USE_DOM && 'TextEvent' in window && !documentMode;

const IS_APPLE_WEBKIT = CAN_USE_DOM && /AppleWebKit\/[\d.]+/.test(navigator.userAgent) && !IS_CHROME;

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

// DOM
const DOM_ELEMENT_TYPE = 1;
const DOM_TEXT_TYPE = 3;

// Reconciling
const NO_DIRTY_NODES = 0;
const HAS_DIRTY_NODES = 1;
const FULL_RECONCILE = 2;

// Text node modes
const IS_NORMAL = 0;
const IS_TOKEN = 1;
const IS_SEGMENTED = 2;
// IS_INERT = 3

// Text node formatting
const IS_BOLD = 1;
const IS_ITALIC = 1 << 1;
const IS_STRIKETHROUGH = 1 << 2;
const IS_UNDERLINE = 1 << 3;
const IS_CODE = 1 << 4;
const IS_SUBSCRIPT = 1 << 5;
const IS_SUPERSCRIPT = 1 << 6;
const IS_HIGHLIGHT = 1 << 7;
const IS_ALL_FORMATTING = IS_BOLD | IS_ITALIC | IS_STRIKETHROUGH | IS_UNDERLINE | IS_CODE | IS_SUBSCRIPT | IS_SUPERSCRIPT | IS_HIGHLIGHT;

// Text node details
const IS_DIRECTIONLESS = 1;
const IS_UNMERGEABLE = 1 << 1;

// Element node formatting
const IS_ALIGN_LEFT = 1;
const IS_ALIGN_CENTER = 2;
const IS_ALIGN_RIGHT = 3;
const IS_ALIGN_JUSTIFY = 4;
const IS_ALIGN_START = 5;
const IS_ALIGN_END = 6;

// Reconciliation
const NON_BREAKING_SPACE = '\u00A0';
const ZERO_WIDTH_SPACE = '\u200b';

// For iOS/Safari we use a non breaking space, otherwise the cursor appears
// overlapping the composed text.
const COMPOSITION_SUFFIX = IS_SAFARI || IS_IOS || IS_APPLE_WEBKIT ? NON_BREAKING_SPACE : ZERO_WIDTH_SPACE;
const DOUBLE_LINE_BREAK = '\n\n';

// For FF, we need to use a non-breaking space, or it gets composition
// in a stuck state.
const COMPOSITION_START_CHAR = IS_FIREFOX ? NON_BREAKING_SPACE : COMPOSITION_SUFFIX;
const RTL = '\u0591-\u07FF\uFB1D-\uFDFD\uFE70-\uFEFC';
const LTR = 'A-Za-z\u00C0-\u00D6\u00D8-\u00F6' + '\u00F8-\u02B8\u0300-\u0590\u0800-\u1FFF\u200E\u2C00-\uFB1C' + '\uFE00-\uFE6F\uFEFD-\uFFFF';

// eslint-disable-next-line no-misleading-character-class
const RTL_REGEX = new RegExp('^[^' + LTR + ']*[' + RTL + ']');
// eslint-disable-next-line no-misleading-character-class
const LTR_REGEX = new RegExp('^[^' + RTL + ']*[' + LTR + ']');
const TEXT_TYPE_TO_FORMAT = {
  bold: IS_BOLD,
  code: IS_CODE,
  highlight: IS_HIGHLIGHT,
  italic: IS_ITALIC,
  strikethrough: IS_STRIKETHROUGH,
  subscript: IS_SUBSCRIPT,
  superscript: IS_SUPERSCRIPT,
  underline: IS_UNDERLINE
};
const DETAIL_TYPE_TO_DETAIL = {
  directionless: IS_DIRECTIONLESS,
  unmergeable: IS_UNMERGEABLE
};
const ELEMENT_TYPE_TO_FORMAT = {
  center: IS_ALIGN_CENTER,
  end: IS_ALIGN_END,
  justify: IS_ALIGN_JUSTIFY,
  left: IS_ALIGN_LEFT,
  right: IS_ALIGN_RIGHT,
  start: IS_ALIGN_START
};
const ELEMENT_FORMAT_TO_TYPE = {
  [IS_ALIGN_CENTER]: 'center',
  [IS_ALIGN_END]: 'end',
  [IS_ALIGN_JUSTIFY]: 'justify',
  [IS_ALIGN_LEFT]: 'left',
  [IS_ALIGN_RIGHT]: 'right',
  [IS_ALIGN_START]: 'start'
};
const TEXT_MODE_TO_TYPE = {
  normal: IS_NORMAL,
  segmented: IS_SEGMENTED,
  token: IS_TOKEN
};
const TEXT_TYPE_TO_MODE = {
  [IS_NORMAL]: 'normal',
  [IS_SEGMENTED]: 'segmented',
  [IS_TOKEN]: 'token'
};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
// The time between a text entry event and the mutation observer firing.
const TEXT_MUTATION_VARIANCE = 100;
let isProcessingMutations = false;
let lastTextEntryTimeStamp = 0;
function getIsProcessingMutations() {
  return isProcessingMutations;
}
function updateTimeStamp(event) {
  lastTextEntryTimeStamp = event.timeStamp;
}
function initTextEntryListener(editor) {
  if (lastTextEntryTimeStamp === 0) {
    getWindow(editor).addEventListener('textInput', updateTimeStamp, true);
  }
}
function isManagedLineBreak(dom, target, editor) {
  return (
    // @ts-expect-error: internal field
    target.__lexicalLineBreak === dom ||
    // @ts-ignore We intentionally add this to the Node.
    dom[`__lexicalKey_${editor._key}`] !== undefined
  );
}
function getLastSelection(editor) {
  return editor.getEditorState().read(() => {
    const selection = $getSelection();
    return selection !== null ? selection.clone() : null;
  });
}
function handleTextMutation(target, node, editor) {
  const domSelection = getDOMSelection(editor._window);
  let anchorOffset = null;
  let focusOffset = null;
  if (domSelection !== null && domSelection.anchorNode === target) {
    anchorOffset = domSelection.anchorOffset;
    focusOffset = domSelection.focusOffset;
  }
  const text = target.nodeValue;
  if (text !== null) {
    $updateTextNodeFromDOMContent(node, text, anchorOffset, focusOffset, false);
  }
}
function shouldUpdateTextNodeFromMutation(selection, targetDOM, targetNode) {
  if ($isRangeSelection(selection)) {
    const anchorNode = selection.anchor.getNode();
    if (anchorNode.is(targetNode) && selection.format !== anchorNode.getFormat()) {
      return false;
    }
  }
  return targetDOM.nodeType === DOM_TEXT_TYPE && targetNode.isAttached();
}
function $flushMutations$1(editor, mutations, observer) {
  isProcessingMutations = true;
  const shouldFlushTextMutations = performance.now() - lastTextEntryTimeStamp > TEXT_MUTATION_VARIANCE;
  try {
    updateEditor(editor, () => {
      const selection = $getSelection() || getLastSelection(editor);
      const badDOMTargets = new Map();
      const rootElement = editor.getRootElement();
      // We use the current editor state, as that reflects what is
      // actually "on screen".
      const currentEditorState = editor._editorState;
      const blockCursorElement = editor._blockCursorElement;
      let shouldRevertSelection = false;
      let possibleTextForFirefoxPaste = '';
      for (let i = 0; i < mutations.length; i++) {
        const mutation = mutations[i];
        const type = mutation.type;
        const targetDOM = mutation.target;
        let targetNode = $getNearestNodeFromDOMNode(targetDOM, currentEditorState);
        if (targetNode === null && targetDOM !== rootElement || $isDecoratorNode(targetNode)) {
          continue;
        }
        if (type === 'characterData') {
          // Text mutations are deferred and passed to mutation listeners to be
          // processed outside of the Lexical engine.
          if (shouldFlushTextMutations && $isTextNode(targetNode) && shouldUpdateTextNodeFromMutation(selection, targetDOM, targetNode)) {
            handleTextMutation(
            // nodeType === DOM_TEXT_TYPE is a Text DOM node
            targetDOM, targetNode, editor);
          }
        } else if (type === 'childList') {
          shouldRevertSelection = true;
          // We attempt to "undo" any changes that have occurred outside
          // of Lexical. We want Lexical's editor state to be source of truth.
          // To the user, these will look like no-ops.
          const addedDOMs = mutation.addedNodes;
          for (let s = 0; s < addedDOMs.length; s++) {
            const addedDOM = addedDOMs[s];
            const node = getNodeFromDOMNode(addedDOM);
            const parentDOM = addedDOM.parentNode;
            if (parentDOM != null && addedDOM !== blockCursorElement && node === null && (addedDOM.nodeName !== 'BR' || !isManagedLineBreak(addedDOM, parentDOM, editor))) {
              if (IS_FIREFOX) {
                const possibleText = addedDOM.innerText || addedDOM.nodeValue;
                if (possibleText) {
                  possibleTextForFirefoxPaste += possibleText;
                }
              }
              parentDOM.removeChild(addedDOM);
            }
          }
          const removedDOMs = mutation.removedNodes;
          const removedDOMsLength = removedDOMs.length;
          if (removedDOMsLength > 0) {
            let unremovedBRs = 0;
            for (let s = 0; s < removedDOMsLength; s++) {
              const removedDOM = removedDOMs[s];
              if (removedDOM.nodeName === 'BR' && isManagedLineBreak(removedDOM, targetDOM, editor) || blockCursorElement === removedDOM) {
                targetDOM.appendChild(removedDOM);
                unremovedBRs++;
              }
            }
            if (removedDOMsLength !== unremovedBRs) {
              if (targetDOM === rootElement) {
                targetNode = internalGetRoot(currentEditorState);
              }
              badDOMTargets.set(targetDOM, targetNode);
            }
          }
        }
      }

      // Now we process each of the unique target nodes, attempting
      // to restore their contents back to the source of truth, which
      // is Lexical's "current" editor state. This is basically like
      // an internal revert on the DOM.
      if (badDOMTargets.size > 0) {
        for (const [targetDOM, targetNode] of badDOMTargets) {
          if ($isElementNode(targetNode)) {
            const childKeys = targetNode.getChildrenKeys();
            let currentDOM = targetDOM.firstChild;
            for (let s = 0; s < childKeys.length; s++) {
              const key = childKeys[s];
              const correctDOM = editor.getElementByKey(key);
              if (correctDOM === null) {
                continue;
              }
              if (currentDOM == null) {
                targetDOM.appendChild(correctDOM);
                currentDOM = correctDOM;
              } else if (currentDOM !== correctDOM) {
                targetDOM.replaceChild(correctDOM, currentDOM);
              }
              currentDOM = currentDOM.nextSibling;
            }
          } else if ($isTextNode(targetNode)) {
            targetNode.markDirty();
          }
        }
      }

      // Capture all the mutations made during this function. This
      // also prevents us having to process them on the next cycle
      // of onMutation, as these mutations were made by us.
      const records = observer.takeRecords();

      // Check for any random auto-added <br> elements, and remove them.
      // These get added by the browser when we undo the above mutations
      // and this can lead to a broken UI.
      if (records.length > 0) {
        for (let i = 0; i < records.length; i++) {
          const record = records[i];
          const addedNodes = record.addedNodes;
          const target = record.target;
          for (let s = 0; s < addedNodes.length; s++) {
            const addedDOM = addedNodes[s];
            const parentDOM = addedDOM.parentNode;
            if (parentDOM != null && addedDOM.nodeName === 'BR' && !isManagedLineBreak(addedDOM, target, editor)) {
              parentDOM.removeChild(addedDOM);
            }
          }
        }

        // Clear any of those removal mutations
        observer.takeRecords();
      }
      if (selection !== null) {
        if (shouldRevertSelection) {
          selection.dirty = true;
          $setSelection(selection);
        }
        if (IS_FIREFOX && isFirefoxClipboardEvents(editor)) {
          selection.insertRawText(possibleTextForFirefoxPaste);
        }
      }
    });
  } finally {
    isProcessingMutations = false;
  }
}
function flushRootMutations(editor) {
  const observer = editor._observer;
  if (observer !== null) {
    const mutations = observer.takeRecords();
    $flushMutations$1(editor, mutations, observer);
  }
}
function initMutationObserver(editor) {
  initTextEntryListener(editor);
  editor._observer = new MutationObserver((mutations, observer) => {
    $flushMutations$1(editor, mutations, observer);
  });
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
function $canSimpleTextNodesBeMerged(node1, node2) {
  const node1Mode = node1.__mode;
  const node1Format = node1.__format;
  const node1Style = node1.__style;
  const node2Mode = node2.__mode;
  const node2Format = node2.__format;
  const node2Style = node2.__style;
  return (node1Mode === null || node1Mode === node2Mode) && (node1Format === null || node1Format === node2Format) && (node1Style === null || node1Style === node2Style);
}
function $mergeTextNodes(node1, node2) {
  const writableNode1 = node1.mergeWithSibling(node2);
  const normalizedNodes = getActiveEditor()._normalizedNodes;
  normalizedNodes.add(node1.__key);
  normalizedNodes.add(node2.__key);
  return writableNode1;
}
function $normalizeTextNode(textNode) {
  let node = textNode;
  if (node.__text === '' && node.isSimpleText() && !node.isUnmergeable()) {
    node.remove();
    return;
  }

  // Backward
  let previousNode;
  while ((previousNode = node.getPreviousSibling()) !== null && $isTextNode(previousNode) && previousNode.isSimpleText() && !previousNode.isUnmergeable()) {
    if (previousNode.__text === '') {
      previousNode.remove();
    } else if ($canSimpleTextNodesBeMerged(previousNode, node)) {
      node = $mergeTextNodes(previousNode, node);
      break;
    } else {
      break;
    }
  }

  // Forward
  let nextNode;
  while ((nextNode = node.getNextSibling()) !== null && $isTextNode(nextNode) && nextNode.isSimpleText() && !nextNode.isUnmergeable()) {
    if (nextNode.__text === '') {
      nextNode.remove();
    } else if ($canSimpleTextNodesBeMerged(node, nextNode)) {
      node = $mergeTextNodes(node, nextNode);
      break;
    } else {
      break;
    }
  }
}
function $normalizeSelection(selection) {
  $normalizePoint(selection.anchor);
  $normalizePoint(selection.focus);
  return selection;
}
function $normalizePoint(point) {
  while (point.type === 'element') {
    const node = point.getNode();
    const offset = point.offset;
    let nextNode;
    let nextOffsetAtEnd;
    if (offset === node.getChildrenSize()) {
      nextNode = node.getChildAtIndex(offset - 1);
      nextOffsetAtEnd = true;
    } else {
      nextNode = node.getChildAtIndex(offset);
      nextOffsetAtEnd = false;
    }
    if ($isTextNode(nextNode)) {
      point.set(nextNode.__key, nextOffsetAtEnd ? nextNode.getTextContentSize() : 0, 'text');
      break;
    } else if (!$isElementNode(nextNode)) {
      break;
    }
    point.set(nextNode.__key, nextOffsetAtEnd ? nextNode.getChildrenSize() : 0, 'element');
  }
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
let keyCounter = 1;
function generateRandomKey() {
  return '' + keyCounter++;
}
function getRegisteredNodeOrThrow(editor, nodeType) {
  const registeredNode = editor._nodes.get(nodeType);
  if (registeredNode === undefined) {
    {
      throw Error(`registeredNode: Type ${nodeType} not found`);
    }
  }
  return registeredNode;
}
const scheduleMicroTask = typeof queueMicrotask === 'function' ? queueMicrotask : fn => {
  // No window prefix intended (#1400)
  Promise.resolve().then(fn);
};
function $isSelectionCapturedInDecorator(node) {
  return $isDecoratorNode($getNearestNodeFromDOMNode(node));
}
function isSelectionCapturedInDecoratorInput(anchorDOM) {
  const activeElement = document.activeElement;
  if (activeElement === null) {
    return false;
  }
  const nodeName = activeElement.nodeName;
  return $isDecoratorNode($getNearestNodeFromDOMNode(anchorDOM)) && (nodeName === 'INPUT' || nodeName === 'TEXTAREA' || activeElement.contentEditable === 'true' &&
  // @ts-ignore iternal field
  activeElement.__lexicalEditor == null);
}
function isSelectionWithinEditor(editor, anchorDOM, focusDOM) {
  const rootElement = editor.getRootElement();
  try {
    return rootElement !== null && rootElement.contains(anchorDOM) && rootElement.contains(focusDOM) &&
    // Ignore if selection is within nested editor
    anchorDOM !== null && !isSelectionCapturedInDecoratorInput(anchorDOM) && getNearestEditorFromDOMNode(anchorDOM) === editor;
  } catch (error) {
    return false;
  }
}
function getNearestEditorFromDOMNode(node) {
  let currentNode = node;
  while (currentNode != null) {
    // @ts-expect-error: internal field
    const editor = currentNode.__lexicalEditor;
    if (editor != null) {
      return editor;
    }
    currentNode = getParentElement(currentNode);
  }
  return null;
}
function getTextDirection(text) {
  if (RTL_REGEX.test(text)) {
    return 'rtl';
  }
  if (LTR_REGEX.test(text)) {
    return 'ltr';
  }
  return null;
}
function $isTokenOrSegmented(node) {
  return node.isToken() || node.isSegmented();
}
function isDOMNodeLexicalTextNode(node) {
  return node.nodeType === DOM_TEXT_TYPE;
}
function getDOMTextNode(element) {
  let node = element;
  while (node != null) {
    if (isDOMNodeLexicalTextNode(node)) {
      return node;
    }
    node = node.firstChild;
  }
  return null;
}
function toggleTextFormatType(format, type, alignWithFormat) {
  const activeFormat = TEXT_TYPE_TO_FORMAT[type];
  if (alignWithFormat !== null && (format & activeFormat) === (alignWithFormat & activeFormat)) {
    return format;
  }
  let newFormat = format ^ activeFormat;
  if (type === 'subscript') {
    newFormat &= ~TEXT_TYPE_TO_FORMAT.superscript;
  } else if (type === 'superscript') {
    newFormat &= ~TEXT_TYPE_TO_FORMAT.subscript;
  }
  return newFormat;
}
function $isLeafNode(node) {
  return $isTextNode(node) || $isLineBreakNode(node) || $isDecoratorNode(node);
}
function $setNodeKey(node, existingKey) {
  if (existingKey != null) {
    node.__key = existingKey;
    return;
  }
  errorOnReadOnly();
  errorOnInfiniteTransforms();
  const editor = getActiveEditor();
  const editorState = getActiveEditorState();
  const key = generateRandomKey();
  editorState._nodeMap.set(key, node);
  // TODO Split this function into leaf/element
  if ($isElementNode(node)) {
    editor._dirtyElements.set(key, true);
  } else {
    editor._dirtyLeaves.add(key);
  }
  editor._cloneNotNeeded.add(key);
  editor._dirtyType = HAS_DIRTY_NODES;
  node.__key = key;
}
function internalMarkParentElementsAsDirty(parentKey, nodeMap, dirtyElements) {
  let nextParentKey = parentKey;
  while (nextParentKey !== null) {
    if (dirtyElements.has(nextParentKey)) {
      return;
    }
    const node = nodeMap.get(nextParentKey);
    if (node === undefined) {
      break;
    }
    dirtyElements.set(nextParentKey, false);
    nextParentKey = node.__parent;
  }
}
function removeFromParent(node) {
  const oldParent = node.getParent();
  if (oldParent !== null) {
    const writableNode = node.getWritable();
    const writableParent = oldParent.getWritable();
    const prevSibling = node.getPreviousSibling();
    const nextSibling = node.getNextSibling();
    // TODO: this function duplicates a bunch of operations, can be simplified.
    if (prevSibling === null) {
      if (nextSibling !== null) {
        const writableNextSibling = nextSibling.getWritable();
        writableParent.__first = nextSibling.__key;
        writableNextSibling.__prev = null;
      } else {
        writableParent.__first = null;
      }
    } else {
      const writablePrevSibling = prevSibling.getWritable();
      if (nextSibling !== null) {
        const writableNextSibling = nextSibling.getWritable();
        writableNextSibling.__prev = writablePrevSibling.__key;
        writablePrevSibling.__next = writableNextSibling.__key;
      } else {
        writablePrevSibling.__next = null;
      }
      writableNode.__prev = null;
    }
    if (nextSibling === null) {
      if (prevSibling !== null) {
        const writablePrevSibling = prevSibling.getWritable();
        writableParent.__last = prevSibling.__key;
        writablePrevSibling.__next = null;
      } else {
        writableParent.__last = null;
      }
    } else {
      const writableNextSibling = nextSibling.getWritable();
      if (prevSibling !== null) {
        const writablePrevSibling = prevSibling.getWritable();
        writablePrevSibling.__next = writableNextSibling.__key;
        writableNextSibling.__prev = writablePrevSibling.__key;
      } else {
        writableNextSibling.__prev = null;
      }
      writableNode.__next = null;
    }
    writableParent.__size--;
    writableNode.__parent = null;
  }
}

// Never use this function directly! It will break
// the cloning heuristic. Instead use node.getWritable().
function internalMarkNodeAsDirty(node) {
  errorOnInfiniteTransforms();
  const latest = node.getLatest();
  const parent = latest.__parent;
  const editorState = getActiveEditorState();
  const editor = getActiveEditor();
  const nodeMap = editorState._nodeMap;
  const dirtyElements = editor._dirtyElements;
  if (parent !== null) {
    internalMarkParentElementsAsDirty(parent, nodeMap, dirtyElements);
  }
  const key = latest.__key;
  editor._dirtyType = HAS_DIRTY_NODES;
  if ($isElementNode(node)) {
    dirtyElements.set(key, true);
  } else {
    // TODO split internally MarkNodeAsDirty into two dedicated Element/leave functions
    editor._dirtyLeaves.add(key);
  }
}
function internalMarkSiblingsAsDirty(node) {
  const previousNode = node.getPreviousSibling();
  const nextNode = node.getNextSibling();
  if (previousNode !== null) {
    internalMarkNodeAsDirty(previousNode);
  }
  if (nextNode !== null) {
    internalMarkNodeAsDirty(nextNode);
  }
}
function $setCompositionKey(compositionKey) {
  errorOnReadOnly();
  const editor = getActiveEditor();
  const previousCompositionKey = editor._compositionKey;
  if (compositionKey !== previousCompositionKey) {
    editor._compositionKey = compositionKey;
    if (previousCompositionKey !== null) {
      const node = $getNodeByKey(previousCompositionKey);
      if (node !== null) {
        node.getWritable();
      }
    }
    if (compositionKey !== null) {
      const node = $getNodeByKey(compositionKey);
      if (node !== null) {
        node.getWritable();
      }
    }
  }
}
function $getCompositionKey() {
  if (isCurrentlyReadOnlyMode()) {
    return null;
  }
  const editor = getActiveEditor();
  return editor._compositionKey;
}
function $getNodeByKey(key, _editorState) {
  const editorState = _editorState || getActiveEditorState();
  const node = editorState._nodeMap.get(key);
  if (node === undefined) {
    return null;
  }
  return node;
}
function getNodeFromDOMNode(dom, editorState) {
  const editor = getActiveEditor();
  // @ts-ignore We intentionally add this to the Node.
  const key = dom[`__lexicalKey_${editor._key}`];
  if (key !== undefined) {
    return $getNodeByKey(key, editorState);
  }
  return null;
}
function $getNearestNodeFromDOMNode(startingDOM, editorState) {
  let dom = startingDOM;
  while (dom != null) {
    const node = getNodeFromDOMNode(dom, editorState);
    if (node !== null) {
      return node;
    }
    dom = getParentElement(dom);
  }
  return null;
}
function cloneDecorators(editor) {
  const currentDecorators = editor._decorators;
  const pendingDecorators = Object.assign({}, currentDecorators);
  editor._pendingDecorators = pendingDecorators;
  return pendingDecorators;
}
function getEditorStateTextContent(editorState) {
  return editorState.read(() => $getRoot().getTextContent());
}
function markAllNodesAsDirty(editor, type) {
  // Mark all existing text nodes as dirty
  updateEditor(editor, () => {
    const editorState = getActiveEditorState();
    if (editorState.isEmpty()) {
      return;
    }
    if (type === 'root') {
      $getRoot().markDirty();
      return;
    }
    const nodeMap = editorState._nodeMap;
    for (const [, node] of nodeMap) {
      node.markDirty();
    }
  }, editor._pendingEditorState === null ? {
    tag: 'history-merge'
  } : undefined);
}
function $getRoot() {
  return internalGetRoot(getActiveEditorState());
}
function internalGetRoot(editorState) {
  return editorState._nodeMap.get('root');
}
function $setSelection(selection) {
  errorOnReadOnly();
  const editorState = getActiveEditorState();
  if (selection !== null) {
    {
      if (Object.isFrozen(selection)) {
        {
          throw Error(`$setSelection called on frozen selection object. Ensure selection is cloned before passing in.`);
        }
      }
    }
    selection.dirty = true;
    selection.setCachedNodes(null);
  }
  editorState._selection = selection;
}
function $flushMutations() {
  errorOnReadOnly();
  const editor = getActiveEditor();
  flushRootMutations(editor);
}
function getNodeFromDOM(dom) {
  const editor = getActiveEditor();
  const nodeKey = getNodeKeyFromDOM(dom, editor);
  if (nodeKey === null) {
    const rootElement = editor.getRootElement();
    if (dom === rootElement) {
      return $getNodeByKey('root');
    }
    return null;
  }
  return $getNodeByKey(nodeKey);
}
function getTextNodeOffset(node, moveSelectionToEnd) {
  return moveSelectionToEnd ? node.getTextContentSize() : 0;
}
function getNodeKeyFromDOM(
// Note that node here refers to a DOM Node, not an Lexical Node
dom, editor) {
  let node = dom;
  while (node != null) {
    // @ts-ignore We intentionally add this to the Node.
    const key = node[`__lexicalKey_${editor._key}`];
    if (key !== undefined) {
      return key;
    }
    node = getParentElement(node);
  }
  return null;
}
function doesContainGrapheme(str) {
  return /[\uD800-\uDBFF][\uDC00-\uDFFF]/g.test(str);
}
function getEditorsToPropagate(editor) {
  const editorsToPropagate = [];
  let currentEditor = editor;
  while (currentEditor !== null) {
    editorsToPropagate.push(currentEditor);
    currentEditor = currentEditor._parentEditor;
  }
  return editorsToPropagate;
}
function createUID() {
  return Math.random().toString(36).replace(/[^a-z]+/g, '').substr(0, 5);
}
function getAnchorTextFromDOM(anchorNode) {
  if (anchorNode.nodeType === DOM_TEXT_TYPE) {
    return anchorNode.nodeValue;
  }
  return null;
}
function $updateSelectedTextFromDOM(isCompositionEnd, editor, data) {
  // Update the text content with the latest composition text
  const domSelection = getDOMSelection(editor._window);
  if (domSelection === null) {
    return;
  }
  const anchorNode = domSelection.anchorNode;
  let {
    anchorOffset,
    focusOffset
  } = domSelection;
  if (anchorNode !== null) {
    let textContent = getAnchorTextFromDOM(anchorNode);
    const node = $getNearestNodeFromDOMNode(anchorNode);
    if (textContent !== null && $isTextNode(node)) {
      // Data is intentionally truthy, as we check for boolean, null and empty string.
      if (textContent === COMPOSITION_SUFFIX && data) {
        const offset = data.length;
        textContent = data;
        anchorOffset = offset;
        focusOffset = offset;
      }
      if (textContent !== null) {
        $updateTextNodeFromDOMContent(node, textContent, anchorOffset, focusOffset, isCompositionEnd);
      }
    }
  }
}
function $updateTextNodeFromDOMContent(textNode, textContent, anchorOffset, focusOffset, compositionEnd) {
  let node = textNode;
  if (node.isAttached() && (compositionEnd || !node.isDirty())) {
    const isComposing = node.isComposing();
    let normalizedTextContent = textContent;
    if ((isComposing || compositionEnd) && textContent[textContent.length - 1] === COMPOSITION_SUFFIX) {
      normalizedTextContent = textContent.slice(0, -1);
    }
    const prevTextContent = node.getTextContent();
    if (compositionEnd || normalizedTextContent !== prevTextContent) {
      if (normalizedTextContent === '') {
        $setCompositionKey(null);
        if (!IS_SAFARI && !IS_IOS && !IS_APPLE_WEBKIT) {
          // For composition (mainly Android), we have to remove the node on a later update
          const editor = getActiveEditor();
          setTimeout(() => {
            editor.update(() => {
              if (node.isAttached()) {
                node.remove();
              }
            });
          }, 20);
        } else {
          node.remove();
        }
        return;
      }
      const parent = node.getParent();
      const prevSelection = $getPreviousSelection();
      const prevTextContentSize = node.getTextContentSize();
      const compositionKey = $getCompositionKey();
      const nodeKey = node.getKey();
      if (node.isToken() || compositionKey !== null && nodeKey === compositionKey && !isComposing ||
      // Check if character was added at the start or boundaries when not insertable, and we need
      // to clear this input from occurring as that action wasn't permitted.
      $isRangeSelection(prevSelection) && (parent !== null && !parent.canInsertTextBefore() && prevSelection.anchor.offset === 0 || prevSelection.anchor.key === textNode.__key && prevSelection.anchor.offset === 0 && !node.canInsertTextBefore() && !isComposing || prevSelection.focus.key === textNode.__key && prevSelection.focus.offset === prevTextContentSize && !node.canInsertTextAfter() && !isComposing)) {
        node.markDirty();
        return;
      }
      const selection = $getSelection();
      if (!$isRangeSelection(selection) || anchorOffset === null || focusOffset === null) {
        node.setTextContent(normalizedTextContent);
        return;
      }
      selection.setTextNodeRange(node, anchorOffset, node, focusOffset);
      if (node.isSegmented()) {
        const originalTextContent = node.getTextContent();
        const replacement = $createTextNode(originalTextContent);
        node.replace(replacement);
        node = replacement;
      }
      node.setTextContent(normalizedTextContent);
    }
  }
}
function $previousSiblingDoesNotAcceptText(node) {
  const previousSibling = node.getPreviousSibling();
  return ($isTextNode(previousSibling) || $isElementNode(previousSibling) && previousSibling.isInline()) && !previousSibling.canInsertTextAfter();
}

// This function is connected to $shouldPreventDefaultAndInsertText and determines whether the
// TextNode boundaries are writable or we should use the previous/next sibling instead. For example,
// in the case of a LinkNode, boundaries are not writable.
function $shouldInsertTextAfterOrBeforeTextNode(selection, node) {
  if (node.isSegmented()) {
    return true;
  }
  if (!selection.isCollapsed()) {
    return false;
  }
  const offset = selection.anchor.offset;
  const parent = node.getParentOrThrow();
  const isToken = node.isToken();
  if (offset === 0) {
    return !node.canInsertTextBefore() || !parent.canInsertTextBefore() || isToken || $previousSiblingDoesNotAcceptText(node);
  } else if (offset === node.getTextContentSize()) {
    return !node.canInsertTextAfter() || !parent.canInsertTextAfter() || isToken;
  } else {
    return false;
  }
}
function isTab(keyCode, altKey, ctrlKey, metaKey) {
  return keyCode === 9 && !altKey && !ctrlKey && !metaKey;
}
function isBold(keyCode, altKey, metaKey, ctrlKey) {
  return keyCode === 66 && !altKey && controlOrMeta(metaKey, ctrlKey);
}
function isItalic(keyCode, altKey, metaKey, ctrlKey) {
  return keyCode === 73 && !altKey && controlOrMeta(metaKey, ctrlKey);
}
function isUnderline(keyCode, altKey, metaKey, ctrlKey) {
  return keyCode === 85 && !altKey && controlOrMeta(metaKey, ctrlKey);
}
function isParagraph(keyCode, shiftKey) {
  return isReturn(keyCode) && !shiftKey;
}
function isLineBreak(keyCode, shiftKey) {
  return isReturn(keyCode) && shiftKey;
}

// Inserts a new line after the selection

function isOpenLineBreak(keyCode, ctrlKey) {
  // 79 = KeyO
  return IS_APPLE && ctrlKey && keyCode === 79;
}
function isDeleteWordBackward(keyCode, altKey, ctrlKey) {
  return isBackspace(keyCode) && (IS_APPLE ? altKey : ctrlKey);
}
function isDeleteWordForward(keyCode, altKey, ctrlKey) {
  return isDelete(keyCode) && (IS_APPLE ? altKey : ctrlKey);
}
function isDeleteLineBackward(keyCode, metaKey) {
  return IS_APPLE && metaKey && isBackspace(keyCode);
}
function isDeleteLineForward(keyCode, metaKey) {
  return IS_APPLE && metaKey && isDelete(keyCode);
}
function isDeleteBackward(keyCode, altKey, metaKey, ctrlKey) {
  if (IS_APPLE) {
    if (altKey || metaKey) {
      return false;
    }
    return isBackspace(keyCode) || keyCode === 72 && ctrlKey;
  }
  if (ctrlKey || altKey || metaKey) {
    return false;
  }
  return isBackspace(keyCode);
}
function isDeleteForward(keyCode, ctrlKey, shiftKey, altKey, metaKey) {
  if (IS_APPLE) {
    if (shiftKey || altKey || metaKey) {
      return false;
    }
    return isDelete(keyCode) || keyCode === 68 && ctrlKey;
  }
  if (ctrlKey || altKey || metaKey) {
    return false;
  }
  return isDelete(keyCode);
}
function isUndo(keyCode, shiftKey, metaKey, ctrlKey) {
  return keyCode === 90 && !shiftKey && controlOrMeta(metaKey, ctrlKey);
}
function isRedo(keyCode, shiftKey, metaKey, ctrlKey) {
  if (IS_APPLE) {
    return keyCode === 90 && metaKey && shiftKey;
  }
  return keyCode === 89 && ctrlKey || keyCode === 90 && ctrlKey && shiftKey;
}
function isCopy(keyCode, shiftKey, metaKey, ctrlKey) {
  if (shiftKey) {
    return false;
  }
  if (keyCode === 67) {
    return IS_APPLE ? metaKey : ctrlKey;
  }
  return false;
}
function isCut(keyCode, shiftKey, metaKey, ctrlKey) {
  if (shiftKey) {
    return false;
  }
  if (keyCode === 88) {
    return IS_APPLE ? metaKey : ctrlKey;
  }
  return false;
}
function isArrowLeft(keyCode) {
  return keyCode === 37;
}
function isArrowRight(keyCode) {
  return keyCode === 39;
}
function isArrowUp(keyCode) {
  return keyCode === 38;
}
function isArrowDown(keyCode) {
  return keyCode === 40;
}
function isMoveBackward(keyCode, ctrlKey, altKey, metaKey) {
  return isArrowLeft(keyCode) && !ctrlKey && !metaKey && !altKey;
}
function isMoveToStart(keyCode, ctrlKey, shiftKey, altKey, metaKey) {
  return isArrowLeft(keyCode) && !altKey && !shiftKey && (ctrlKey || metaKey);
}
function isMoveForward(keyCode, ctrlKey, altKey, metaKey) {
  return isArrowRight(keyCode) && !ctrlKey && !metaKey && !altKey;
}
function isMoveToEnd(keyCode, ctrlKey, shiftKey, altKey, metaKey) {
  return isArrowRight(keyCode) && !altKey && !shiftKey && (ctrlKey || metaKey);
}
function isMoveUp(keyCode, ctrlKey, metaKey) {
  return isArrowUp(keyCode) && !ctrlKey && !metaKey;
}
function isMoveDown(keyCode, ctrlKey, metaKey) {
  return isArrowDown(keyCode) && !ctrlKey && !metaKey;
}
function isModifier(ctrlKey, shiftKey, altKey, metaKey) {
  return ctrlKey || shiftKey || altKey || metaKey;
}
function isSpace(keyCode) {
  return keyCode === 32;
}
function controlOrMeta(metaKey, ctrlKey) {
  if (IS_APPLE) {
    return metaKey;
  }
  return ctrlKey;
}
function isReturn(keyCode) {
  return keyCode === 13;
}
function isBackspace(keyCode) {
  return keyCode === 8;
}
function isEscape(keyCode) {
  return keyCode === 27;
}
function isDelete(keyCode) {
  return keyCode === 46;
}
function isSelectAll(keyCode, metaKey, ctrlKey) {
  return keyCode === 65 && controlOrMeta(metaKey, ctrlKey);
}
function $selectAll() {
  const root = $getRoot();
  const selection = root.select(0, root.getChildrenSize());
  $setSelection($normalizeSelection(selection));
}
function getCachedClassNameArray(classNamesTheme, classNameThemeType) {
  if (classNamesTheme.__lexicalClassNameCache === undefined) {
    classNamesTheme.__lexicalClassNameCache = {};
  }
  const classNamesCache = classNamesTheme.__lexicalClassNameCache;
  const cachedClassNames = classNamesCache[classNameThemeType];
  if (cachedClassNames !== undefined) {
    return cachedClassNames;
  }
  const classNames = classNamesTheme[classNameThemeType];
  // As we're using classList, we need
  // to handle className tokens that have spaces.
  // The easiest way to do this to convert the
  // className tokens to an array that can be
  // applied to classList.add()/remove().
  if (typeof classNames === 'string') {
    const classNamesArr = classNames.split(' ');
    classNamesCache[classNameThemeType] = classNamesArr;
    return classNamesArr;
  }
  return classNames;
}
function setMutatedNode(mutatedNodes, registeredNodes, mutationListeners, node, mutation) {
  if (mutationListeners.size === 0) {
    return;
  }
  const nodeType = node.__type;
  const nodeKey = node.__key;
  // eslint-disable-next-line no-console
  console.log('2.[lexical][setMutatedNode] nodeType:', {
    mutation,
    node
  });
  const registeredNode = registeredNodes.get(nodeType);
  if (registeredNode === undefined) {
    {
      throw Error(`Type ${nodeType} not in registeredNodes`);
    }
  }
  const klass = registeredNode.klass;
  let mutatedNodesByType = mutatedNodes.get(klass);
  if (mutatedNodesByType === undefined) {
    mutatedNodesByType = new Map();
    mutatedNodes.set(klass, mutatedNodesByType);
  }
  const prevMutation = mutatedNodesByType.get(nodeKey);
  // If the node has already been "destroyed", yet we are
  // re-making it, then this means a move likely happened.
  // We should change the mutation to be that of "updated"
  // instead.
  const isMove = prevMutation === 'destroyed' && mutation === 'created';
  if (prevMutation === undefined || isMove) {
    mutatedNodesByType.set(nodeKey, isMove ? 'updated' : mutation);
  }
}
function $nodesOfType(klass) {
  const editorState = getActiveEditorState();
  const readOnly = editorState._readOnly;
  const klassType = klass.getType();
  const nodes = editorState._nodeMap;
  const nodesOfType = [];
  for (const [, node] of nodes) {
    if (node instanceof klass && node.__type === klassType && (readOnly || node.isAttached())) {
      nodesOfType.push(node);
    }
  }
  return nodesOfType;
}
function resolveElement(element, isBackward, focusOffset) {
  const parent = element.getParent();
  let offset = focusOffset;
  let block = element;
  if (parent !== null) {
    if (isBackward && focusOffset === 0) {
      offset = block.getIndexWithinParent();
      block = parent;
    } else if (!isBackward && focusOffset === block.getChildrenSize()) {
      offset = block.getIndexWithinParent() + 1;
      block = parent;
    }
  }
  return block.getChildAtIndex(isBackward ? offset - 1 : offset);
}
function $getAdjacentNode(focus, isBackward) {
  const focusOffset = focus.offset;
  if (focus.type === 'element') {
    const block = focus.getNode();
    return resolveElement(block, isBackward, focusOffset);
  } else {
    const focusNode = focus.getNode();
    if (isBackward && focusOffset === 0 || !isBackward && focusOffset === focusNode.getTextContentSize()) {
      const possibleNode = isBackward ? focusNode.getPreviousSibling() : focusNode.getNextSibling();
      if (possibleNode === null) {
        return resolveElement(focusNode.getParentOrThrow(), isBackward, focusNode.getIndexWithinParent() + (isBackward ? 0 : 1));
      }
      return possibleNode;
    }
  }
  return null;
}
function isFirefoxClipboardEvents(editor) {
  const event = getWindow(editor).event;
  const inputType = event && event.inputType;
  return inputType === 'insertFromPaste' || inputType === 'insertFromPasteAsQuotation';
}
function dispatchCommand(editor, command, payload) {
  return triggerCommandListeners(editor, command, payload);
}
function $textContentRequiresDoubleLinebreakAtEnd(node) {
  return !$isRootNode(node) && !node.isLastChild() && !node.isInline();
}
function getElementByKeyOrThrow(editor, key) {
  const element = editor._keyToDOMMap.get(key);
  if (element === undefined) {
    {
      throw Error(`Reconciliation: could not find DOM element for node key ${key}`);
    }
  }
  return element;
}
function getParentElement(node) {
  const parentElement = node.assignedSlot || node.parentElement;
  return parentElement !== null && parentElement.nodeType === 11 ? parentElement.host : parentElement;
}
function scrollIntoViewIfNeeded(editor, selectionRect, rootElement) {
  const doc = rootElement.ownerDocument;
  const defaultView = doc.defaultView;
  if (defaultView === null) {
    return;
  }
  let {
    top: currentTop,
    bottom: currentBottom
  } = selectionRect;
  let targetTop = 0;
  let targetBottom = 0;
  let element = rootElement;
  while (element !== null) {
    const isBodyElement = element === doc.body;
    if (isBodyElement) {
      targetTop = 0;
      targetBottom = getWindow(editor).innerHeight;
    } else {
      const targetRect = element.getBoundingClientRect();
      targetTop = targetRect.top;
      targetBottom = targetRect.bottom;
    }
    let diff = 0;
    if (currentTop < targetTop) {
      diff = -(targetTop - currentTop);
    } else if (currentBottom > targetBottom) {
      diff = currentBottom - targetBottom;
    }
    if (diff !== 0) {
      if (isBodyElement) {
        // Only handles scrolling of Y axis
        defaultView.scrollBy(0, diff);
      } else {
        const scrollTop = element.scrollTop;
        element.scrollTop += diff;
        const yOffset = element.scrollTop - scrollTop;
        currentTop -= yOffset;
        currentBottom -= yOffset;
      }
    }
    if (isBodyElement) {
      break;
    }
    element = getParentElement(element);
  }
}
function $hasUpdateTag(tag) {
  const editor = getActiveEditor();
  return editor._updateTags.has(tag);
}
function $addUpdateTag(tag) {
  errorOnReadOnly();
  const editor = getActiveEditor();
  editor._updateTags.add(tag);
}
function $maybeMoveChildrenSelectionToParent(parentNode) {
  const selection = $getSelection();
  if (!$isRangeSelection(selection) || !$isElementNode(parentNode)) {
    return selection;
  }
  const {
    anchor,
    focus
  } = selection;
  const anchorNode = anchor.getNode();
  const focusNode = focus.getNode();
  if ($hasAncestor(anchorNode, parentNode)) {
    anchor.set(parentNode.__key, 0, 'element');
  }
  if ($hasAncestor(focusNode, parentNode)) {
    focus.set(parentNode.__key, 0, 'element');
  }
  return selection;
}
function $hasAncestor(child, targetNode) {
  let parent = child.getParent();
  while (parent !== null) {
    if (parent.is(targetNode)) {
      return true;
    }
    parent = parent.getParent();
  }
  return false;
}
function getDefaultView(domElem) {
  const ownerDoc = domElem.ownerDocument;
  return ownerDoc && ownerDoc.defaultView || null;
}
function getWindow(editor) {
  const windowObj = editor._window;
  if (windowObj === null) {
    {
      throw Error(`window object not found`);
    }
  }
  return windowObj;
}
function $isInlineElementOrDecoratorNode(node) {
  return $isElementNode(node) && node.isInline() || $isDecoratorNode(node) && node.isInline();
}
function $getNearestRootOrShadowRoot(node) {
  let parent = node.getParentOrThrow();
  while (parent !== null) {
    if ($isRootOrShadowRoot(parent)) {
      return parent;
    }
    parent = parent.getParentOrThrow();
  }
  return parent;
}
function $isRootOrShadowRoot(node) {
  return $isRootNode(node) || $isElementNode(node) && node.isShadowRoot();
}
function $copyNode(node) {
  const copy = node.constructor.clone(node);
  $setNodeKey(copy, null);
  // @ts-expect-error
  return copy;
}
function $applyNodeReplacement(node) {
  const editor = getActiveEditor();
  const nodeType = node.constructor.getType();
  const registeredNode = editor._nodes.get(nodeType);
  if (registeredNode === undefined) {
    {
      throw Error(`$initializeNode failed. Ensure node has been registered to the editor. You can do this by passing the node class via the "nodes" array in the editor config.`);
    }
  }
  const replaceFunc = registeredNode.replace;
  if (replaceFunc !== null) {
    const replacementNode = replaceFunc(node);
    if (!(replacementNode instanceof node.constructor)) {
      {
        throw Error(`$initializeNode failed. Ensure replacement node is a subclass of the original node.`);
      }
    }
    return replacementNode;
  }
  return node;
}
function errorOnInsertTextNodeOnRoot(node, insertNode) {
  const parentNode = node.getParent();
  if ($isRootNode(parentNode) && !$isElementNode(insertNode) && !$isDecoratorNode(insertNode)) {
    {
      throw Error(`Only element or decorator nodes can be inserted in to the root node`);
    }
  }
}
function createBlockCursorElement(editorConfig) {
  const theme = editorConfig.theme;
  const element = document.createElement('div');
  element.contentEditable = 'false';
  element.setAttribute('data-lexical-cursor', 'true');
  let blockCursorTheme = theme.blockCursor;
  if (blockCursorTheme !== undefined) {
    if (typeof blockCursorTheme === 'string') {
      const classNamesArr = blockCursorTheme.split(' ');
      // @ts-expect-error: intentional
      blockCursorTheme = theme.blockCursor = classNamesArr;
    }
    if (blockCursorTheme !== undefined) {
      element.classList.add(...blockCursorTheme);
    }
  }
  return element;
}
function needsBlockCursor(node) {
  return ($isDecoratorNode(node) || $isElementNode(node) && !node.canBeEmpty()) && !node.isInline();
}
function removeDOMBlockCursorElement(blockCursorElement, editor, rootElement) {
  rootElement.style.removeProperty('caret-color');
  editor._blockCursorElement = null;
  const parentElement = blockCursorElement.parentElement;
  if (parentElement !== null) {
    parentElement.removeChild(blockCursorElement);
  }
}
function updateDOMBlockCursorElement(editor, rootElement, nextSelection) {
  let blockCursorElement = editor._blockCursorElement;
  if ($isRangeSelection(nextSelection) && nextSelection.isCollapsed() && nextSelection.anchor.type === 'element' && rootElement.contains(document.activeElement)) {
    const anchor = nextSelection.anchor;
    const elementNode = anchor.getNode();
    const offset = anchor.offset;
    const elementNodeSize = elementNode.getChildrenSize();
    let isBlockCursor = false;
    let insertBeforeElement = null;
    if (offset === elementNodeSize) {
      const child = elementNode.getChildAtIndex(offset - 1);
      if (needsBlockCursor(child)) {
        isBlockCursor = true;
      }
    } else {
      const child = elementNode.getChildAtIndex(offset);
      if (needsBlockCursor(child)) {
        const sibling = child.getPreviousSibling();
        if (sibling === null || needsBlockCursor(sibling)) {
          isBlockCursor = true;
          insertBeforeElement = editor.getElementByKey(child.__key);
        }
      }
    }
    if (isBlockCursor) {
      const elementDOM = editor.getElementByKey(elementNode.__key);
      if (blockCursorElement === null) {
        editor._blockCursorElement = blockCursorElement = createBlockCursorElement(editor._config);
      }
      rootElement.style.caretColor = 'transparent';
      if (insertBeforeElement === null) {
        elementDOM.appendChild(blockCursorElement);
      } else {
        elementDOM.insertBefore(blockCursorElement, insertBeforeElement);
      }
      return;
    }
  }
  // Remove cursor
  if (blockCursorElement !== null) {
    removeDOMBlockCursorElement(blockCursorElement, editor, rootElement);
  }
}
function getDOMSelection(targetWindow) {
  return !CAN_USE_DOM ? null : (targetWindow || window).getSelection();
}
function $splitNode(node, offset) {
  let startNode = node.getChildAtIndex(offset);
  if (startNode == null) {
    startNode = node;
  }
  if (!!$isRootOrShadowRoot(node)) {
    throw Error(`Can not call $splitNode() on root element`);
  }
  const recurse = currentNode => {
    const parent = currentNode.getParentOrThrow();
    const isParentRoot = $isRootOrShadowRoot(parent);
    // The node we start split from (leaf) is moved, but its recursive
    // parents are copied to create separate tree
    const nodeToMove = currentNode === startNode && !isParentRoot ? currentNode : $copyNode(currentNode);
    if (isParentRoot) {
      if (!($isElementNode(currentNode) && $isElementNode(nodeToMove))) {
        throw Error(`Children of a root must be ElementNode`);
      }
      currentNode.insertAfter(nodeToMove);
      return [currentNode, nodeToMove, nodeToMove];
    } else {
      const [leftTree, rightTree, newParent] = recurse(parent);
      const nextSiblings = currentNode.getNextSiblings();
      newParent.append(nodeToMove, ...nextSiblings);
      return [leftTree, rightTree, nodeToMove];
    }
  };
  const [leftTree, rightTree] = recurse(startNode);
  return [leftTree, rightTree];
}

/**
 * @param x - The element being tested
 * @returns Returns true if x is an HTML anchor tag, false otherwise
 */
function isHTMLAnchorElement(x) {
  return isHTMLElement(x) && x.tagName === 'A';
}

/**
 * @param x - The element being testing
 * @returns Returns true if x is an HTML element, false otherwise.
 */
function isHTMLElement(x) {
  // @ts-ignore-next-line - strict check on nodeType here should filter out non-Element EventTarget implementors
  return x.nodeType === 1;
}

/**
 * This function is for internal use of the library.
 * Please do not use it as it may change in the future.
 */
function INTERNAL_$isBlock(node) {
  if ($isDecoratorNode(node) && !node.isInline()) {
    return true;
  }
  if (!$isElementNode(node) || $isRootOrShadowRoot(node)) {
    return false;
  }
  const firstChild = node.getFirstChild();
  const isLeafElement = firstChild === null || $isLineBreakNode(firstChild) || $isTextNode(firstChild) || firstChild.isInline();
  return !node.isInline() && node.canBeEmpty() !== false && isLeafElement;
}
function $getAncestor(node, predicate) {
  let parent = node;
  while (parent !== null && parent.getParent() !== null && !predicate(parent)) {
    parent = parent.getParentOrThrow();
  }
  return predicate(parent) ? parent : null;
}

/**
 * Utility function for accessing current active editor instance.
 * @returns Current active editor
 */
function $getEditor() {
  return getActiveEditor();
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
function $garbageCollectDetachedDecorators(editor, pendingEditorState) {
  const currentDecorators = editor._decorators;
  const pendingDecorators = editor._pendingDecorators;
  let decorators = pendingDecorators || currentDecorators;
  const nodeMap = pendingEditorState._nodeMap;
  let key;
  for (key in decorators) {
    if (!nodeMap.has(key)) {
      if (decorators === currentDecorators) {
        decorators = cloneDecorators(editor);
      }
      delete decorators[key];
    }
  }
}
function $garbageCollectDetachedDeepChildNodes(node, parentKey, prevNodeMap, nodeMap, nodeMapDelete, dirtyNodes) {
  let child = node.getFirstChild();
  while (child !== null) {
    const childKey = child.__key;
    // TODO Revise condition below, redundant? LexicalNode already cleans up children when moving Nodes
    if (child.__parent === parentKey) {
      if ($isElementNode(child)) {
        $garbageCollectDetachedDeepChildNodes(child, childKey, prevNodeMap, nodeMap, nodeMapDelete, dirtyNodes);
      }

      // If we have created a node and it was dereferenced, then also
      // remove it from out dirty nodes Set.
      if (!prevNodeMap.has(childKey)) {
        dirtyNodes.delete(childKey);
      }
      nodeMapDelete.push(childKey);
    }
    child = child.getNextSibling();
  }
}
function $garbageCollectDetachedNodes(prevEditorState, editorState, dirtyLeaves, dirtyElements) {
  const prevNodeMap = prevEditorState._nodeMap;
  const nodeMap = editorState._nodeMap;
  // Store dirtyElements in a queue for later deletion; deleting dirty subtrees too early will
  // hinder accessing .__next on child nodes
  const nodeMapDelete = [];
  for (const [nodeKey] of dirtyElements) {
    const node = nodeMap.get(nodeKey);
    if (node !== undefined) {
      // Garbage collect node and its children if they exist
      if (!node.isAttached()) {
        if ($isElementNode(node)) {
          $garbageCollectDetachedDeepChildNodes(node, nodeKey, prevNodeMap, nodeMap, nodeMapDelete, dirtyElements);
        }
        // If we have created a node and it was dereferenced, then also
        // remove it from out dirty nodes Set.
        if (!prevNodeMap.has(nodeKey)) {
          dirtyElements.delete(nodeKey);
        }
        nodeMapDelete.push(nodeKey);
      }
    }
  }
  for (const nodeKey of nodeMapDelete) {
    nodeMap.delete(nodeKey);
  }
  for (const nodeKey of dirtyLeaves) {
    const node = nodeMap.get(nodeKey);
    if (node !== undefined && !node.isAttached()) {
      if (!prevNodeMap.has(nodeKey)) {
        dirtyLeaves.delete(nodeKey);
      }
      nodeMap.delete(nodeKey);
    }
  }
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
let subTreeTextContent = '';
let subTreeDirectionedTextContent = '';
let editorTextContent = '';
let activeEditorConfig;
let activeEditor$1;
let activeEditorNodes;
let treatAllNodesAsDirty = false;
let activeEditorStateReadOnly = false;
let activeMutationListeners;
let activeTextDirection = null;
let activeDirtyElements;
let activeDirtyLeaves;
let activePrevNodeMap;
let activeNextNodeMap;
let activePrevKeyToDOMMap;
let mutatedNodes;
function destroyNode(key, parentDOM) {
  const node = activePrevNodeMap.get(key);
  if (parentDOM !== null) {
    const dom = getPrevElementByKeyOrThrow(key);
    if (dom.parentNode === parentDOM) {
      parentDOM.removeChild(dom);
    }
  }

  // This logic is really important, otherwise we will leak DOM nodes
  // when their corresponding LexicalNodes are removed from the editor state.
  if (!activeNextNodeMap.has(key)) {
    activeEditor$1._keyToDOMMap.delete(key);
  }
  if ($isElementNode(node)) {
    const children = createChildrenArray(node, activePrevNodeMap);
    destroyChildren(children, 0, children.length - 1, null);
  }
  if (node !== undefined) {
    setMutatedNode(mutatedNodes, activeEditorNodes, activeMutationListeners, node, 'destroyed');
  }
}
function destroyChildren(children, _startIndex, endIndex, dom) {
  let startIndex = _startIndex;
  for (; startIndex <= endIndex; ++startIndex) {
    const child = children[startIndex];
    if (child !== undefined) {
      destroyNode(child, dom);
    }
  }
}
function setTextAlign(domStyle, value) {
  domStyle.setProperty('text-align', value);
}
const DEFAULT_INDENT_VALUE = '40px';
function setElementIndent(dom, indent) {
  const indentClassName = activeEditorConfig.theme.indent;
  if (typeof indentClassName === 'string') {
    const elementHasClassName = dom.classList.contains(indentClassName);
    if (indent > 0 && !elementHasClassName) {
      dom.classList.add(indentClassName);
    } else if (indent < 1 && elementHasClassName) {
      dom.classList.remove(indentClassName);
    }
  }
  const indentationBaseValue = getComputedStyle(dom).getPropertyValue('--lexical-indent-base-value') || DEFAULT_INDENT_VALUE;
  dom.style.setProperty('padding-inline-start', indent === 0 ? '' : `calc(${indent} * ${indentationBaseValue})`);
}
function setElementFormat(dom, format) {
  const domStyle = dom.style;
  if (format === 0) {
    setTextAlign(domStyle, '');
  } else if (format === IS_ALIGN_LEFT) {
    setTextAlign(domStyle, 'left');
  } else if (format === IS_ALIGN_CENTER) {
    setTextAlign(domStyle, 'center');
  } else if (format === IS_ALIGN_RIGHT) {
    setTextAlign(domStyle, 'right');
  } else if (format === IS_ALIGN_JUSTIFY) {
    setTextAlign(domStyle, 'justify');
  } else if (format === IS_ALIGN_START) {
    setTextAlign(domStyle, 'start');
  } else if (format === IS_ALIGN_END) {
    setTextAlign(domStyle, 'end');
  }
}
function createNode(key, parentDOM, insertDOM) {
  const node = activeNextNodeMap.get(key);
  if (node === undefined) {
    {
      throw Error(`createNode: node does not exist in nodeMap`);
    }
  }
  const dom = node.createDOM(activeEditorConfig, activeEditor$1);
  storeDOMWithKey(key, dom, activeEditor$1);

  // This helps preserve the text, and stops spell check tools from
  // merging or break the spans (which happens if they are missing
  // this attribute).
  if ($isTextNode(node)) {
    dom.setAttribute('data-lexical-text', 'true');
  } else if ($isDecoratorNode(node)) {
    dom.setAttribute('data-lexical-decorator', 'true');
  }
  if ($isElementNode(node)) {
    const indent = node.__indent;
    const childrenSize = node.__size;
    if (indent !== 0) {
      setElementIndent(dom, indent);
    }
    if (childrenSize !== 0) {
      const endIndex = childrenSize - 1;
      const children = createChildrenArray(node, activeNextNodeMap);
      createChildrenWithDirection(children, endIndex, node, dom);
    }
    const format = node.__format;
    // TODO: UNSAFE - FORK PART
    // apply added __fontColor, __textFormat to node during Reconciliation
    const nodeKeys = ['__fontColor', '__textFormat'];
    nodeKeys.forEach(nK => {
      if (!(nK in node) || typeof node[nK] === 'undefined') {
        return;
      }
      if (nK === '__fontColor') {
        dom.style.color = node[nK];
      }
    });
    if (format !== 0) {
      setElementFormat(dom, format);
    }
    if (!node.isInline()) {
      reconcileElementTerminatingLineBreak(null, node, dom);
    }
    if ($textContentRequiresDoubleLinebreakAtEnd(node)) {
      subTreeTextContent += DOUBLE_LINE_BREAK;
      editorTextContent += DOUBLE_LINE_BREAK;
    }
  } else {
    const text = node.getTextContent();
    if ($isDecoratorNode(node)) {
      const decorator = node.decorate(activeEditor$1, activeEditorConfig);
      if (decorator !== null) {
        reconcileDecorator(key, decorator);
      }
      // Decorators are always non editable
      dom.contentEditable = 'false';
    } else if ($isTextNode(node)) {
      if (!node.isDirectionless()) {
        subTreeDirectionedTextContent += text;
      }
    }
    subTreeTextContent += text;
    editorTextContent += text;
  }
  if (parentDOM !== null) {
    if (insertDOM != null) {
      parentDOM.insertBefore(dom, insertDOM);
    } else {
      // @ts-expect-error: internal field
      const possibleLineBreak = parentDOM.__lexicalLineBreak;
      if (possibleLineBreak != null) {
        parentDOM.insertBefore(dom, possibleLineBreak);
      } else {
        parentDOM.appendChild(dom);
      }
    }
  }
  {
    // Freeze the node in DEV to prevent accidental mutations
    Object.freeze(node);
  }
  setMutatedNode(mutatedNodes, activeEditorNodes, activeMutationListeners, node, 'created');
  return dom;
}
function createChildrenWithDirection(children, endIndex, element, dom) {
  const previousSubTreeDirectionedTextContent = subTreeDirectionedTextContent;
  subTreeDirectionedTextContent = '';
  createChildren(children, element, 0, endIndex, dom, null);
  reconcileBlockDirection(element, dom);
  subTreeDirectionedTextContent = previousSubTreeDirectionedTextContent;
}
function createChildren(children, element, _startIndex, endIndex, dom, insertDOM) {
  const previousSubTreeTextContent = subTreeTextContent;
  subTreeTextContent = '';
  let startIndex = _startIndex;
  for (; startIndex <= endIndex; ++startIndex) {
    createNode(children[startIndex], dom, insertDOM);
  }
  if ($textContentRequiresDoubleLinebreakAtEnd(element)) {
    subTreeTextContent += DOUBLE_LINE_BREAK;
  }
  // @ts-expect-error: internal field
  dom.__lexicalTextContent = subTreeTextContent;
  subTreeTextContent = previousSubTreeTextContent + subTreeTextContent;
}
function isLastChildLineBreakOrDecorator(childKey, nodeMap) {
  const node = nodeMap.get(childKey);
  return $isLineBreakNode(node) || $isDecoratorNode(node) && node.isInline();
}

// If we end an element with a LineBreakNode, then we need to add an additional <br>
function reconcileElementTerminatingLineBreak(prevElement, nextElement, dom) {
  const prevLineBreak = prevElement !== null && (prevElement.__size === 0 || isLastChildLineBreakOrDecorator(prevElement.__last, activePrevNodeMap));
  const nextLineBreak = nextElement.__size === 0 || isLastChildLineBreakOrDecorator(nextElement.__last, activeNextNodeMap);
  if (prevLineBreak) {
    if (!nextLineBreak) {
      // @ts-expect-error: internal field
      const element = dom.__lexicalLineBreak;
      if (element != null) {
        dom.removeChild(element);
      }

      // @ts-expect-error: internal field
      dom.__lexicalLineBreak = null;
    }
  } else if (nextLineBreak) {
    const element = document.createElement('br');
    // @ts-expect-error: internal field
    dom.__lexicalLineBreak = element;
    dom.appendChild(element);
  }
}
function reconcileBlockDirection(element, dom) {
  const previousSubTreeDirectionTextContent =
  // @ts-expect-error: internal field
  dom.__lexicalDirTextContent;
  // @ts-expect-error: internal field
  const previousDirection = dom.__lexicalDir;
  if (previousSubTreeDirectionTextContent !== subTreeDirectionedTextContent || previousDirection !== activeTextDirection) {
    const hasEmptyDirectionedTextContent = subTreeDirectionedTextContent === '';
    const direction = hasEmptyDirectionedTextContent ? activeTextDirection : getTextDirection(subTreeDirectionedTextContent);
    if (direction !== previousDirection) {
      const classList = dom.classList;
      const theme = activeEditorConfig.theme;
      let previousDirectionTheme = previousDirection !== null ? theme[previousDirection] : undefined;
      let nextDirectionTheme = direction !== null ? theme[direction] : undefined;

      // Remove the old theme classes if they exist
      if (previousDirectionTheme !== undefined) {
        if (typeof previousDirectionTheme === 'string') {
          const classNamesArr = previousDirectionTheme.split(' ');
          previousDirectionTheme = theme[previousDirection] = classNamesArr;
        }

        // @ts-ignore: intentional
        classList.remove(...previousDirectionTheme);
      }
      if (direction === null || hasEmptyDirectionedTextContent && direction === 'ltr') {
        // Remove direction
        dom.removeAttribute('dir');
      } else {
        // Apply the new theme classes if they exist
        if (nextDirectionTheme !== undefined) {
          if (typeof nextDirectionTheme === 'string') {
            const classNamesArr = nextDirectionTheme.split(' ');
            // @ts-expect-error: intentional
            nextDirectionTheme = theme[direction] = classNamesArr;
          }
          if (nextDirectionTheme !== undefined) {
            classList.add(...nextDirectionTheme);
          }
        }

        // Update direction
        dom.dir = direction;
      }
      if (!activeEditorStateReadOnly) {
        const writableNode = element.getWritable();
        writableNode.__dir = direction;
      }
    }
    activeTextDirection = direction;
    // @ts-expect-error: internal field
    dom.__lexicalDirTextContent = subTreeDirectionedTextContent;
    // @ts-expect-error: internal field
    dom.__lexicalDir = direction;
  }
}
function reconcileChildrenWithDirection(prevElement, nextElement, dom) {
  const previousSubTreeDirectionTextContent = subTreeDirectionedTextContent;
  subTreeDirectionedTextContent = '';
  // eslint-disable-next-line no-console
  console.log('2.[lexical][reconcileChildrenWithDirection]', {
    dom,
    nextElement,
    prevElement
  });
  reconcileChildren(prevElement, nextElement, dom);
  reconcileBlockDirection(nextElement, dom);
  subTreeDirectionedTextContent = previousSubTreeDirectionTextContent;
}
function createChildrenArray(element, nodeMap) {
  const children = [];
  let nodeKey = element.__first;
  while (nodeKey !== null) {
    const node = nodeMap.get(nodeKey);
    if (node === undefined) {
      {
        throw Error(`createChildrenArray: node does not exist in nodeMap`);
      }
    }
    children.push(nodeKey);
    nodeKey = node.__next;
  }
  return children;
}
function reconcileChildren(prevElement, nextElement, dom) {
  const previousSubTreeTextContent = subTreeTextContent;
  const prevChildrenSize = prevElement.__size;
  const nextChildrenSize = nextElement.__size;
  subTreeTextContent = '';
  if (prevChildrenSize === 1 && nextChildrenSize === 1) {
    const prevFirstChildKey = prevElement.__first;
    const nextFrstChildKey = nextElement.__first;
    if (prevFirstChildKey === nextFrstChildKey) {
      reconcileNode(prevFirstChildKey, dom);
    } else {
      const lastDOM = getPrevElementByKeyOrThrow(prevFirstChildKey);
      const replacementDOM = createNode(nextFrstChildKey, null, null);
      dom.replaceChild(replacementDOM, lastDOM);
      destroyNode(prevFirstChildKey, null);
    }
  } else {
    const prevChildren = createChildrenArray(prevElement, activePrevNodeMap);
    const nextChildren = createChildrenArray(nextElement, activeNextNodeMap);
    if (prevChildrenSize === 0) {
      if (nextChildrenSize !== 0) {
        createChildren(nextChildren, nextElement, 0, nextChildrenSize - 1, dom, null);
      }
    } else if (nextChildrenSize === 0) {
      if (prevChildrenSize !== 0) {
        // @ts-expect-error: internal field
        const lexicalLineBreak = dom.__lexicalLineBreak;
        const canUseFastPath = lexicalLineBreak == null;
        destroyChildren(prevChildren, 0, prevChildrenSize - 1, canUseFastPath ? null : dom);
        if (canUseFastPath) {
          // Fast path for removing DOM nodes
          dom.textContent = '';
        }
      }
    } else {
      reconcileNodeChildren(nextElement, prevChildren, nextChildren, prevChildrenSize, nextChildrenSize, dom);
    }
  }
  if ($textContentRequiresDoubleLinebreakAtEnd(nextElement)) {
    subTreeTextContent += DOUBLE_LINE_BREAK;
  }

  // @ts-expect-error: internal field
  dom.__lexicalTextContent = subTreeTextContent;
  subTreeTextContent = previousSubTreeTextContent + subTreeTextContent;
}
function reconcileNode(key, parentDOM) {
  const prevNode = activePrevNodeMap.get(key);
  let nextNode = activeNextNodeMap.get(key);
  if (prevNode === undefined || nextNode === undefined) {
    {
      throw Error(`reconcileNode: prevNode or nextNode does not exist in nodeMap`);
    }
  }
  const isDirty = treatAllNodesAsDirty || activeDirtyLeaves.has(key) || activeDirtyElements.has(key);
  const dom = getElementByKeyOrThrow(activeEditor$1, key);
  // eslint-disable-next-line no-console
  console.log('2.[lexical][reconcileNode] dom:', dom);
  // If the node key points to the same instance in both states
  // and isn't dirty, we just update the text content cache
  // and return the existing DOM Node.
  if (prevNode === nextNode && !isDirty) {
    // eslint-disable-next-line no-console
    console.log('2.[lexical][reconcileNode] prevNode === nextNode && !isDirty:', dom);
    if ($isElementNode(prevNode)) {
      // @ts-expect-error: internal field
      const previousSubTreeTextContent = dom.__lexicalTextContent;
      if (previousSubTreeTextContent !== undefined) {
        subTreeTextContent += previousSubTreeTextContent;
        editorTextContent += previousSubTreeTextContent;
      }

      // @ts-expect-error: internal field
      const previousSubTreeDirectionTextContent = dom.__lexicalDirTextContent;
      if (previousSubTreeDirectionTextContent !== undefined) {
        subTreeDirectionedTextContent += previousSubTreeDirectionTextContent;
      }
    } else {
      const text = prevNode.getTextContent();
      if ($isTextNode(prevNode) && !prevNode.isDirectionless()) {
        subTreeDirectionedTextContent += text;
      }
      editorTextContent += text;
      subTreeTextContent += text;
    }
    return dom;
  }
  // If the node key doesn't point to the same instance in both maps,
  // it means it were cloned. If they're also dirty, we mark them as mutated.
  if (prevNode !== nextNode && isDirty) {
    // eslint-disable-next-line no-console
    console.log('2.[lexical][reconcileNode] prevNode !== nextNode && isDirty');
    setMutatedNode(mutatedNodes, activeEditorNodes, activeMutationListeners, nextNode, 'updated');
  }

  // Update node. If it returns true, we need to unmount and re-create the node
  if (nextNode.updateDOM(prevNode, dom, activeEditorConfig)) {
    // eslint-disable-next-line no-console
    console.log('2.[lexical][reconcileNode] nextNode.updateDOM:', dom);
    const replacementDOM = createNode(key, null, null);
    if (parentDOM === null) {
      {
        throw Error(`reconcileNode: parentDOM is null`);
      }
    }
    parentDOM.replaceChild(replacementDOM, dom);
    destroyNode(key, null);
    return replacementDOM;
  }
  if ($isElementNode(prevNode) && $isElementNode(nextNode)) {
    // eslint-disable-next-line no-console
    console.log('2.[lexical][reconcileNode] Reconcile element children');
    // Reconcile element children
    const nextIndent = nextNode.__indent;
    if (nextIndent !== prevNode.__indent) {
      setElementIndent(dom, nextIndent);
    }
    const nextFormat = nextNode.__format;
    if (nextFormat !== prevNode.__format) {
      setElementFormat(dom, nextFormat);
    }
    const nodeKeys = ['__fontColor', '__textFormat'];
    nodeKeys.forEach(nK => {
      if (!nextNode) {
        return;
      }
      const nextValue = nextNode[nK];
      const prevValue = prevNode[nK];
      if (nextValue !== prevValue) {
        // @ts-ignore
        nextNode[nK] = nextValue;
      }
    });

    // TODO: fork, do some kind of map

    if (isDirty) {
      reconcileChildrenWithDirection(prevNode, nextNode, dom);
      if (!$isRootNode(nextNode) && !nextNode.isInline()) {
        reconcileElementTerminatingLineBreak(prevNode, nextNode, dom);
      }
    }
    if ($textContentRequiresDoubleLinebreakAtEnd(nextNode)) {
      subTreeTextContent += DOUBLE_LINE_BREAK;
      editorTextContent += DOUBLE_LINE_BREAK;
    }
  } else {
    const text = nextNode.getTextContent();
    if ($isDecoratorNode(nextNode)) {
      const decorator = nextNode.decorate(activeEditor$1, activeEditorConfig);
      if (decorator !== null) {
        reconcileDecorator(key, decorator);
      }
    } else if ($isTextNode(nextNode) && !nextNode.isDirectionless()) {
      // Handle text content, for LTR, LTR cases.
      subTreeDirectionedTextContent += text;
    }
    subTreeTextContent += text;
    editorTextContent += text;
  }
  if (!activeEditorStateReadOnly && $isRootNode(nextNode) && nextNode.__cachedText !== editorTextContent) {
    // Cache the latest text content.
    const nextRootNode = nextNode.getWritable();
    nextRootNode.__cachedText = editorTextContent;
    nextNode = nextRootNode;
  }
  {
    // Freeze the node in DEV to prevent accidental mutations
    Object.freeze(nextNode);
  }
  return dom;
}
function reconcileDecorator(key, decorator) {
  let pendingDecorators = activeEditor$1._pendingDecorators;
  const currentDecorators = activeEditor$1._decorators;
  if (pendingDecorators === null) {
    if (currentDecorators[key] === decorator) {
      return;
    }
    pendingDecorators = cloneDecorators(activeEditor$1);
  }
  pendingDecorators[key] = decorator;
}
function getFirstChild(element) {
  return element.firstChild;
}
function getNextSibling(element) {
  let nextSibling = element.nextSibling;
  if (nextSibling !== null && nextSibling === activeEditor$1._blockCursorElement) {
    nextSibling = nextSibling.nextSibling;
  }
  return nextSibling;
}
function reconcileNodeChildren(nextElement, prevChildren, nextChildren, prevChildrenLength, nextChildrenLength, dom) {
  const prevEndIndex = prevChildrenLength - 1;
  const nextEndIndex = nextChildrenLength - 1;
  let prevChildrenSet;
  let nextChildrenSet;
  let siblingDOM = getFirstChild(dom);
  let prevIndex = 0;
  let nextIndex = 0;
  while (prevIndex <= prevEndIndex && nextIndex <= nextEndIndex) {
    const prevKey = prevChildren[prevIndex];
    const nextKey = nextChildren[nextIndex];
    if (prevKey === nextKey) {
      siblingDOM = getNextSibling(reconcileNode(nextKey, dom));
      prevIndex++;
      nextIndex++;
    } else {
      if (prevChildrenSet === undefined) {
        prevChildrenSet = new Set(prevChildren);
      }
      if (nextChildrenSet === undefined) {
        nextChildrenSet = new Set(nextChildren);
      }
      const nextHasPrevKey = nextChildrenSet.has(prevKey);
      const prevHasNextKey = prevChildrenSet.has(nextKey);
      if (!nextHasPrevKey) {
        // Remove prev
        siblingDOM = getNextSibling(getPrevElementByKeyOrThrow(prevKey));
        destroyNode(prevKey, dom);
        prevIndex++;
      } else if (!prevHasNextKey) {
        // Create next
        createNode(nextKey, dom, siblingDOM);
        nextIndex++;
      } else {
        // Move next
        const childDOM = getElementByKeyOrThrow(activeEditor$1, nextKey);
        if (childDOM === siblingDOM) {
          siblingDOM = getNextSibling(reconcileNode(nextKey, dom));
        } else {
          if (siblingDOM != null) {
            dom.insertBefore(childDOM, siblingDOM);
          } else {
            dom.appendChild(childDOM);
          }
          reconcileNode(nextKey, dom);
        }
        prevIndex++;
        nextIndex++;
      }
    }
  }
  const appendNewChildren = prevIndex > prevEndIndex;
  const removeOldChildren = nextIndex > nextEndIndex;
  if (appendNewChildren && !removeOldChildren) {
    const previousNode = nextChildren[nextEndIndex + 1];
    const insertDOM = previousNode === undefined ? null : activeEditor$1.getElementByKey(previousNode);
    createChildren(nextChildren, nextElement, nextIndex, nextEndIndex, dom, insertDOM);
  } else if (removeOldChildren && !appendNewChildren) {
    destroyChildren(prevChildren, prevIndex, prevEndIndex, dom);
  }
}
function reconcileRoot(prevEditorState, nextEditorState, editor, dirtyType, dirtyElements, dirtyLeaves) {
  // We cache text content to make retrieval more efficient.
  // The cache must be rebuilt during reconciliation to account for any changes.
  subTreeTextContent = '';
  editorTextContent = '';
  subTreeDirectionedTextContent = '';
  // Rather than pass around a load of arguments through the stack recursively
  // we instead set them as bindings within the scope of the module.
  treatAllNodesAsDirty = dirtyType === FULL_RECONCILE;
  activeTextDirection = null;
  activeEditor$1 = editor;
  activeEditorConfig = editor._config;
  activeEditorNodes = editor._nodes;
  activeMutationListeners = activeEditor$1._listeners.mutation;
  activeDirtyElements = dirtyElements;
  activeDirtyLeaves = dirtyLeaves;
  activePrevNodeMap = prevEditorState._nodeMap;
  activeNextNodeMap = nextEditorState._nodeMap;
  activeEditorStateReadOnly = nextEditorState._readOnly;
  activePrevKeyToDOMMap = new Map(editor._keyToDOMMap);
  // We keep track of mutated nodes so we can trigger mutation
  // listeners later in the update cycle.
  const currentMutatedNodes = new Map();
  mutatedNodes = currentMutatedNodes;
  reconcileNode('root', null);
  // We don't want a bunch of void checks throughout the scope
  // so instead we make it seem that these values are always set.
  // We also want to make sure we clear them down, otherwise we
  // can leak memory.
  // @ts-ignore
  activeEditor$1 = undefined;
  // @ts-ignore
  activeEditorNodes = undefined;
  // @ts-ignore
  activeDirtyElements = undefined;
  // @ts-ignore
  activeDirtyLeaves = undefined;
  // @ts-ignore
  activePrevNodeMap = undefined;
  // @ts-ignore
  activeNextNodeMap = undefined;
  // @ts-ignore
  activeEditorConfig = undefined;
  // @ts-ignore
  activePrevKeyToDOMMap = undefined;
  // @ts-ignore
  mutatedNodes = undefined;
  return currentMutatedNodes;
}
function storeDOMWithKey(key, dom, editor) {
  const keyToDOMMap = editor._keyToDOMMap;
  // @ts-ignore We intentionally add this to the Node.
  dom['__lexicalKey_' + editor._key] = key;
  keyToDOMMap.set(key, dom);
}
function getPrevElementByKeyOrThrow(key) {
  const element = activePrevKeyToDOMMap.get(key);
  if (element === undefined) {
    {
      throw Error(`Reconciliation: could not find DOM element for node key ${key}`);
    }
  }
  return element;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
const PASS_THROUGH_COMMAND = Object.freeze({});
const ANDROID_COMPOSITION_LATENCY = 30;
const rootElementEvents = [['keydown', onKeyDown], ['pointerdown', onPointerDown], ['compositionstart', onCompositionStart], ['compositionend', onCompositionEnd], ['input', onInput], ['click', onClick], ['cut', PASS_THROUGH_COMMAND], ['copy', PASS_THROUGH_COMMAND], ['dragstart', PASS_THROUGH_COMMAND], ['dragover', PASS_THROUGH_COMMAND], ['dragend', PASS_THROUGH_COMMAND], ['paste', PASS_THROUGH_COMMAND], ['focus', PASS_THROUGH_COMMAND], ['blur', PASS_THROUGH_COMMAND], ['drop', PASS_THROUGH_COMMAND]];
if (CAN_USE_BEFORE_INPUT) {
  rootElementEvents.push(['beforeinput', (event, editor) => onBeforeInput(event, editor)]);
}
let lastKeyDownTimeStamp = 0;
let lastKeyCode = 0;
let lastBeforeInputInsertTextTimeStamp = 0;
let unprocessedBeforeInputData = null;
let rootElementsRegistered = 0;
let isSelectionChangeFromDOMUpdate = false;
let isSelectionChangeFromMouseDown = false;
let isInsertLineBreak = false;
let isFirefoxEndingComposition = false;
let collapsedSelectionFormat = [0, '', 0, 'root', 0];

// This function is used to determine if Lexical should attempt to override
// the default browser behavior for insertion of text and use its own internal
// heuristics. This is an extremely important function, and makes much of Lexical
// work as intended between different browsers and across word, line and character
// boundary/formats. It also is important for text replacement, node schemas and
// composition mechanics.

function $shouldPreventDefaultAndInsertText(selection, domTargetRange, text, timeStamp, isBeforeInput) {
  const anchor = selection.anchor;
  const focus = selection.focus;
  const anchorNode = anchor.getNode();
  const editor = getActiveEditor();
  const domSelection = getDOMSelection(editor._window);
  const domAnchorNode = domSelection !== null ? domSelection.anchorNode : null;
  const anchorKey = anchor.key;
  const backingAnchorElement = editor.getElementByKey(anchorKey);
  const textLength = text.length;
  return anchorKey !== focus.key ||
  // If we're working with a non-text node.
  !$isTextNode(anchorNode) ||
  // If we are replacing a range with a single character or grapheme, and not composing.
  (!isBeforeInput && (!CAN_USE_BEFORE_INPUT ||
  // We check to see if there has been
  // a recent beforeinput event for "textInput". If there has been one in the last
  // 50ms then we proceed as normal. However, if there is not, then this is likely
  // a dangling `input` event caused by execCommand('insertText').
  lastBeforeInputInsertTextTimeStamp < timeStamp + 50) || anchorNode.isDirty() && textLength < 2 || doesContainGrapheme(text)) && anchor.offset !== focus.offset && !anchorNode.isComposing() ||
  // Any non standard text node.
  $isTokenOrSegmented(anchorNode) ||
  // If the text length is more than a single character and we're either
  // dealing with this in "beforeinput" or where the node has already recently
  // been changed (thus is dirty).
  anchorNode.isDirty() && textLength > 1 ||
  // If the DOM selection element is not the same as the backing node during beforeinput.
  (isBeforeInput || !CAN_USE_BEFORE_INPUT) && backingAnchorElement !== null && !anchorNode.isComposing() && domAnchorNode !== getDOMTextNode(backingAnchorElement) ||
  // If TargetRange is not the same as the DOM selection; browser trying to edit random parts
  // of the editor.
  domSelection !== null && domTargetRange !== null && (!domTargetRange.collapsed || domTargetRange.startContainer !== domSelection.anchorNode || domTargetRange.startOffset !== domSelection.anchorOffset) ||
  // Check if we're changing from bold to italics, or some other format.
  anchorNode.getFormat() !== selection.format || anchorNode.getStyle() !== selection.style ||
  // One last set of heuristics to check against.
  $shouldInsertTextAfterOrBeforeTextNode(selection, anchorNode);
}
function shouldSkipSelectionChange(domNode, offset) {
  return domNode !== null && domNode.nodeValue !== null && domNode.nodeType === DOM_TEXT_TYPE && offset !== 0 && offset !== domNode.nodeValue.length;
}
function onSelectionChange(domSelection, editor, isActive) {
  const {
    anchorNode: anchorDOM,
    anchorOffset,
    focusNode: focusDOM,
    focusOffset
  } = domSelection;
  if (isSelectionChangeFromDOMUpdate) {
    isSelectionChangeFromDOMUpdate = false;

    // If native DOM selection is on a DOM element, then
    // we should continue as usual, as Lexical's selection
    // may have normalized to a better child. If the DOM
    // element is a text node, we can safely apply this
    // optimization and skip the selection change entirely.
    // We also need to check if the offset is at the boundary,
    // because in this case, we might need to normalize to a
    // sibling instead.
    if (shouldSkipSelectionChange(anchorDOM, anchorOffset) && shouldSkipSelectionChange(focusDOM, focusOffset)) {
      return;
    }
  }
  updateEditor(editor, () => {
    // Non-active editor don't need any extra logic for selection, it only needs update
    // to reconcile selection (set it to null) to ensure that only one editor has non-null selection.
    if (!isActive) {
      $setSelection(null);
      return;
    }
    if (!isSelectionWithinEditor(editor, anchorDOM, focusDOM)) {
      return;
    }
    const selection = $getSelection();

    // Update the selection format
    if ($isRangeSelection(selection)) {
      const anchor = selection.anchor;
      const anchorNode = anchor.getNode();
      if (selection.isCollapsed()) {
        // Badly interpreted range selection when collapsed - #1482
        if (domSelection.type === 'Range' && domSelection.anchorNode === domSelection.focusNode) {
          selection.dirty = true;
        }

        // If we have marked a collapsed selection format, and we're
        // within the given time range – then attempt to use that format
        // instead of getting the format from the anchor node.
        const windowEvent = getWindow(editor).event;
        const currentTimeStamp = windowEvent ? windowEvent.timeStamp : performance.now();
        const [lastFormat, lastStyle, lastOffset, lastKey, timeStamp] = collapsedSelectionFormat;
        const root = $getRoot();
        const isRootTextContentEmpty = editor.isComposing() === false && root.getTextContent() === '';
        if (currentTimeStamp < timeStamp + 200 && anchor.offset === lastOffset && anchor.key === lastKey) {
          selection.format = lastFormat;
          selection.style = lastStyle;
        } else {
          if (anchor.type === 'text') {
            if (!$isTextNode(anchorNode)) {
              throw Error(`Point.getNode() must return TextNode when type is text`);
            }
            selection.format = anchorNode.getFormat();
            selection.style = anchorNode.getStyle();
          } else if (anchor.type === 'element' && !isRootTextContentEmpty) {
            selection.format = 0;
            selection.style = '';
          }
        }
      } else {
        const anchorKey = anchor.key;
        const focus = selection.focus;
        const focusKey = focus.key;
        const nodes = selection.getNodes();
        const nodesLength = nodes.length;
        const isBackward = selection.isBackward();
        const startOffset = isBackward ? focusOffset : anchorOffset;
        const endOffset = isBackward ? anchorOffset : focusOffset;
        const startKey = isBackward ? focusKey : anchorKey;
        const endKey = isBackward ? anchorKey : focusKey;
        let combinedFormat = IS_ALL_FORMATTING;
        let hasTextNodes = false;
        for (let i = 0; i < nodesLength; i++) {
          const node = nodes[i];
          const textContentSize = node.getTextContentSize();
          if ($isTextNode(node) && textContentSize !== 0 &&
          // Exclude empty text nodes at boundaries resulting from user's selection
          !(i === 0 && node.__key === startKey && startOffset === textContentSize || i === nodesLength - 1 && node.__key === endKey && endOffset === 0)) {
            // TODO: what about style?
            hasTextNodes = true;
            combinedFormat &= node.getFormat();
            if (combinedFormat === 0) {
              break;
            }
          }
        }
        selection.format = hasTextNodes ? combinedFormat : 0;
      }
    }
    dispatchCommand(editor, SELECTION_CHANGE_COMMAND, undefined);
  });
}

// This is a work-around is mainly Chrome specific bug where if you select
// the contents of an empty block, you cannot easily unselect anything.
// This results in a tiny selection box that looks buggy/broken. This can
// also help other browsers when selection might "appear" lost, when it
// really isn't.
function onClick(event, editor) {
  updateEditor(editor, () => {
    const selection = $getSelection();
    const domSelection = getDOMSelection(editor._window);
    const lastSelection = $getPreviousSelection();
    if (domSelection) {
      if ($isRangeSelection(selection)) {
        const anchor = selection.anchor;
        const anchorNode = anchor.getNode();
        if (anchor.type === 'element' && anchor.offset === 0 && selection.isCollapsed() && !$isRootNode(anchorNode) && $getRoot().getChildrenSize() === 1 && anchorNode.getTopLevelElementOrThrow().isEmpty() && lastSelection !== null && selection.is(lastSelection)) {
          domSelection.removeAllRanges();
          selection.dirty = true;
        } else if (event.detail === 3 && !selection.isCollapsed()) {
          // Tripple click causing selection to overflow into the nearest element. In that
          // case visually it looks like a single element content is selected, focus node
          // is actually at the beginning of the next element (if present) and any manipulations
          // with selection (formatting) are affecting second element as well
          const focus = selection.focus;
          const focusNode = focus.getNode();
          if (anchorNode !== focusNode) {
            if ($isElementNode(anchorNode)) {
              anchorNode.select(0);
            } else {
              anchorNode.getParentOrThrow().select(0);
            }
          }
        }
      } else if (event.pointerType === 'touch') {
        // This is used to update the selection on touch devices when the user clicks on text after a
        // node selection. See isSelectionChangeFromMouseDown for the inverse
        const domAnchorNode = domSelection.anchorNode;
        if (domAnchorNode !== null) {
          const nodeType = domAnchorNode.nodeType;
          // If the user is attempting to click selection back onto text, then
          // we should attempt create a range selection.
          // When we click on an empty paragraph node or the end of a paragraph that ends
          // with an image/poll, the nodeType will be ELEMENT_NODE
          if (nodeType === DOM_ELEMENT_TYPE || nodeType === DOM_TEXT_TYPE) {
            const newSelection = internalCreateRangeSelection(lastSelection, domSelection, editor, event);
            $setSelection(newSelection);
          }
        }
      }
    }
    dispatchCommand(editor, CLICK_COMMAND, event);
  });
}
function onPointerDown(event, editor) {
  // TODO implement text drag & drop
  const target = event.target;
  const pointerType = event.pointerType;
  if (target instanceof Node && pointerType !== 'touch') {
    updateEditor(editor, () => {
      // Drag & drop should not recompute selection until mouse up; otherwise the initially
      // selected content is lost.
      if (!$isSelectionCapturedInDecorator(target)) {
        isSelectionChangeFromMouseDown = true;
      }
    });
  }
}
function getTargetRange(event) {
  if (!event.getTargetRanges) {
    return null;
  }
  const targetRanges = event.getTargetRanges();
  if (targetRanges.length === 0) {
    return null;
  }
  return targetRanges[0];
}
function $canRemoveText(anchorNode, focusNode) {
  return anchorNode !== focusNode || $isElementNode(anchorNode) || $isElementNode(focusNode) || !anchorNode.isToken() || !focusNode.isToken();
}
function isPossiblyAndroidKeyPress(timeStamp) {
  return lastKeyCode === 229 && timeStamp < lastKeyDownTimeStamp + ANDROID_COMPOSITION_LATENCY;
}
function onBeforeInput(event, editor) {
  const inputType = event.inputType;
  const targetRange = getTargetRange(event);

  // We let the browser do its own thing for composition.
  if (inputType === 'deleteCompositionText' ||
  // If we're pasting in FF, we shouldn't get this event
  // as the `paste` event should have triggered, unless the
  // user has dom.event.clipboardevents.enabled disabled in
  // about:config. In that case, we need to process the
  // pasted content in the DOM mutation phase.
  IS_FIREFOX && isFirefoxClipboardEvents(editor)) {
    return;
  } else if (inputType === 'insertCompositionText') {
    return;
  }
  updateEditor(editor, () => {
    const selection = $getSelection();
    if (inputType === 'deleteContentBackward') {
      if (selection === null) {
        // Use previous selection
        const prevSelection = $getPreviousSelection();
        if (!$isRangeSelection(prevSelection)) {
          return;
        }
        $setSelection(prevSelection.clone());
      }
      if ($isRangeSelection(selection)) {
        // Used for handling backspace in Android.
        if (IS_ANDROID) {
          $setCompositionKey(selection.anchor.key);
        }
        if (isPossiblyAndroidKeyPress(event.timeStamp) && editor.isComposing() && selection.anchor.key === selection.focus.key) {
          $setCompositionKey(null);
          lastKeyDownTimeStamp = 0;
          // Fixes an Android bug where selection flickers when backspacing
          setTimeout(() => {
            updateEditor(editor, () => {
              $setCompositionKey(null);
            });
          }, ANDROID_COMPOSITION_LATENCY);
          if ($isRangeSelection(selection)) {
            const anchorNode = selection.anchor.getNode();
            anchorNode.markDirty();
            selection.format = anchorNode.getFormat();
            if (!$isTextNode(anchorNode)) {
              throw Error(`Anchor node must be a TextNode`);
            }
            selection.style = anchorNode.getStyle();
          }
          const selectedText = selection.anchor.getNode().getTextContent();
          if (selectedText.length <= 1) {
            event.preventDefault();
            dispatchCommand(editor, DELETE_CHARACTER_COMMAND, true);
          }
        } else {
          $setCompositionKey(null);
          event.preventDefault();
          dispatchCommand(editor, DELETE_CHARACTER_COMMAND, true);
        }
        return;
      }
    }
    if (!$isRangeSelection(selection)) {
      return;
    }
    const data = event.data;

    // This represents the case when two beforeinput events are triggered at the same time (without a
    // full event loop ending at input). This happens with MacOS with the default keyboard settings,
    // a combination of autocorrection + autocapitalization.
    // Having Lexical run everything in controlled mode would fix the issue without additional code
    // but this would kill the massive performance win from the most common typing event.
    // Alternatively, when this happens we can prematurely update our EditorState based on the DOM
    // content, a job that would usually be the input event's responsibility.
    if (unprocessedBeforeInputData !== null) {
      $updateSelectedTextFromDOM(false, editor, unprocessedBeforeInputData);
    }
    if ((!selection.dirty || unprocessedBeforeInputData !== null) && selection.isCollapsed() && !$isRootNode(selection.anchor.getNode()) && targetRange !== null) {
      selection.applyDOMRange(targetRange);
    }
    unprocessedBeforeInputData = null;
    const anchor = selection.anchor;
    const focus = selection.focus;
    const anchorNode = anchor.getNode();
    const focusNode = focus.getNode();
    if (inputType === 'insertText' || inputType === 'insertTranspose') {
      if (data === '\n') {
        event.preventDefault();
        dispatchCommand(editor, INSERT_LINE_BREAK_COMMAND, false);
      } else if (data === DOUBLE_LINE_BREAK) {
        event.preventDefault();
        dispatchCommand(editor, INSERT_PARAGRAPH_COMMAND, undefined);
      } else if (data == null && event.dataTransfer) {
        // Gets around a Safari text replacement bug.
        const text = event.dataTransfer.getData('text/plain');
        event.preventDefault();
        selection.insertRawText(text);
      } else if (data != null && $shouldPreventDefaultAndInsertText(selection, targetRange, data, event.timeStamp, true)) {
        event.preventDefault();
        dispatchCommand(editor, CONTROLLED_TEXT_INSERTION_COMMAND, data);
      } else {
        unprocessedBeforeInputData = data;
      }
      lastBeforeInputInsertTextTimeStamp = event.timeStamp;
      return;
    }

    // Prevent the browser from carrying out
    // the input event, so we can control the
    // output.
    event.preventDefault();
    switch (inputType) {
      case 'insertFromYank':
      case 'insertFromDrop':
      case 'insertReplacementText':
        {
          dispatchCommand(editor, CONTROLLED_TEXT_INSERTION_COMMAND, event);
          break;
        }
      case 'insertFromComposition':
        {
          // This is the end of composition
          $setCompositionKey(null);
          dispatchCommand(editor, CONTROLLED_TEXT_INSERTION_COMMAND, event);
          break;
        }
      case 'insertLineBreak':
        {
          // Used for Android
          $setCompositionKey(null);
          dispatchCommand(editor, INSERT_LINE_BREAK_COMMAND, false);
          break;
        }
      case 'insertParagraph':
        {
          // Used for Android
          $setCompositionKey(null);

          // Safari does not provide the type "insertLineBreak".
          // So instead, we need to infer it from the keyboard event.
          // We do not apply this logic to iOS to allow newline auto-capitalization
          // work without creating linebreaks when pressing Enter
          if (isInsertLineBreak && !IS_IOS) {
            isInsertLineBreak = false;
            dispatchCommand(editor, INSERT_LINE_BREAK_COMMAND, false);
          } else {
            dispatchCommand(editor, INSERT_PARAGRAPH_COMMAND, undefined);
          }
          break;
        }
      case 'insertFromPaste':
      case 'insertFromPasteAsQuotation':
        {
          dispatchCommand(editor, PASTE_COMMAND, event);
          break;
        }
      case 'deleteByComposition':
        {
          if ($canRemoveText(anchorNode, focusNode)) {
            dispatchCommand(editor, REMOVE_TEXT_COMMAND, event);
          }
          break;
        }
      case 'deleteByDrag':
      case 'deleteByCut':
        {
          dispatchCommand(editor, REMOVE_TEXT_COMMAND, event);
          break;
        }
      case 'deleteContent':
        {
          dispatchCommand(editor, DELETE_CHARACTER_COMMAND, false);
          break;
        }
      case 'deleteWordBackward':
        {
          dispatchCommand(editor, DELETE_WORD_COMMAND, true);
          break;
        }
      case 'deleteWordForward':
        {
          dispatchCommand(editor, DELETE_WORD_COMMAND, false);
          break;
        }
      case 'deleteHardLineBackward':
      case 'deleteSoftLineBackward':
        {
          dispatchCommand(editor, DELETE_LINE_COMMAND, true);
          break;
        }
      case 'deleteContentForward':
      case 'deleteHardLineForward':
      case 'deleteSoftLineForward':
        {
          dispatchCommand(editor, DELETE_LINE_COMMAND, false);
          break;
        }
      case 'formatStrikeThrough':
        {
          dispatchCommand(editor, FORMAT_TEXT_COMMAND, 'strikethrough');
          break;
        }
      case 'formatBold':
        {
          dispatchCommand(editor, FORMAT_TEXT_COMMAND, 'bold');
          break;
        }
      case 'formatItalic':
        {
          dispatchCommand(editor, FORMAT_TEXT_COMMAND, 'italic');
          break;
        }
      case 'formatUnderline':
        {
          dispatchCommand(editor, FORMAT_TEXT_COMMAND, 'underline');
          break;
        }
      case 'historyUndo':
        {
          dispatchCommand(editor, UNDO_COMMAND, undefined);
          break;
        }
      case 'historyRedo':
        {
          dispatchCommand(editor, REDO_COMMAND, undefined);
          break;
        }
      // NO-OP
    }
  });
}

function onInput(event, editor) {
  // We don't want the onInput to bubble, in the case of nested editors.
  event.stopPropagation();
  updateEditor(editor, () => {
    const selection = $getSelection();
    const data = event.data;
    const targetRange = getTargetRange(event);
    if (data != null && $isRangeSelection(selection) && $shouldPreventDefaultAndInsertText(selection, targetRange, data, event.timeStamp, false)) {
      // Given we're over-riding the default behavior, we will need
      // to ensure to disable composition before dispatching the
      // insertText command for when changing the sequence for FF.
      if (isFirefoxEndingComposition) {
        onCompositionEndImpl(editor, data);
        isFirefoxEndingComposition = false;
      }
      const anchor = selection.anchor;
      const anchorNode = anchor.getNode();
      const domSelection = getDOMSelection(editor._window);
      if (domSelection === null) {
        return;
      }
      const offset = anchor.offset;
      // If the content is the same as inserted, then don't dispatch an insertion.
      // Given onInput doesn't take the current selection (it uses the previous)
      // we can compare that against what the DOM currently says.
      if (!CAN_USE_BEFORE_INPUT || selection.isCollapsed() || !$isTextNode(anchorNode) || domSelection.anchorNode === null || anchorNode.getTextContent().slice(0, offset) + data + anchorNode.getTextContent().slice(offset + selection.focus.offset) !== getAnchorTextFromDOM(domSelection.anchorNode)) {
        dispatchCommand(editor, CONTROLLED_TEXT_INSERTION_COMMAND, data);
      }
      const textLength = data.length;

      // Another hack for FF, as it's possible that the IME is still
      // open, even though compositionend has already fired (sigh).
      if (IS_FIREFOX && textLength > 1 && event.inputType === 'insertCompositionText' && !editor.isComposing()) {
        selection.anchor.offset -= textLength;
      }

      // This ensures consistency on Android.
      if (!IS_SAFARI && !IS_IOS && !IS_APPLE_WEBKIT && editor.isComposing()) {
        lastKeyDownTimeStamp = 0;
        $setCompositionKey(null);
      }
    } else {
      const characterData = data !== null ? data : undefined;
      $updateSelectedTextFromDOM(false, editor, characterData);

      // onInput always fires after onCompositionEnd for FF.
      if (isFirefoxEndingComposition) {
        onCompositionEndImpl(editor, data || undefined);
        isFirefoxEndingComposition = false;
      }
    }

    // Also flush any other mutations that might have occurred
    // since the change.
    $flushMutations();
  });
  unprocessedBeforeInputData = null;
}
function onCompositionStart(event, editor) {
  updateEditor(editor, () => {
    const selection = $getSelection();
    if ($isRangeSelection(selection) && !editor.isComposing()) {
      const anchor = selection.anchor;
      const node = selection.anchor.getNode();
      $setCompositionKey(anchor.key);
      if (
      // If it has been 30ms since the last keydown, then we should
      // apply the empty space heuristic. We can't do this for Safari,
      // as the keydown fires after composition start.
      event.timeStamp < lastKeyDownTimeStamp + ANDROID_COMPOSITION_LATENCY ||
      // FF has issues around composing multibyte characters, so we also
      // need to invoke the empty space heuristic below.
      anchor.type === 'element' || !selection.isCollapsed() || node.getFormat() !== selection.format || $isTextNode(node) && node.getStyle() !== selection.style) {
        // We insert a zero width character, ready for the composition
        // to get inserted into the new node we create. If
        // we don't do this, Safari will fail on us because
        // there is no text node matching the selection.
        dispatchCommand(editor, CONTROLLED_TEXT_INSERTION_COMMAND, COMPOSITION_START_CHAR);
      }
    }
  });
}
function onCompositionEndImpl(editor, data) {
  const compositionKey = editor._compositionKey;
  $setCompositionKey(null);

  // Handle termination of composition.
  if (compositionKey !== null && data != null) {
    // Composition can sometimes move to an adjacent DOM node when backspacing.
    // So check for the empty case.
    if (data === '') {
      const node = $getNodeByKey(compositionKey);
      const textNode = getDOMTextNode(editor.getElementByKey(compositionKey));
      if (textNode !== null && textNode.nodeValue !== null && $isTextNode(node)) {
        $updateTextNodeFromDOMContent(node, textNode.nodeValue, null, null, true);
      }
      return;
    }

    // Composition can sometimes be that of a new line. In which case, we need to
    // handle that accordingly.
    if (data[data.length - 1] === '\n') {
      const selection = $getSelection();
      if ($isRangeSelection(selection)) {
        // If the last character is a line break, we also need to insert
        // a line break.
        const focus = selection.focus;
        selection.anchor.set(focus.key, focus.offset, focus.type);
        dispatchCommand(editor, KEY_ENTER_COMMAND, null);
        return;
      }
    }
  }
  $updateSelectedTextFromDOM(true, editor, data);
}
function onCompositionEnd(event, editor) {
  // Firefox fires onCompositionEnd before onInput, but Chrome/Webkit,
  // fire onInput before onCompositionEnd. To ensure the sequence works
  // like Chrome/Webkit we use the isFirefoxEndingComposition flag to
  // defer handling of onCompositionEnd in Firefox till we have processed
  // the logic in onInput.
  if (IS_FIREFOX) {
    isFirefoxEndingComposition = true;
  } else {
    updateEditor(editor, () => {
      onCompositionEndImpl(editor, event.data);
    });
  }
}
function onKeyDown(event, editor) {
  lastKeyDownTimeStamp = event.timeStamp;
  lastKeyCode = event.keyCode;
  if (editor.isComposing()) {
    return;
  }
  const {
    keyCode,
    shiftKey,
    ctrlKey,
    metaKey,
    altKey
  } = event;
  if (dispatchCommand(editor, KEY_DOWN_COMMAND, event)) {
    return;
  }
  if (isMoveForward(keyCode, ctrlKey, altKey, metaKey)) {
    dispatchCommand(editor, KEY_ARROW_RIGHT_COMMAND, event);
  } else if (isMoveToEnd(keyCode, ctrlKey, shiftKey, altKey, metaKey)) {
    dispatchCommand(editor, MOVE_TO_END, event);
  } else if (isMoveBackward(keyCode, ctrlKey, altKey, metaKey)) {
    dispatchCommand(editor, KEY_ARROW_LEFT_COMMAND, event);
  } else if (isMoveToStart(keyCode, ctrlKey, shiftKey, altKey, metaKey)) {
    dispatchCommand(editor, MOVE_TO_START, event);
  } else if (isMoveUp(keyCode, ctrlKey, metaKey)) {
    dispatchCommand(editor, KEY_ARROW_UP_COMMAND, event);
  } else if (isMoveDown(keyCode, ctrlKey, metaKey)) {
    dispatchCommand(editor, KEY_ARROW_DOWN_COMMAND, event);
  } else if (isLineBreak(keyCode, shiftKey)) {
    isInsertLineBreak = true;
    dispatchCommand(editor, KEY_ENTER_COMMAND, event);
  } else if (isSpace(keyCode)) {
    dispatchCommand(editor, KEY_SPACE_COMMAND, event);
  } else if (isOpenLineBreak(keyCode, ctrlKey)) {
    event.preventDefault();
    isInsertLineBreak = true;
    dispatchCommand(editor, INSERT_LINE_BREAK_COMMAND, true);
  } else if (isParagraph(keyCode, shiftKey)) {
    isInsertLineBreak = false;
    dispatchCommand(editor, KEY_ENTER_COMMAND, event);
  } else if (isDeleteBackward(keyCode, altKey, metaKey, ctrlKey)) {
    if (isBackspace(keyCode)) {
      dispatchCommand(editor, KEY_BACKSPACE_COMMAND, event);
    } else {
      event.preventDefault();
      dispatchCommand(editor, DELETE_CHARACTER_COMMAND, true);
    }
  } else if (isEscape(keyCode)) {
    dispatchCommand(editor, KEY_ESCAPE_COMMAND, event);
  } else if (isDeleteForward(keyCode, ctrlKey, shiftKey, altKey, metaKey)) {
    if (isDelete(keyCode)) {
      dispatchCommand(editor, KEY_DELETE_COMMAND, event);
    } else {
      event.preventDefault();
      dispatchCommand(editor, DELETE_CHARACTER_COMMAND, false);
    }
  } else if (isDeleteWordBackward(keyCode, altKey, ctrlKey)) {
    event.preventDefault();
    dispatchCommand(editor, DELETE_WORD_COMMAND, true);
  } else if (isDeleteWordForward(keyCode, altKey, ctrlKey)) {
    event.preventDefault();
    dispatchCommand(editor, DELETE_WORD_COMMAND, false);
  } else if (isDeleteLineBackward(keyCode, metaKey)) {
    event.preventDefault();
    dispatchCommand(editor, DELETE_LINE_COMMAND, true);
  } else if (isDeleteLineForward(keyCode, metaKey)) {
    event.preventDefault();
    dispatchCommand(editor, DELETE_LINE_COMMAND, false);
  } else if (isBold(keyCode, altKey, metaKey, ctrlKey)) {
    event.preventDefault();
    dispatchCommand(editor, FORMAT_TEXT_COMMAND, 'bold');
  } else if (isUnderline(keyCode, altKey, metaKey, ctrlKey)) {
    event.preventDefault();
    dispatchCommand(editor, FORMAT_TEXT_COMMAND, 'underline');
  } else if (isItalic(keyCode, altKey, metaKey, ctrlKey)) {
    event.preventDefault();
    dispatchCommand(editor, FORMAT_TEXT_COMMAND, 'italic');
  } else if (isTab(keyCode, altKey, ctrlKey, metaKey)) {
    dispatchCommand(editor, KEY_TAB_COMMAND, event);
  } else if (isUndo(keyCode, shiftKey, metaKey, ctrlKey)) {
    event.preventDefault();
    dispatchCommand(editor, UNDO_COMMAND, undefined);
  } else if (isRedo(keyCode, shiftKey, metaKey, ctrlKey)) {
    event.preventDefault();
    dispatchCommand(editor, REDO_COMMAND, undefined);
  } else {
    const prevSelection = editor._editorState._selection;
    if ($isNodeSelection(prevSelection)) {
      if (isCopy(keyCode, shiftKey, metaKey, ctrlKey)) {
        event.preventDefault();
        dispatchCommand(editor, COPY_COMMAND, event);
      } else if (isCut(keyCode, shiftKey, metaKey, ctrlKey)) {
        event.preventDefault();
        dispatchCommand(editor, CUT_COMMAND, event);
      } else if (isSelectAll(keyCode, metaKey, ctrlKey)) {
        event.preventDefault();
        dispatchCommand(editor, SELECT_ALL_COMMAND, event);
      }
      // FF does it well (no need to override behavior)
    } else if (!IS_FIREFOX && isSelectAll(keyCode, metaKey, ctrlKey)) {
      event.preventDefault();
      dispatchCommand(editor, SELECT_ALL_COMMAND, event);
    }
  }
  if (isModifier(ctrlKey, shiftKey, altKey, metaKey)) {
    dispatchCommand(editor, KEY_MODIFIER_COMMAND, event);
  }
}
function getRootElementRemoveHandles(rootElement) {
  // @ts-expect-error: internal field
  let eventHandles = rootElement.__lexicalEventHandles;
  if (eventHandles === undefined) {
    eventHandles = [];
    // @ts-expect-error: internal field
    rootElement.__lexicalEventHandles = eventHandles;
  }
  return eventHandles;
}

// Mapping root editors to their active nested editors, contains nested editors
// mapping only, so if root editor is selected map will have no reference to free up memory
const activeNestedEditorsMap = new Map();
function onDocumentSelectionChange(event) {
  const target = event.target;
  const targetWindow = target == null ? null : target.nodeType === 9 ? target.defaultView : target.ownerDocument.defaultView;
  const domSelection = getDOMSelection(targetWindow);
  if (domSelection === null) {
    return;
  }
  const nextActiveEditor = getNearestEditorFromDOMNode(domSelection.anchorNode);
  if (nextActiveEditor === null) {
    return;
  }
  if (isSelectionChangeFromMouseDown) {
    isSelectionChangeFromMouseDown = false;
    updateEditor(nextActiveEditor, () => {
      const lastSelection = $getPreviousSelection();
      const domAnchorNode = domSelection.anchorNode;
      if (domAnchorNode === null) {
        return;
      }
      const nodeType = domAnchorNode.nodeType;
      // If the user is attempting to click selection back onto text, then
      // we should attempt create a range selection.
      // When we click on an empty paragraph node or the end of a paragraph that ends
      // with an image/poll, the nodeType will be ELEMENT_NODE
      if (nodeType !== DOM_ELEMENT_TYPE && nodeType !== DOM_TEXT_TYPE) {
        return;
      }
      const newSelection = internalCreateRangeSelection(lastSelection, domSelection, nextActiveEditor, event);
      $setSelection(newSelection);
    });
  }

  // When editor receives selection change event, we're checking if
  // it has any sibling editors (within same parent editor) that were active
  // before, and trigger selection change on it to nullify selection.
  const editors = getEditorsToPropagate(nextActiveEditor);
  const rootEditor = editors[editors.length - 1];
  const rootEditorKey = rootEditor._key;
  const activeNestedEditor = activeNestedEditorsMap.get(rootEditorKey);
  const prevActiveEditor = activeNestedEditor || rootEditor;
  if (prevActiveEditor !== nextActiveEditor) {
    onSelectionChange(domSelection, prevActiveEditor, false);
  }
  onSelectionChange(domSelection, nextActiveEditor, true);

  // If newly selected editor is nested, then add it to the map, clean map otherwise
  if (nextActiveEditor !== rootEditor) {
    activeNestedEditorsMap.set(rootEditorKey, nextActiveEditor);
  } else if (activeNestedEditor) {
    activeNestedEditorsMap.delete(rootEditorKey);
  }
}
function stopLexicalPropagation(event) {
  // We attach a special property to ensure the same event doesn't re-fire
  // for parent editors.
  // @ts-ignore
  event._lexicalHandled = true;
}
function hasStoppedLexicalPropagation(event) {
  // @ts-ignore
  const stopped = event._lexicalHandled === true;
  return stopped;
}
function addRootElementEvents(rootElement, editor) {
  // We only want to have a single global selectionchange event handler, shared
  // between all editor instances.
  if (rootElementsRegistered === 0) {
    const doc = rootElement.ownerDocument;
    doc.addEventListener('selectionchange', onDocumentSelectionChange);
  }
  rootElementsRegistered++;
  // @ts-expect-error: internal field
  rootElement.__lexicalEditor = editor;
  const removeHandles = getRootElementRemoveHandles(rootElement);
  for (let i = 0; i < rootElementEvents.length; i++) {
    const [eventName, onEvent] = rootElementEvents[i];
    const eventHandler = typeof onEvent === 'function' ? event => {
      if (hasStoppedLexicalPropagation(event)) {
        return;
      }
      stopLexicalPropagation(event);
      if (editor.isEditable()) {
        onEvent(event, editor);
      }
    } : event => {
      if (hasStoppedLexicalPropagation(event)) {
        return;
      }
      stopLexicalPropagation(event);
      if (editor.isEditable()) {
        switch (eventName) {
          case 'cut':
            return dispatchCommand(editor, CUT_COMMAND, event);
          case 'copy':
            return dispatchCommand(editor, COPY_COMMAND, event);
          case 'paste':
            return dispatchCommand(editor, PASTE_COMMAND, event);
          case 'dragstart':
            return dispatchCommand(editor, DRAGSTART_COMMAND, event);
          case 'dragover':
            return dispatchCommand(editor, DRAGOVER_COMMAND, event);
          case 'dragend':
            return dispatchCommand(editor, DRAGEND_COMMAND, event);
          case 'focus':
            return dispatchCommand(editor, FOCUS_COMMAND, event);
          case 'blur':
            {
              return dispatchCommand(editor, BLUR_COMMAND, event);
            }
          case 'drop':
            return dispatchCommand(editor, DROP_COMMAND, event);
        }
      }
    };
    rootElement.addEventListener(eventName, eventHandler);
    removeHandles.push(() => {
      rootElement.removeEventListener(eventName, eventHandler);
    });
  }
}
function removeRootElementEvents(rootElement) {
  if (rootElementsRegistered !== 0) {
    rootElementsRegistered--;

    // We only want to have a single global selectionchange event handler, shared
    // between all editor instances.
    if (rootElementsRegistered === 0) {
      const doc = rootElement.ownerDocument;
      doc.removeEventListener('selectionchange', onDocumentSelectionChange);
    }
  }

  // @ts-expect-error: internal field
  const editor = rootElement.__lexicalEditor;
  if (editor !== null && editor !== undefined) {
    cleanActiveNestedEditorsMap(editor);
    // @ts-expect-error: internal field
    rootElement.__lexicalEditor = null;
  }
  const removeHandles = getRootElementRemoveHandles(rootElement);
  for (let i = 0; i < removeHandles.length; i++) {
    removeHandles[i]();
  }

  // @ts-expect-error: internal field
  rootElement.__lexicalEventHandles = [];
}
function cleanActiveNestedEditorsMap(editor) {
  if (editor._parentEditor !== null) {
    // For nested editor cleanup map if this editor was marked as active
    const editors = getEditorsToPropagate(editor);
    const rootEditor = editors[editors.length - 1];
    const rootEditorKey = rootEditor._key;
    if (activeNestedEditorsMap.get(rootEditorKey) === editor) {
      activeNestedEditorsMap.delete(rootEditorKey);
    }
  } else {
    // For top-level editors cleanup map
    activeNestedEditorsMap.delete(editor._key);
  }
}
function markSelectionChangeFromDOMUpdate() {
  isSelectionChangeFromDOMUpdate = true;
}
function markCollapsedSelectionFormat(format, style, offset, key, timeStamp) {
  collapsedSelectionFormat = [format, style, offset, key, timeStamp];
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
function removeNode(nodeToRemove, restoreSelection, preserveEmptyParent) {
  errorOnReadOnly();
  const key = nodeToRemove.__key;
  const parent = nodeToRemove.getParent();
  if (parent === null) {
    return;
  }
  const selection = $maybeMoveChildrenSelectionToParent(nodeToRemove);
  let selectionMoved = false;
  if ($isRangeSelection(selection) && restoreSelection) {
    const anchor = selection.anchor;
    const focus = selection.focus;
    if (anchor.key === key) {
      moveSelectionPointToSibling(anchor, nodeToRemove, parent, nodeToRemove.getPreviousSibling(), nodeToRemove.getNextSibling());
      selectionMoved = true;
    }
    if (focus.key === key) {
      moveSelectionPointToSibling(focus, nodeToRemove, parent, nodeToRemove.getPreviousSibling(), nodeToRemove.getNextSibling());
      selectionMoved = true;
    }
  } else if ($isNodeSelection(selection) && restoreSelection && nodeToRemove.isSelected()) {
    nodeToRemove.selectPrevious();
  }
  if ($isRangeSelection(selection) && restoreSelection && !selectionMoved) {
    // Doing this is O(n) so lets avoid it unless we need to do it
    const index = nodeToRemove.getIndexWithinParent();
    removeFromParent(nodeToRemove);
    $updateElementSelectionOnCreateDeleteNode(selection, parent, index, -1);
  } else {
    removeFromParent(nodeToRemove);
  }
  if (!preserveEmptyParent && !$isRootOrShadowRoot(parent) && !parent.canBeEmpty() && parent.isEmpty()) {
    removeNode(parent, restoreSelection);
  }
  if (restoreSelection && $isRootNode(parent) && parent.isEmpty()) {
    parent.selectEnd();
  }
}
class LexicalNode {
  // Allow us to look up the type including static props

  /** @internal */

  /** @internal */ //@ts-ignore We set the key in the constructor.
  /** @internal */
  /** @internal */
  /** @internal */
  // Flow doesn't support abstract classes unfortunately, so we can't _force_
  // subclasses of Node to implement statics. All subclasses of Node should have
  // a static getType and clone method though. We define getType and clone here so we can call it
  // on any  Node, and we throw this error by default since the subclass should provide
  // their own implementation.
  /**
   * Returns the string type of this node. Every node must
   * implement this and it MUST BE UNIQUE amongst nodes registered
   * on the editor.
   *
   */
  static getType() {
    {
      throw Error(`LexicalNode: Node ${this.name} does not implement .getType().`);
    }
  }

  /**
   * Clones this node, creating a new node with a different key
   * and adding it to the EditorState (but not attaching it anywhere!). All nodes must
   * implement this method.
   *
   */
  static clone(_data) {
    {
      throw Error(`LexicalNode: Node ${this.name} does not implement .clone().`);
    }
  }

  // eslint-disable-next-line @typescript-eslint/no-explicit-any

  constructor(key) {
    this.__type = this.constructor.getType();
    this.__parent = null;
    this.__prev = null;
    this.__next = null;
    $setNodeKey(this, key);
    {
      if (this.__type !== 'root') {
        errorOnReadOnly();
        errorOnTypeKlassMismatch(this.__type, this.constructor);
      }
    }
  }
  // Getters and Traversers

  /**
   * Returns the string type of this node.
   */
  getType() {
    return this.__type;
  }
  isInline() {
    {
      throw Error(`LexicalNode: Node ${this.constructor.name} does not implement .isInline().`);
    }
  }

  /**
   * Returns true if there is a path between this node and the RootNode, false otherwise.
   * This is a way of determining if the node is "attached" EditorState. Unattached nodes
   * won't be reconciled and will ultimatelt be cleaned up by the Lexical GC.
   */
  isAttached() {
    let nodeKey = this.__key;
    while (nodeKey !== null) {
      if (nodeKey === 'root') {
        return true;
      }
      const node = $getNodeByKey(nodeKey);
      if (node === null) {
        break;
      }
      nodeKey = node.__parent;
    }
    return false;
  }

  /**
   * Returns true if this node is contained within the provided Selection., false otherwise.
   * Relies on the algorithms implemented in {@link BaseSelection.getNodes} to determine
   * what's included.
   *
   * @param selection - The selection that we want to determine if the node is in.
   */
  isSelected(selection) {
    const targetSelection = selection || $getSelection();
    if (targetSelection == null) {
      return false;
    }
    const isSelected = targetSelection.getNodes().some(n => n.__key === this.__key);
    if ($isTextNode(this)) {
      return isSelected;
    }
    // For inline images inside of element nodes.
    // Without this change the image will be selected if the cursor is before or after it.
    if ($isRangeSelection(targetSelection) && targetSelection.anchor.type === 'element' && targetSelection.focus.type === 'element' && targetSelection.anchor.key === targetSelection.focus.key && targetSelection.anchor.offset === targetSelection.focus.offset) {
      return false;
    }
    return isSelected;
  }

  /**
   * Returns this nodes key.
   */
  getKey() {
    // Key is stable between copies
    return this.__key;
  }

  /**
   * Returns the zero-based index of this node within the parent.
   */
  getIndexWithinParent() {
    const parent = this.getParent();
    if (parent === null) {
      return -1;
    }
    let node = parent.getFirstChild();
    let index = 0;
    while (node !== null) {
      if (this.is(node)) {
        return index;
      }
      index++;
      node = node.getNextSibling();
    }
    return -1;
  }

  /**
   * Returns the parent of this node, or null if none is found.
   */
  getParent() {
    const parent = this.getLatest().__parent;
    if (parent === null) {
      return null;
    }
    return $getNodeByKey(parent);
  }

  /**
   * Returns the parent of this node, or throws if none is found.
   */
  getParentOrThrow() {
    const parent = this.getParent();
    if (parent === null) {
      {
        throw Error(`Expected node ${this.__key} to have a parent.`);
      }
    }
    return parent;
  }

  /**
   * Returns the highest (in the EditorState tree)
   * non-root ancestor of this node, or null if none is found. See {@link lexical!$isRootOrShadowRoot}
   * for more information on which Elements comprise "roots".
   */
  getTopLevelElement() {
    let node = this;
    while (node !== null) {
      const parent = node.getParent();
      if ($isRootOrShadowRoot(parent)) {
        if (!$isElementNode(node)) {
          throw Error(`Children of root nodes must be elements`);
        }
        return node;
      }
      node = parent;
    }
    return null;
  }

  /**
   * Returns the highest (in the EditorState tree)
   * non-root ancestor of this node, or throws if none is found. See {@link lexical!$isRootOrShadowRoot}
   * for more information on which Elements comprise "roots".
   */
  getTopLevelElementOrThrow() {
    const parent = this.getTopLevelElement();
    if (parent === null) {
      {
        throw Error(`Expected node ${this.__key} to have a top parent element.`);
      }
    }
    return parent;
  }

  /**
   * Returns a list of the every ancestor of this node,
   * all the way up to the RootNode.
   *
   */
  getParents() {
    const parents = [];
    let node = this.getParent();
    while (node !== null) {
      parents.push(node);
      node = node.getParent();
    }
    return parents;
  }

  /**
   * Returns a list of the keys of every ancestor of this node,
   * all the way up to the RootNode.
   *
   */
  getParentKeys() {
    const parents = [];
    let node = this.getParent();
    while (node !== null) {
      parents.push(node.__key);
      node = node.getParent();
    }
    return parents;
  }

  /**
   * Returns the "previous" siblings - that is, the node that comes
   * before this one in the same parent.
   *
   */
  getPreviousSibling() {
    const self = this.getLatest();
    const prevKey = self.__prev;
    return prevKey === null ? null : $getNodeByKey(prevKey);
  }

  /**
   * Returns the "previous" siblings - that is, the nodes that come between
   * this one and the first child of it's parent, inclusive.
   *
   */
  getPreviousSiblings() {
    const siblings = [];
    const parent = this.getParent();
    if (parent === null) {
      return siblings;
    }
    let node = parent.getFirstChild();
    while (node !== null) {
      if (node.is(this)) {
        break;
      }
      siblings.push(node);
      node = node.getNextSibling();
    }
    return siblings;
  }

  /**
   * Returns the "next" siblings - that is, the node that comes
   * after this one in the same parent
   *
   */
  getNextSibling() {
    const self = this.getLatest();
    const nextKey = self.__next;
    return nextKey === null ? null : $getNodeByKey(nextKey);
  }

  /**
   * Returns all "next" siblings - that is, the nodes that come between this
   * one and the last child of it's parent, inclusive.
   *
   */
  getNextSiblings() {
    const siblings = [];
    let node = this.getNextSibling();
    while (node !== null) {
      siblings.push(node);
      node = node.getNextSibling();
    }
    return siblings;
  }

  /**
   * Returns the closest common ancestor of this node and the provided one or null
   * if one cannot be found.
   *
   * @param node - the other node to find the common ancestor of.
   */
  getCommonAncestor(node) {
    const a = this.getParents();
    const b = node.getParents();
    if ($isElementNode(this)) {
      a.unshift(this);
    }
    if ($isElementNode(node)) {
      b.unshift(node);
    }
    const aLength = a.length;
    const bLength = b.length;
    if (aLength === 0 || bLength === 0 || a[aLength - 1] !== b[bLength - 1]) {
      return null;
    }
    const bSet = new Set(b);
    for (let i = 0; i < aLength; i++) {
      const ancestor = a[i];
      if (bSet.has(ancestor)) {
        return ancestor;
      }
    }
    return null;
  }

  /**
   * Returns true if the provided node is the exact same one as this node, from Lexical's perspective.
   * Always use this instead of referential equality.
   *
   * @param object - the node to perform the equality comparison on.
   */
  is(object) {
    if (object == null) {
      return false;
    }
    return this.__key === object.__key;
  }

  /**
   * Returns true if this node logical precedes the target node in the editor state.
   *
   * @param targetNode - the node we're testing to see if it's after this one.
   */
  isBefore(targetNode) {
    if (this === targetNode) {
      return false;
    }
    if (targetNode.isParentOf(this)) {
      return true;
    }
    if (this.isParentOf(targetNode)) {
      return false;
    }
    const commonAncestor = this.getCommonAncestor(targetNode);
    let indexA = 0;
    let indexB = 0;
    let node = this;
    while (true) {
      const parent = node.getParentOrThrow();
      if (parent === commonAncestor) {
        indexA = node.getIndexWithinParent();
        break;
      }
      node = parent;
    }
    node = targetNode;
    while (true) {
      const parent = node.getParentOrThrow();
      if (parent === commonAncestor) {
        indexB = node.getIndexWithinParent();
        break;
      }
      node = parent;
    }
    return indexA < indexB;
  }

  /**
   * Returns true if this node is the parent of the target node, false otherwise.
   *
   * @param targetNode - the would-be child node.
   */
  isParentOf(targetNode) {
    const key = this.__key;
    if (key === targetNode.__key) {
      return false;
    }
    let node = targetNode;
    while (node !== null) {
      if (node.__key === key) {
        return true;
      }
      node = node.getParent();
    }
    return false;
  }

  // TO-DO: this function can be simplified a lot
  /**
   * Returns a list of nodes that are between this node and
   * the target node in the EditorState.
   *
   * @param targetNode - the node that marks the other end of the range of nodes to be returned.
   */
  getNodesBetween(targetNode) {
    const isBefore = this.isBefore(targetNode);
    const nodes = [];
    const visited = new Set();
    let node = this;
    while (true) {
      const key = node.__key;
      if (!visited.has(key)) {
        visited.add(key);
        nodes.push(node);
      }
      if (node === targetNode) {
        break;
      }
      const child = $isElementNode(node) ? isBefore ? node.getFirstChild() : node.getLastChild() : null;
      if (child !== null) {
        node = child;
        continue;
      }
      const nextSibling = isBefore ? node.getNextSibling() : node.getPreviousSibling();
      if (nextSibling !== null) {
        node = nextSibling;
        continue;
      }
      const parent = node.getParentOrThrow();
      if (!visited.has(parent.__key)) {
        nodes.push(parent);
      }
      if (parent === targetNode) {
        break;
      }
      let parentSibling = null;
      let ancestor = parent;
      do {
        if (ancestor === null) {
          {
            throw Error(`getNodesBetween: ancestor is null`);
          }
        }
        parentSibling = isBefore ? ancestor.getNextSibling() : ancestor.getPreviousSibling();
        ancestor = ancestor.getParent();
        if (ancestor !== null) {
          if (parentSibling === null && !visited.has(ancestor.__key)) {
            nodes.push(ancestor);
          }
        }
      } while (parentSibling === null);
      node = parentSibling;
    }
    if (!isBefore) {
      nodes.reverse();
    }
    return nodes;
  }

  /**
   * Returns true if this node has been marked dirty during this update cycle.
   *
   */
  isDirty() {
    const editor = getActiveEditor();
    const dirtyLeaves = editor._dirtyLeaves;
    return dirtyLeaves !== null && dirtyLeaves.has(this.__key);
  }

  /**
   * Returns the latest version of the node from the active EditorState.
   * This is used to avoid getting values from stale node references.
   *
   */
  getLatest() {
    const latest = $getNodeByKey(this.__key);
    if (latest === null) {
      {
        throw Error(`Lexical node does not exist in active editor state. Avoid using the same node references between nested closures from editorState.read/editor.update.`);
      }
    }
    return latest;
  }

  /**
   * Returns a mutable version of the node. Will throw an error if
   * called outside of a Lexical Editor {@link LexicalEditor.update} callback.
   *
   */
  getWritable() {
    errorOnReadOnly();
    const editorState = getActiveEditorState();
    const editor = getActiveEditor();
    const nodeMap = editorState._nodeMap;
    const key = this.__key;
    // Ensure we get the latest node from pending state
    const latestNode = this.getLatest();
    const parent = latestNode.__parent;
    const cloneNotNeeded = editor._cloneNotNeeded;
    const selection = $getSelection();
    if (selection !== null) {
      selection.setCachedNodes(null);
    }
    if (cloneNotNeeded.has(key)) {
      // Transforms clear the dirty node set on each iteration to keep track on newly dirty nodes
      internalMarkNodeAsDirty(latestNode);
      return latestNode;
    }
    const constructor = latestNode.constructor;
    const mutableNode = constructor.clone(latestNode);
    mutableNode.__parent = parent;
    mutableNode.__next = latestNode.__next;
    mutableNode.__prev = latestNode.__prev;
    if ($isElementNode(latestNode) && $isElementNode(mutableNode)) {
      mutableNode.__first = latestNode.__first;
      mutableNode.__last = latestNode.__last;
      mutableNode.__size = latestNode.__size;
      mutableNode.__indent = latestNode.__indent;
      mutableNode.__format = latestNode.__format;
      mutableNode.__dir = latestNode.__dir;
    } else if ($isTextNode(latestNode) && $isTextNode(mutableNode)) {
      mutableNode.__format = latestNode.__format;
      mutableNode.__style = latestNode.__style;
      mutableNode.__mode = latestNode.__mode;
      mutableNode.__detail = latestNode.__detail;
    }
    cloneNotNeeded.add(key);
    mutableNode.__key = key;
    internalMarkNodeAsDirty(mutableNode);
    // Update reference in node map
    nodeMap.set(key, mutableNode);

    // @ts-expect-error
    return mutableNode;
  }

  /**
   * Returns the text content of the node. Override this for
   * custom nodes that should have a representation in plain text
   * format (for copy + paste, for example)
   *
   */
  getTextContent() {
    return '';
  }

  /**
   * Returns the length of the string produced by calling getTextContent on this node.
   *
   */
  getTextContentSize() {
    return this.getTextContent().length;
  }

  // View

  /**
   * Called during the reconciliation process to determine which nodes
   * to insert into the DOM for this Lexical Node.
   *
   * This method must return exactly one HTMLElement. Nested elements are not supported.
   *
   * Do not attempt to update the Lexical EditorState during this phase of the update lifecyle.
   *
   * @param _config - allows access to things like the EditorTheme (to apply classes) during reconciliation.
   * @param _editor - allows access to the editor for context during reconciliation.
   *
   * */
  createDOM(_config, _editor) {
    {
      throw Error(`createDOM: base method not extended`);
    }
  }

  /**
   * Called when a node changes and should update the DOM
   * in whatever way is necessary to make it align with any changes that might
   * have happened during the update.
   *
   * Returning "true" here will cause lexical to unmount and recreate the DOM node
   * (by calling createDOM). You would need to do this if the element tag changes,
   * for instance.
   *
   * */
  updateDOM(_prevNode, _dom, _config) {
    {
      throw Error(`updateDOM: base method not extended`);
    }
  }

  /**
   * Controls how the this node is serialized to HTML. This is important for
   * copy and paste between Lexical and non-Lexical editors, or Lexical editors with different namespaces,
   * in which case the primary transfer format is HTML. It's also important if you're serializing
   * to HTML for any other reason via {@link @lexical/html!$generateHtmlFromNodes}. You could
   * also use this method to build your own HTML renderer.
   *
   * */
  exportDOM(editor) {
    const element = this.createDOM(editor._config, editor);
    return {
      element
    };
  }

  /**
   * Controls how the this node is serialized to JSON. This is important for
   * copy and paste between Lexical editors sharing the same namespace. It's also important
   * if you're serializing to JSON for persistent storage somewhere.
   * See [Serialization & Deserialization](https://lexical.dev/docs/concepts/serialization#lexical---html).
   *
   * */
  exportJSON() {
    {
      throw Error(`exportJSON: base method not extended`);
    }
  }

  /**
   * Controls how the this node is deserialized from JSON. This is usually boilerplate,
   * but provides an abstraction between the node implementation and serialized interface that can
   * be important if you ever make breaking changes to a node schema (by adding or removing properties).
   * See [Serialization & Deserialization](https://lexical.dev/docs/concepts/serialization#lexical---html).
   *
   * */
  static importJSON(_serializedNode) {
    {
      throw Error(`LexicalNode: Node ${this.name} does not implement .importJSON().`);
    }
  }
  /**
   * @experimental
   *
   * Registers the returned function as a transform on the node during
   * Editor initialization. Most such use cases should be addressed via
   * the {@link LexicalEditor.registerNodeTransform} API.
   *
   * Experimental - use at your own risk.
   */
  static transform() {
    return null;
  }

  // Setters and mutators

  /**
   * Removes this LexicalNode from the EditorState. If the node isn't re-inserted
   * somewhere, the Lexical garbage collector will eventually clean it up.
   *
   * @param preserveEmptyParent - If falsy, the node's parent will be removed if
   * it's empty after the removal operation. This is the default behavior, subject to
   * other node heuristics such as {@link ElementNode#canBeEmpty}
   * */
  remove(preserveEmptyParent) {
    removeNode(this, true, preserveEmptyParent);
  }

  /**
   * Replaces this LexicalNode with the provided node, optionally transferring the children
   * of the replaced node to the replacing node.
   *
   * @param replaceWith - The node to replace this one with.
   * @param includeChildren - Whether or not to transfer the children of this node to the replacing node.
   * */
  replace(replaceWith, includeChildren) {
    errorOnReadOnly();
    let selection = $getSelection();
    if (selection !== null) selection = selection.clone();
    errorOnInsertTextNodeOnRoot(this, replaceWith);
    const self = this.getLatest();
    const toReplaceKey = this.__key;
    const key = replaceWith.__key;
    const writableReplaceWith = replaceWith.getWritable();
    const writableParent = this.getParentOrThrow().getWritable();
    const size = writableParent.__size;
    removeFromParent(writableReplaceWith);
    const prevSibling = self.getPreviousSibling();
    const nextSibling = self.getNextSibling();
    const prevKey = self.__prev;
    const nextKey = self.__next;
    const parentKey = self.__parent;
    removeNode(self, false, true);
    if (prevSibling === null) {
      writableParent.__first = key;
    } else {
      const writablePrevSibling = prevSibling.getWritable();
      writablePrevSibling.__next = key;
    }
    writableReplaceWith.__prev = prevKey;
    if (nextSibling === null) {
      writableParent.__last = key;
    } else {
      const writableNextSibling = nextSibling.getWritable();
      writableNextSibling.__prev = key;
    }
    writableReplaceWith.__next = nextKey;
    writableReplaceWith.__parent = parentKey;
    writableParent.__size = size;
    if (includeChildren) {
      if (!($isElementNode(this) && $isElementNode(writableReplaceWith))) {
        throw Error(`includeChildren should only be true for ElementNodes`);
      }
      this.getChildren().forEach(child => {
        writableReplaceWith.append(child);
      });
    }
    if ($isRangeSelection(selection)) {
      $setSelection(selection);
      const anchor = selection.anchor;
      const focus = selection.focus;
      if (anchor.key === toReplaceKey) {
        $moveSelectionPointToEnd(anchor, writableReplaceWith);
      }
      if (focus.key === toReplaceKey) {
        $moveSelectionPointToEnd(focus, writableReplaceWith);
      }
    }
    if ($getCompositionKey() === toReplaceKey) {
      $setCompositionKey(key);
    }
    return writableReplaceWith;
  }

  /**
   * Inserts a node after this LexicalNode (as the next sibling).
   *
   * @param nodeToInsert - The node to insert after this one.
   * @param restoreSelection - Whether or not to attempt to resolve the
   * selection to the appropriate place after the operation is complete.
   * */
  insertAfter(nodeToInsert, restoreSelection = true) {
    errorOnReadOnly();
    errorOnInsertTextNodeOnRoot(this, nodeToInsert);
    const writableSelf = this.getWritable();
    const writableNodeToInsert = nodeToInsert.getWritable();
    const oldParent = writableNodeToInsert.getParent();
    const selection = $getSelection();
    let elementAnchorSelectionOnNode = false;
    let elementFocusSelectionOnNode = false;
    if (oldParent !== null) {
      // TODO: this is O(n), can we improve?
      const oldIndex = nodeToInsert.getIndexWithinParent();
      removeFromParent(writableNodeToInsert);
      if ($isRangeSelection(selection)) {
        const oldParentKey = oldParent.__key;
        const anchor = selection.anchor;
        const focus = selection.focus;
        elementAnchorSelectionOnNode = anchor.type === 'element' && anchor.key === oldParentKey && anchor.offset === oldIndex + 1;
        elementFocusSelectionOnNode = focus.type === 'element' && focus.key === oldParentKey && focus.offset === oldIndex + 1;
      }
    }
    const nextSibling = this.getNextSibling();
    const writableParent = this.getParentOrThrow().getWritable();
    const insertKey = writableNodeToInsert.__key;
    const nextKey = writableSelf.__next;
    if (nextSibling === null) {
      writableParent.__last = insertKey;
    } else {
      const writableNextSibling = nextSibling.getWritable();
      writableNextSibling.__prev = insertKey;
    }
    writableParent.__size++;
    writableSelf.__next = insertKey;
    writableNodeToInsert.__next = nextKey;
    writableNodeToInsert.__prev = writableSelf.__key;
    writableNodeToInsert.__parent = writableSelf.__parent;
    if (restoreSelection && $isRangeSelection(selection)) {
      const index = this.getIndexWithinParent();
      $updateElementSelectionOnCreateDeleteNode(selection, writableParent, index + 1);
      const writableParentKey = writableParent.__key;
      if (elementAnchorSelectionOnNode) {
        selection.anchor.set(writableParentKey, index + 2, 'element');
      }
      if (elementFocusSelectionOnNode) {
        selection.focus.set(writableParentKey, index + 2, 'element');
      }
    }
    return nodeToInsert;
  }

  /**
   * Inserts a node before this LexicalNode (as the previous sibling).
   *
   * @param nodeToInsert - The node to insert before this one.
   * @param restoreSelection - Whether or not to attempt to resolve the
   * selection to the appropriate place after the operation is complete.
   * */
  insertBefore(nodeToInsert, restoreSelection = true) {
    errorOnReadOnly();
    errorOnInsertTextNodeOnRoot(this, nodeToInsert);
    const writableSelf = this.getWritable();
    const writableNodeToInsert = nodeToInsert.getWritable();
    const insertKey = writableNodeToInsert.__key;
    removeFromParent(writableNodeToInsert);
    const prevSibling = this.getPreviousSibling();
    const writableParent = this.getParentOrThrow().getWritable();
    const prevKey = writableSelf.__prev;
    // TODO: this is O(n), can we improve?
    const index = this.getIndexWithinParent();
    if (prevSibling === null) {
      writableParent.__first = insertKey;
    } else {
      const writablePrevSibling = prevSibling.getWritable();
      writablePrevSibling.__next = insertKey;
    }
    writableParent.__size++;
    writableSelf.__prev = insertKey;
    writableNodeToInsert.__prev = prevKey;
    writableNodeToInsert.__next = writableSelf.__key;
    writableNodeToInsert.__parent = writableSelf.__parent;
    const selection = $getSelection();
    if (restoreSelection && $isRangeSelection(selection)) {
      const parent = this.getParentOrThrow();
      $updateElementSelectionOnCreateDeleteNode(selection, parent, index);
    }
    return nodeToInsert;
  }

  /**
   * Whether or not this node has a required parent. Used during copy + paste operations
   * to normalize nodes that would otherwise be orphaned. For example, ListItemNodes without
   * a ListNode parent or TextNodes with a ParagraphNode parent.
   *
   * */
  isParentRequired() {
    return false;
  }

  /**
   * The creation logic for any required parent. Should be implemented if {@link isParentRequired} returns true.
   *
   * */
  createParentElementNode() {
    return $createParagraphNode();
  }
  selectStart() {
    return this.selectPrevious();
  }
  selectEnd() {
    return this.selectNext(0, 0);
  }

  /**
   * Moves selection to the previous sibling of this node, at the specified offsets.
   *
   * @param anchorOffset - The anchor offset for selection.
   * @param focusOffset -  The focus offset for selection
   * */
  selectPrevious(anchorOffset, focusOffset) {
    errorOnReadOnly();
    const prevSibling = this.getPreviousSibling();
    const parent = this.getParentOrThrow();
    if (prevSibling === null) {
      return parent.select(0, 0);
    }
    if ($isElementNode(prevSibling)) {
      return prevSibling.select();
    } else if (!$isTextNode(prevSibling)) {
      const index = prevSibling.getIndexWithinParent() + 1;
      return parent.select(index, index);
    }
    return prevSibling.select(anchorOffset, focusOffset);
  }

  /**
   * Moves selection to the next sibling of this node, at the specified offsets.
   *
   * @param anchorOffset - The anchor offset for selection.
   * @param focusOffset -  The focus offset for selection
   * */
  selectNext(anchorOffset, focusOffset) {
    errorOnReadOnly();
    const nextSibling = this.getNextSibling();
    const parent = this.getParentOrThrow();
    if (nextSibling === null) {
      return parent.select();
    }
    if ($isElementNode(nextSibling)) {
      return nextSibling.select(0, 0);
    } else if (!$isTextNode(nextSibling)) {
      const index = nextSibling.getIndexWithinParent();
      return parent.select(index, index);
    }
    return nextSibling.select(anchorOffset, focusOffset);
  }

  /**
   * Marks a node dirty, triggering transforms and
   * forcing it to be reconciled during the update cycle.
   *
   * */
  markDirty() {
    this.getWritable();
  }
}
function errorOnTypeKlassMismatch(type, klass) {
  const registeredNode = getActiveEditor()._nodes.get(type);
  // Common error - split in its own invariant
  if (registeredNode === undefined) {
    {
      throw Error(`Create node: Attempted to create node ${klass.name} that was not configured to be used on the editor.`);
    }
  }
  const editorKlass = registeredNode.klass;
  if (editorKlass !== klass) {
    {
      throw Error(`Create node: Type ${type} in node ${klass.name} does not match registered node ${editorKlass.name} with the same type`);
    }
  }
}

/**
 * Insert a series of nodes after this LexicalNode (as next siblings)
 *
 * @param firstToInsert - The first node to insert after this one.
 * @param lastToInsert - The last node to insert after this one. Must be a
 * later sibling of FirstNode. If not provided, it will be its last sibling.
 */
function insertRangeAfter(node, firstToInsert, lastToInsert) {
  const lastToInsert2 = lastToInsert || firstToInsert.getParentOrThrow().getLastChild();
  let current = firstToInsert;
  const nodesToInsert = [firstToInsert];
  while (current !== lastToInsert2) {
    if (!current.getNextSibling()) {
      {
        throw Error(`insertRangeAfter: lastToInsert must be a later sibling of firstToInsert`);
      }
    }
    current = current.getNextSibling();
    nodesToInsert.push(current);
  }
  let currentNode = node;
  for (const nodeToInsert of nodesToInsert) {
    currentNode = currentNode.insertAfter(nodeToInsert);
  }
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
/** @noInheritDoc */
class LineBreakNode extends LexicalNode {
  static getType() {
    return 'linebreak';
  }
  static clone(node) {
    return new LineBreakNode(node.__key);
  }
  constructor(key) {
    super(key);
  }
  getTextContent() {
    return '\n';
  }
  createDOM() {
    return document.createElement('br');
  }
  updateDOM() {
    return false;
  }
  static importDOM() {
    return {
      br: node => {
        if (isOnlyChild(node)) {
          return null;
        }
        return {
          conversion: convertLineBreakElement,
          priority: 0
        };
      }
    };
  }
  static importJSON(serializedLineBreakNode) {
    return $createLineBreakNode();
  }
  exportJSON() {
    return {
      type: 'linebreak',
      version: 1
    };
  }
}
function convertLineBreakElement(node) {
  return {
    node: $createLineBreakNode()
  };
}
function $createLineBreakNode() {
  return $applyNodeReplacement(new LineBreakNode());
}
function $isLineBreakNode(node) {
  return node instanceof LineBreakNode;
}
function isOnlyChild(node) {
  const parentElement = node.parentElement;
  if (parentElement !== null) {
    const firstChild = parentElement.firstChild;
    if (firstChild === node || firstChild.nextSibling === node && isWhitespaceDomTextNode(firstChild)) {
      const lastChild = parentElement.lastChild;
      if (lastChild === node || lastChild.previousSibling === node && isWhitespaceDomTextNode(lastChild)) {
        return true;
      }
    }
  }
  return false;
}
function isWhitespaceDomTextNode(node) {
  return node.nodeType === DOM_TEXT_TYPE && /^( |\t|\r?\n)+$/.test(node.textContent || '');
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
function getElementOuterTag(node, format) {
  if (format & IS_CODE) {
    return 'code';
  }
  if (format & IS_HIGHLIGHT) {
    return 'mark';
  }
  if (format & IS_SUBSCRIPT) {
    return 'sub';
  }
  if (format & IS_SUPERSCRIPT) {
    return 'sup';
  }
  return null;
}
function getElementInnerTag(node, format) {
  if (format & IS_BOLD) {
    return 'strong';
  }
  if (format & IS_ITALIC) {
    return 'em';
  }
  return 'span';
}
function setTextThemeClassNames(tag, prevFormat, nextFormat, dom, textClassNames) {
  const domClassList = dom.classList;
  // Firstly we handle the base theme.
  let classNames = getCachedClassNameArray(textClassNames, 'base');
  if (classNames !== undefined) {
    domClassList.add(...classNames);
  }
  // Secondly we handle the special case: underline + strikethrough.
  // We have to do this as we need a way to compose the fact that
  // the same CSS property will need to be used: text-decoration.
  // In an ideal world we shouldn't have to do this, but there's no
  // easy workaround for many atomic CSS systems today.
  classNames = getCachedClassNameArray(textClassNames, 'underlineStrikethrough');
  let hasUnderlineStrikethrough = false;
  const prevUnderlineStrikethrough = prevFormat & IS_UNDERLINE && prevFormat & IS_STRIKETHROUGH;
  const nextUnderlineStrikethrough = nextFormat & IS_UNDERLINE && nextFormat & IS_STRIKETHROUGH;
  if (classNames !== undefined) {
    if (nextUnderlineStrikethrough) {
      hasUnderlineStrikethrough = true;
      if (!prevUnderlineStrikethrough) {
        domClassList.add(...classNames);
      }
    } else if (prevUnderlineStrikethrough) {
      domClassList.remove(...classNames);
    }
  }
  for (const key in TEXT_TYPE_TO_FORMAT) {
    const format = key;
    const flag = TEXT_TYPE_TO_FORMAT[format];
    classNames = getCachedClassNameArray(textClassNames, key);
    if (classNames !== undefined) {
      if (nextFormat & flag) {
        if (hasUnderlineStrikethrough && (key === 'underline' || key === 'strikethrough')) {
          if (prevFormat & flag) {
            domClassList.remove(...classNames);
          }
          continue;
        }
        if ((prevFormat & flag) === 0 || prevUnderlineStrikethrough && key === 'underline' || key === 'strikethrough') {
          domClassList.add(...classNames);
        }
      } else if (prevFormat & flag) {
        domClassList.remove(...classNames);
      }
    }
  }
}
function diffComposedText(a, b) {
  const aLength = a.length;
  const bLength = b.length;
  let left = 0;
  let right = 0;
  while (left < aLength && left < bLength && a[left] === b[left]) {
    left++;
  }
  while (right + left < aLength && right + left < bLength && a[aLength - right - 1] === b[bLength - right - 1]) {
    right++;
  }
  return [left, aLength - left - right, b.slice(left, bLength - right)];
}
function setTextContent(nextText, dom, node) {
  const firstChild = dom.firstChild;
  const isComposing = node.isComposing();
  // Always add a suffix if we're composing a node
  const suffix = isComposing ? COMPOSITION_SUFFIX : '';
  const text = nextText + suffix;
  if (firstChild == null) {
    dom.textContent = text;
  } else {
    const nodeValue = firstChild.nodeValue;
    if (nodeValue !== text) {
      if (isComposing || IS_FIREFOX) {
        // We also use the diff composed text for general text in FF to avoid
        // the spellcheck red line from flickering.
        const [index, remove, insert] = diffComposedText(nodeValue, text);
        if (remove !== 0) {
          // @ts-expect-error
          firstChild.deleteData(index, remove);
        }
        // @ts-expect-error
        firstChild.insertData(index, insert);
      } else {
        firstChild.nodeValue = text;
      }
    }
  }
}
function createTextInnerDOM(innerDOM, node, innerTag, format, text, config) {
  setTextContent(text, innerDOM, node);
  const theme = config.theme;
  // Apply theme class names
  const textClassNames = theme.text;
  if (textClassNames !== undefined) {
    setTextThemeClassNames(innerTag, 0, format, innerDOM, textClassNames);
  }
}
function wrapElementWith(element, tag) {
  const el = document.createElement(tag);
  el.appendChild(element);
  return el;
}

/** @noInheritDoc */
class TextNode extends LexicalNode {
  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  static getType() {
    return 'text';
  }
  static clone(node) {
    return new TextNode(node.__text, node.__key);
  }
  constructor(text, key) {
    super(key);
    this.__text = text;
    this.__format = 0;
    this.__style = '';
    this.__mode = 0;
    this.__detail = 0;
  }

  /**
   * Returns a 32-bit integer that represents the TextFormatTypes currently applied to the
   * TextNode. You probably don't want to use this method directly - consider using TextNode.hasFormat instead.
   *
   * @returns a number representing the format of the text node.
   */
  getFormat() {
    const self = this.getLatest();
    return self.__format;
  }

  /**
   * Returns a 32-bit integer that represents the TextDetailTypes currently applied to the
   * TextNode. You probably don't want to use this method directly - consider using TextNode.isDirectionless
   * or TextNode.isUnmergeable instead.
   *
   * @returns a number representing the detail of the text node.
   */
  getDetail() {
    const self = this.getLatest();
    return self.__detail;
  }

  /**
   * Returns the mode (TextModeType) of the TextNode, which may be "normal", "token", or "segmented"
   *
   * @returns TextModeType.
   */
  getMode() {
    const self = this.getLatest();
    return TEXT_TYPE_TO_MODE[self.__mode];
  }

  /**
   * Returns the styles currently applied to the node. This is analogous to CSSText in the DOM.
   *
   * @returns CSSText-like string of styles applied to the underlying DOM node.
   */
  getStyle() {
    const self = this.getLatest();
    return self.__style;
  }

  /**
   * Returns whether or not the node is in "token" mode. TextNodes in token mode can be navigated through character-by-character
   * with a RangeSelection, but are deleted as a single entity (not invdividually by character).
   *
   * @returns true if the node is in token mode, false otherwise.
   */
  isToken() {
    const self = this.getLatest();
    return self.__mode === IS_TOKEN;
  }

  /**
   *
   * @returns true if Lexical detects that an IME or other 3rd-party script is attempting to
   * mutate the TextNode, false otherwise.
   */
  isComposing() {
    return this.__key === $getCompositionKey();
  }

  /**
   * Returns whether or not the node is in "segemented" mode. TextNodes in segemented mode can be navigated through character-by-character
   * with a RangeSelection, but are deleted in space-delimited "segments".
   *
   * @returns true if the node is in segmented mode, false otherwise.
   */
  isSegmented() {
    const self = this.getLatest();
    return self.__mode === IS_SEGMENTED;
  }
  /**
   * Returns whether or not the node is "directionless". Directionless nodes don't respect changes between RTL and LTR modes.
   *
   * @returns true if the node is directionless, false otherwise.
   */
  isDirectionless() {
    const self = this.getLatest();
    return (self.__detail & IS_DIRECTIONLESS) !== 0;
  }
  /**
   * Returns whether or not the node is unmergeable. In some scenarios, Lexical tries to merge
   * adjacent TextNodes into a single TextNode. If a TextNode is unmergeable, this won't happen.
   *
   * @returns true if the node is unmergeable, false otherwise.
   */
  isUnmergeable() {
    const self = this.getLatest();
    return (self.__detail & IS_UNMERGEABLE) !== 0;
  }

  /**
   * Returns whether or not the node has the provided format applied. Use this with the human-readable TextFormatType
   * string values to get the format of a TextNode.
   *
   * @param type - the TextFormatType to check for.
   *
   * @returns true if the node has the provided format, false otherwise.
   */
  hasFormat(type) {
    const formatFlag = TEXT_TYPE_TO_FORMAT[type];
    return (this.getFormat() & formatFlag) !== 0;
  }

  /**
   * Returns whether or not the node is simple text. Simple text is defined as a TextNode that has the string type "text"
   * (i.e., not a subclass) and has no mode applied to it (i.e., not segmented or token).
   *
   * @returns true if the node is simple text, false otherwise.
   */
  isSimpleText() {
    return this.__type === 'text' && this.__mode === 0;
  }

  /**
   * Returns the text content of the node as a string.
   *
   * @returns a string representing the text content of the node.
   */
  getTextContent() {
    const self = this.getLatest();
    return self.__text;
  }

  /**
   * Returns the format flags applied to the node as a 32-bit integer.
   *
   * @returns a number representing the TextFormatTypes applied to the node.
   */
  getFormatFlags(type, alignWithFormat) {
    const self = this.getLatest();
    const format = self.__format;
    return toggleTextFormatType(format, type, alignWithFormat);
  }

  /**
   *
   * @returns true if the text node supports font styling, false otherwise.
   */
  canHaveFormat() {
    return true;
  }

  // View

  createDOM(config, editor) {
    const format = this.__format;
    const outerTag = getElementOuterTag(this, format);
    const innerTag = getElementInnerTag(this, format);
    const tag = outerTag === null ? innerTag : outerTag;
    const dom = document.createElement(tag);
    let innerDOM = dom;
    if (this.hasFormat('code')) {
      dom.setAttribute('spellcheck', 'false');
    }
    if (outerTag !== null) {
      innerDOM = document.createElement(innerTag);
      dom.appendChild(innerDOM);
    }
    const text = this.__text;
    createTextInnerDOM(innerDOM, this, innerTag, format, text, config);
    const style = this.__style;
    if (style !== '') {
      dom.style.cssText = style;
    }
    return dom;
  }
  updateDOM(prevNode, dom, config) {
    const nextText = this.__text;
    const prevFormat = prevNode.__format;
    const nextFormat = this.__format;
    const prevOuterTag = getElementOuterTag(this, prevFormat);
    const nextOuterTag = getElementOuterTag(this, nextFormat);
    const prevInnerTag = getElementInnerTag(this, prevFormat);
    const nextInnerTag = getElementInnerTag(this, nextFormat);
    const prevTag = prevOuterTag === null ? prevInnerTag : prevOuterTag;
    const nextTag = nextOuterTag === null ? nextInnerTag : nextOuterTag;
    if (prevTag !== nextTag) {
      return true;
    }
    if (prevOuterTag === nextOuterTag && prevInnerTag !== nextInnerTag) {
      // should always be an element
      const prevInnerDOM = dom.firstChild;
      if (prevInnerDOM == null) {
        {
          throw Error(`updateDOM: prevInnerDOM is null or undefined`);
        }
      }
      const nextInnerDOM = document.createElement(nextInnerTag);
      createTextInnerDOM(nextInnerDOM, this, nextInnerTag, nextFormat, nextText, config);
      dom.replaceChild(nextInnerDOM, prevInnerDOM);
      return false;
    }
    let innerDOM = dom;
    if (nextOuterTag !== null) {
      if (prevOuterTag !== null) {
        innerDOM = dom.firstChild;
        if (innerDOM == null) {
          {
            throw Error(`updateDOM: innerDOM is null or undefined`);
          }
        }
      }
    }
    setTextContent(nextText, innerDOM, this);
    const theme = config.theme;
    // Apply theme class names
    const textClassNames = theme.text;
    if (textClassNames !== undefined && prevFormat !== nextFormat) {
      setTextThemeClassNames(nextInnerTag, prevFormat, nextFormat, innerDOM, textClassNames);
    }
    const prevStyle = prevNode.__style;
    const nextStyle = this.__style;
    if (prevStyle !== nextStyle) {
      dom.style.cssText = nextStyle;
    }
    return false;
  }
  static importDOM() {
    return {
      '#text': () => ({
        conversion: convertTextDOMNode,
        priority: 0
      }),
      b: () => ({
        conversion: convertBringAttentionToElement,
        priority: 0
      }),
      code: () => ({
        conversion: convertTextFormatElement,
        priority: 0
      }),
      em: () => ({
        conversion: convertTextFormatElement,
        priority: 0
      }),
      i: () => ({
        conversion: convertTextFormatElement,
        priority: 0
      }),
      s: () => ({
        conversion: convertTextFormatElement,
        priority: 0
      }),
      span: () => ({
        conversion: convertSpanElement,
        priority: 0
      }),
      strong: () => ({
        conversion: convertTextFormatElement,
        priority: 0
      }),
      sub: () => ({
        conversion: convertTextFormatElement,
        priority: 0
      }),
      sup: () => ({
        conversion: convertTextFormatElement,
        priority: 0
      }),
      u: () => ({
        conversion: convertTextFormatElement,
        priority: 0
      })
    };
  }
  static importJSON(serializedNode) {
    const node = $createTextNode(serializedNode.text);
    node.setFormat(serializedNode.format);
    node.setDetail(serializedNode.detail);
    node.setMode(serializedNode.mode);
    node.setStyle(serializedNode.style);
    return node;
  }

  // This improves Lexical's basic text output in copy+paste plus
  // for headless mode where people might use Lexical to generate
  // HTML content and not have the ability to use CSS classes.
  exportDOM(editor) {
    let {
      element
    } = super.exportDOM(editor);
    if (!(element !== null && isHTMLElement(element))) {
      throw Error(`Expected TextNode createDOM to always return a HTMLElement`);
    }
    element.style.whiteSpace = 'pre-wrap';
    // This is the only way to properly add support for most clients,
    // even if it's semantically incorrect to have to resort to using
    // <b>, <u>, <s>, <i> elements.
    if (this.hasFormat('bold')) {
      element = wrapElementWith(element, 'b');
    }
    if (this.hasFormat('italic')) {
      element = wrapElementWith(element, 'i');
    }
    if (this.hasFormat('strikethrough')) {
      element = wrapElementWith(element, 's');
    }
    if (this.hasFormat('underline')) {
      element = wrapElementWith(element, 'u');
    }
    return {
      element
    };
  }
  exportJSON() {
    return {
      detail: this.getDetail(),
      format: this.getFormat(),
      mode: this.getMode(),
      style: this.getStyle(),
      text: this.getTextContent(),
      type: 'text',
      version: 1
    };
  }

  // Mutators
  selectionTransform(prevSelection, nextSelection) {
    return;
  }

  /**
   * Sets the node format to the provided TextFormatType or 32-bit integer. Note that the TextFormatType
   * version of the argument can only specify one format and doing so will remove all other formats that
   * may be applied to the node. For toggling behavior, consider using {@link TextNode.toggleFormat}
   *
   * @param format - TextFormatType or 32-bit integer representing the node format.
   *
   * @returns this TextNode.
   * // TODO 0.12 This should just be a `string`.
   */
  setFormat(format) {
    const self = this.getWritable();
    self.__format = typeof format === 'string' ? TEXT_TYPE_TO_FORMAT[format] : format;
    return self;
  }

  /**
   * Sets the node detail to the provided TextDetailType or 32-bit integer. Note that the TextDetailType
   * version of the argument can only specify one detail value and doing so will remove all other detail values that
   * may be applied to the node. For toggling behavior, consider using {@link TextNode.toggleDirectionless}
   * or {@link TextNode.togglerUnmergeable}
   *
   * @param detail - TextDetailType or 32-bit integer representing the node detail.
   *
   * @returns this TextNode.
   * // TODO 0.12 This should just be a `string`.
   */
  setDetail(detail) {
    const self = this.getWritable();
    self.__detail = typeof detail === 'string' ? DETAIL_TYPE_TO_DETAIL[detail] : detail;
    return self;
  }

  /**
   * Sets the node style to the provided CSSText-like string. Set this property as you
   * would an HTMLElement style attribute to apply inline styles to the underlying DOM Element.
   *
   * @param style - CSSText to be applied to the underlying HTMLElement.
   *
   * @returns this TextNode.
   */
  setStyle(style) {
    const self = this.getWritable();
    self.__style = style;
    return self;
  }

  /**
   * Applies the provided format to this TextNode if it's not present. Removes it if it's present.
   * The subscript and superscript formats are mutually exclusive.
   * Prefer using this method to turn specific formats on and off.
   *
   * @param type - TextFormatType to toggle.
   *
   * @returns this TextNode.
   */
  toggleFormat(type) {
    const format = this.getFormat();
    const newFormat = toggleTextFormatType(format, type, null);
    return this.setFormat(newFormat);
  }

  /**
   * Toggles the directionless detail value of the node. Prefer using this method over setDetail.
   *
   * @returns this TextNode.
   */
  toggleDirectionless() {
    const self = this.getWritable();
    self.__detail ^= IS_DIRECTIONLESS;
    return self;
  }

  /**
   * Toggles the unmergeable detail value of the node. Prefer using this method over setDetail.
   *
   * @returns this TextNode.
   */
  toggleUnmergeable() {
    const self = this.getWritable();
    self.__detail ^= IS_UNMERGEABLE;
    return self;
  }

  /**
   * Sets the mode of the node.
   *
   * @returns this TextNode.
   */
  setMode(type) {
    const mode = TEXT_MODE_TO_TYPE[type];
    if (this.__mode === mode) {
      return this;
    }
    const self = this.getWritable();
    self.__mode = mode;
    return self;
  }

  /**
   * Sets the text content of the node.
   *
   * @param text - the string to set as the text value of the node.
   *
   * @returns this TextNode.
   */
  setTextContent(text) {
    if (this.__text === text) {
      return this;
    }
    const self = this.getWritable();
    self.__text = text;
    return self;
  }

  /**
   * Sets the current Lexical selection to be a RangeSelection with anchor and focus on this TextNode at the provided offsets.
   *
   * @param _anchorOffset - the offset at which the Selection anchor will be placed.
   * @param _focusOffset - the offset at which the Selection focus will be placed.
   *
   * @returns the new RangeSelection.
   */
  select(_anchorOffset, _focusOffset) {
    errorOnReadOnly();
    let anchorOffset = _anchorOffset;
    let focusOffset = _focusOffset;
    const selection = $getSelection();
    const text = this.getTextContent();
    const key = this.__key;
    if (typeof text === 'string') {
      const lastOffset = text.length;
      if (anchorOffset === undefined) {
        anchorOffset = lastOffset;
      }
      if (focusOffset === undefined) {
        focusOffset = lastOffset;
      }
    } else {
      anchorOffset = 0;
      focusOffset = 0;
    }
    if (!$isRangeSelection(selection)) {
      return internalMakeRangeSelection(key, anchorOffset, key, focusOffset, 'text', 'text');
    } else {
      const compositionKey = $getCompositionKey();
      if (compositionKey === selection.anchor.key || compositionKey === selection.focus.key) {
        $setCompositionKey(key);
      }
      selection.setTextNodeRange(this, anchorOffset, this, focusOffset);
    }
    return selection;
  }
  selectStart() {
    return this.select(0, 0);
  }
  selectEnd() {
    const size = this.getTextContentSize();
    return this.select(size, size);
  }

  /**
   * Inserts the provided text into this TextNode at the provided offset, deleting the number of characters
   * specified. Can optionally calculate a new selection after the operation is complete.
   *
   * @param offset - the offset at which the splice operation should begin.
   * @param delCount - the number of characters to delete, starting from the offset.
   * @param newText - the text to insert into the TextNode at the offset.
   * @param moveSelection - optional, whether or not to move selection to the end of the inserted substring.
   *
   * @returns this TextNode.
   */
  spliceText(offset, delCount, newText, moveSelection) {
    const writableSelf = this.getWritable();
    const text = writableSelf.__text;
    const handledTextLength = newText.length;
    let index = offset;
    if (index < 0) {
      index = handledTextLength + index;
      if (index < 0) {
        index = 0;
      }
    }
    const selection = $getSelection();
    if (moveSelection && $isRangeSelection(selection)) {
      const newOffset = offset + handledTextLength;
      selection.setTextNodeRange(writableSelf, newOffset, writableSelf, newOffset);
    }
    const updatedText = text.slice(0, index) + newText + text.slice(index + delCount);
    writableSelf.__text = updatedText;
    return writableSelf;
  }

  /**
   * This method is meant to be overriden by TextNode subclasses to control the behavior of those nodes
   * when a user event would cause text to be inserted before them in the editor. If true, Lexical will attempt
   * to insert text into this node. If false, it will insert the text in a new sibling node.
   *
   * @returns true if text can be inserted before the node, false otherwise.
   */
  canInsertTextBefore() {
    return true;
  }

  /**
   * This method is meant to be overriden by TextNode subclasses to control the behavior of those nodes
   * when a user event would cause text to be inserted after them in the editor. If true, Lexical will attempt
   * to insert text into this node. If false, it will insert the text in a new sibling node.
   *
   * @returns true if text can be inserted after the node, false otherwise.
   */
  canInsertTextAfter() {
    return true;
  }

  /**
   * Splits this TextNode at the provided character offsets, forming new TextNodes from the substrings
   * formed by the split, and inserting those new TextNodes into the editor, replacing the one that was split.
   *
   * @param splitOffsets - rest param of the text content character offsets at which this node should be split.
   *
   * @returns an Array containing the newly-created TextNodes.
   */
  splitText(...splitOffsets) {
    errorOnReadOnly();
    const self = this.getLatest();
    const textContent = self.getTextContent();
    const key = self.__key;
    const compositionKey = $getCompositionKey();
    const offsetsSet = new Set(splitOffsets);
    const parts = [];
    const textLength = textContent.length;
    let string = '';
    for (let i = 0; i < textLength; i++) {
      if (string !== '' && offsetsSet.has(i)) {
        parts.push(string);
        string = '';
      }
      string += textContent[i];
    }
    if (string !== '') {
      parts.push(string);
    }
    const partsLength = parts.length;
    if (partsLength === 0) {
      return [];
    } else if (parts[0] === textContent) {
      return [self];
    }
    const firstPart = parts[0];
    const parent = self.getParentOrThrow();
    let writableNode;
    const format = self.getFormat();
    const style = self.getStyle();
    const detail = self.__detail;
    let hasReplacedSelf = false;
    if (self.isSegmented()) {
      // Create a new TextNode
      writableNode = $createTextNode(firstPart);
      writableNode.__format = format;
      writableNode.__style = style;
      writableNode.__detail = detail;
      hasReplacedSelf = true;
    } else {
      // For the first part, update the existing node
      writableNode = self.getWritable();
      writableNode.__text = firstPart;
    }

    // Handle selection
    const selection = $getSelection();

    // Then handle all other parts
    const splitNodes = [writableNode];
    let textSize = firstPart.length;
    for (let i = 1; i < partsLength; i++) {
      const part = parts[i];
      const partSize = part.length;
      const sibling = $createTextNode(part).getWritable();
      sibling.__format = format;
      sibling.__style = style;
      sibling.__detail = detail;
      const siblingKey = sibling.__key;
      const nextTextSize = textSize + partSize;
      if ($isRangeSelection(selection)) {
        const anchor = selection.anchor;
        const focus = selection.focus;
        if (anchor.key === key && anchor.type === 'text' && anchor.offset > textSize && anchor.offset <= nextTextSize) {
          anchor.key = siblingKey;
          anchor.offset -= textSize;
          selection.dirty = true;
        }
        if (focus.key === key && focus.type === 'text' && focus.offset > textSize && focus.offset <= nextTextSize) {
          focus.key = siblingKey;
          focus.offset -= textSize;
          selection.dirty = true;
        }
      }
      if (compositionKey === key) {
        $setCompositionKey(siblingKey);
      }
      textSize = nextTextSize;
      splitNodes.push(sibling);
    }

    // Insert the nodes into the parent's children
    internalMarkSiblingsAsDirty(this);
    const writableParent = parent.getWritable();
    const insertionIndex = this.getIndexWithinParent();
    if (hasReplacedSelf) {
      writableParent.splice(insertionIndex, 0, splitNodes);
      this.remove();
    } else {
      writableParent.splice(insertionIndex, 1, splitNodes);
    }
    if ($isRangeSelection(selection)) {
      $updateElementSelectionOnCreateDeleteNode(selection, parent, insertionIndex, partsLength - 1);
    }
    return splitNodes;
  }

  /**
   * Merges the target TextNode into this TextNode, removing the target node.
   *
   * @param target - the TextNode to merge into this one.
   *
   * @returns this TextNode.
   */
  mergeWithSibling(target) {
    const isBefore = target === this.getPreviousSibling();
    if (!isBefore && target !== this.getNextSibling()) {
      {
        throw Error(`mergeWithSibling: sibling must be a previous or next sibling`);
      }
    }
    const key = this.__key;
    const targetKey = target.__key;
    const text = this.__text;
    const textLength = text.length;
    const compositionKey = $getCompositionKey();
    if (compositionKey === targetKey) {
      $setCompositionKey(key);
    }
    const selection = $getSelection();
    if ($isRangeSelection(selection)) {
      const anchor = selection.anchor;
      const focus = selection.focus;
      if (anchor !== null && anchor.key === targetKey) {
        adjustPointOffsetForMergedSibling(anchor, isBefore, key, target, textLength);
        selection.dirty = true;
      }
      if (focus !== null && focus.key === targetKey) {
        adjustPointOffsetForMergedSibling(focus, isBefore, key, target, textLength);
        selection.dirty = true;
      }
    }
    const targetText = target.__text;
    const newText = isBefore ? targetText + text : text + targetText;
    this.setTextContent(newText);
    const writableSelf = this.getWritable();
    target.remove();
    return writableSelf;
  }

  /**
   * This method is meant to be overriden by TextNode subclasses to control the behavior of those nodes
   * when used with the registerLexicalTextEntity function. If you're using registerLexicalTextEntity, the
   * node class that you create and replace matched text with should return true from this method.
   *
   * @returns true if the node is to be treated as a "text entity", false otherwise.
   */
  isTextEntity() {
    return false;
  }
}
function convertSpanElement(domNode) {
  // domNode is a <span> since we matched it by nodeName
  const span = domNode;
  // Google Docs uses span tags + font-weight for bold text
  const hasBoldFontWeight = span.style.fontWeight === '700';
  // Google Docs uses span tags + text-decoration: line-through for strikethrough text
  const hasLinethroughTextDecoration = span.style.textDecoration === 'line-through';
  // Google Docs uses span tags + font-style for italic text
  const hasItalicFontStyle = span.style.fontStyle === 'italic';
  // Google Docs uses span tags + text-decoration: underline for underline text
  const hasUnderlineTextDecoration = span.style.textDecoration === 'underline';
  // Google Docs uses span tags + vertical-align to specify subscript and superscript
  const verticalAlign = span.style.verticalAlign;
  return {
    forChild: lexicalNode => {
      if (!$isTextNode(lexicalNode)) {
        return lexicalNode;
      }
      if (hasBoldFontWeight) {
        lexicalNode.toggleFormat('bold');
      }
      if (hasLinethroughTextDecoration) {
        lexicalNode.toggleFormat('strikethrough');
      }
      if (hasItalicFontStyle) {
        lexicalNode.toggleFormat('italic');
      }
      if (hasUnderlineTextDecoration) {
        lexicalNode.toggleFormat('underline');
      }
      if (verticalAlign === 'sub') {
        lexicalNode.toggleFormat('subscript');
      }
      if (verticalAlign === 'super') {
        lexicalNode.toggleFormat('superscript');
      }
      return lexicalNode;
    },
    node: null
  };
}
function convertBringAttentionToElement(domNode) {
  // domNode is a <b> since we matched it by nodeName
  const b = domNode;
  // Google Docs wraps all copied HTML in a <b> with font-weight normal
  const hasNormalFontWeight = b.style.fontWeight === 'normal';
  return {
    forChild: lexicalNode => {
      if ($isTextNode(lexicalNode) && !hasNormalFontWeight) {
        lexicalNode.toggleFormat('bold');
      }
      return lexicalNode;
    },
    node: null
  };
}
const preParentCache = new WeakMap();
function isNodePre(node) {
  return node.nodeName === 'PRE' || node.nodeType === DOM_ELEMENT_TYPE && node.style !== undefined && node.style.whiteSpace !== undefined && node.style.whiteSpace.startsWith('pre');
}
function findParentPreDOMNode(node) {
  let cached;
  let parent = node.parentNode;
  const visited = [node];
  while (parent !== null && (cached = preParentCache.get(parent)) === undefined && !isNodePre(parent)) {
    visited.push(parent);
    parent = parent.parentNode;
  }
  const resultNode = cached === undefined ? parent : cached;
  for (let i = 0; i < visited.length; i++) {
    preParentCache.set(visited[i], resultNode);
  }
  return resultNode;
}
function convertTextDOMNode(domNode) {
  const domNode_ = domNode;
  const parentDom = domNode.parentElement;
  if (!(parentDom !== null)) {
    throw Error(`Expected parentElement of Text not to be null`);
  }
  let textContent = domNode_.textContent || '';
  // No collapse and preserve segment break for pre, pre-wrap and pre-line
  if (findParentPreDOMNode(domNode_) !== null) {
    const parts = textContent.split(/(\r?\n|\t)/);
    const nodes = [];
    const length = parts.length;
    for (let i = 0; i < length; i++) {
      const part = parts[i];
      if (part === '\n' || part === '\r\n') {
        nodes.push($createLineBreakNode());
      } else if (part === '\t') {
        nodes.push($createTabNode());
      } else if (part !== '') {
        nodes.push($createTextNode(part));
      }
    }
    return {
      node: nodes
    };
  }
  textContent = textContent.replace(/\r/g, '').replace(/[ \t\n]+/g, ' ');
  if (textContent === '') {
    return {
      node: null
    };
  }
  if (textContent[0] === ' ') {
    // Traverse backward while in the same line. If content contains new line or tab -> pontential
    // delete, other elements can borrow from this one. Deletion depends on whether it's also the
    // last space (see next condition: textContent[textContent.length - 1] === ' '))
    let previousText = domNode_;
    let isStartOfLine = true;
    while (previousText !== null && (previousText = findTextInLine(previousText, false)) !== null) {
      const previousTextContent = previousText.textContent || '';
      if (previousTextContent.length > 0) {
        if (/[ \t\n]$/.test(previousTextContent)) {
          textContent = textContent.slice(1);
        }
        isStartOfLine = false;
        break;
      }
    }
    if (isStartOfLine) {
      textContent = textContent.slice(1);
    }
  }
  if (textContent[textContent.length - 1] === ' ') {
    // Traverse forward while in the same line, preserve if next inline will require a space
    let nextText = domNode_;
    let isEndOfLine = true;
    while (nextText !== null && (nextText = findTextInLine(nextText, true)) !== null) {
      const nextTextContent = (nextText.textContent || '').replace(/^( |\t|\r?\n)+/, '');
      if (nextTextContent.length > 0) {
        isEndOfLine = false;
        break;
      }
    }
    if (isEndOfLine) {
      textContent = textContent.slice(0, textContent.length - 1);
    }
  }
  if (textContent === '') {
    return {
      node: null
    };
  }
  return {
    node: $createTextNode(textContent)
  };
}
const inlineParents = new RegExp(/^(a|abbr|acronym|b|cite|code|del|em|i|ins|kbd|label|output|q|ruby|s|samp|span|strong|sub|sup|time|u|tt|var)$/, 'i');
function findTextInLine(text, forward) {
  let node = text;
  // eslint-disable-next-line no-constant-condition
  while (true) {
    let sibling;
    while ((sibling = forward ? node.nextSibling : node.previousSibling) === null) {
      const parentElement = node.parentElement;
      if (parentElement === null) {
        return null;
      }
      node = parentElement;
    }
    node = sibling;
    if (node.nodeType === DOM_ELEMENT_TYPE) {
      const display = node.style.display;
      if (display === '' && node.nodeName.match(inlineParents) === null || display !== '' && !display.startsWith('inline')) {
        return null;
      }
    }
    let descendant = node;
    while ((descendant = forward ? node.firstChild : node.lastChild) !== null) {
      node = descendant;
    }
    if (node.nodeType === DOM_TEXT_TYPE) {
      return node;
    } else if (node.nodeName === 'BR') {
      return null;
    }
  }
}
const nodeNameToTextFormat = {
  code: 'code',
  em: 'italic',
  i: 'italic',
  s: 'strikethrough',
  strong: 'bold',
  sub: 'subscript',
  sup: 'superscript',
  u: 'underline'
};
function convertTextFormatElement(domNode) {
  const format = nodeNameToTextFormat[domNode.nodeName.toLowerCase()];
  if (format === undefined) {
    return {
      node: null
    };
  }
  return {
    forChild: lexicalNode => {
      if ($isTextNode(lexicalNode) && !lexicalNode.hasFormat(format)) {
        lexicalNode.toggleFormat(format);
      }
      return lexicalNode;
    },
    node: null
  };
}
function $createTextNode(text = '') {
  return $applyNodeReplacement(new TextNode(text));
}
function $isTextNode(node) {
  return node instanceof TextNode;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
/** @noInheritDoc */
class TabNode extends TextNode {
  static getType() {
    return 'tab';
  }
  static clone(node) {
    const newNode = new TabNode(node.__key);
    // TabNode __text can be either '\t' or ''. insertText will remove the empty Node
    newNode.__text = node.__text;
    newNode.__format = node.__format;
    newNode.__style = node.__style;
    return newNode;
  }
  constructor(key) {
    super('\t', key);
    this.__detail = IS_UNMERGEABLE;
  }
  static importDOM() {
    return null;
  }
  static importJSON(serializedTabNode) {
    const node = $createTabNode();
    node.setFormat(serializedTabNode.format);
    node.setStyle(serializedTabNode.style);
    return node;
  }
  exportJSON() {
    return {
      ...super.exportJSON(),
      type: 'tab',
      version: 1
    };
  }
  setTextContent(_text) {
    {
      throw Error(`TabNode does not support setTextContent`);
    }
  }
  setDetail(_detail) {
    {
      throw Error(`TabNode does not support setDetail`);
    }
  }
  setMode(_type) {
    {
      throw Error(`TabNode does not support setMode`);
    }
  }
  canInsertTextBefore() {
    return false;
  }
  canInsertTextAfter() {
    return false;
  }
}
function $createTabNode() {
  return $applyNodeReplacement(new TabNode());
}
function $isTabNode(node) {
  return node instanceof TabNode;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
class Point {
  constructor(key, offset, type) {
    this._selection = null;
    this.key = key;
    this.offset = offset;
    this.type = type;
  }
  is(point) {
    return this.key === point.key && this.offset === point.offset && this.type === point.type;
  }
  isBefore(b) {
    let aNode = this.getNode();
    let bNode = b.getNode();
    const aOffset = this.offset;
    const bOffset = b.offset;
    if ($isElementNode(aNode)) {
      const aNodeDescendant = aNode.getDescendantByIndex(aOffset);
      aNode = aNodeDescendant != null ? aNodeDescendant : aNode;
    }
    if ($isElementNode(bNode)) {
      const bNodeDescendant = bNode.getDescendantByIndex(bOffset);
      bNode = bNodeDescendant != null ? bNodeDescendant : bNode;
    }
    if (aNode === bNode) {
      return aOffset < bOffset;
    }
    return aNode.isBefore(bNode);
  }
  getNode() {
    const key = this.key;
    const node = $getNodeByKey(key);
    if (node === null) {
      {
        throw Error(`Point.getNode: node not found`);
      }
    }
    return node;
  }
  set(key, offset, type) {
    const selection = this._selection;
    const oldKey = this.key;
    this.key = key;
    this.offset = offset;
    this.type = type;
    if (!isCurrentlyReadOnlyMode()) {
      if ($getCompositionKey() === oldKey) {
        $setCompositionKey(key);
      }
      if (selection !== null) {
        selection.setCachedNodes(null);
        selection.dirty = true;
      }
    }
  }
}
function $createPoint(key, offset, type) {
  // @ts-expect-error: intentionally cast as we use a class for perf reasons
  return new Point(key, offset, type);
}
function selectPointOnNode(point, node) {
  let key = node.__key;
  let offset = point.offset;
  let type = 'element';
  if ($isTextNode(node)) {
    type = 'text';
    const textContentLength = node.getTextContentSize();
    if (offset > textContentLength) {
      offset = textContentLength;
    }
  } else if (!$isElementNode(node)) {
    const nextSibling = node.getNextSibling();
    if ($isTextNode(nextSibling)) {
      key = nextSibling.__key;
      offset = 0;
      type = 'text';
    } else {
      const parentNode = node.getParent();
      if (parentNode) {
        key = parentNode.__key;
        offset = node.getIndexWithinParent() + 1;
      }
    }
  }
  point.set(key, offset, type);
}
function $moveSelectionPointToEnd(point, node) {
  if ($isElementNode(node)) {
    const lastNode = node.getLastDescendant();
    if ($isElementNode(lastNode) || $isTextNode(lastNode)) {
      selectPointOnNode(point, lastNode);
    } else {
      selectPointOnNode(point, node);
    }
  } else {
    selectPointOnNode(point, node);
  }
}
function $transferStartingElementPointToTextPoint(start, end, format, style) {
  const element = start.getNode();
  const placementNode = element.getChildAtIndex(start.offset);
  const textNode = $createTextNode();
  const target = $isRootNode(element) ? $createParagraphNode().append(textNode) : textNode;
  textNode.setFormat(format);
  textNode.setStyle(style);
  if (placementNode === null) {
    element.append(target);
  } else {
    placementNode.insertBefore(target);
  }
  // Transfer the element point to a text point.
  if (start.is(end)) {
    end.set(textNode.__key, 0, 'text');
  }
  start.set(textNode.__key, 0, 'text');
}
function $setPointValues(point, key, offset, type) {
  point.key = key;
  point.offset = offset;
  point.type = type;
}
class NodeSelection {
  constructor(objects) {
    this._cachedNodes = null;
    this._nodes = objects;
    this.dirty = false;
  }
  getCachedNodes() {
    return this._cachedNodes;
  }
  setCachedNodes(nodes) {
    this._cachedNodes = nodes;
  }
  is(selection) {
    if (!$isNodeSelection(selection)) {
      return false;
    }
    const a = this._nodes;
    const b = selection._nodes;
    return a.size === b.size && Array.from(a).every(key => b.has(key));
  }
  isCollapsed() {
    return false;
  }
  isBackward() {
    return false;
  }
  getStartEndPoints() {
    return null;
  }
  add(key) {
    this.dirty = true;
    this._nodes.add(key);
    this._cachedNodes = null;
  }
  delete(key) {
    this.dirty = true;
    this._nodes.delete(key);
    this._cachedNodes = null;
  }
  clear() {
    this.dirty = true;
    this._nodes.clear();
    this._cachedNodes = null;
  }
  has(key) {
    return this._nodes.has(key);
  }
  clone() {
    return new NodeSelection(new Set(this._nodes));
  }
  extract() {
    return this.getNodes();
  }
  insertRawText(text) {
    // Do nothing?
  }
  insertText() {
    // Do nothing?
  }
  insertNodes(nodes) {
    const selectedNodes = this.getNodes();
    const selectedNodesLength = selectedNodes.length;
    const lastSelectedNode = selectedNodes[selectedNodesLength - 1];
    let selectionAtEnd;
    // Insert nodes
    if ($isTextNode(lastSelectedNode)) {
      selectionAtEnd = lastSelectedNode.select();
    } else {
      const index = lastSelectedNode.getIndexWithinParent() + 1;
      selectionAtEnd = lastSelectedNode.getParentOrThrow().select(index, index);
    }
    selectionAtEnd.insertNodes(nodes);
    // Remove selected nodes
    for (let i = 0; i < selectedNodesLength; i++) {
      selectedNodes[i].remove();
    }
  }
  getNodes() {
    const cachedNodes = this._cachedNodes;
    if (cachedNodes !== null) {
      return cachedNodes;
    }
    const objects = this._nodes;
    const nodes = [];
    for (const object of objects) {
      const node = $getNodeByKey(object);
      if (node !== null) {
        nodes.push(node);
      }
    }
    if (!isCurrentlyReadOnlyMode()) {
      this._cachedNodes = nodes;
    }
    return nodes;
  }
  getTextContent() {
    const nodes = this.getNodes();
    let textContent = '';
    for (let i = 0; i < nodes.length; i++) {
      textContent += nodes[i].getTextContent();
    }
    return textContent;
  }
}
function $isRangeSelection(x) {
  return x instanceof RangeSelection;
}
class RangeSelection {
  constructor(anchor, focus, format, style) {
    this.anchor = anchor;
    this.focus = focus;
    anchor._selection = this;
    focus._selection = this;
    this._cachedNodes = null;
    this.format = format;
    this.style = style;
    this.dirty = false;
  }
  getCachedNodes() {
    return this._cachedNodes;
  }
  setCachedNodes(nodes) {
    this._cachedNodes = nodes;
  }

  /**
   * Used to check if the provided selections is equal to this one by value,
   * inluding anchor, focus, format, and style properties.
   * @param selection - the Selection to compare this one to.
   * @returns true if the Selections are equal, false otherwise.
   */
  is(selection) {
    if (!$isRangeSelection(selection)) {
      return false;
    }
    return this.anchor.is(selection.anchor) && this.focus.is(selection.focus) && this.format === selection.format && this.style === selection.style;
  }

  /**
   * Returns whether the Selection is "collapsed", meaning the anchor and focus are
   * the same node and have the same offset.
   *
   * @returns true if the Selection is collapsed, false otherwise.
   */
  isCollapsed() {
    return this.anchor.is(this.focus);
  }

  /**
   * Gets all the nodes in the Selection. Uses caching to make it generally suitable
   * for use in hot paths.
   *
   * @returns an Array containing all the nodes in the Selection
   */
  getNodes() {
    const cachedNodes = this._cachedNodes;
    if (cachedNodes !== null) {
      return cachedNodes;
    }
    const anchor = this.anchor;
    const focus = this.focus;
    const isBefore = anchor.isBefore(focus);
    const firstPoint = isBefore ? anchor : focus;
    const lastPoint = isBefore ? focus : anchor;
    let firstNode = firstPoint.getNode();
    let lastNode = lastPoint.getNode();
    const startOffset = firstPoint.offset;
    const endOffset = lastPoint.offset;
    if ($isElementNode(firstNode)) {
      const firstNodeDescendant = firstNode.getDescendantByIndex(startOffset);
      firstNode = firstNodeDescendant != null ? firstNodeDescendant : firstNode;
    }
    if ($isElementNode(lastNode)) {
      let lastNodeDescendant = lastNode.getDescendantByIndex(endOffset);
      // We don't want to over-select, as node selection infers the child before
      // the last descendant, not including that descendant.
      if (lastNodeDescendant !== null && lastNodeDescendant !== firstNode && lastNode.getChildAtIndex(endOffset) === lastNodeDescendant) {
        lastNodeDescendant = lastNodeDescendant.getPreviousSibling();
      }
      lastNode = lastNodeDescendant != null ? lastNodeDescendant : lastNode;
    }
    let nodes;
    if (firstNode.is(lastNode)) {
      if ($isElementNode(firstNode) && firstNode.getChildrenSize() > 0) {
        nodes = [];
      } else {
        nodes = [firstNode];
      }
    } else {
      nodes = firstNode.getNodesBetween(lastNode);
    }
    if (!isCurrentlyReadOnlyMode()) {
      this._cachedNodes = nodes;
    }
    return nodes;
  }

  /**
   * Sets this Selection to be of type "text" at the provided anchor and focus values.
   *
   * @param anchorNode - the anchor node to set on the Selection
   * @param anchorOffset - the offset to set on the Selection
   * @param focusNode - the focus node to set on the Selection
   * @param focusOffset - the focus offset to set on the Selection
   */
  setTextNodeRange(anchorNode, anchorOffset, focusNode, focusOffset) {
    $setPointValues(this.anchor, anchorNode.__key, anchorOffset, 'text');
    $setPointValues(this.focus, focusNode.__key, focusOffset, 'text');
    this._cachedNodes = null;
    this.dirty = true;
  }

  /**
   * Gets the (plain) text content of all the nodes in the selection.
   *
   * @returns a string representing the text content of all the nodes in the Selection
   */
  getTextContent() {
    const nodes = this.getNodes();
    if (nodes.length === 0) {
      return '';
    }
    const firstNode = nodes[0];
    const lastNode = nodes[nodes.length - 1];
    const anchor = this.anchor;
    const focus = this.focus;
    const isBefore = anchor.isBefore(focus);
    const [anchorOffset, focusOffset] = $getCharacterOffsets(this);
    let textContent = '';
    let prevWasElement = true;
    for (let i = 0; i < nodes.length; i++) {
      const node = nodes[i];
      if ($isElementNode(node) && !node.isInline()) {
        if (!prevWasElement) {
          textContent += '\n';
        }
        if (node.isEmpty()) {
          prevWasElement = false;
        } else {
          prevWasElement = true;
        }
      } else {
        prevWasElement = false;
        if ($isTextNode(node)) {
          let text = node.getTextContent();
          if (node === firstNode) {
            if (node === lastNode) {
              if (anchor.type !== 'element' || focus.type !== 'element' || focus.offset === anchor.offset) {
                text = anchorOffset < focusOffset ? text.slice(anchorOffset, focusOffset) : text.slice(focusOffset, anchorOffset);
              }
            } else {
              text = isBefore ? text.slice(anchorOffset) : text.slice(focusOffset);
            }
          } else if (node === lastNode) {
            text = isBefore ? text.slice(0, focusOffset) : text.slice(0, anchorOffset);
          }
          textContent += text;
        } else if (($isDecoratorNode(node) || $isLineBreakNode(node)) && (node !== lastNode || !this.isCollapsed())) {
          textContent += node.getTextContent();
        }
      }
    }
    return textContent;
  }

  /**
   * Attempts to map a DOM selection range onto this Lexical Selection,
   * setting the anchor, focus, and type accordingly
   *
   * @param range a DOM Selection range conforming to the StaticRange interface.
   */
  applyDOMRange(range) {
    const editor = getActiveEditor();
    const currentEditorState = editor.getEditorState();
    const lastSelection = currentEditorState._selection;
    const resolvedSelectionPoints = internalResolveSelectionPoints(range.startContainer, range.startOffset, range.endContainer, range.endOffset, editor, lastSelection);
    if (resolvedSelectionPoints === null) {
      return;
    }
    const [anchorPoint, focusPoint] = resolvedSelectionPoints;
    $setPointValues(this.anchor, anchorPoint.key, anchorPoint.offset, anchorPoint.type);
    $setPointValues(this.focus, focusPoint.key, focusPoint.offset, focusPoint.type);
    this._cachedNodes = null;
  }

  /**
   * Creates a new RangeSelection, copying over all the property values from this one.
   *
   * @returns a new RangeSelection with the same property values as this one.
   */
  clone() {
    const anchor = this.anchor;
    const focus = this.focus;
    const selection = new RangeSelection($createPoint(anchor.key, anchor.offset, anchor.type), $createPoint(focus.key, focus.offset, focus.type), this.format, this.style);
    return selection;
  }

  /**
   * Toggles the provided format on all the TextNodes in the Selection.
   *
   * @param format a string TextFormatType to toggle on the TextNodes in the selection
   */
  toggleFormat(format) {
    this.format = toggleTextFormatType(this.format, format, null);
    this.dirty = true;
  }

  /**
   * Sets the value of the style property on the Selection
   *
   * @param style - the style to set at the value of the style property.
   */
  setStyle(style) {
    this.style = style;
    this.dirty = true;
  }

  /**
   * Returns whether the provided TextFormatType is present on the Selection. This will be true if any node in the Selection
   * has the specified format.
   *
   * @param type the TextFormatType to check for.
   * @returns true if the provided format is currently toggled on on the Selection, false otherwise.
   */
  hasFormat(type) {
    const formatFlag = TEXT_TYPE_TO_FORMAT[type];
    return (this.format & formatFlag) !== 0;
  }

  /**
   * Attempts to insert the provided text into the EditorState at the current Selection.
   * converts tabs, newlines, and carriage returns into LexicalNodes.
   *
   * @param text the text to insert into the Selection
   */
  insertRawText(text) {
    const parts = text.split(/(\r?\n|\t)/);
    const nodes = [];
    const length = parts.length;
    for (let i = 0; i < length; i++) {
      const part = parts[i];
      if (part === '\n' || part === '\r\n') {
        nodes.push($createLineBreakNode());
      } else if (part === '\t') {
        nodes.push($createTabNode());
      } else {
        nodes.push($createTextNode(part));
      }
    }
    this.insertNodes(nodes);
  }

  /**
   * Attempts to insert the provided text into the EditorState at the current Selection as a new
   * Lexical TextNode, according to a series of insertion heuristics based on the selection type and position.
   *
   * @param text the text to insert into the Selection
   */
  insertText(text) {
    const anchor = this.anchor;
    const focus = this.focus;
    const isBefore = this.isCollapsed() || anchor.isBefore(focus);
    const format = this.format;
    const style = this.style;
    if (isBefore && anchor.type === 'element') {
      $transferStartingElementPointToTextPoint(anchor, focus, format, style);
    } else if (!isBefore && focus.type === 'element') {
      $transferStartingElementPointToTextPoint(focus, anchor, format, style);
    }
    const selectedNodes = this.getNodes();
    const selectedNodesLength = selectedNodes.length;
    const firstPoint = isBefore ? anchor : focus;
    const endPoint = isBefore ? focus : anchor;
    const startOffset = firstPoint.offset;
    const endOffset = endPoint.offset;
    let firstNode = selectedNodes[0];
    if (!$isTextNode(firstNode)) {
      {
        throw Error(`insertText: first node is not a text node`);
      }
    }
    const firstNodeText = firstNode.getTextContent();
    const firstNodeTextLength = firstNodeText.length;
    const firstNodeParent = firstNode.getParentOrThrow();
    const lastIndex = selectedNodesLength - 1;
    let lastNode = selectedNodes[lastIndex];
    if (this.isCollapsed() && startOffset === firstNodeTextLength && (firstNode.isSegmented() || firstNode.isToken() || !firstNode.canInsertTextAfter() || !firstNodeParent.canInsertTextAfter() && firstNode.getNextSibling() === null)) {
      let nextSibling = firstNode.getNextSibling();
      if (!$isTextNode(nextSibling) || !nextSibling.canInsertTextBefore() || $isTokenOrSegmented(nextSibling)) {
        nextSibling = $createTextNode();
        nextSibling.setFormat(format);
        if (!firstNodeParent.canInsertTextAfter()) {
          firstNodeParent.insertAfter(nextSibling);
        } else {
          firstNode.insertAfter(nextSibling);
        }
      }
      nextSibling.select(0, 0);
      firstNode = nextSibling;
      if (text !== '') {
        this.insertText(text);
        return;
      }
    } else if (this.isCollapsed() && startOffset === 0 && (firstNode.isSegmented() || firstNode.isToken() || !firstNode.canInsertTextBefore() || !firstNodeParent.canInsertTextBefore() && firstNode.getPreviousSibling() === null)) {
      let prevSibling = firstNode.getPreviousSibling();
      if (!$isTextNode(prevSibling) || $isTokenOrSegmented(prevSibling)) {
        prevSibling = $createTextNode();
        prevSibling.setFormat(format);
        if (!firstNodeParent.canInsertTextBefore()) {
          firstNodeParent.insertBefore(prevSibling);
        } else {
          firstNode.insertBefore(prevSibling);
        }
      }
      prevSibling.select();
      firstNode = prevSibling;
      if (text !== '') {
        this.insertText(text);
        return;
      }
    } else if (firstNode.isSegmented() && startOffset !== firstNodeTextLength) {
      const textNode = $createTextNode(firstNode.getTextContent());
      textNode.setFormat(format);
      firstNode.replace(textNode);
      firstNode = textNode;
    } else if (!this.isCollapsed() && text !== '') {
      // When the firstNode or lastNode parents are elements that
      // do not allow text to be inserted before or after, we first
      // clear the content. Then we normalize selection, then insert
      // the new content.
      const lastNodeParent = lastNode.getParent();
      if (!firstNodeParent.canInsertTextBefore() || !firstNodeParent.canInsertTextAfter() || $isElementNode(lastNodeParent) && (!lastNodeParent.canInsertTextBefore() || !lastNodeParent.canInsertTextAfter())) {
        this.insertText('');
        normalizeSelectionPointsForBoundaries(this.anchor, this.focus, null);
        this.insertText(text);
        return;
      }
    }
    if (selectedNodesLength === 1) {
      if (firstNode.isToken()) {
        const textNode = $createTextNode(text);
        textNode.select();
        firstNode.replace(textNode);
        return;
      }
      const firstNodeFormat = firstNode.getFormat();
      const firstNodeStyle = firstNode.getStyle();
      if (startOffset === endOffset && (firstNodeFormat !== format || firstNodeStyle !== style)) {
        if (firstNode.getTextContent() === '') {
          firstNode.setFormat(format);
          firstNode.setStyle(style);
        } else {
          const textNode = $createTextNode(text);
          textNode.setFormat(format);
          textNode.setStyle(style);
          textNode.select();
          if (startOffset === 0) {
            firstNode.insertBefore(textNode, false);
          } else {
            const [targetNode] = firstNode.splitText(startOffset);
            targetNode.insertAfter(textNode, false);
          }
          // When composing, we need to adjust the anchor offset so that
          // we correctly replace that right range.
          if (textNode.isComposing() && this.anchor.type === 'text') {
            this.anchor.offset -= text.length;
          }
          return;
        }
      } else if ($isTabNode(firstNode)) {
        // We don't need to check for delCount because there is only the entire selected node case
        // that can hit here for content size 1 and with canInsertTextBeforeAfter false
        const textNode = $createTextNode(text);
        textNode.setFormat(format);
        textNode.setStyle(style);
        textNode.select();
        firstNode.replace(textNode);
        return;
      }
      const delCount = endOffset - startOffset;
      firstNode = firstNode.spliceText(startOffset, delCount, text, true);
      if (firstNode.getTextContent() === '') {
        firstNode.remove();
      } else if (this.anchor.type === 'text') {
        if (firstNode.isComposing()) {
          // When composing, we need to adjust the anchor offset so that
          // we correctly replace that right range.
          this.anchor.offset -= text.length;
        } else {
          this.format = firstNodeFormat;
          this.style = firstNodeStyle;
        }
      }
    } else {
      const markedNodeKeysForKeep = new Set([...firstNode.getParentKeys(), ...lastNode.getParentKeys()]);

      // We have to get the parent elements before the next section,
      // as in that section we might mutate the lastNode.
      const firstElement = $isElementNode(firstNode) ? firstNode : firstNode.getParentOrThrow();
      let lastElement = $isElementNode(lastNode) ? lastNode : lastNode.getParentOrThrow();
      let lastElementChild = lastNode;

      // If the last element is inline, we should instead look at getting
      // the nodes of its parent, rather than itself. This behavior will
      // then better match how text node insertions work. We will need to
      // also update the last element's child accordingly as we do this.
      if (!firstElement.is(lastElement) && lastElement.isInline()) {
        // Keep traversing till we have a non-inline element parent.
        do {
          lastElementChild = lastElement;
          lastElement = lastElement.getParentOrThrow();
        } while (lastElement.isInline());
      }

      // Handle mutations to the last node.
      if (endPoint.type === 'text' && (endOffset !== 0 || lastNode.getTextContent() === '') || endPoint.type === 'element' && lastNode.getIndexWithinParent() < endOffset) {
        if ($isTextNode(lastNode) && !lastNode.isToken() && endOffset !== lastNode.getTextContentSize()) {
          if (lastNode.isSegmented()) {
            const textNode = $createTextNode(lastNode.getTextContent());
            lastNode.replace(textNode);
            lastNode = textNode;
          }
          // root node selections only select whole nodes, so no text splice is necessary
          if (!$isRootNode(endPoint.getNode()) && endPoint.type === 'text') {
            lastNode = lastNode.spliceText(0, endOffset, '');
          }
          markedNodeKeysForKeep.add(lastNode.__key);
        } else {
          const lastNodeParent = lastNode.getParentOrThrow();
          if (!lastNodeParent.canBeEmpty() && lastNodeParent.getChildrenSize() === 1) {
            lastNodeParent.remove();
          } else {
            lastNode.remove();
          }
        }
      } else {
        markedNodeKeysForKeep.add(lastNode.__key);
      }

      // Either move the remaining nodes of the last parent to after
      // the first child, or remove them entirely. If the last parent
      // is the same as the first parent, this logic also works.
      const lastNodeChildren = lastElement.getChildren();
      const selectedNodesSet = new Set(selectedNodes);
      const firstAndLastElementsAreEqual = firstElement.is(lastElement);

      // We choose a target to insert all nodes after. In the case of having
      // and inline starting parent element with a starting node that has no
      // siblings, we should insert after the starting parent element, otherwise
      // we will incorrectly merge into the starting parent element.
      // TODO: should we keep on traversing parents if we're inside another
      // nested inline element?
      const insertionTarget = firstElement.isInline() && firstNode.getNextSibling() === null ? firstElement : firstNode;
      for (let i = lastNodeChildren.length - 1; i >= 0; i--) {
        const lastNodeChild = lastNodeChildren[i];
        if (lastNodeChild.is(firstNode) || $isElementNode(lastNodeChild) && lastNodeChild.isParentOf(firstNode)) {
          break;
        }
        if (lastNodeChild.isAttached()) {
          if (!selectedNodesSet.has(lastNodeChild) || lastNodeChild.is(lastElementChild)) {
            if (!firstAndLastElementsAreEqual) {
              insertionTarget.insertAfter(lastNodeChild, false);
            }
          } else {
            lastNodeChild.remove();
          }
        }
      }
      if (!firstAndLastElementsAreEqual) {
        // Check if we have already moved out all the nodes of the
        // last parent, and if so, traverse the parent tree and mark
        // them all as being able to deleted too.
        let parent = lastElement;
        let lastRemovedParent = null;
        while (parent !== null) {
          const children = parent.getChildren();
          const childrenLength = children.length;
          if (childrenLength === 0 || children[childrenLength - 1].is(lastRemovedParent)) {
            markedNodeKeysForKeep.delete(parent.__key);
            lastRemovedParent = parent;
          }
          parent = parent.getParent();
        }
      }

      // Ensure we do splicing after moving of nodes, as splicing
      // can have side-effects (in the case of hashtags).
      if (!firstNode.isToken()) {
        firstNode = firstNode.spliceText(startOffset, firstNodeTextLength - startOffset, text, true);
        if (firstNode.getTextContent() === '') {
          firstNode.remove();
        } else if (firstNode.isComposing() && this.anchor.type === 'text') {
          // When composing, we need to adjust the anchor offset so that
          // we correctly replace that right range.
          this.anchor.offset -= text.length;
        }
      } else if (startOffset === firstNodeTextLength) {
        firstNode.select();
      } else {
        const textNode = $createTextNode(text);
        textNode.select();
        firstNode.replace(textNode);
      }

      // Remove all selected nodes that haven't already been removed.
      for (let i = 1; i < selectedNodesLength; i++) {
        const selectedNode = selectedNodes[i];
        const key = selectedNode.__key;
        if (!markedNodeKeysForKeep.has(key)) {
          selectedNode.remove();
        }
      }
    }
  }

  /**
   * Removes the text in the Selection, adjusting the EditorState accordingly.
   */
  removeText() {
    this.insertText('');
  }

  /**
   * Applies the provided format to the TextNodes in the Selection, splitting or
   * merging nodes as necessary.
   *
   * @param formatType the format type to apply to the nodes in the Selection.
   */
  formatText(formatType) {
    if (this.isCollapsed()) {
      this.toggleFormat(formatType);
      // When changing format, we should stop composition
      $setCompositionKey(null);
      return;
    }
    const selectedNodes = this.getNodes();
    const selectedTextNodes = [];
    for (const selectedNode of selectedNodes) {
      if ($isTextNode(selectedNode)) {
        selectedTextNodes.push(selectedNode);
      }
    }
    const selectedTextNodesLength = selectedTextNodes.length;
    if (selectedTextNodesLength === 0) {
      this.toggleFormat(formatType);
      // When changing format, we should stop composition
      $setCompositionKey(null);
      return;
    }
    const anchor = this.anchor;
    const focus = this.focus;
    const isBackward = this.isBackward();
    const startPoint = isBackward ? focus : anchor;
    const endPoint = isBackward ? anchor : focus;
    let firstIndex = 0;
    let firstNode = selectedTextNodes[0];
    let startOffset = startPoint.type === 'element' ? 0 : startPoint.offset;

    // In case selection started at the end of text node use next text node
    if (startPoint.type === 'text' && startOffset === firstNode.getTextContentSize()) {
      firstIndex = 1;
      firstNode = selectedTextNodes[1];
      startOffset = 0;
    }
    if (firstNode == null) {
      return;
    }
    const firstNextFormat = firstNode.getFormatFlags(formatType, null);
    const lastIndex = selectedTextNodesLength - 1;
    let lastNode = selectedTextNodes[lastIndex];
    const endOffset = endPoint.type === 'text' ? endPoint.offset : lastNode.getTextContentSize();

    // Single node selected
    if (firstNode.is(lastNode)) {
      // No actual text is selected, so do nothing.
      if (startOffset === endOffset) {
        return;
      }
      // The entire node is selected, so just format it
      if (startOffset === 0 && endOffset === firstNode.getTextContentSize()) {
        firstNode.setFormat(firstNextFormat);
      } else {
        // Node is partially selected, so split it into two nodes
        // add style the selected one.
        const splitNodes = firstNode.splitText(startOffset, endOffset);
        const replacement = startOffset === 0 ? splitNodes[0] : splitNodes[1];
        replacement.setFormat(firstNextFormat);

        // Update selection only if starts/ends on text node
        if (startPoint.type === 'text') {
          startPoint.set(replacement.__key, 0, 'text');
        }
        if (endPoint.type === 'text') {
          endPoint.set(replacement.__key, endOffset - startOffset, 'text');
        }
      }
      this.format = firstNextFormat;
      return;
    }
    // Multiple nodes selected
    // The entire first node isn't selected, so split it
    if (startOffset !== 0) {
      [, firstNode] = firstNode.splitText(startOffset);
      startOffset = 0;
    }
    firstNode.setFormat(firstNextFormat);
    const lastNextFormat = lastNode.getFormatFlags(formatType, firstNextFormat);
    // If the offset is 0, it means no actual characters are selected,
    // so we skip formatting the last node altogether.
    if (endOffset > 0) {
      if (endOffset !== lastNode.getTextContentSize()) {
        [lastNode] = lastNode.splitText(endOffset);
      }
      lastNode.setFormat(lastNextFormat);
    }

    // Process all text nodes in between
    for (let i = firstIndex + 1; i < lastIndex; i++) {
      const textNode = selectedTextNodes[i];
      if (!textNode.isToken()) {
        const nextFormat = textNode.getFormatFlags(formatType, lastNextFormat);
        textNode.setFormat(nextFormat);
      }
    }

    // Update selection only if starts/ends on text node
    if (startPoint.type === 'text') {
      startPoint.set(firstNode.__key, startOffset, 'text');
    }
    if (endPoint.type === 'text') {
      endPoint.set(lastNode.__key, endOffset, 'text');
    }
    this.format = firstNextFormat | lastNextFormat;
  }

  /**
   * Attempts to "intelligently" insert an arbitrary list of Lexical nodes into the EditorState at the
   * current Selection according to a set of heuristics that determine how surrounding nodes
   * should be changed, replaced, or moved to accomodate the incoming ones.
   *
   * @param nodes - the nodes to insert
   */
  insertNodes(nodes) {
    if (nodes.length === 0) {
      return;
    }
    if (this.anchor.key === 'root') {
      this.insertParagraph();
      const selection = $getSelection();
      if (!$isRangeSelection(selection)) {
        throw Error(`Expected RangeSelection after insertParagraph`);
      }
      return selection.insertNodes(nodes);
    }
    const firstPoint = this.isBackward() ? this.focus : this.anchor;
    const firstBlock = $getAncestor(firstPoint.getNode(), INTERNAL_$isBlock);
    const last = nodes[nodes.length - 1];

    // CASE 1: insert inside a code block
    if ('__language' in firstBlock && $isElementNode(firstBlock)) {
      if ('__language' in nodes[0]) {
        this.insertText(nodes[0].getTextContent());
      } else {
        const index = removeTextAndSplitBlock(this);
        firstBlock.splice(index, 0, nodes);
        last.selectEnd();
      }
      return;
    }

    // CASE 2: All elements of the array are inline
    const notInline = node => ($isElementNode(node) || $isDecoratorNode(node)) && !node.isInline();
    if (!nodes.some(notInline)) {
      if (!$isElementNode(firstBlock)) {
        throw Error(`Expected 'firstBlock' to be an ElementNode`);
      }
      const index = removeTextAndSplitBlock(this);
      firstBlock.splice(index, 0, nodes);
      last.selectEnd();
      return;
    }

    // CASE 3: At least 1 element of the array is not inline
    const blocksParent = $wrapInlineNodes(nodes);
    const nodeToSelect = blocksParent.getLastDescendant();
    const blocks = blocksParent.getChildren();
    const isLI = node => '__value' in node && '__checked' in node;
    const isMergeable = node => $isElementNode(node) && INTERNAL_$isBlock(node) && !node.isEmpty() && $isElementNode(firstBlock) && (!firstBlock.isEmpty() || isLI(firstBlock));
    const shouldInsert = !$isElementNode(firstBlock) || !firstBlock.isEmpty();
    const insertedParagraph = shouldInsert ? this.insertParagraph() : null;
    const lastToInsert = blocks[blocks.length - 1];
    let firstToInsert = blocks[0];
    if (isMergeable(firstToInsert)) {
      if (!$isElementNode(firstBlock)) {
        throw Error(`Expected 'firstBlock' to be an ElementNode`);
      }
      firstBlock.append(...firstToInsert.getChildren());
      firstToInsert = blocks[1];
    }
    if (firstToInsert) {
      insertRangeAfter(firstBlock, firstToInsert);
    }
    const lastInsertedBlock = $getAncestor(nodeToSelect, INTERNAL_$isBlock);
    if (insertedParagraph && $isElementNode(lastInsertedBlock) && (isLI(insertedParagraph) || INTERNAL_$isBlock(lastToInsert))) {
      lastInsertedBlock.append(...insertedParagraph.getChildren());
      insertedParagraph.remove();
    }
    if ($isElementNode(firstBlock) && firstBlock.isEmpty()) {
      firstBlock.remove();
    }
    nodeToSelect.selectEnd();

    // To understand this take a look at the test "can wrap post-linebreak nodes into new element"
    const lastChild = $isElementNode(firstBlock) ? firstBlock.getLastChild() : null;
    if ($isLineBreakNode(lastChild) && lastInsertedBlock !== firstBlock) {
      lastChild.remove();
    }
  }

  /**
   * Inserts a new ParagraphNode into the EditorState at the current Selection
   *
   * @returns the newly inserted node.
   */
  insertParagraph() {
    if (this.anchor.key === 'root') {
      const paragraph = $createParagraphNode();
      $getRoot().splice(this.anchor.offset, 0, [paragraph]);
      paragraph.select();
      return paragraph;
    }
    const index = removeTextAndSplitBlock(this);
    const block = $getAncestor(this.anchor.getNode(), INTERNAL_$isBlock);
    if (!$isElementNode(block)) {
      throw Error(`Expected ancestor to be an ElementNode`);
    }
    const firstToAppend = block.getChildAtIndex(index);
    const nodesToInsert = firstToAppend ? [firstToAppend, ...firstToAppend.getNextSiblings()] : [];
    const newBlock = block.insertNewAfter(this, false);
    if (newBlock) {
      newBlock.append(...nodesToInsert);
      newBlock.selectStart();
      return newBlock;
    }
    // if newBlock is null, it means that block is of type CodeNode.
    return null;
  }

  /**
   * Inserts a logical linebreak, which may be a new LineBreakNode or a new ParagraphNode, into the EditorState at the
   * current Selection.
   */
  insertLineBreak(selectStart) {
    const lineBreak = $createLineBreakNode();
    this.insertNodes([lineBreak]);
    // this is used in MacOS with the command 'ctrl-O' (openLineBreak)
    if (selectStart) {
      const parent = lineBreak.getParentOrThrow();
      const index = lineBreak.getIndexWithinParent();
      parent.select(index, index);
    }
  }

  /**
   * Extracts the nodes in the Selection, splitting nodes where necessary
   * to get offset-level precision.
   *
   * @returns The nodes in the Selection
   */
  extract() {
    const selectedNodes = this.getNodes();
    const selectedNodesLength = selectedNodes.length;
    const lastIndex = selectedNodesLength - 1;
    const anchor = this.anchor;
    const focus = this.focus;
    let firstNode = selectedNodes[0];
    let lastNode = selectedNodes[lastIndex];
    const [anchorOffset, focusOffset] = $getCharacterOffsets(this);
    if (selectedNodesLength === 0) {
      return [];
    } else if (selectedNodesLength === 1) {
      if ($isTextNode(firstNode) && !this.isCollapsed()) {
        const startOffset = anchorOffset > focusOffset ? focusOffset : anchorOffset;
        const endOffset = anchorOffset > focusOffset ? anchorOffset : focusOffset;
        const splitNodes = firstNode.splitText(startOffset, endOffset);
        const node = startOffset === 0 ? splitNodes[0] : splitNodes[1];
        return node != null ? [node] : [];
      }
      return [firstNode];
    }
    const isBefore = anchor.isBefore(focus);
    if ($isTextNode(firstNode)) {
      const startOffset = isBefore ? anchorOffset : focusOffset;
      if (startOffset === firstNode.getTextContentSize()) {
        selectedNodes.shift();
      } else if (startOffset !== 0) {
        [, firstNode] = firstNode.splitText(startOffset);
        selectedNodes[0] = firstNode;
      }
    }
    if ($isTextNode(lastNode)) {
      const lastNodeText = lastNode.getTextContent();
      const lastNodeTextLength = lastNodeText.length;
      const endOffset = isBefore ? focusOffset : anchorOffset;
      if (endOffset === 0) {
        selectedNodes.pop();
      } else if (endOffset !== lastNodeTextLength) {
        [lastNode] = lastNode.splitText(endOffset);
        selectedNodes[lastIndex] = lastNode;
      }
    }
    return selectedNodes;
  }

  /**
   * Modifies the Selection according to the parameters and a set of heuristics that account for
   * various node types. Can be used to safely move or extend selection by one logical "unit" without
   * dealing explicitly with all the possible node types.
   *
   * @param alter the type of modification to perform
   * @param isBackward whether or not selection is backwards
   * @param granularity the granularity at which to apply the modification
   */
  modify(alter, isBackward, granularity) {
    const focus = this.focus;
    const anchor = this.anchor;
    const collapse = alter === 'move';

    // Handle the selection movement around decorators.
    const possibleNode = $getAdjacentNode(focus, isBackward);
    if ($isDecoratorNode(possibleNode) && !possibleNode.isIsolated()) {
      // Make it possible to move selection from range selection to
      // node selection on the node.
      if (collapse && possibleNode.isKeyboardSelectable()) {
        const nodeSelection = $createNodeSelection();
        nodeSelection.add(possibleNode.__key);
        $setSelection(nodeSelection);
        return;
      }
      const sibling = isBackward ? possibleNode.getPreviousSibling() : possibleNode.getNextSibling();
      if (!$isTextNode(sibling)) {
        const parent = possibleNode.getParentOrThrow();
        let offset;
        let elementKey;
        if ($isElementNode(sibling)) {
          elementKey = sibling.__key;
          offset = isBackward ? sibling.getChildrenSize() : 0;
        } else {
          offset = possibleNode.getIndexWithinParent();
          elementKey = parent.__key;
          if (!isBackward) {
            offset++;
          }
        }
        focus.set(elementKey, offset, 'element');
        if (collapse) {
          anchor.set(elementKey, offset, 'element');
        }
        return;
      } else {
        const siblingKey = sibling.__key;
        const offset = isBackward ? sibling.getTextContent().length : 0;
        focus.set(siblingKey, offset, 'text');
        if (collapse) {
          anchor.set(siblingKey, offset, 'text');
        }
        return;
      }
    }
    const editor = getActiveEditor();
    const domSelection = getDOMSelection(editor._window);
    if (!domSelection) {
      return;
    }
    const blockCursorElement = editor._blockCursorElement;
    const rootElement = editor._rootElement;
    // Remove the block cursor element if it exists. This will ensure selection
    // works as intended. If we leave it in the DOM all sorts of strange bugs
    // occur. :/
    if (rootElement !== null && blockCursorElement !== null && $isElementNode(possibleNode) && !possibleNode.isInline() && !possibleNode.canBeEmpty()) {
      removeDOMBlockCursorElement(blockCursorElement, editor, rootElement);
    }
    // We use the DOM selection.modify API here to "tell" us what the selection
    // will be. We then use it to update the Lexical selection accordingly. This
    // is much more reliable than waiting for a beforeinput and using the ranges
    // from getTargetRanges(), and is also better than trying to do it ourselves
    // using Intl.Segmenter or other workarounds that struggle with word segments
    // and line segments (especially with word wrapping and non-Roman languages).
    moveNativeSelection(domSelection, alter, isBackward ? 'backward' : 'forward', granularity);
    // Guard against no ranges
    if (domSelection.rangeCount > 0) {
      const range = domSelection.getRangeAt(0);
      // Apply the DOM selection to our Lexical selection.
      const anchorNode = this.anchor.getNode();
      const root = $isRootNode(anchorNode) ? anchorNode : $getNearestRootOrShadowRoot(anchorNode);
      this.applyDOMRange(range);
      this.dirty = true;
      if (!collapse) {
        // Validate selection; make sure that the new extended selection respects shadow roots
        const nodes = this.getNodes();
        const validNodes = [];
        let shrinkSelection = false;
        for (let i = 0; i < nodes.length; i++) {
          const nextNode = nodes[i];
          if ($hasAncestor(nextNode, root)) {
            validNodes.push(nextNode);
          } else {
            shrinkSelection = true;
          }
        }
        if (shrinkSelection && validNodes.length > 0) {
          // validNodes length check is a safeguard against an invalid selection; as getNodes()
          // will return an empty array in this case
          if (isBackward) {
            const firstValidNode = validNodes[0];
            if ($isElementNode(firstValidNode)) {
              firstValidNode.selectStart();
            } else {
              firstValidNode.getParentOrThrow().selectStart();
            }
          } else {
            const lastValidNode = validNodes[validNodes.length - 1];
            if ($isElementNode(lastValidNode)) {
              lastValidNode.selectEnd();
            } else {
              lastValidNode.getParentOrThrow().selectEnd();
            }
          }
        }

        // Because a range works on start and end, we might need to flip
        // the anchor and focus points to match what the DOM has, not what
        // the range has specifically.
        if (domSelection.anchorNode !== range.startContainer || domSelection.anchorOffset !== range.startOffset) {
          $swapPoints(this);
        }
      }
    }
  }

  /**
   * Performs one logical character deletion operation on the EditorState based on the current Selection.
   * Handles different node types.
   *
   * @param isBackward whether or not the selection is backwards.
   */
  deleteCharacter(isBackward) {
    const wasCollapsed = this.isCollapsed();
    if (this.isCollapsed()) {
      const anchor = this.anchor;
      const focus = this.focus;
      let anchorNode = anchor.getNode();
      if (!isBackward && (
      // Delete forward handle case
      anchor.type === 'element' && $isElementNode(anchorNode) && anchor.offset === anchorNode.getChildrenSize() || anchor.type === 'text' && anchor.offset === anchorNode.getTextContentSize())) {
        const parent = anchorNode.getParent();
        const nextSibling = anchorNode.getNextSibling() || (parent === null ? null : parent.getNextSibling());
        if ($isElementNode(nextSibling) && nextSibling.isShadowRoot()) {
          return;
        }
      }
      // Handle the deletion around decorators.
      const possibleNode = $getAdjacentNode(focus, isBackward);
      if ($isDecoratorNode(possibleNode) && !possibleNode.isIsolated()) {
        // Make it possible to move selection from range selection to
        // node selection on the node.
        if (possibleNode.isKeyboardSelectable() && $isElementNode(anchorNode) && anchorNode.getChildrenSize() === 0) {
          anchorNode.remove();
          const nodeSelection = $createNodeSelection();
          nodeSelection.add(possibleNode.__key);
          $setSelection(nodeSelection);
        } else {
          possibleNode.remove();
          const editor = getActiveEditor();
          editor.dispatchCommand(SELECTION_CHANGE_COMMAND, undefined);
        }
        return;
      } else if (!isBackward && $isElementNode(possibleNode) && $isElementNode(anchorNode) && anchorNode.isEmpty()) {
        anchorNode.remove();
        possibleNode.selectStart();
        return;
      }
      this.modify('extend', isBackward, 'character');
      if (!this.isCollapsed()) {
        const focusNode = focus.type === 'text' ? focus.getNode() : null;
        anchorNode = anchor.type === 'text' ? anchor.getNode() : null;
        if (focusNode !== null && focusNode.isSegmented()) {
          const offset = focus.offset;
          const textContentSize = focusNode.getTextContentSize();
          if (focusNode.is(anchorNode) || isBackward && offset !== textContentSize || !isBackward && offset !== 0) {
            $removeSegment(focusNode, isBackward, offset);
            return;
          }
        } else if (anchorNode !== null && anchorNode.isSegmented()) {
          const offset = anchor.offset;
          const textContentSize = anchorNode.getTextContentSize();
          if (anchorNode.is(focusNode) || isBackward && offset !== 0 || !isBackward && offset !== textContentSize) {
            $removeSegment(anchorNode, isBackward, offset);
            return;
          }
        }
        $updateCaretSelectionForUnicodeCharacter(this, isBackward);
      } else if (isBackward && anchor.offset === 0) {
        // Special handling around rich text nodes
        const element = anchor.type === 'element' ? anchor.getNode() : anchor.getNode().getParentOrThrow();
        if (element.collapseAtStart(this)) {
          return;
        }
      }
    }
    this.removeText();
    if (isBackward && !wasCollapsed && this.isCollapsed() && this.anchor.type === 'element' && this.anchor.offset === 0) {
      const anchorNode = this.anchor.getNode();
      if (anchorNode.isEmpty() && $isRootNode(anchorNode.getParent()) && anchorNode.getIndexWithinParent() === 0) {
        anchorNode.collapseAtStart(this);
      }
    }
  }

  /**
   * Performs one logical line deletion operation on the EditorState based on the current Selection.
   * Handles different node types.
   *
   * @param isBackward whether or not the selection is backwards.
   */
  deleteLine(isBackward) {
    if (this.isCollapsed()) {
      if (this.anchor.type === 'text') {
        this.modify('extend', isBackward, 'lineboundary');
      }

      // If selection is extended to cover text edge then extend it one character more
      // to delete its parent element. Otherwise text content will be deleted but empty
      // parent node will remain
      const endPoint = isBackward ? this.focus : this.anchor;
      if (endPoint.offset === 0) {
        this.modify('extend', isBackward, 'character');
      }
    }
    this.removeText();
  }

  /**
   * Performs one logical word deletion operation on the EditorState based on the current Selection.
   * Handles different node types.
   *
   * @param isBackward whether or not the selection is backwards.
   */
  deleteWord(isBackward) {
    if (this.isCollapsed()) {
      this.modify('extend', isBackward, 'word');
    }
    this.removeText();
  }

  /**
   * Returns whether the Selection is "backwards", meaning the focus
   * logically precedes the anchor in the EditorState.
   * @returns true if the Selection is backwards, false otherwise.
   */
  isBackward() {
    return this.focus.isBefore(this.anchor);
  }
  getStartEndPoints() {
    return [this.anchor, this.focus];
  }
}
function $isNodeSelection(x) {
  return x instanceof NodeSelection;
}
function getCharacterOffset(point) {
  const offset = point.offset;
  if (point.type === 'text') {
    return offset;
  }
  const parent = point.getNode();
  return offset === parent.getChildrenSize() ? parent.getTextContent().length : 0;
}
function $getCharacterOffsets(selection) {
  const anchorAndFocus = selection.getStartEndPoints();
  if (anchorAndFocus === null) {
    return [0, 0];
  }
  const [anchor, focus] = anchorAndFocus;
  if (anchor.type === 'element' && focus.type === 'element' && anchor.key === focus.key && anchor.offset === focus.offset) {
    return [0, 0];
  }
  return [getCharacterOffset(anchor), getCharacterOffset(focus)];
}
function $swapPoints(selection) {
  const focus = selection.focus;
  const anchor = selection.anchor;
  const anchorKey = anchor.key;
  const anchorOffset = anchor.offset;
  const anchorType = anchor.type;
  $setPointValues(anchor, focus.key, focus.offset, focus.type);
  $setPointValues(focus, anchorKey, anchorOffset, anchorType);
  selection._cachedNodes = null;
}
function moveNativeSelection(domSelection, alter, direction, granularity) {
  // Selection.modify() method applies a change to the current selection or cursor position,
  // but is still non-standard in some browsers.
  domSelection.modify(alter, direction, granularity);
}
function $updateCaretSelectionForUnicodeCharacter(selection, isBackward) {
  const anchor = selection.anchor;
  const focus = selection.focus;
  const anchorNode = anchor.getNode();
  const focusNode = focus.getNode();
  if (anchorNode === focusNode && anchor.type === 'text' && focus.type === 'text') {
    // Handling of multibyte characters
    const anchorOffset = anchor.offset;
    const focusOffset = focus.offset;
    const isBefore = anchorOffset < focusOffset;
    const startOffset = isBefore ? anchorOffset : focusOffset;
    const endOffset = isBefore ? focusOffset : anchorOffset;
    const characterOffset = endOffset - 1;
    if (startOffset !== characterOffset) {
      const text = anchorNode.getTextContent().slice(startOffset, endOffset);
      if (!doesContainGrapheme(text)) {
        if (isBackward) {
          focus.offset = characterOffset;
        } else {
          anchor.offset = characterOffset;
        }
      }
    }
  }
}
function $removeSegment(node, isBackward, offset) {
  const textNode = node;
  const textContent = textNode.getTextContent();
  const split = textContent.split(/(?=\s)/g);
  const splitLength = split.length;
  let segmentOffset = 0;
  let restoreOffset = 0;
  for (let i = 0; i < splitLength; i++) {
    const text = split[i];
    const isLast = i === splitLength - 1;
    restoreOffset = segmentOffset;
    segmentOffset += text.length;
    if (isBackward && segmentOffset === offset || segmentOffset > offset || isLast) {
      split.splice(i, 1);
      if (isLast) {
        restoreOffset = undefined;
      }
      break;
    }
  }
  const nextTextContent = split.join('').trim();
  if (nextTextContent === '') {
    textNode.remove();
  } else {
    textNode.setTextContent(nextTextContent);
    textNode.select(restoreOffset, restoreOffset);
  }
}
function shouldResolveAncestor(resolvedElement, resolvedOffset, lastPoint) {
  const parent = resolvedElement.getParent();
  return lastPoint === null || parent === null || !parent.canBeEmpty() || parent !== lastPoint.getNode();
}
function internalResolveSelectionPoint(dom, offset, lastPoint, editor) {
  let resolvedOffset = offset;
  let resolvedNode;
  // If we have selection on an element, we will
  // need to figure out (using the offset) what text
  // node should be selected.

  if (dom.nodeType === DOM_ELEMENT_TYPE) {
    // Resolve element to a ElementNode, or TextNode, or null
    let moveSelectionToEnd = false;
    // Given we're moving selection to another node, selection is
    // definitely dirty.
    // We use the anchor to find which child node to select
    const childNodes = dom.childNodes;
    const childNodesLength = childNodes.length;
    // If the anchor is the same as length, then this means we
    // need to select the very last text node.
    if (resolvedOffset === childNodesLength) {
      moveSelectionToEnd = true;
      resolvedOffset = childNodesLength - 1;
    }
    let childDOM = childNodes[resolvedOffset];
    let hasBlockCursor = false;
    if (childDOM === editor._blockCursorElement) {
      childDOM = childNodes[resolvedOffset + 1];
      hasBlockCursor = true;
    } else if (editor._blockCursorElement !== null) {
      resolvedOffset--;
    }
    resolvedNode = getNodeFromDOM(childDOM);
    if ($isTextNode(resolvedNode)) {
      resolvedOffset = getTextNodeOffset(resolvedNode, moveSelectionToEnd);
    } else {
      let resolvedElement = getNodeFromDOM(dom);
      // Ensure resolvedElement is actually a element.
      if (resolvedElement === null) {
        return null;
      }
      if ($isElementNode(resolvedElement)) {
        let child = resolvedElement.getChildAtIndex(resolvedOffset);
        if ($isElementNode(child) && shouldResolveAncestor(child, resolvedOffset, lastPoint)) {
          const descendant = moveSelectionToEnd ? child.getLastDescendant() : child.getFirstDescendant();
          if (descendant === null) {
            resolvedElement = child;
            resolvedOffset = 0;
          } else {
            child = descendant;
            resolvedElement = $isElementNode(child) ? child : child.getParentOrThrow();
          }
        }
        if ($isTextNode(child)) {
          resolvedNode = child;
          resolvedElement = null;
          resolvedOffset = getTextNodeOffset(child, moveSelectionToEnd);
        } else if (child !== resolvedElement && moveSelectionToEnd && !hasBlockCursor) {
          resolvedOffset++;
        }
      } else {
        const index = resolvedElement.getIndexWithinParent();
        // When selecting decorators, there can be some selection issues when using resolvedOffset,
        // and instead we should be checking if we're using the offset
        if (offset === 0 && $isDecoratorNode(resolvedElement) && getNodeFromDOM(dom) === resolvedElement) {
          resolvedOffset = index;
        } else {
          resolvedOffset = index + 1;
        }
        resolvedElement = resolvedElement.getParentOrThrow();
      }
      if ($isElementNode(resolvedElement)) {
        return $createPoint(resolvedElement.__key, resolvedOffset, 'element');
      }
    }
  } else {
    // TextNode or null
    resolvedNode = getNodeFromDOM(dom);
  }
  if (!$isTextNode(resolvedNode)) {
    return null;
  }
  return $createPoint(resolvedNode.__key, resolvedOffset, 'text');
}
function resolveSelectionPointOnBoundary(point, isBackward, isCollapsed) {
  const offset = point.offset;
  const node = point.getNode();
  if (offset === 0) {
    const prevSibling = node.getPreviousSibling();
    const parent = node.getParent();
    if (!isBackward) {
      if ($isElementNode(prevSibling) && !isCollapsed && prevSibling.isInline()) {
        point.key = prevSibling.__key;
        point.offset = prevSibling.getChildrenSize();
        // @ts-expect-error: intentional
        point.type = 'element';
      } else if ($isTextNode(prevSibling)) {
        point.key = prevSibling.__key;
        point.offset = prevSibling.getTextContent().length;
      }
    } else if ((isCollapsed || !isBackward) && prevSibling === null && $isElementNode(parent) && parent.isInline()) {
      const parentSibling = parent.getPreviousSibling();
      if ($isTextNode(parentSibling)) {
        point.key = parentSibling.__key;
        point.offset = parentSibling.getTextContent().length;
      }
    }
  } else if (offset === node.getTextContent().length) {
    const nextSibling = node.getNextSibling();
    const parent = node.getParent();
    if (isBackward && $isElementNode(nextSibling) && nextSibling.isInline()) {
      point.key = nextSibling.__key;
      point.offset = 0;
      // @ts-expect-error: intentional
      point.type = 'element';
    } else if ((isCollapsed || isBackward) && nextSibling === null && $isElementNode(parent) && parent.isInline() && !parent.canInsertTextAfter()) {
      const parentSibling = parent.getNextSibling();
      if ($isTextNode(parentSibling)) {
        point.key = parentSibling.__key;
        point.offset = 0;
      }
    }
  }
}
function normalizeSelectionPointsForBoundaries(anchor, focus, lastSelection) {
  if (anchor.type === 'text' && focus.type === 'text') {
    const isBackward = anchor.isBefore(focus);
    const isCollapsed = anchor.is(focus);

    // Attempt to normalize the offset to the previous sibling if we're at the
    // start of a text node and the sibling is a text node or inline element.
    resolveSelectionPointOnBoundary(anchor, isBackward, isCollapsed);
    resolveSelectionPointOnBoundary(focus, !isBackward, isCollapsed);
    if (isCollapsed) {
      focus.key = anchor.key;
      focus.offset = anchor.offset;
      focus.type = anchor.type;
    }
    const editor = getActiveEditor();
    if (editor.isComposing() && editor._compositionKey !== anchor.key && $isRangeSelection(lastSelection)) {
      const lastAnchor = lastSelection.anchor;
      const lastFocus = lastSelection.focus;
      $setPointValues(anchor, lastAnchor.key, lastAnchor.offset, lastAnchor.type);
      $setPointValues(focus, lastFocus.key, lastFocus.offset, lastFocus.type);
    }
  }
}
function internalResolveSelectionPoints(anchorDOM, anchorOffset, focusDOM, focusOffset, editor, lastSelection) {
  if (anchorDOM === null || focusDOM === null || !isSelectionWithinEditor(editor, anchorDOM, focusDOM)) {
    return null;
  }
  const resolvedAnchorPoint = internalResolveSelectionPoint(anchorDOM, anchorOffset, $isRangeSelection(lastSelection) ? lastSelection.anchor : null, editor);
  if (resolvedAnchorPoint === null) {
    return null;
  }
  const resolvedFocusPoint = internalResolveSelectionPoint(focusDOM, focusOffset, $isRangeSelection(lastSelection) ? lastSelection.focus : null, editor);
  if (resolvedFocusPoint === null) {
    return null;
  }
  if (resolvedAnchorPoint.type === 'element' && resolvedFocusPoint.type === 'element') {
    const anchorNode = getNodeFromDOM(anchorDOM);
    const focusNode = getNodeFromDOM(focusDOM);
    // Ensure if we're selecting the content of a decorator that we
    // return null for this point, as it's not in the controlled scope
    // of Lexical.
    if ($isDecoratorNode(anchorNode) && $isDecoratorNode(focusNode)) {
      return null;
    }
  }

  // Handle normalization of selection when it is at the boundaries.
  normalizeSelectionPointsForBoundaries(resolvedAnchorPoint, resolvedFocusPoint, lastSelection);
  return [resolvedAnchorPoint, resolvedFocusPoint];
}
function $isBlockElementNode(node) {
  return $isElementNode(node) && !node.isInline();
}

// This is used to make a selection when the existing
// selection is null, i.e. forcing selection on the editor
// when it current exists outside the editor.

function internalMakeRangeSelection(anchorKey, anchorOffset, focusKey, focusOffset, anchorType, focusType) {
  const editorState = getActiveEditorState();
  const selection = new RangeSelection($createPoint(anchorKey, anchorOffset, anchorType), $createPoint(focusKey, focusOffset, focusType), 0, '');
  selection.dirty = true;
  editorState._selection = selection;
  return selection;
}
function $createRangeSelection() {
  const anchor = $createPoint('root', 0, 'element');
  const focus = $createPoint('root', 0, 'element');
  return new RangeSelection(anchor, focus, 0, '');
}
function $createNodeSelection() {
  return new NodeSelection(new Set());
}
function internalCreateSelection(editor) {
  const currentEditorState = editor.getEditorState();
  const lastSelection = currentEditorState._selection;
  const domSelection = getDOMSelection(editor._window);
  if ($isRangeSelection(lastSelection) || lastSelection == null) {
    return internalCreateRangeSelection(lastSelection, domSelection, editor, null);
  }
  return lastSelection.clone();
}
function internalCreateRangeSelection(lastSelection, domSelection, editor, event) {
  const windowObj = editor._window;
  if (windowObj === null) {
    return null;
  }
  // When we create a selection, we try to use the previous
  // selection where possible, unless an actual user selection
  // change has occurred. When we do need to create a new selection
  // we validate we can have text nodes for both anchor and focus
  // nodes. If that holds true, we then return that selection
  // as a mutable object that we use for the editor state for this
  // update cycle. If a selection gets changed, and requires a
  // update to native DOM selection, it gets marked as "dirty".
  // If the selection changes, but matches with the existing
  // DOM selection, then we only need to sync it. Otherwise,
  // we generally bail out of doing an update to selection during
  // reconciliation unless there are dirty nodes that need
  // reconciling.

  const windowEvent = event || windowObj.event;
  const eventType = windowEvent ? windowEvent.type : undefined;
  const isSelectionChange = eventType === 'selectionchange';
  const useDOMSelection = !getIsProcessingMutations() && (isSelectionChange || eventType === 'beforeinput' || eventType === 'compositionstart' || eventType === 'compositionend' || eventType === 'click' && windowEvent && windowEvent.detail === 3 || eventType === 'drop' || eventType === undefined);
  let anchorDOM, focusDOM, anchorOffset, focusOffset;
  if (!$isRangeSelection(lastSelection) || useDOMSelection) {
    if (domSelection === null) {
      return null;
    }
    anchorDOM = domSelection.anchorNode;
    focusDOM = domSelection.focusNode;
    anchorOffset = domSelection.anchorOffset;
    focusOffset = domSelection.focusOffset;
    if (isSelectionChange && $isRangeSelection(lastSelection) && !isSelectionWithinEditor(editor, anchorDOM, focusDOM)) {
      return lastSelection.clone();
    }
  } else {
    return lastSelection.clone();
  }
  // Let's resolve the text nodes from the offsets and DOM nodes we have from
  // native selection.
  const resolvedSelectionPoints = internalResolveSelectionPoints(anchorDOM, anchorOffset, focusDOM, focusOffset, editor, lastSelection);
  if (resolvedSelectionPoints === null) {
    return null;
  }
  const [resolvedAnchorPoint, resolvedFocusPoint] = resolvedSelectionPoints;
  return new RangeSelection(resolvedAnchorPoint, resolvedFocusPoint, !$isRangeSelection(lastSelection) ? 0 : lastSelection.format, !$isRangeSelection(lastSelection) ? '' : lastSelection.style);
}
function $getSelection() {
  const editorState = getActiveEditorState();
  return editorState._selection;
}
function $getPreviousSelection() {
  const editor = getActiveEditor();
  return editor._editorState._selection;
}
function $updateElementSelectionOnCreateDeleteNode(selection, parentNode, nodeOffset, times = 1) {
  const anchor = selection.anchor;
  const focus = selection.focus;
  const anchorNode = anchor.getNode();
  const focusNode = focus.getNode();
  if (!parentNode.is(anchorNode) && !parentNode.is(focusNode)) {
    return;
  }
  const parentKey = parentNode.__key;
  // Single node. We shift selection but never redimension it
  if (selection.isCollapsed()) {
    const selectionOffset = anchor.offset;
    if (nodeOffset <= selectionOffset && times > 0 || nodeOffset < selectionOffset && times < 0) {
      const newSelectionOffset = Math.max(0, selectionOffset + times);
      anchor.set(parentKey, newSelectionOffset, 'element');
      focus.set(parentKey, newSelectionOffset, 'element');
      // The new selection might point to text nodes, try to resolve them
      $updateSelectionResolveTextNodes(selection);
    }
  } else {
    // Multiple nodes selected. We shift or redimension selection
    const isBackward = selection.isBackward();
    const firstPoint = isBackward ? focus : anchor;
    const firstPointNode = firstPoint.getNode();
    const lastPoint = isBackward ? anchor : focus;
    const lastPointNode = lastPoint.getNode();
    if (parentNode.is(firstPointNode)) {
      const firstPointOffset = firstPoint.offset;
      if (nodeOffset <= firstPointOffset && times > 0 || nodeOffset < firstPointOffset && times < 0) {
        firstPoint.set(parentKey, Math.max(0, firstPointOffset + times), 'element');
      }
    }
    if (parentNode.is(lastPointNode)) {
      const lastPointOffset = lastPoint.offset;
      if (nodeOffset <= lastPointOffset && times > 0 || nodeOffset < lastPointOffset && times < 0) {
        lastPoint.set(parentKey, Math.max(0, lastPointOffset + times), 'element');
      }
    }
  }
  // The new selection might point to text nodes, try to resolve them
  $updateSelectionResolveTextNodes(selection);
}
function $updateSelectionResolveTextNodes(selection) {
  const anchor = selection.anchor;
  const anchorOffset = anchor.offset;
  const focus = selection.focus;
  const focusOffset = focus.offset;
  const anchorNode = anchor.getNode();
  const focusNode = focus.getNode();
  if (selection.isCollapsed()) {
    if (!$isElementNode(anchorNode)) {
      return;
    }
    const childSize = anchorNode.getChildrenSize();
    const anchorOffsetAtEnd = anchorOffset >= childSize;
    const child = anchorOffsetAtEnd ? anchorNode.getChildAtIndex(childSize - 1) : anchorNode.getChildAtIndex(anchorOffset);
    if ($isTextNode(child)) {
      let newOffset = 0;
      if (anchorOffsetAtEnd) {
        newOffset = child.getTextContentSize();
      }
      anchor.set(child.__key, newOffset, 'text');
      focus.set(child.__key, newOffset, 'text');
    }
    return;
  }
  if ($isElementNode(anchorNode)) {
    const childSize = anchorNode.getChildrenSize();
    const anchorOffsetAtEnd = anchorOffset >= childSize;
    const child = anchorOffsetAtEnd ? anchorNode.getChildAtIndex(childSize - 1) : anchorNode.getChildAtIndex(anchorOffset);
    if ($isTextNode(child)) {
      let newOffset = 0;
      if (anchorOffsetAtEnd) {
        newOffset = child.getTextContentSize();
      }
      anchor.set(child.__key, newOffset, 'text');
    }
  }
  if ($isElementNode(focusNode)) {
    const childSize = focusNode.getChildrenSize();
    const focusOffsetAtEnd = focusOffset >= childSize;
    const child = focusOffsetAtEnd ? focusNode.getChildAtIndex(childSize - 1) : focusNode.getChildAtIndex(focusOffset);
    if ($isTextNode(child)) {
      let newOffset = 0;
      if (focusOffsetAtEnd) {
        newOffset = child.getTextContentSize();
      }
      focus.set(child.__key, newOffset, 'text');
    }
  }
}
function applySelectionTransforms(nextEditorState, editor) {
  const prevEditorState = editor.getEditorState();
  const prevSelection = prevEditorState._selection;
  const nextSelection = nextEditorState._selection;
  if ($isRangeSelection(nextSelection)) {
    const anchor = nextSelection.anchor;
    const focus = nextSelection.focus;
    let anchorNode;
    if (anchor.type === 'text') {
      anchorNode = anchor.getNode();
      anchorNode.selectionTransform(prevSelection, nextSelection);
    }
    if (focus.type === 'text') {
      const focusNode = focus.getNode();
      if (anchorNode !== focusNode) {
        focusNode.selectionTransform(prevSelection, nextSelection);
      }
    }
  }
}
function moveSelectionPointToSibling(point, node, parent, prevSibling, nextSibling) {
  let siblingKey = null;
  let offset = 0;
  let type = null;
  if (prevSibling !== null) {
    siblingKey = prevSibling.__key;
    if ($isTextNode(prevSibling)) {
      offset = prevSibling.getTextContentSize();
      type = 'text';
    } else if ($isElementNode(prevSibling)) {
      offset = prevSibling.getChildrenSize();
      type = 'element';
    }
  } else {
    if (nextSibling !== null) {
      siblingKey = nextSibling.__key;
      if ($isTextNode(nextSibling)) {
        type = 'text';
      } else if ($isElementNode(nextSibling)) {
        type = 'element';
      }
    }
  }
  if (siblingKey !== null && type !== null) {
    point.set(siblingKey, offset, type);
  } else {
    offset = node.getIndexWithinParent();
    if (offset === -1) {
      // Move selection to end of parent
      offset = parent.getChildrenSize();
    }
    point.set(parent.__key, offset, 'element');
  }
}
function adjustPointOffsetForMergedSibling(point, isBefore, key, target, textLength) {
  if (point.type === 'text') {
    point.key = key;
    if (!isBefore) {
      point.offset += textLength;
    }
  } else if (point.offset > target.getIndexWithinParent()) {
    point.offset -= 1;
  }
}
function updateDOMSelection(prevSelection, nextSelection, editor, domSelection, tags, rootElement, nodeCount) {
  const anchorDOMNode = domSelection.anchorNode;
  const focusDOMNode = domSelection.focusNode;
  const anchorOffset = domSelection.anchorOffset;
  const focusOffset = domSelection.focusOffset;
  const activeElement = document.activeElement;

  // TODO: make this not hard-coded, and add another config option
  // that makes this configurable.
  if (tags.has('collaboration') && activeElement !== rootElement || activeElement !== null && isSelectionCapturedInDecoratorInput(activeElement)) {
    return;
  }
  if (!$isRangeSelection(nextSelection)) {
    // We don't remove selection if the prevSelection is null because
    // of editor.setRootElement(). If this occurs on init when the
    // editor is already focused, then this can cause the editor to
    // lose focus.
    if (prevSelection !== null && isSelectionWithinEditor(editor, anchorDOMNode, focusDOMNode)) {
      domSelection.removeAllRanges();
    }
    return;
  }
  const anchor = nextSelection.anchor;
  const focus = nextSelection.focus;
  const anchorKey = anchor.key;
  const focusKey = focus.key;
  const anchorDOM = getElementByKeyOrThrow(editor, anchorKey);
  const focusDOM = getElementByKeyOrThrow(editor, focusKey);
  const nextAnchorOffset = anchor.offset;
  const nextFocusOffset = focus.offset;
  const nextFormat = nextSelection.format;
  const nextStyle = nextSelection.style;
  const isCollapsed = nextSelection.isCollapsed();
  let nextAnchorNode = anchorDOM;
  let nextFocusNode = focusDOM;
  let anchorFormatOrStyleChanged = false;
  if (anchor.type === 'text') {
    nextAnchorNode = getDOMTextNode(anchorDOM);
    const anchorNode = anchor.getNode();
    anchorFormatOrStyleChanged = anchorNode.getFormat() !== nextFormat || anchorNode.getStyle() !== nextStyle;
  } else if ($isRangeSelection(prevSelection) && prevSelection.anchor.type === 'text') {
    anchorFormatOrStyleChanged = true;
  }
  if (focus.type === 'text') {
    nextFocusNode = getDOMTextNode(focusDOM);
  }

  // If we can't get an underlying text node for selection, then
  // we should avoid setting selection to something incorrect.
  if (nextAnchorNode === null || nextFocusNode === null) {
    return;
  }
  if (isCollapsed && (prevSelection === null || anchorFormatOrStyleChanged || $isRangeSelection(prevSelection) && (prevSelection.format !== nextFormat || prevSelection.style !== nextStyle))) {
    markCollapsedSelectionFormat(nextFormat, nextStyle, nextAnchorOffset, anchorKey, performance.now());
  }

  // Diff against the native DOM selection to ensure we don't do
  // an unnecessary selection update. We also skip this check if
  // we're moving selection to within an element, as this can
  // sometimes be problematic around scrolling.
  if (anchorOffset === nextAnchorOffset && focusOffset === nextFocusOffset && anchorDOMNode === nextAnchorNode && focusDOMNode === nextFocusNode &&
  // Badly interpreted range selection when collapsed - #1482
  !(domSelection.type === 'Range' && isCollapsed)) {
    // If the root element does not have focus, ensure it has focus
    if (activeElement === null || !rootElement.contains(activeElement)) {
      rootElement.focus({
        preventScroll: true
      });
    }
    if (anchor.type !== 'element') {
      return;
    }
  }

  // Apply the updated selection to the DOM. Note: this will trigger
  // a "selectionchange" event, although it will be asynchronous.
  try {
    domSelection.setBaseAndExtent(nextAnchorNode, nextAnchorOffset, nextFocusNode, nextFocusOffset);
  } catch (error) {
    // If we encounter an error, continue. This can sometimes
    // occur with FF and there's no good reason as to why it
    // should happen.
  }
  if (!tags.has('skip-scroll-into-view') && nextSelection.isCollapsed() && rootElement !== null && rootElement === document.activeElement) {
    const selectionTarget = nextSelection instanceof RangeSelection && nextSelection.anchor.type === 'element' ? nextAnchorNode.childNodes[nextAnchorOffset] || null : domSelection.rangeCount > 0 ? domSelection.getRangeAt(0) : null;
    if (selectionTarget !== null) {
      let selectionRect;
      if (selectionTarget instanceof Text) {
        const range = document.createRange();
        range.selectNode(selectionTarget);
        selectionRect = range.getBoundingClientRect();
      } else {
        selectionRect = selectionTarget.getBoundingClientRect();
      }
      scrollIntoViewIfNeeded(editor, selectionRect, rootElement);
    }
  }
  markSelectionChangeFromDOMUpdate();
}
function $insertNodes(nodes) {
  let selection = $getSelection() || $getPreviousSelection();
  if (selection === null) {
    selection = $getRoot().selectEnd();
  }
  selection.insertNodes(nodes);
}
function $getTextContent() {
  const selection = $getSelection();
  if (selection === null) {
    return '';
  }
  return selection.getTextContent();
}
function removeTextAndSplitBlock(selection) {
  if (!selection.isCollapsed()) {
    selection.removeText();
  }
  const anchor = selection.anchor;
  let node = anchor.getNode();
  let offset = anchor.offset;
  while (!INTERNAL_$isBlock(node)) {
    [node, offset] = splitNodeAtPoint(node, offset);
  }
  return offset;
}
function splitNodeAtPoint(node, offset) {
  const parent = node.getParent();
  if (!parent) {
    const paragraph = $createParagraphNode();
    $getRoot().append(paragraph);
    paragraph.select();
    return [$getRoot(), 0];
  }
  if ($isTextNode(node)) {
    const split = node.splitText(offset);
    if (split.length === 0) {
      return [parent, node.getIndexWithinParent()];
    }
    const x = offset === 0 ? 0 : 1;
    const index = split[0].getIndexWithinParent() + x;
    return [parent, index];
  }
  if (!$isElementNode(node) || offset === 0) {
    return [parent, node.getIndexWithinParent()];
  }
  const firstToAppend = node.getChildAtIndex(offset);
  if (firstToAppend) {
    const insertPoint = new RangeSelection($createPoint(node.__key, offset, 'element'), $createPoint(node.__key, offset, 'element'), 0, '');
    const newElement = node.insertNewAfter(insertPoint);
    if (newElement) {
      newElement.append(firstToAppend, ...firstToAppend.getNextSiblings());
    }
  }
  return [parent, node.getIndexWithinParent() + 1];
}
function $wrapInlineNodes(nodes) {
  // We temporarily insert the topLevelNodes into an arbitrary ElementNode,
  // since insertAfter does not work on nodes that have no parent (TO-DO: fix that).
  const virtualRoot = $createParagraphNode();
  let currentBlock = null;
  for (let i = 0; i < nodes.length; i++) {
    const node = nodes[i];
    const isLineBreakNode = $isLineBreakNode(node);
    if (isLineBreakNode || $isDecoratorNode(node) && node.isInline() || $isElementNode(node) && node.isInline() || $isTextNode(node) || node.isParentRequired()) {
      if (currentBlock === null) {
        currentBlock = node.createParentElementNode();
        virtualRoot.append(currentBlock);
        // In the case of LineBreakNode, we just need to
        // add an empty ParagraphNode to the topLevelBlocks.
        if (isLineBreakNode) {
          continue;
        }
      }
      if (currentBlock !== null) {
        currentBlock.append(node);
      }
    } else {
      virtualRoot.append(node);
      currentBlock = null;
    }
  }
  return virtualRoot;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
let activeEditorState = null;
let activeEditor = null;
let isReadOnlyMode = false;
let isAttemptingToRecoverFromReconcilerError = false;
let infiniteTransformCount = 0;
const observerOptions = {
  characterData: true,
  childList: true,
  subtree: true
};
function isCurrentlyReadOnlyMode() {
  return isReadOnlyMode || activeEditorState !== null && activeEditorState._readOnly;
}
function errorOnReadOnly() {
  if (isReadOnlyMode) {
    {
      throw Error(`Cannot use method in read-only mode.`);
    }
  }
}
function errorOnInfiniteTransforms() {
  if (infiniteTransformCount > 99) {
    {
      throw Error(`One or more transforms are endlessly triggering additional transforms. May have encountered infinite recursion caused by transforms that have their preconditions too lose and/or conflict with each other.`);
    }
  }
}
function getActiveEditorState() {
  if (activeEditorState === null) {
    {
      throw Error(`Unable to find an active editor state. State helpers or node methods can only be used synchronously during the callback of editor.update() or editorState.read().`);
    }
  }
  return activeEditorState;
}
function getActiveEditor() {
  if (activeEditor === null) {
    {
      throw Error(`Unable to find an active editor. This method can only be used synchronously during the callback of editor.update().`);
    }
  }
  return activeEditor;
}
function internalGetActiveEditor() {
  return activeEditor;
}
function $applyTransforms(editor, node, transformsCache) {
  const type = node.__type;
  const registeredNode = getRegisteredNodeOrThrow(editor, type);
  let transformsArr = transformsCache.get(type);
  if (transformsArr === undefined) {
    transformsArr = Array.from(registeredNode.transforms);
    transformsCache.set(type, transformsArr);
  }
  const transformsArrLength = transformsArr.length;
  for (let i = 0; i < transformsArrLength; i++) {
    transformsArr[i](node);
    if (!node.isAttached()) {
      break;
    }
  }
}
function $isNodeValidForTransform(node, compositionKey) {
  return node !== undefined &&
  // We don't want to transform nodes being composed
  node.__key !== compositionKey && node.isAttached();
}
function $normalizeAllDirtyTextNodes(editorState, editor) {
  const dirtyLeaves = editor._dirtyLeaves;
  const nodeMap = editorState._nodeMap;
  for (const nodeKey of dirtyLeaves) {
    const node = nodeMap.get(nodeKey);
    if ($isTextNode(node) && node.isAttached() && node.isSimpleText() && !node.isUnmergeable()) {
      $normalizeTextNode(node);
    }
  }
}

/**
 * Transform heuristic:
 * 1. We transform leaves first. If transforms generate additional dirty nodes we repeat step 1.
 * The reasoning behind this is that marking a leaf as dirty marks all its parent elements as dirty too.
 * 2. We transform elements. If element transforms generate additional dirty nodes we repeat step 1.
 * If element transforms only generate additional dirty elements we only repeat step 2.
 *
 * Note that to keep track of newly dirty nodes and subtrees we leverage the editor._dirtyNodes and
 * editor._subtrees which we reset in every loop.
 */
function $applyAllTransforms(editorState, editor) {
  const dirtyLeaves = editor._dirtyLeaves;
  const dirtyElements = editor._dirtyElements;
  const nodeMap = editorState._nodeMap;
  const compositionKey = $getCompositionKey();
  const transformsCache = new Map();
  let untransformedDirtyLeaves = dirtyLeaves;
  let untransformedDirtyLeavesLength = untransformedDirtyLeaves.size;
  let untransformedDirtyElements = dirtyElements;
  let untransformedDirtyElementsLength = untransformedDirtyElements.size;
  while (untransformedDirtyLeavesLength > 0 || untransformedDirtyElementsLength > 0) {
    if (untransformedDirtyLeavesLength > 0) {
      // We leverage editor._dirtyLeaves to track the new dirty leaves after the transforms
      editor._dirtyLeaves = new Set();
      for (const nodeKey of untransformedDirtyLeaves) {
        const node = nodeMap.get(nodeKey);
        if ($isTextNode(node) && node.isAttached() && node.isSimpleText() && !node.isUnmergeable()) {
          $normalizeTextNode(node);
        }
        if (node !== undefined && $isNodeValidForTransform(node, compositionKey)) {
          $applyTransforms(editor, node, transformsCache);
        }
        dirtyLeaves.add(nodeKey);
      }
      untransformedDirtyLeaves = editor._dirtyLeaves;
      untransformedDirtyLeavesLength = untransformedDirtyLeaves.size;

      // We want to prioritize node transforms over element transforms
      if (untransformedDirtyLeavesLength > 0) {
        infiniteTransformCount++;
        continue;
      }
    }

    // All dirty leaves have been processed. Let's do elements!
    // We have previously processed dirty leaves, so let's restart the editor leaves Set to track
    // new ones caused by element transforms
    editor._dirtyLeaves = new Set();
    editor._dirtyElements = new Map();
    for (const currentUntransformedDirtyElement of untransformedDirtyElements) {
      const nodeKey = currentUntransformedDirtyElement[0];
      const intentionallyMarkedAsDirty = currentUntransformedDirtyElement[1];
      if (nodeKey !== 'root' && !intentionallyMarkedAsDirty) {
        continue;
      }
      const node = nodeMap.get(nodeKey);
      if (node !== undefined && $isNodeValidForTransform(node, compositionKey)) {
        $applyTransforms(editor, node, transformsCache);
      }
      dirtyElements.set(nodeKey, intentionallyMarkedAsDirty);
    }
    untransformedDirtyLeaves = editor._dirtyLeaves;
    untransformedDirtyLeavesLength = untransformedDirtyLeaves.size;
    untransformedDirtyElements = editor._dirtyElements;
    untransformedDirtyElementsLength = untransformedDirtyElements.size;
    infiniteTransformCount++;
  }
  editor._dirtyLeaves = dirtyLeaves;
  editor._dirtyElements = dirtyElements;
}
function $parseSerializedNode(serializedNode) {
  const internalSerializedNode = serializedNode;
  return $parseSerializedNodeImpl(internalSerializedNode, getActiveEditor()._nodes);
}
function $parseSerializedNodeImpl(serializedNode, registeredNodes) {
  const type = serializedNode.type;
  const registeredNode = registeredNodes.get(type);
  if (registeredNode === undefined) {
    {
      throw Error(`parseEditorState: type "${type}" + not found`);
    }
  }
  const nodeClass = registeredNode.klass;
  if (serializedNode.type !== nodeClass.getType()) {
    {
      throw Error(`LexicalNode: Node ${nodeClass.name} does not implement .importJSON().`);
    }
  }
  const node = nodeClass.importJSON(serializedNode);
  const children = serializedNode.children;
  if ($isElementNode(node) && Array.isArray(children)) {
    for (let i = 0; i < children.length; i++) {
      const serializedJSONChildNode = children[i];
      const childNode = $parseSerializedNodeImpl(serializedJSONChildNode, registeredNodes);
      node.append(childNode);
    }
  }
  return node;
}
function parseEditorState(serializedEditorState, editor, updateFn) {
  const editorState = createEmptyEditorState();
  const previousActiveEditorState = activeEditorState;
  const previousReadOnlyMode = isReadOnlyMode;
  const previousActiveEditor = activeEditor;
  const previousDirtyElements = editor._dirtyElements;
  const previousDirtyLeaves = editor._dirtyLeaves;
  const previousCloneNotNeeded = editor._cloneNotNeeded;
  const previousDirtyType = editor._dirtyType;
  editor._dirtyElements = new Map();
  editor._dirtyLeaves = new Set();
  editor._cloneNotNeeded = new Set();
  editor._dirtyType = 0;
  activeEditorState = editorState;
  isReadOnlyMode = false;
  activeEditor = editor;
  try {
    const registeredNodes = editor._nodes;
    const serializedNode = serializedEditorState.root;
    $parseSerializedNodeImpl(serializedNode, registeredNodes);
    if (updateFn) {
      updateFn();
    }

    // Make the editorState immutable
    editorState._readOnly = true;
    {
      handleDEVOnlyPendingUpdateGuarantees(editorState);
    }
  } catch (error) {
    if (error instanceof Error) {
      editor._onError(error);
    }
  } finally {
    editor._dirtyElements = previousDirtyElements;
    editor._dirtyLeaves = previousDirtyLeaves;
    editor._cloneNotNeeded = previousCloneNotNeeded;
    editor._dirtyType = previousDirtyType;
    activeEditorState = previousActiveEditorState;
    isReadOnlyMode = previousReadOnlyMode;
    activeEditor = previousActiveEditor;
  }
  return editorState;
}

// This technically isn't an update but given we need
// exposure to the module's active bindings, we have this
// function here

function readEditorState(editorState, callbackFn) {
  const previousActiveEditorState = activeEditorState;
  const previousReadOnlyMode = isReadOnlyMode;
  const previousActiveEditor = activeEditor;
  activeEditorState = editorState;
  isReadOnlyMode = true;
  activeEditor = null;
  try {
    return callbackFn();
  } finally {
    activeEditorState = previousActiveEditorState;
    isReadOnlyMode = previousReadOnlyMode;
    activeEditor = previousActiveEditor;
  }
}
function handleDEVOnlyPendingUpdateGuarantees(pendingEditorState) {
  // Given we can't Object.freeze the nodeMap as it's a Map,
  // we instead replace its set, clear and delete methods.
  const nodeMap = pendingEditorState._nodeMap;
  nodeMap.set = () => {
    throw new Error('Cannot call set() on a frozen Lexical node map');
  };
  nodeMap.clear = () => {
    throw new Error('Cannot call clear() on a frozen Lexical node map');
  };
  nodeMap.delete = () => {
    throw new Error('Cannot call delete() on a frozen Lexical node map');
  };
}
function commitPendingUpdates(editor, recoveryEditorState) {
  const pendingEditorState = editor._pendingEditorState;
  const rootElement = editor._rootElement;
  const shouldSkipDOM = editor._headless || rootElement === null;
  if (pendingEditorState === null) {
    return;
  }
  // eslint-disable-next-line no-console
  console.log('2.[lexical][commitPendingUpdates]');

  // ======
  // Reconciliation has started.
  // ======

  const currentEditorState = editor._editorState;
  const currentSelection = currentEditorState._selection;
  const pendingSelection = pendingEditorState._selection;
  const needsUpdate = editor._dirtyType !== NO_DIRTY_NODES;
  const previousActiveEditorState = activeEditorState;
  const previousReadOnlyMode = isReadOnlyMode;
  const previousActiveEditor = activeEditor;
  const previouslyUpdating = editor._updating;
  const observer = editor._observer;
  let mutatedNodes = null;
  editor._pendingEditorState = null;
  editor._editorState = pendingEditorState;
  if (!shouldSkipDOM && needsUpdate && observer !== null) {
    // eslint-disable-next-line no-console
    console.log('2.1.[lexical][commitPendingUpdates] observer.disconnect()');
    activeEditor = editor;
    activeEditorState = pendingEditorState;
    isReadOnlyMode = false;
    // We don't want updates to sync block the reconciliation.
    editor._updating = true;
    try {
      const dirtyType = editor._dirtyType;
      const dirtyElements = editor._dirtyElements;
      const dirtyLeaves = editor._dirtyLeaves;
      observer.disconnect();
      mutatedNodes = reconcileRoot(currentEditorState, pendingEditorState, editor, dirtyType, dirtyElements, dirtyLeaves);
    } catch (error) {
      // Report errors
      if (error instanceof Error) {
        editor._onError(error);
      }

      // Reset editor and restore incoming editor state to the DOM
      if (!isAttemptingToRecoverFromReconcilerError) {
        // eslint-disable-next-line no-console
        console.log('2.[lexical][commitPendingUpdates] resetEditor and restore incoming editor state to the DOM');
        resetEditor(editor, null, rootElement, pendingEditorState);
        initMutationObserver(editor);
        editor._dirtyType = FULL_RECONCILE;
        isAttemptingToRecoverFromReconcilerError = true;
        commitPendingUpdates(editor, currentEditorState);
        isAttemptingToRecoverFromReconcilerError = false;
      } else {
        // To avoid a possible situation of infinite loops, lets throw
        throw error;
      }
      return;
    } finally {
      observer.observe(rootElement, observerOptions);
      editor._updating = previouslyUpdating;
      activeEditorState = previousActiveEditorState;
      isReadOnlyMode = previousReadOnlyMode;
      activeEditor = previousActiveEditor;
    }
  }
  if (!pendingEditorState._readOnly) {
    pendingEditorState._readOnly = true;
    {
      handleDEVOnlyPendingUpdateGuarantees(pendingEditorState);
      if ($isRangeSelection(pendingSelection)) {
        Object.freeze(pendingSelection.anchor);
        Object.freeze(pendingSelection.focus);
      }
      Object.freeze(pendingSelection);
    }
  }
  const dirtyLeaves = editor._dirtyLeaves;
  const dirtyElements = editor._dirtyElements;
  const normalizedNodes = editor._normalizedNodes;
  const tags = editor._updateTags;
  const deferred = editor._deferred;
  if (needsUpdate) {
    editor._dirtyType = NO_DIRTY_NODES;
    editor._cloneNotNeeded.clear();
    editor._dirtyLeaves = new Set();
    editor._dirtyElements = new Map();
    editor._normalizedNodes = new Set();
    editor._updateTags = new Set();
  }
  // eslint-disable-next-line no-console
  console.log('2.2.[lexical][commitPendingUpdates] $garbageCollectDetachedDecorators');
  $garbageCollectDetachedDecorators(editor, pendingEditorState);

  // ======
  // Reconciliation has finished. Now update selection and trigger listeners.
  // ======

  const domSelection = shouldSkipDOM ? null : getDOMSelection(editor._window);

  // Attempt to update the DOM selection, including focusing of the root element,
  // and scroll into view if needed.
  if (editor._editable &&
  // domSelection will be null in headless
  domSelection !== null && (needsUpdate || pendingSelection === null || pendingSelection.dirty)) {
    activeEditor = editor;
    activeEditorState = pendingEditorState;
    try {
      if (observer !== null) {
        observer.disconnect();
      }
      if (needsUpdate || pendingSelection === null || pendingSelection.dirty) {
        // eslint-disable-next-line no-console
        console.log('2.[lexical][commitPendingUpdates] updateDOMSelection');
        const blockCursorElement = editor._blockCursorElement;
        if (blockCursorElement !== null) {
          removeDOMBlockCursorElement(blockCursorElement, editor, rootElement);
        }
        updateDOMSelection(currentSelection, pendingSelection, editor, domSelection, tags, rootElement);
      }
      updateDOMBlockCursorElement(editor, rootElement, pendingSelection);
      if (observer !== null) {
        observer.observe(rootElement, observerOptions);
      }
    } finally {
      activeEditor = previousActiveEditor;
      activeEditorState = previousActiveEditorState;
    }
  }
  if (mutatedNodes !== null) {
    triggerMutationListeners(editor, mutatedNodes, tags, dirtyLeaves, currentEditorState);
  }
  if (!$isRangeSelection(pendingSelection) && pendingSelection !== null && (currentSelection === null || !currentSelection.is(pendingSelection))) {
    editor.dispatchCommand(SELECTION_CHANGE_COMMAND, undefined);
  }
  /**
   * Capture pendingDecorators after garbage collecting detached decorators
   */
  const pendingDecorators = editor._pendingDecorators;
  if (pendingDecorators !== null) {
    editor._decorators = pendingDecorators;
    editor._pendingDecorators = null;
    triggerListeners('decorator', editor, true, pendingDecorators);
  }

  // If reconciler fails, we reset whole editor (so current editor state becomes empty)
  // and attempt to re-render pendingEditorState. If that goes through we trigger
  // listeners, but instead use recoverEditorState which is current editor state before reset
  // This specifically important for collab that relies on prevEditorState from update
  // listener to calculate delta of changed nodes/properties
  triggerTextContentListeners(editor, recoveryEditorState || currentEditorState, pendingEditorState);
  triggerListeners('update', editor, true, {
    dirtyElements,
    dirtyLeaves,
    editorState: pendingEditorState,
    normalizedNodes,
    prevEditorState: recoveryEditorState || currentEditorState,
    tags
  });
  triggerDeferredUpdateCallbacks(editor, deferred);
  triggerEnqueuedUpdates(editor);
  // eslint-disable-next-line no-console
  console.log('2.[lexical][commitPendingUpdates] end');
}
function triggerTextContentListeners(editor, currentEditorState, pendingEditorState) {
  const currentTextContent = getEditorStateTextContent(currentEditorState);
  const latestTextContent = getEditorStateTextContent(pendingEditorState);
  if (currentTextContent !== latestTextContent) {
    triggerListeners('textcontent', editor, true, latestTextContent);
  }
}
function triggerMutationListeners(editor, mutatedNodes, updateTags, dirtyLeaves, prevEditorState) {
  const listeners = Array.from(editor._listeners.mutation);
  const listenersLength = listeners.length;
  for (let i = 0; i < listenersLength; i++) {
    const [listener, klass] = listeners[i];
    const mutatedNodesByType = mutatedNodes.get(klass);
    if (mutatedNodesByType !== undefined) {
      listener(mutatedNodesByType, {
        dirtyLeaves,
        prevEditorState,
        updateTags
      });
    }
  }
}
function triggerListeners(type, editor, isCurrentlyEnqueuingUpdates, ...payload) {
  const previouslyUpdating = editor._updating;
  editor._updating = isCurrentlyEnqueuingUpdates;
  try {
    const listeners = Array.from(editor._listeners[type]);
    for (let i = 0; i < listeners.length; i++) {
      // @ts-ignore
      listeners[i].apply(null, payload);
    }
  } finally {
    editor._updating = previouslyUpdating;
  }
}
function triggerCommandListeners(editor, type, payload) {
  if (editor._updating === false || activeEditor !== editor) {
    let returnVal = false;
    editor.update(() => {
      returnVal = triggerCommandListeners(editor, type, payload);
    });
    return returnVal;
  }
  const editors = getEditorsToPropagate(editor);
  for (let i = 4; i >= 0; i--) {
    for (let e = 0; e < editors.length; e++) {
      const currentEditor = editors[e];
      const commandListeners = currentEditor._commands;
      const listenerInPriorityOrder = commandListeners.get(type);
      if (listenerInPriorityOrder !== undefined) {
        const listenersSet = listenerInPriorityOrder[i];
        if (listenersSet !== undefined) {
          const listeners = Array.from(listenersSet);
          const listenersLength = listeners.length;
          for (let j = 0; j < listenersLength; j++) {
            if (listeners[j](payload, editor) === true) {
              return true;
            }
          }
        }
      }
    }
  }
  return false;
}
function triggerEnqueuedUpdates(editor) {
  const queuedUpdates = editor._updates;
  if (queuedUpdates.length !== 0) {
    const queuedUpdate = queuedUpdates.shift();
    if (queuedUpdate) {
      const [updateFn, options] = queuedUpdate;
      beginUpdate(editor, updateFn, options);
    }
  }
}
function triggerDeferredUpdateCallbacks(editor, deferred) {
  editor._deferred = [];
  if (deferred.length !== 0) {
    const previouslyUpdating = editor._updating;
    editor._updating = true;
    try {
      for (let i = 0; i < deferred.length; i++) {
        deferred[i]();
      }
    } finally {
      editor._updating = previouslyUpdating;
    }
  }
}
function processNestedUpdates(editor, initialSkipTransforms) {
  const queuedUpdates = editor._updates;
  let skipTransforms = initialSkipTransforms || false;

  // Updates might grow as we process them, we so we'll need
  // to handle each update as we go until the updates array is
  // empty.
  while (queuedUpdates.length !== 0) {
    const queuedUpdate = queuedUpdates.shift();
    if (queuedUpdate) {
      const [nextUpdateFn, options] = queuedUpdate;
      let onUpdate;
      let tag;
      if (options !== undefined) {
        onUpdate = options.onUpdate;
        tag = options.tag;
        if (options.skipTransforms) {
          skipTransforms = true;
        }
        if (onUpdate) {
          editor._deferred.push(onUpdate);
        }
        if (tag) {
          editor._updateTags.add(tag);
        }
      }
      nextUpdateFn();
    }
  }
  return skipTransforms;
}
function beginUpdate(editor, updateFn, options) {
  const updateTags = editor._updateTags;
  let onUpdate;
  let tag;
  let skipTransforms = false;
  let discrete = false;
  if (options !== undefined) {
    onUpdate = options.onUpdate;
    tag = options.tag;
    if (tag != null) {
      updateTags.add(tag);
    }
    skipTransforms = options.skipTransforms || false;
    discrete = options.discrete || false;
  }
  if (onUpdate) {
    editor._deferred.push(onUpdate);
  }
  const currentEditorState = editor._editorState;
  let pendingEditorState = editor._pendingEditorState;
  let editorStateWasCloned = false;
  if (pendingEditorState === null || pendingEditorState._readOnly) {
    pendingEditorState = editor._pendingEditorState = cloneEditorState(pendingEditorState || currentEditorState);
    editorStateWasCloned = true;
  }
  pendingEditorState._flushSync = discrete;
  const previousActiveEditorState = activeEditorState;
  const previousReadOnlyMode = isReadOnlyMode;
  const previousActiveEditor = activeEditor;
  const previouslyUpdating = editor._updating;
  activeEditorState = pendingEditorState;
  isReadOnlyMode = false;
  editor._updating = true;
  activeEditor = editor;
  try {
    if (editorStateWasCloned) {
      if (editor._headless) {
        if (currentEditorState._selection !== null) {
          pendingEditorState._selection = currentEditorState._selection.clone();
        }
      } else {
        pendingEditorState._selection = internalCreateSelection(editor);
      }
    }
    const startingCompositionKey = editor._compositionKey;
    updateFn();
    skipTransforms = processNestedUpdates(editor, skipTransforms);
    applySelectionTransforms(pendingEditorState, editor);
    if (editor._dirtyType !== NO_DIRTY_NODES) {
      if (skipTransforms) {
        $normalizeAllDirtyTextNodes(pendingEditorState, editor);
      } else {
        $applyAllTransforms(pendingEditorState, editor);
      }
      processNestedUpdates(editor);
      $garbageCollectDetachedNodes(currentEditorState, pendingEditorState, editor._dirtyLeaves, editor._dirtyElements);
    }
    const endingCompositionKey = editor._compositionKey;
    if (startingCompositionKey !== endingCompositionKey) {
      pendingEditorState._flushSync = true;
    }
    const pendingSelection = pendingEditorState._selection;
    if ($isRangeSelection(pendingSelection)) {
      const pendingNodeMap = pendingEditorState._nodeMap;
      const anchorKey = pendingSelection.anchor.key;
      const focusKey = pendingSelection.focus.key;
      if (pendingNodeMap.get(anchorKey) === undefined || pendingNodeMap.get(focusKey) === undefined) {
        {
          throw Error(`updateEditor: selection has been lost because the previously selected nodes have been removed and selection wasn't moved to another node. Ensure selection changes after removing/replacing a selected node.`);
        }
      }
    } else if ($isNodeSelection(pendingSelection)) {
      // TODO: we should also validate node selection?
      if (pendingSelection._nodes.size === 0) {
        pendingEditorState._selection = null;
      }
    }
  } catch (error) {
    // Report errors
    if (error instanceof Error) {
      editor._onError(error);
    }

    // Restore existing editor state to the DOM
    editor._pendingEditorState = currentEditorState;
    editor._dirtyType = FULL_RECONCILE;
    editor._cloneNotNeeded.clear();
    editor._dirtyLeaves = new Set();
    editor._dirtyElements.clear();
    commitPendingUpdates(editor);
    return;
  } finally {
    activeEditorState = previousActiveEditorState;
    isReadOnlyMode = previousReadOnlyMode;
    activeEditor = previousActiveEditor;
    editor._updating = previouslyUpdating;
    infiniteTransformCount = 0;
  }
  const shouldUpdate = editor._dirtyType !== NO_DIRTY_NODES || editorStateHasDirtySelection(pendingEditorState, editor);
  if (shouldUpdate) {
    if (pendingEditorState._flushSync) {
      pendingEditorState._flushSync = false;
      commitPendingUpdates(editor);
    } else if (editorStateWasCloned) {
      scheduleMicroTask(() => {
        commitPendingUpdates(editor);
      });
    }
  } else {
    pendingEditorState._flushSync = false;
    if (editorStateWasCloned) {
      updateTags.clear();
      editor._deferred = [];
      editor._pendingEditorState = null;
    }
  }
}
function updateEditor(editor, updateFn, options) {
  if (editor._updating) {
    editor._updates.push([updateFn, options]);
  } else {
    beginUpdate(editor, updateFn, options);
  }
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

/** @noInheritDoc */
class DecoratorNode extends LexicalNode {
  constructor(key) {
    super(key);
  }

  /**
   * The returned value is added to the LexicalEditor._decorators
   */
  decorate(editor, config) {
    {
      throw Error(`decorate: base method not extended`);
    }
  }
  isIsolated() {
    return false;
  }
  isInline() {
    return true;
  }
  isKeyboardSelectable() {
    return true;
  }
}
function $isDecoratorNode(node) {
  return node instanceof DecoratorNode;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
/** @noInheritDoc */
class ElementNode extends LexicalNode {
  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  constructor(key) {
    super(key);
    this.__first = null;
    this.__last = null;
    this.__size = 0;
    this.__format = 0;
    this.__indent = 0;
    this.__dir = null;
  }
  getFormat() {
    const self = this.getLatest();
    return self.__format;
  }
  getFormatType() {
    const format = this.getFormat();
    return ELEMENT_FORMAT_TO_TYPE[format] || '';
  }
  getIndent() {
    const self = this.getLatest();
    return self.__indent;
  }
  getChildren() {
    const children = [];
    let child = this.getFirstChild();
    while (child !== null) {
      children.push(child);
      child = child.getNextSibling();
    }
    return children;
  }
  getChildrenKeys() {
    const children = [];
    let child = this.getFirstChild();
    while (child !== null) {
      children.push(child.__key);
      child = child.getNextSibling();
    }
    return children;
  }
  getChildrenSize() {
    const self = this.getLatest();
    return self.__size;
  }
  isEmpty() {
    return this.getChildrenSize() === 0;
  }
  isDirty() {
    const editor = getActiveEditor();
    const dirtyElements = editor._dirtyElements;
    return dirtyElements !== null && dirtyElements.has(this.__key);
  }
  isLastChild() {
    const self = this.getLatest();
    const parentLastChild = this.getParentOrThrow().getLastChild();
    return parentLastChild !== null && parentLastChild.is(self);
  }
  getAllTextNodes() {
    const textNodes = [];
    let child = this.getFirstChild();
    while (child !== null) {
      if ($isTextNode(child)) {
        textNodes.push(child);
      }
      if ($isElementNode(child)) {
        const subChildrenNodes = child.getAllTextNodes();
        textNodes.push(...subChildrenNodes);
      }
      child = child.getNextSibling();
    }
    return textNodes;
  }
  getFirstDescendant() {
    let node = this.getFirstChild();
    while (node !== null) {
      if ($isElementNode(node)) {
        const child = node.getFirstChild();
        if (child !== null) {
          node = child;
          continue;
        }
      }
      break;
    }
    return node;
  }
  getLastDescendant() {
    let node = this.getLastChild();
    while (node !== null) {
      if ($isElementNode(node)) {
        const child = node.getLastChild();
        if (child !== null) {
          node = child;
          continue;
        }
      }
      break;
    }
    return node;
  }
  getDescendantByIndex(index) {
    const children = this.getChildren();
    const childrenLength = children.length;
    // For non-empty element nodes, we resolve its descendant
    // (either a leaf node or the bottom-most element)
    if (index >= childrenLength) {
      const resolvedNode = children[childrenLength - 1];
      return $isElementNode(resolvedNode) && resolvedNode.getLastDescendant() || resolvedNode || null;
    }
    const resolvedNode = children[index];
    return $isElementNode(resolvedNode) && resolvedNode.getFirstDescendant() || resolvedNode || null;
  }
  getFirstChild() {
    const self = this.getLatest();
    const firstKey = self.__first;
    return firstKey === null ? null : $getNodeByKey(firstKey);
  }
  getFirstChildOrThrow() {
    const firstChild = this.getFirstChild();
    if (firstChild === null) {
      {
        throw Error(`Expected node ${this.__key} to have a first child.`);
      }
    }
    return firstChild;
  }
  getLastChild() {
    const self = this.getLatest();
    const lastKey = self.__last;
    return lastKey === null ? null : $getNodeByKey(lastKey);
  }
  getLastChildOrThrow() {
    const lastChild = this.getLastChild();
    if (lastChild === null) {
      {
        throw Error(`Expected node ${this.__key} to have a last child.`);
      }
    }
    return lastChild;
  }
  getChildAtIndex(index) {
    const size = this.getChildrenSize();
    let node;
    let i;
    if (index < size / 2) {
      node = this.getFirstChild();
      i = 0;
      while (node !== null && i <= index) {
        if (i === index) {
          return node;
        }
        node = node.getNextSibling();
        i++;
      }
      return null;
    }
    node = this.getLastChild();
    i = size - 1;
    while (node !== null && i >= index) {
      if (i === index) {
        return node;
      }
      node = node.getPreviousSibling();
      i--;
    }
    return null;
  }
  getTextContent() {
    let textContent = '';
    const children = this.getChildren();
    const childrenLength = children.length;
    for (let i = 0; i < childrenLength; i++) {
      const child = children[i];
      textContent += child.getTextContent();
      if ($isElementNode(child) && i !== childrenLength - 1 && !child.isInline()) {
        textContent += DOUBLE_LINE_BREAK;
      }
    }
    return textContent;
  }
  getTextContentSize() {
    let textContentSize = 0;
    const children = this.getChildren();
    const childrenLength = children.length;
    for (let i = 0; i < childrenLength; i++) {
      const child = children[i];
      textContentSize += child.getTextContentSize();
      if ($isElementNode(child) && i !== childrenLength - 1 && !child.isInline()) {
        textContentSize += DOUBLE_LINE_BREAK.length;
      }
    }
    return textContentSize;
  }
  getDirection() {
    const self = this.getLatest();
    return self.__dir;
  }
  hasFormat(type) {
    if (type !== '') {
      const formatFlag = ELEMENT_TYPE_TO_FORMAT[type];
      return (this.getFormat() & formatFlag) !== 0;
    }
    return false;
  }

  // Mutators

  select(_anchorOffset, _focusOffset) {
    errorOnReadOnly();
    const selection = $getSelection();
    let anchorOffset = _anchorOffset;
    let focusOffset = _focusOffset;
    const childrenCount = this.getChildrenSize();
    if (!this.canBeEmpty()) {
      if (_anchorOffset === 0 && _focusOffset === 0) {
        const firstChild = this.getFirstChild();
        if ($isTextNode(firstChild) || $isElementNode(firstChild)) {
          return firstChild.select(0, 0);
        }
      } else if ((_anchorOffset === undefined || _anchorOffset === childrenCount) && (_focusOffset === undefined || _focusOffset === childrenCount)) {
        const lastChild = this.getLastChild();
        if ($isTextNode(lastChild) || $isElementNode(lastChild)) {
          return lastChild.select();
        }
      }
    }
    if (anchorOffset === undefined) {
      anchorOffset = childrenCount;
    }
    if (focusOffset === undefined) {
      focusOffset = childrenCount;
    }
    const key = this.__key;
    if (!$isRangeSelection(selection)) {
      return internalMakeRangeSelection(key, anchorOffset, key, focusOffset, 'element', 'element');
    } else {
      selection.anchor.set(key, anchorOffset, 'element');
      selection.focus.set(key, focusOffset, 'element');
      selection.dirty = true;
    }
    return selection;
  }
  selectStart() {
    const firstNode = this.getFirstDescendant();
    return firstNode ? firstNode.selectStart() : this.select();
  }
  selectEnd() {
    const lastNode = this.getLastDescendant();
    return lastNode ? lastNode.selectEnd() : this.select();
  }
  clear() {
    const writableSelf = this.getWritable();
    const children = this.getChildren();
    children.forEach(child => child.remove());
    return writableSelf;
  }
  append(...nodesToAppend) {
    return this.splice(this.getChildrenSize(), 0, nodesToAppend);
  }
  setDirection(direction) {
    const self = this.getWritable();
    self.__dir = direction;
    return self;
  }
  setFormat(type) {
    const self = this.getWritable();
    self.__format = type !== '' ? ELEMENT_TYPE_TO_FORMAT[type] : 0;
    return this;
  }
  setIndent(indentLevel) {
    const self = this.getWritable();
    self.__indent = indentLevel;
    return this;
  }
  splice(start, deleteCount, nodesToInsert) {
    const nodesToInsertLength = nodesToInsert.length;
    const oldSize = this.getChildrenSize();
    const writableSelf = this.getWritable();
    const writableSelfKey = writableSelf.__key;
    const nodesToInsertKeys = [];
    const nodesToRemoveKeys = [];
    const nodeAfterRange = this.getChildAtIndex(start + deleteCount);
    let nodeBeforeRange = null;
    let newSize = oldSize - deleteCount + nodesToInsertLength;
    if (start !== 0) {
      if (start === oldSize) {
        nodeBeforeRange = this.getLastChild();
      } else {
        const node = this.getChildAtIndex(start);
        if (node !== null) {
          nodeBeforeRange = node.getPreviousSibling();
        }
      }
    }
    if (deleteCount > 0) {
      let nodeToDelete = nodeBeforeRange === null ? this.getFirstChild() : nodeBeforeRange.getNextSibling();
      for (let i = 0; i < deleteCount; i++) {
        if (nodeToDelete === null) {
          {
            throw Error(`splice: sibling not found`);
          }
        }
        const nextSibling = nodeToDelete.getNextSibling();
        const nodeKeyToDelete = nodeToDelete.__key;
        const writableNodeToDelete = nodeToDelete.getWritable();
        removeFromParent(writableNodeToDelete);
        nodesToRemoveKeys.push(nodeKeyToDelete);
        nodeToDelete = nextSibling;
      }
    }
    let prevNode = nodeBeforeRange;
    for (let i = 0; i < nodesToInsertLength; i++) {
      const nodeToInsert = nodesToInsert[i];
      if (prevNode !== null && nodeToInsert.is(prevNode)) {
        nodeBeforeRange = prevNode = prevNode.getPreviousSibling();
      }
      const writableNodeToInsert = nodeToInsert.getWritable();
      if (writableNodeToInsert.__parent === writableSelfKey) {
        newSize--;
      }
      removeFromParent(writableNodeToInsert);
      const nodeKeyToInsert = nodeToInsert.__key;
      if (prevNode === null) {
        writableSelf.__first = nodeKeyToInsert;
        writableNodeToInsert.__prev = null;
      } else {
        const writablePrevNode = prevNode.getWritable();
        writablePrevNode.__next = nodeKeyToInsert;
        writableNodeToInsert.__prev = writablePrevNode.__key;
      }
      if (nodeToInsert.__key === writableSelfKey) {
        {
          throw Error(`append: attempting to append self`);
        }
      }
      // Set child parent to self
      writableNodeToInsert.__parent = writableSelfKey;
      nodesToInsertKeys.push(nodeKeyToInsert);
      prevNode = nodeToInsert;
    }
    if (start + deleteCount === oldSize) {
      if (prevNode !== null) {
        const writablePrevNode = prevNode.getWritable();
        writablePrevNode.__next = null;
        writableSelf.__last = prevNode.__key;
      }
    } else if (nodeAfterRange !== null) {
      const writableNodeAfterRange = nodeAfterRange.getWritable();
      if (prevNode !== null) {
        const writablePrevNode = prevNode.getWritable();
        writableNodeAfterRange.__prev = prevNode.__key;
        writablePrevNode.__next = nodeAfterRange.__key;
      } else {
        writableNodeAfterRange.__prev = null;
      }
    }
    writableSelf.__size = newSize;

    // In case of deletion we need to adjust selection, unlink removed nodes
    // and clean up node itself if it becomes empty. None of these needed
    // for insertion-only cases
    if (nodesToRemoveKeys.length) {
      // Adjusting selection, in case node that was anchor/focus will be deleted
      const selection = $getSelection();
      if ($isRangeSelection(selection)) {
        const nodesToRemoveKeySet = new Set(nodesToRemoveKeys);
        const nodesToInsertKeySet = new Set(nodesToInsertKeys);
        const {
          anchor,
          focus
        } = selection;
        if (isPointRemoved(anchor, nodesToRemoveKeySet, nodesToInsertKeySet)) {
          moveSelectionPointToSibling(anchor, anchor.getNode(), this, nodeBeforeRange, nodeAfterRange);
        }
        if (isPointRemoved(focus, nodesToRemoveKeySet, nodesToInsertKeySet)) {
          moveSelectionPointToSibling(focus, focus.getNode(), this, nodeBeforeRange, nodeAfterRange);
        }
        // Cleanup if node can't be empty
        if (newSize === 0 && !this.canBeEmpty() && !$isRootOrShadowRoot(this)) {
          this.remove();
        }
      }
    }
    return writableSelf;
  }
  // JSON serialization
  exportJSON() {
    return {
      children: [],
      direction: this.getDirection(),
      format: this.getFormatType(),
      indent: this.getIndent(),
      type: 'element',
      version: 1
    };
  }
  // These are intended to be extends for specific element heuristics.
  insertNewAfter(selection, restoreSelection) {
    return null;
  }
  canIndent() {
    return true;
  }
  /*
   * This method controls the behavior of a the node during backwards
   * deletion (i.e., backspace) when selection is at the beginning of
   * the node (offset 0)
   */
  collapseAtStart(selection) {
    return false;
  }
  excludeFromCopy(destination) {
    return false;
  }
  // TODO 0.10 deprecate
  canExtractContents() {
    return true;
  }
  canReplaceWith(replacement) {
    return true;
  }
  canInsertAfter(node) {
    return true;
  }
  canBeEmpty() {
    return true;
  }
  canInsertTextBefore() {
    return true;
  }
  canInsertTextAfter() {
    return true;
  }
  isInline() {
    return false;
  }
  // A shadow root is a Node that behaves like RootNode. The shadow root (and RootNode) mark the
  // end of the hiercharchy, most implementations should treat it as there's nothing (upwards)
  // beyond this point. For example, node.getTopLevelElement(), when performed inside a TableCellNode
  // will return the immediate first child underneath TableCellNode instead of RootNode.
  isShadowRoot() {
    return false;
  }
  canMergeWith(node) {
    return false;
  }
  extractWithChild(child, selection, destination) {
    return false;
  }
}
function $isElementNode(node) {
  return node instanceof ElementNode;
}
function isPointRemoved(point, nodesToRemoveKeySet, nodesToInsertKeySet) {
  let node = point.getNode();
  while (node) {
    const nodeKey = node.__key;
    if (nodesToRemoveKeySet.has(nodeKey) && !nodesToInsertKeySet.has(nodeKey)) {
      return true;
    }
    node = node.getParent();
  }
  return false;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
/** @noInheritDoc */
class RootNode extends ElementNode {
  /** @internal */

  static getType() {
    return 'root';
  }
  static clone() {
    return new RootNode();
  }
  constructor() {
    super('root');
    this.__cachedText = null;
  }
  getTopLevelElementOrThrow() {
    {
      throw Error(`getTopLevelElementOrThrow: root nodes are not top level elements`);
    }
  }
  getTextContent() {
    const cachedText = this.__cachedText;
    if (isCurrentlyReadOnlyMode() || getActiveEditor()._dirtyType === NO_DIRTY_NODES) {
      if (cachedText !== null) {
        return cachedText;
      }
    }
    return super.getTextContent();
  }
  remove() {
    {
      throw Error(`remove: cannot be called on root nodes`);
    }
  }
  replace(node) {
    {
      throw Error(`replace: cannot be called on root nodes`);
    }
  }
  insertBefore(nodeToInsert) {
    {
      throw Error(`insertBefore: cannot be called on root nodes`);
    }
  }
  insertAfter(nodeToInsert) {
    {
      throw Error(`insertAfter: cannot be called on root nodes`);
    }
  }

  // View

  updateDOM(prevNode, dom) {
    return false;
  }

  // Mutate

  append(...nodesToAppend) {
    for (let i = 0; i < nodesToAppend.length; i++) {
      const node = nodesToAppend[i];
      if (!$isElementNode(node) && !$isDecoratorNode(node)) {
        {
          throw Error(`rootNode.append: Only element or decorator nodes can be appended to the root node`);
        }
      }
    }
    return super.append(...nodesToAppend);
  }
  static importJSON(serializedNode) {
    // We don't create a root, and instead use the existing root.
    const node = $getRoot();
    node.setFormat(serializedNode.format);
    node.setIndent(serializedNode.indent);
    node.setDirection(serializedNode.direction);
    return node;
  }
  exportJSON() {
    return {
      children: [],
      direction: this.getDirection(),
      format: this.getFormatType(),
      indent: this.getIndent(),
      type: 'root',
      version: 1
    };
  }
  collapseAtStart() {
    return true;
  }
}
function $createRootNode() {
  return new RootNode();
}
function $isRootNode(node) {
  return node instanceof RootNode;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
function editorStateHasDirtySelection(editorState, editor) {
  const currentSelection = editor.getEditorState()._selection;
  const pendingSelection = editorState._selection;

  // Check if we need to update because of changes in selection
  if (pendingSelection !== null) {
    if (pendingSelection.dirty || !pendingSelection.is(currentSelection)) {
      return true;
    }
  } else if (currentSelection !== null) {
    return true;
  }
  return false;
}
function cloneEditorState(current) {
  return new EditorState(new Map(current._nodeMap));
}
function createEmptyEditorState() {
  return new EditorState(new Map([['root', $createRootNode()]]));
}
function exportNodeToJSON(node) {
  const serializedNode = node.exportJSON();
  const nodeClass = node.constructor;
  if (serializedNode.type !== nodeClass.getType()) {
    {
      throw Error(`LexicalNode: Node ${nodeClass.name} does not match the serialized type. Check if .exportJSON() is implemented and it is returning the correct type.`);
    }
  }
  if ($isElementNode(node)) {
    const serializedChildren = serializedNode.children;
    if (!Array.isArray(serializedChildren)) {
      {
        throw Error(`LexicalNode: Node ${nodeClass.name} is an element but .exportJSON() does not have a children array.`);
      }
    }
    const children = node.getChildren();
    for (let i = 0; i < children.length; i++) {
      const child = children[i];
      const serializedChildNode = exportNodeToJSON(child);
      serializedChildren.push(serializedChildNode);
    }
  }

  // @ts-expect-error
  return serializedNode;
}
class EditorState {
  constructor(nodeMap, selection) {
    this._nodeMap = nodeMap;
    this._selection = selection || null;
    this._flushSync = false;
    this._readOnly = false;
  }
  isEmpty() {
    return this._nodeMap.size === 1 && this._selection === null;
  }
  read(callbackFn) {
    return readEditorState(this, callbackFn);
  }
  clone(selection) {
    const editorState = new EditorState(this._nodeMap, selection === undefined ? this._selection : selection);
    editorState._readOnly = true;
    return editorState;
  }
  toJSON() {
    return readEditorState(this, () => ({
      root: exportNodeToJSON($getRoot())
    }));
  }
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
/** @noInheritDoc */
class ParagraphNode extends ElementNode {
  static getType() {
    return 'paragraph';
  }
  static clone(node) {
    return new ParagraphNode(node.__key);
  }

  // View

  createDOM(config) {
    const dom = document.createElement('p');
    const classNames = getCachedClassNameArray(config.theme, 'paragraph');
    if (classNames !== undefined) {
      const domClassList = dom.classList;
      domClassList.add(...classNames);
    }
    return dom;
  }
  updateDOM(prevNode, dom, config) {
    return false;
  }
  static importDOM() {
    return {
      p: node => ({
        conversion: convertParagraphElement,
        priority: 0
      })
    };
  }
  exportDOM(editor) {
    const {
      element
    } = super.exportDOM(editor);
    if (element && isHTMLElement(element)) {
      if (this.isEmpty()) element.append(document.createElement('br'));
      const formatType = this.getFormatType();
      element.style.textAlign = formatType;
      const direction = this.getDirection();
      if (direction) {
        element.dir = direction;
      }
      const indent = this.getIndent();
      if (indent > 0) {
        // padding-inline-start is not widely supported in email HTML, but
        // Lexical Reconciler uses padding-inline-start. Using text-indent instead.
        element.style.textIndent = `${indent * 20}px`;
      }
    }
    return {
      element
    };
  }
  static importJSON(serializedNode) {
    const node = $createParagraphNode();
    node.setFormat(serializedNode.format);
    node.setIndent(serializedNode.indent);
    node.setDirection(serializedNode.direction);
    return node;
  }
  exportJSON() {
    return {
      ...super.exportJSON(),
      type: 'paragraph',
      version: 1
    };
  }

  // Mutation

  insertNewAfter(_, restoreSelection) {
    const newElement = $createParagraphNode();
    const direction = this.getDirection();
    newElement.setDirection(direction);
    this.insertAfter(newElement, restoreSelection);
    return newElement;
  }
  collapseAtStart() {
    const children = this.getChildren();
    // If we have an empty (trimmed) first paragraph and try and remove it,
    // delete the paragraph as long as we have another sibling to go to
    if (children.length === 0 || $isTextNode(children[0]) && children[0].getTextContent().trim() === '') {
      const nextSibling = this.getNextSibling();
      if (nextSibling !== null) {
        this.selectNext();
        this.remove();
        return true;
      }
      const prevSibling = this.getPreviousSibling();
      if (prevSibling !== null) {
        this.selectPrevious();
        this.remove();
        return true;
      }
    }
    return false;
  }
}
function convertParagraphElement(element) {
  const node = $createParagraphNode();
  if (element.style) {
    node.setFormat(element.style.textAlign);
    const indent = parseInt(element.style.textIndent, 10) / 20;
    if (indent > 0) {
      node.setIndent(indent);
    }
  }
  return {
    node
  };
}
function $createParagraphNode() {
  return $applyNodeReplacement(new ParagraphNode());
}
function $isParagraphNode(node) {
  return node instanceof ParagraphNode;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

// https://github.com/microsoft/TypeScript/issues/3841
// eslint-disable-next-line @typescript-eslint/no-explicit-any
// eslint-disable-next-line @typescript-eslint/no-explicit-any
const COMMAND_PRIORITY_EDITOR = 0;
const COMMAND_PRIORITY_LOW = 1;
const COMMAND_PRIORITY_NORMAL = 2;
const COMMAND_PRIORITY_HIGH = 3;
const COMMAND_PRIORITY_CRITICAL = 4;

// eslint-disable-next-line @typescript-eslint/no-unused-vars

/**
 * Type helper for extracting the payload type from a command.
 *
 * @example
 * ```ts
 * const MY_COMMAND = createCommand<SomeType>();
 *
 * // ...
 *
 * editor.registerCommand(MY_COMMAND, payload => {
 *   // Type of `payload` is inferred here. But lets say we want to extract a function to delegate to
 *   handleMyCommand(editor, payload);
 *   return true;
 * });
 *
 * function handleMyCommand(editor: LexicalEditor, payload: CommandPayloadType<typeof MY_COMMAND>) {
 *   // `payload` is of type `SomeType`, extracted from the command.
 * }
 * ```
 */

function resetEditor(editor, prevRootElement, nextRootElement, pendingEditorState,
// TODO: UNSAFE - FORK PART
keepAllNodes) {
  // eslint-disable-next-line no-console
  console.log('resetEditor 29/01');
  const keyNodeMap = editor._keyToDOMMap;
  keyNodeMap.clear();
  editor._editorState = createEmptyEditorState();
  editor._pendingEditorState = pendingEditorState;
  editor._compositionKey = null;
  editor._dirtyType = NO_DIRTY_NODES;
  editor._cloneNotNeeded.clear();
  editor._dirtyLeaves = new Set();
  editor._dirtyElements.clear();
  editor._normalizedNodes = new Set();
  editor._updateTags = new Set();
  editor._updates = [];
  editor._blockCursorElement = null;
  const observer = editor._observer;
  if (observer !== null) {
    observer.disconnect();
    editor._observer = null;
  }

  // Remove all the DOM nodes from the root element
  // TODO: UNSAFE - FORK PART
  if (prevRootElement !== null && !keepAllNodes) {
    prevRootElement.textContent = '';
  }
  if (nextRootElement !== null) {
    nextRootElement.textContent = '';
    keyNodeMap.set('root', nextRootElement);
  }
}
function initializeConversionCache(nodes, additionalConversions) {
  const conversionCache = new Map();
  const handledConversions = new Set();
  const addConversionsToCache = map => {
    Object.keys(map).forEach(key => {
      let currentCache = conversionCache.get(key);
      if (currentCache === undefined) {
        currentCache = [];
        conversionCache.set(key, currentCache);
      }
      currentCache.push(map[key]);
    });
  };
  nodes.forEach(node => {
    const importDOM = node.klass.importDOM != null ? node.klass.importDOM.bind(node.klass) : null;
    if (importDOM == null || handledConversions.has(importDOM)) {
      return;
    }
    handledConversions.add(importDOM);
    const map = importDOM();
    if (map !== null) {
      addConversionsToCache(map);
    }
  });
  if (additionalConversions) {
    addConversionsToCache(additionalConversions);
  }
  return conversionCache;
}

/**
 * Creates a new LexicalEditor attached to a single contentEditable (provided in the config). This is
 * the lowest-level initialization API for a LexicalEditor. If you're using React or another framework,
 * consider using the appropriate abstractions, such as LexicalComposer
 * @param editorConfig - the editor configuration.
 * @returns a LexicalEditor instance
 */
function createEditor(editorConfig) {
  const config = editorConfig || {};
  const activeEditor = internalGetActiveEditor();
  const theme = config.theme || {};
  const parentEditor = editorConfig === undefined ? activeEditor : config.parentEditor || null;
  const disableEvents = config.disableEvents || false;
  const editorState = createEmptyEditorState();
  const namespace = config.namespace || (parentEditor !== null ? parentEditor._config.namespace : createUID());
  const initialEditorState = config.editorState;
  const nodes = [RootNode, TextNode, LineBreakNode, TabNode, ParagraphNode, ...(config.nodes || [])];
  const {
    onError,
    html
  } = config;
  const isEditable = config.editable !== undefined ? config.editable : true;
  let registeredNodes;
  if (editorConfig === undefined && activeEditor !== null) {
    registeredNodes = activeEditor._nodes;
  } else {
    registeredNodes = new Map();
    for (let i = 0; i < nodes.length; i++) {
      let klass = nodes[i];
      let replace = null;
      let replaceWithKlass = null;
      if (typeof klass !== 'function') {
        const options = klass;
        klass = options.replace;
        replace = options.with;
        replaceWithKlass = options.withKlass || null;
      }
      // Ensure custom nodes implement required methods.
      {
        const name = klass.name;
        if (name !== 'RootNode') {
          const proto = klass.prototype;
          ['getType', 'clone'].forEach(method => {
            // eslint-disable-next-line no-prototype-builtins
            if (!klass.hasOwnProperty(method)) {
              console.warn(`${name} must implement static "${method}" method`);
            }
          });
          if (
          // eslint-disable-next-line no-prototype-builtins
          !klass.hasOwnProperty('importDOM') &&
          // eslint-disable-next-line no-prototype-builtins
          klass.hasOwnProperty('exportDOM')) {
            console.warn(`${name} should implement "importDOM" if using a custom "exportDOM" method to ensure HTML serialization (important for copy & paste) works as expected`);
          }
          if (proto instanceof DecoratorNode) {
            // eslint-disable-next-line no-prototype-builtins
            if (!proto.hasOwnProperty('decorate')) {
              console.warn(`${proto.constructor.name} must implement "decorate" method`);
            }
          }
          if (
          // eslint-disable-next-line no-prototype-builtins
          !klass.hasOwnProperty('importJSON')) {
            console.warn(`${name} should implement "importJSON" method to ensure JSON and default HTML serialization works as expected`);
          }
          if (
          // eslint-disable-next-line no-prototype-builtins
          !proto.hasOwnProperty('exportJSON')) {
            console.warn(`${name} should implement "exportJSON" method to ensure JSON and default HTML serialization works as expected`);
          }
        }
      }
      const type = klass.getType();
      const transform = klass.transform();
      const transforms = new Set();
      if (transform !== null) {
        transforms.add(transform);
      }
      registeredNodes.set(type, {
        exportDOM: html && html.export ? html.export.get(klass) : undefined,
        klass,
        replace,
        replaceWithKlass,
        transforms
      });
    }
  }
  const editor = new LexicalEditor(editorState, parentEditor, registeredNodes, {
    disableEvents,
    namespace,
    theme
  }, onError ? onError : console.error, initializeConversionCache(registeredNodes, html ? html.import : undefined), isEditable);
  if (initialEditorState !== undefined) {
    editor._pendingEditorState = initialEditorState;
    editor._dirtyType = FULL_RECONCILE;
  }
  return editor;
}
class LexicalEditor {
  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */

  /** @internal */
  constructor(editorState, parentEditor, nodes, config, onError, htmlConversions, editable) {
    this._parentEditor = parentEditor;
    // The root element associated with this editor
    this._rootElement = null;
    // The current editor state
    this._editorState = editorState;
    // Handling of drafts and updates
    this._pendingEditorState = null;
    // Used to help co-ordinate selection and events
    this._compositionKey = null;
    this._deferred = [];
    // Used during reconciliation
    this._keyToDOMMap = new Map();
    this._updates = [];
    this._updating = false;
    // Listeners
    this._listeners = {
      decorator: new Set(),
      editable: new Set(),
      mutation: new Map(),
      root: new Set(),
      textcontent: new Set(),
      update: new Set()
    };
    // Commands
    this._commands = new Map();
    // Editor configuration for theme/context.
    this._config = config;
    // Mapping of types to their nodes
    this._nodes = nodes;
    // React node decorators for portals
    this._decorators = {};
    this._pendingDecorators = null;
    // Used to optimize reconciliation
    this._dirtyType = NO_DIRTY_NODES;
    this._cloneNotNeeded = new Set();
    this._dirtyLeaves = new Set();
    this._dirtyElements = new Map();
    this._normalizedNodes = new Set();
    this._updateTags = new Set();
    // Handling of DOM mutations
    this._observer = null;
    // Used for identifying owning editors
    this._key = createUID();
    this._onError = onError;
    this._htmlConversions = htmlConversions;
    this._editable = editable;
    this._headless = parentEditor !== null && parentEditor._headless;
    this._window = null;
    this._blockCursorElement = null;
  }

  /**
   *
   * @returns true if the editor is currently in "composition" mode due to receiving input
   * through an IME, or 3P extension, for example. Returns false otherwise.
   */
  isComposing() {
    return this._compositionKey != null;
  }
  /**
   * Registers a listener for Editor update event. Will trigger the provided callback
   * each time the editor goes through an update (via {@link LexicalEditor.update}) until the
   * teardown function is called.
   *
   * @returns a teardown function that can be used to cleanup the listener.
   */
  registerUpdateListener(listener) {
    const listenerSetOrMap = this._listeners.update;
    listenerSetOrMap.add(listener);
    return () => {
      listenerSetOrMap.delete(listener);
    };
  }
  /**
   * Registers a listener for for when the editor changes between editable and non-editable states.
   * Will trigger the provided callback each time the editor transitions between these states until the
   * teardown function is called.
   *
   * @returns a teardown function that can be used to cleanup the listener.
   */
  registerEditableListener(listener) {
    const listenerSetOrMap = this._listeners.editable;
    listenerSetOrMap.add(listener);
    return () => {
      listenerSetOrMap.delete(listener);
    };
  }
  /**
   * Registers a listener for when the editor's decorator object changes. The decorator object contains
   * all DecoratorNode keys -> their decorated value. This is primarily used with external UI frameworks.
   *
   * Will trigger the provided callback each time the editor transitions between these states until the
   * teardown function is called.
   *
   * @returns a teardown function that can be used to cleanup the listener.
   */
  registerDecoratorListener(listener) {
    const listenerSetOrMap = this._listeners.decorator;
    listenerSetOrMap.add(listener);
    return () => {
      listenerSetOrMap.delete(listener);
    };
  }
  /**
   * Registers a listener for when Lexical commits an update to the DOM and the text content of
   * the editor changes from the previous state of the editor. If the text content is the
   * same between updates, no notifications to the listeners will happen.
   *
   * Will trigger the provided callback each time the editor transitions between these states until the
   * teardown function is called.
   *
   * @returns a teardown function that can be used to cleanup the listener.
   */
  registerTextContentListener(listener) {
    const listenerSetOrMap = this._listeners.textcontent;
    listenerSetOrMap.add(listener);
    return () => {
      listenerSetOrMap.delete(listener);
    };
  }
  /**
   * Registers a listener for when the editor's root DOM element (the content editable
   * Lexical attaches to) changes. This is primarily used to attach event listeners to the root
   *  element. The root listener function is executed directly upon registration and then on
   * any subsequent update.
   *
   * Will trigger the provided callback each time the editor transitions between these states until the
   * teardown function is called.
   *
   * @returns a teardown function that can be used to cleanup the listener.
   */
  registerRootListener(listener) {
    const listenerSetOrMap = this._listeners.root;
    listener(this._rootElement, null);
    listenerSetOrMap.add(listener);
    return () => {
      listener(null, this._rootElement);
      listenerSetOrMap.delete(listener);
    };
  }
  /**
   * Registers a listener that will trigger anytime the provided command
   * is dispatched, subject to priority. Listeners that run at a higher priority can "intercept"
   * commands and prevent them from propagating to other handlers by returning true.
   *
   * Listeners registered at the same priority level will run deterministically in the order of registration.
   *
   * @param command - the command that will trigger the callback.
   * @param listener - the function that will execute when the command is dispatched.
   * @param priority - the relative priority of the listener. 0 | 1 | 2 | 3 | 4
   * @returns a teardown function that can be used to cleanup the listener.
   */
  registerCommand(command, listener, priority) {
    if (priority === undefined) {
      {
        throw Error(`Listener for type "command" requires a "priority".`);
      }
    }
    const commandsMap = this._commands;
    if (!commandsMap.has(command)) {
      commandsMap.set(command, [new Set(), new Set(), new Set(), new Set(), new Set()]);
    }
    const listenersInPriorityOrder = commandsMap.get(command);
    if (listenersInPriorityOrder === undefined) {
      {
        throw Error(`registerCommand: Command ${String(command)} not found in command map`);
      }
    }
    const listeners = listenersInPriorityOrder[priority];
    listeners.add(listener);
    return () => {
      listeners.delete(listener);
      if (listenersInPriorityOrder.every(listenersSet => listenersSet.size === 0)) {
        commandsMap.delete(command);
      }
    };
  }

  /**
   * Registers a listener that will run when a Lexical node of the provided class is
   * mutated. The listener will receive a list of nodes along with the type of mutation
   * that was performed on each: created, destroyed, or updated.
   *
   * One common use case for this is to attach DOM event listeners to the underlying DOM nodes as Lexical nodes are created.
   * {@link LexicalEditor.getElementByKey} can be used for this.
   *
   * @param klass - The class of the node that you want to listen to mutations on.
   * @param listener - The logic you want to run when the node is mutated.
   * @returns a teardown function that can be used to cleanup the listener.
   */
  registerMutationListener(klass, listener) {
    const registeredNode = this._nodes.get(klass.getType());
    if (registeredNode === undefined) {
      {
        throw Error(`Node ${klass.name} has not been registered. Ensure node has been passed to createEditor.`);
      }
    }
    const mutations = this._listeners.mutation;
    mutations.set(listener, klass);
    return () => {
      mutations.delete(listener);
    };
  }

  /** @internal */
  registerNodeTransformToKlass(klass, listener) {
    const type = klass.getType();
    const registeredNode = this._nodes.get(type);
    if (registeredNode === undefined) {
      {
        throw Error(`Node ${klass.name} has not been registered. Ensure node has been passed to createEditor.`);
      }
    }
    const transforms = registeredNode.transforms;
    transforms.add(listener);
    return registeredNode;
  }

  /**
   * Registers a listener that will run when a Lexical node of the provided class is
   * marked dirty during an update. The listener will continue to run as long as the node
   * is marked dirty. There are no guarantees around the order of transform execution!
   *
   * Watch out for infinite loops. See [Node Transforms](https://lexical.dev/docs/concepts/transforms)
   * @param klass - The class of the node that you want to run transforms on.
   * @param listener - The logic you want to run when the node is updated.
   * @returns a teardown function that can be used to cleanup the listener.
   */
  registerNodeTransform(klass, listener) {
    const registeredNode = this.registerNodeTransformToKlass(klass, listener);
    const registeredNodes = [registeredNode];
    const replaceWithKlass = registeredNode.replaceWithKlass;
    if (replaceWithKlass != null) {
      const registeredReplaceWithNode = this.registerNodeTransformToKlass(replaceWithKlass, listener);
      registeredNodes.push(registeredReplaceWithNode);
    }
    markAllNodesAsDirty(this, klass.getType());
    return () => {
      registeredNodes.forEach(node => node.transforms.delete(listener));
    };
  }

  /**
   * Used to assert that a certain node is registered, usually by plugins to ensure nodes that they
   * depend on have been registered.
   * @returns True if the editor has registered the provided node type, false otherwise.
   */
  hasNode(node) {
    return this._nodes.has(node.getType());
  }

  /**
   * Used to assert that certain nodes are registered, usually by plugins to ensure nodes that they
   * depend on have been registered.
   * @returns True if the editor has registered all of the provided node types, false otherwise.
   */
  hasNodes(nodes) {
    return nodes.every(this.hasNode.bind(this));
  }

  /**
   * Dispatches a command of the specified type with the specified payload.
   * This triggers all command listeners (set by {@link LexicalEditor.registerCommand})
   * for this type, passing them the provided payload.
   * @param type - the type of command listeners to trigger.
   * @param payload - the data to pass as an argument to the command listeners.
   */
  dispatchCommand(type, payload) {
    return dispatchCommand(this, type, payload);
  }

  /**
   * Gets a map of all decorators in the editor.
   * @returns A mapping of call decorator keys to their decorated content
   */
  getDecorators() {
    return this._decorators;
  }

  /**
   *
   * @returns the current root element of the editor. If you want to register
   * an event listener, do it via {@link LexicalEditor.registerRootListener}, since
   * this reference may not be stable.
   */
  getRootElement() {
    return this._rootElement;
  }

  /**
   * Gets the key of the editor
   * @returns The editor key
   */
  getKey() {
    return this._key;
  }

  /**
   * Imperatively set the root contenteditable element that Lexical listens
   * for events on.
   */
  setRootElement(nextRootElement,
  // TODO: UNSAFE - FORK PART
  options) {
    const prevRootElement = this._rootElement;
    if (nextRootElement !== prevRootElement) {
      const classNames = getCachedClassNameArray(this._config.theme, 'root');
      const pendingEditorState = this._pendingEditorState || this._editorState;
      this._rootElement = nextRootElement;
      resetEditor(this, prevRootElement, nextRootElement, pendingEditorState,
      // TODO: UNSAFE - FORK PART
      options && options.ignoreDom);
      if (prevRootElement !== null) {
        // TODO: remove this flag once we no longer use UEv2 internally
        if (!this._config.disableEvents) {
          removeRootElementEvents(prevRootElement);
        }
        if (classNames != null) {
          prevRootElement.classList.remove(...classNames);
        }
      }
      if (nextRootElement !== null) {
        const windowObj = getDefaultView(nextRootElement);
        const style = nextRootElement.style;
        style.userSelect = 'text';
        style.whiteSpace = 'pre-wrap';
        style.wordBreak = 'break-word';
        nextRootElement.setAttribute('data-lexical-editor', 'true');
        this._window = windowObj;
        this._dirtyType = FULL_RECONCILE;
        initMutationObserver(this);
        this._updateTags.add('history-merge');
        commitPendingUpdates(this);

        // TODO: remove this flag once we no longer use UEv2 internally
        if (!this._config.disableEvents) {
          addRootElementEvents(nextRootElement, this);
        }
        if (classNames != null) {
          nextRootElement.classList.add(...classNames);
        }
      } else {
        // If content editable is unmounted we'll reset editor state back to original
        // (or pending) editor state since there will be no reconciliation
        this._editorState = pendingEditorState;
        this._pendingEditorState = null;
        this._window = null;
      }
      triggerListeners('root', this, false, nextRootElement, prevRootElement);
    }
  }

  /**
   * Gets the underlying HTMLElement associated with the LexicalNode for the given key.
   * @returns the HTMLElement rendered by the LexicalNode associated with the key.
   * @param key - the key of the LexicalNode.
   */
  getElementByKey(key) {
    return this._keyToDOMMap.get(key) || null;
  }

  /**
   * Gets the active editor state.
   * @returns The editor state
   */
  getEditorState() {
    return this._editorState;
  }

  /**
   * Imperatively set the EditorState. Triggers reconciliation like an update.
   * @param editorState - the state to set the editor
   * @param options - options for the update.
   */
  setEditorState(editorState, options) {
    if (editorState.isEmpty()) {
      {
        throw Error(`setEditorState: the editor state is empty. Ensure the editor state's root node never becomes empty.`);
      }
    }
    flushRootMutations(this);
    const pendingEditorState = this._pendingEditorState;
    const tags = this._updateTags;
    const tag = options !== undefined ? options.tag : null;
    if (pendingEditorState !== null && !pendingEditorState.isEmpty()) {
      if (tag != null) {
        tags.add(tag);
      }
      commitPendingUpdates(this);
    }
    this._pendingEditorState = editorState;
    this._dirtyType = FULL_RECONCILE;
    this._dirtyElements.set('root', false);
    this._compositionKey = null;
    if (tag != null) {
      tags.add(tag);
    }
    commitPendingUpdates(this);
  }

  /**
   * Parses a SerializedEditorState (usually produced by {@link EditorState.toJSON}) and returns
   * and EditorState object that can be, for example, passed to {@link LexicalEditor.setEditorState}. Typically,
   * deserliazation from JSON stored in a database uses this method.
   * @param maybeStringifiedEditorState
   * @param updateFn
   * @returns
   */
  parseEditorState(maybeStringifiedEditorState, updateFn) {
    const serializedEditorState = typeof maybeStringifiedEditorState === 'string' ? JSON.parse(maybeStringifiedEditorState) : maybeStringifiedEditorState;
    return parseEditorState(serializedEditorState, this, updateFn);
  }

  /**
   * Executes an update to the editor state. The updateFn callback is the ONLY place
   * where Lexical editor state can be safely mutated.
   * @param updateFn - A function that has access to writable editor state.
   * @param options - A bag of options to control the behavior of the update.
   * @param options.onUpdate - A function to run once the update is complete.
   * Useful for synchronizing updates in some cases.
   * @param options.skipTransforms - Setting this to true will suppress all node
   * transforms for this update cycle.
   * @param options.tag - A tag to identify this update, in an update listener, for instance.
   * Some tags are reserved by the core and control update behavior in different ways.
   * @param options.discrete - If true, prevents this update from being batched, forcing it to
   * run synchronously.
   */
  update(updateFn, options) {
    updateEditor(this, updateFn, options);
  }

  /**
   * Focuses the editor
   * @param callbackFn - A function to run after the editor is focused.
   * @param options - A bag of options
   * @param options.defaultSelection - Where to move selection when the editor is
   * focused. Can be rootStart, rootEnd, or undefined. Defaults to rootEnd.
   */
  focus(callbackFn, options = {}) {
    const rootElement = this._rootElement;
    if (rootElement !== null) {
      // This ensures that iOS does not trigger caps lock upon focus
      rootElement.setAttribute('autocapitalize', 'off');
      updateEditor(this, () => {
        const selection = $getSelection();
        const root = $getRoot();
        if (selection !== null) {
          // Marking the selection dirty will force the selection back to it
          selection.dirty = true;
        } else if (root.getChildrenSize() !== 0) {
          if (options.defaultSelection === 'rootStart') {
            root.selectStart();
          } else {
            root.selectEnd();
          }
        }
      }, {
        onUpdate: () => {
          rootElement.removeAttribute('autocapitalize');
          if (callbackFn) {
            callbackFn();
          }
        },
        tag: 'focus'
      });
      // In the case where onUpdate doesn't fire (due to the focus update not
      // occuring).
      if (this._pendingEditorState === null) {
        rootElement.removeAttribute('autocapitalize');
      }
    }
  }

  /**
   * Removes focus from the editor.
   */
  blur() {
    const rootElement = this._rootElement;
    if (rootElement !== null) {
      rootElement.blur();
    }
    const domSelection = getDOMSelection(this._window);
    if (domSelection !== null) {
      domSelection.removeAllRanges();
    }
  }
  /**
   * Returns true if the editor is editable, false otherwise.
   * @returns True if the editor is editable, false otherwise.
   */
  isEditable() {
    return this._editable;
  }
  /**
   * Sets the editable property of the editor. When false, the
   * editor will not listen for user events on the underling contenteditable.
   * @param editable - the value to set the editable mode to.
   */
  setEditable(editable) {
    if (this._editable !== editable) {
      this._editable = editable;
      triggerListeners('editable', this, true, editable);
    }
  }
  /**
   * Returns a JSON-serializable javascript object NOT a JSON string.
   * You still must call JSON.stringify (or something else) to turn the
   * state into a string you can transfer over the wire and store in a database.
   *
   * See {@link LexicalNode.exportJSON}
   *
   * @returns A JSON-serializable javascript object
   */
  toJSON() {
    return {
      editorState: this._editorState.toJSON()
    };
  }
}
Lexical_dev.$addUpdateTag = $addUpdateTag;
Lexical_dev.$applyNodeReplacement = $applyNodeReplacement;
Lexical_dev.$copyNode = $copyNode;
Lexical_dev.$createLineBreakNode = $createLineBreakNode;
Lexical_dev.$createNodeSelection = $createNodeSelection;
Lexical_dev.$createParagraphNode = $createParagraphNode;
Lexical_dev.$createPoint = $createPoint;
Lexical_dev.$createRangeSelection = $createRangeSelection;
Lexical_dev.$createTabNode = $createTabNode;
Lexical_dev.$createTextNode = $createTextNode;
Lexical_dev.$getAdjacentNode = $getAdjacentNode;
Lexical_dev.$getCharacterOffsets = $getCharacterOffsets;
Lexical_dev.$getEditor = $getEditor;
Lexical_dev.$getNearestNodeFromDOMNode = $getNearestNodeFromDOMNode;
Lexical_dev.$getNearestRootOrShadowRoot = $getNearestRootOrShadowRoot;
Lexical_dev.$getNodeByKey = $getNodeByKey;
Lexical_dev.$getPreviousSelection = $getPreviousSelection;
Lexical_dev.$getRoot = $getRoot;
Lexical_dev.$getSelection = $getSelection;
Lexical_dev.$getTextContent = $getTextContent;
Lexical_dev.$hasAncestor = $hasAncestor;
Lexical_dev.$hasUpdateTag = $hasUpdateTag;
Lexical_dev.$insertNodes = $insertNodes;
Lexical_dev.$isBlockElementNode = $isBlockElementNode;
Lexical_dev.$isDecoratorNode = $isDecoratorNode;
Lexical_dev.$isElementNode = $isElementNode;
Lexical_dev.$isInlineElementOrDecoratorNode = $isInlineElementOrDecoratorNode;
Lexical_dev.$isLeafNode = $isLeafNode;
Lexical_dev.$isLineBreakNode = $isLineBreakNode;
Lexical_dev.$isNodeSelection = $isNodeSelection;
Lexical_dev.$isParagraphNode = $isParagraphNode;
Lexical_dev.$isRangeSelection = $isRangeSelection;
Lexical_dev.$isRootNode = $isRootNode;
Lexical_dev.$isRootOrShadowRoot = $isRootOrShadowRoot;
Lexical_dev.$isTabNode = $isTabNode;
Lexical_dev.$isTextNode = $isTextNode;
Lexical_dev.$nodesOfType = $nodesOfType;
Lexical_dev.$normalizeSelection__EXPERIMENTAL = $normalizeSelection;
Lexical_dev.$parseSerializedNode = $parseSerializedNode;
Lexical_dev.$selectAll = $selectAll;
Lexical_dev.$setCompositionKey = $setCompositionKey;
Lexical_dev.$setSelection = $setSelection;
Lexical_dev.$splitNode = $splitNode;
Lexical_dev.BLUR_COMMAND = BLUR_COMMAND;
Lexical_dev.CAN_REDO_COMMAND = CAN_REDO_COMMAND;
Lexical_dev.CAN_UNDO_COMMAND = CAN_UNDO_COMMAND;
Lexical_dev.CLEAR_EDITOR_COMMAND = CLEAR_EDITOR_COMMAND;
Lexical_dev.CLEAR_HISTORY_COMMAND = CLEAR_HISTORY_COMMAND;
Lexical_dev.CLICK_COMMAND = CLICK_COMMAND;
Lexical_dev.COMMAND_PRIORITY_CRITICAL = COMMAND_PRIORITY_CRITICAL;
Lexical_dev.COMMAND_PRIORITY_EDITOR = COMMAND_PRIORITY_EDITOR;
Lexical_dev.COMMAND_PRIORITY_HIGH = COMMAND_PRIORITY_HIGH;
Lexical_dev.COMMAND_PRIORITY_LOW = COMMAND_PRIORITY_LOW;
Lexical_dev.COMMAND_PRIORITY_NORMAL = COMMAND_PRIORITY_NORMAL;
Lexical_dev.COMPOSITION_SUFFIX = COMPOSITION_SUFFIX;
Lexical_dev.CONTROLLED_TEXT_INSERTION_COMMAND = CONTROLLED_TEXT_INSERTION_COMMAND;
Lexical_dev.COPY_COMMAND = COPY_COMMAND;
Lexical_dev.CUT_COMMAND = CUT_COMMAND;
Lexical_dev.DELETE_CHARACTER_COMMAND = DELETE_CHARACTER_COMMAND;
Lexical_dev.DELETE_LINE_COMMAND = DELETE_LINE_COMMAND;
Lexical_dev.DELETE_WORD_COMMAND = DELETE_WORD_COMMAND;
Lexical_dev.DOM_ELEMENT_TYPE = DOM_ELEMENT_TYPE;
Lexical_dev.DOM_TEXT_TYPE = DOM_TEXT_TYPE;
Lexical_dev.DRAGEND_COMMAND = DRAGEND_COMMAND;
Lexical_dev.DRAGOVER_COMMAND = DRAGOVER_COMMAND;
Lexical_dev.DRAGSTART_COMMAND = DRAGSTART_COMMAND;
Lexical_dev.DROP_COMMAND = DROP_COMMAND;
Lexical_dev.DecoratorNode = DecoratorNode;
Lexical_dev.ElementNode = ElementNode;
Lexical_dev.FOCUS_COMMAND = FOCUS_COMMAND;
Lexical_dev.FORMAT_ELEMENT_COMMAND = FORMAT_ELEMENT_COMMAND;
Lexical_dev.FORMAT_TEXT_COMMAND = FORMAT_TEXT_COMMAND;
Lexical_dev.INDENT_CONTENT_COMMAND = INDENT_CONTENT_COMMAND;
Lexical_dev.INSERT_LINE_BREAK_COMMAND = INSERT_LINE_BREAK_COMMAND;
Lexical_dev.INSERT_PARAGRAPH_COMMAND = INSERT_PARAGRAPH_COMMAND;
Lexical_dev.INSERT_TAB_COMMAND = INSERT_TAB_COMMAND;
Lexical_dev.KEY_ARROW_DOWN_COMMAND = KEY_ARROW_DOWN_COMMAND;
Lexical_dev.KEY_ARROW_LEFT_COMMAND = KEY_ARROW_LEFT_COMMAND;
Lexical_dev.KEY_ARROW_RIGHT_COMMAND = KEY_ARROW_RIGHT_COMMAND;
Lexical_dev.KEY_ARROW_UP_COMMAND = KEY_ARROW_UP_COMMAND;
Lexical_dev.KEY_BACKSPACE_COMMAND = KEY_BACKSPACE_COMMAND;
Lexical_dev.KEY_DELETE_COMMAND = KEY_DELETE_COMMAND;
Lexical_dev.KEY_DOWN_COMMAND = KEY_DOWN_COMMAND;
Lexical_dev.KEY_ENTER_COMMAND = KEY_ENTER_COMMAND;
Lexical_dev.KEY_ESCAPE_COMMAND = KEY_ESCAPE_COMMAND;
Lexical_dev.KEY_MODIFIER_COMMAND = KEY_MODIFIER_COMMAND;
Lexical_dev.KEY_SPACE_COMMAND = KEY_SPACE_COMMAND;
Lexical_dev.KEY_TAB_COMMAND = KEY_TAB_COMMAND;
Lexical_dev.LineBreakNode = LineBreakNode;
Lexical_dev.MOVE_TO_END = MOVE_TO_END;
Lexical_dev.MOVE_TO_START = MOVE_TO_START;
Lexical_dev.OUTDENT_CONTENT_COMMAND = OUTDENT_CONTENT_COMMAND;
Lexical_dev.PASTE_COMMAND = PASTE_COMMAND;
Lexical_dev.ParagraphNode = ParagraphNode;
Lexical_dev.REDO_COMMAND = REDO_COMMAND;
Lexical_dev.REMOVE_TEXT_COMMAND = REMOVE_TEXT_COMMAND;
Lexical_dev.RootNode = RootNode;
Lexical_dev.SELECTION_CHANGE_COMMAND = SELECTION_CHANGE_COMMAND;
Lexical_dev.SELECTION_INSERT_CLIPBOARD_NODES_COMMAND = SELECTION_INSERT_CLIPBOARD_NODES_COMMAND;
Lexical_dev.SELECT_ALL_COMMAND = SELECT_ALL_COMMAND;
Lexical_dev.TabNode = TabNode;
Lexical_dev.TextNode = TextNode;
Lexical_dev.UNDO_COMMAND = UNDO_COMMAND;
Lexical_dev.createCommand = createCommand;
Lexical_dev.createEditor = createEditor;
Lexical_dev.findParentPreDOMNode = findParentPreDOMNode;
Lexical_dev.getCachedClassNameArray = getCachedClassNameArray;
Lexical_dev.getNearestEditorFromDOMNode = getNearestEditorFromDOMNode;
Lexical_dev.isCurrentlyReadOnlyMode = isCurrentlyReadOnlyMode;
Lexical_dev.isHTMLAnchorElement = isHTMLAnchorElement;
Lexical_dev.isHTMLElement = isHTMLElement;
Lexical_dev.isSelectionCapturedInDecoratorInput = isSelectionCapturedInDecoratorInput;
Lexical_dev.isSelectionWithinEditor = isSelectionWithinEditor;

var Lexical_prod = {};

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

let ba = {},
  ca = {},
  da = {},
  ea = {},
  fa = {},
  ka = {},
  la = {},
  ma = {},
  oa = {},
  pa = {},
  qa = {},
  ra = {},
  sa = {},
  ta = {},
  ua = {},
  va = {},
  wa = {},
  ya = {},
  za = {},
  Aa = {},
  Ba = {},
  Ca = {},
  Da = {},
  Ga = {},
  Ha = {},
  Ia = {},
  Ja = {},
  Ka = {},
  La = {},
  Ma = {},
  Na = {},
  Oa = {},
  Pa = {},
  Qa = {},
  Ra = {},
  Sa = {},
  Ta = "undefined" !== typeof window && "undefined" !== typeof window.document && "undefined" !== typeof window.document.createElement,
  Ua = Ta && "documentMode" in document ? document.documentMode : null,
  p = Ta && /Mac|iPod|iPhone|iPad/.test(navigator.platform),
  Va = Ta && /^(?!.*Seamonkey)(?=.*Firefox).*/i.test(navigator.userAgent),
  Xa = Ta && "InputEvent" in window && !Ua ? "getTargetRanges" in new window.InputEvent("input") : !1,
  Ya = Ta && /Version\/[\d.]+.*Safari/.test(navigator.userAgent),
  Za = Ta && /iPad|iPhone|iPod/.test(navigator.userAgent) && !window.MSStream,
  $a = Ta && /Android/.test(navigator.userAgent),
  ab = Ta && /^(?=.*Chrome).*/i.test(navigator.userAgent),
  bb = Ta && /AppleWebKit\/[\d.]+/.test(navigator.userAgent) && !ab,
  cb = Ya || Za || bb ? "\u00a0" : "\u200b",
  db = Va ? "\u00a0" : cb,
  eb = /^[^A-Za-z\u00c0-\u00d6\u00d8-\u00f6\u00f8-\u02b8\u0300-\u0590\u0800-\u1fff\u200e\u2c00-\ufb1c\ufe00-\ufe6f\ufefd-\uffff]*[\u0591-\u07ff\ufb1d-\ufdfd\ufe70-\ufefc]/,
  fb = /^[^\u0591-\u07ff\ufb1d-\ufdfd\ufe70-\ufefc]*[A-Za-z\u00c0-\u00d6\u00d8-\u00f6\u00f8-\u02b8\u0300-\u0590\u0800-\u1fff\u200e\u2c00-\ufb1c\ufe00-\ufe6f\ufefd-\uffff]/,
  gb = {
    bold: 1,
    code: 16,
    highlight: 128,
    italic: 2,
    strikethrough: 4,
    subscript: 32,
    superscript: 64,
    underline: 8
  },
  hb = {
    directionless: 1,
    unmergeable: 2
  },
  ib = {
    center: 2,
    end: 6,
    justify: 4,
    left: 1,
    right: 3,
    start: 5
  },
  mb = {
    2: "center",
    6: "end",
    4: "justify",
    1: "left",
    3: "right",
    5: "start"
  },
  nb = {
    normal: 0,
    segmented: 2,
    token: 1
  },
  ob = {
    0: "normal",
    2: "segmented",
    1: "token"
  };
function t(a) {
  let b = new URLSearchParams();
  b.append("code", a);
  for (let c = 1; c < arguments.length; c++) b.append("v", arguments[c]);
  throw Error(`Minified Lexical error #${a}; visit https://lexical.dev/docs/error?${b} for the full message or ` + "use the non-minified dev environment for full errors and additional helpful warnings.");
}
let pb = !1,
  qb = 0;
function rb(a) {
  qb = a.timeStamp;
}
function sb(a, b, c) {
  return b.__lexicalLineBreak === a || void 0 !== a[`__lexicalKey_${c._key}`];
}
function tb(a) {
  return a.getEditorState().read(() => {
    let b = u();
    return null !== b ? b.clone() : null;
  });
}
function ub(a, b, c) {
  pb = !0;
  let d = 100 < performance.now() - qb;
  try {
    v(a, () => {
      let e = u() || tb(a);
      var f = new Map(),
        g = a.getRootElement(),
        h = a._editorState,
        k = a._blockCursorElement;
      let m = !1,
        q = "";
      for (var n = 0; n < b.length; n++) {
        var l = b[n],
          r = l.type,
          w = l.target,
          A = vb(w, h);
        if (!(null === A && w !== g || y(A))) if ("characterData" === r) {
          if (l = d && B(A)) a: {
            l = e;
            r = w;
            var x = A;
            if (C(l)) {
              var z = l.anchor.getNode();
              if (z.is(x) && l.format !== z.getFormat()) {
                l = !1;
                break a;
              }
            }
            l = 3 === r.nodeType && x.isAttached();
          }
          l && (x = wb(a._window), r = l = null, null !== x && x.anchorNode === w && (l = x.anchorOffset, r = x.focusOffset), w = w.nodeValue, null !== w && xb(A, w, l, r, !1));
        } else if ("childList" === r) {
          m = !0;
          r = l.addedNodes;
          for (x = 0; x < r.length; x++) {
            z = r[x];
            var aa = yb(z),
              W = z.parentNode;
            null == W || z === k || null !== aa || "BR" === z.nodeName && sb(z, W, a) || (Va && (aa = z.innerText || z.nodeValue) && (q += aa), W.removeChild(z));
          }
          l = l.removedNodes;
          r = l.length;
          if (0 < r) {
            x = 0;
            for (z = 0; z < r; z++) if (W = l[z], "BR" === W.nodeName && sb(W, w, a) || k === W) w.appendChild(W), x++;
            r !== x && (w === g && (A = h._nodeMap.get("root")), f.set(w, A));
          }
        }
      }
      if (0 < f.size) for (let [Wa, ja] of f) if (E(ja)) for (f = ja.getChildrenKeys(), g = Wa.firstChild, h = 0; h < f.length; h++) k = a.getElementByKey(f[h]), null !== k && (null == g ? (Wa.appendChild(k), g = k) : g !== k && Wa.replaceChild(k, g), g = g.nextSibling);else B(ja) && ja.markDirty();
      f = c.takeRecords();
      if (0 < f.length) {
        for (g = 0; g < f.length; g++) for (k = f[g], h = k.addedNodes, k = k.target, n = 0; n < h.length; n++) A = h[n], w = A.parentNode, null == w || "BR" !== A.nodeName || sb(A, k, a) || w.removeChild(A);
        c.takeRecords();
      }
      null !== e && (m && (e.dirty = !0, zb(e)), Va && Ab(a) && e.insertRawText(q));
    });
  } finally {
    pb = !1;
  }
}
function Bb(a) {
  let b = a._observer;
  if (null !== b) {
    let c = b.takeRecords();
    ub(a, c, b);
  }
}
function Cb(a) {
  0 === qb && Db(a).addEventListener("textInput", rb, !0);
  a._observer = new MutationObserver((b, c) => {
    ub(a, b, c);
  });
}
function Eb(a, b) {
  let c = a.__mode,
    d = a.__format;
  a = a.__style;
  let e = b.__mode,
    f = b.__format;
  b = b.__style;
  return (null === c || c === e) && (null === d || d === f) && (null === a || a === b);
}
function Fb(a, b) {
  let c = a.mergeWithSibling(b),
    d = F()._normalizedNodes;
  d.add(a.__key);
  d.add(b.__key);
  return c;
}
function Gb(a) {
  if ("" === a.__text && a.isSimpleText() && !a.isUnmergeable()) a.remove();else {
    for (var b; null !== (b = a.getPreviousSibling()) && B(b) && b.isSimpleText() && !b.isUnmergeable();) if ("" === b.__text) b.remove();else {
      Eb(b, a) && (a = Fb(b, a));
      break;
    }
    for (var c; null !== (c = a.getNextSibling()) && B(c) && c.isSimpleText() && !c.isUnmergeable();) if ("" === c.__text) c.remove();else {
      Eb(a, c) && Fb(a, c);
      break;
    }
  }
}
function Hb(a) {
  Ib(a.anchor);
  Ib(a.focus);
  return a;
}
function Ib(a) {
  for (; "element" === a.type;) {
    var b = a.getNode(),
      c = a.offset;
    c === b.getChildrenSize() ? (b = b.getChildAtIndex(c - 1), c = !0) : (b = b.getChildAtIndex(c), c = !1);
    if (B(b)) {
      a.set(b.__key, c ? b.getTextContentSize() : 0, "text");
      break;
    } else if (!E(b)) break;
    a.set(b.__key, c ? b.getChildrenSize() : 0, "element");
  }
}
let Jb = 1,
  Kb = "function" === typeof queueMicrotask ? queueMicrotask : a => {
    Promise.resolve().then(a);
  };
function Rb(a) {
  let b = document.activeElement;
  if (null === b) return !1;
  let c = b.nodeName;
  return y(vb(a)) && ("INPUT" === c || "TEXTAREA" === c || "true" === b.contentEditable && null == b.__lexicalEditor);
}
function Sb(a, b, c) {
  let d = a.getRootElement();
  try {
    return null !== d && d.contains(b) && d.contains(c) && null !== b && !Rb(b) && Tb(b) === a;
  } catch (e) {
    return !1;
  }
}
function Tb(a) {
  for (; null != a;) {
    let b = a.__lexicalEditor;
    if (null != b) return b;
    a = Ub(a);
  }
  return null;
}
function Vb(a) {
  return a.isToken() || a.isSegmented();
}
function Wb(a) {
  for (; null != a;) {
    if (3 === a.nodeType) return a;
    a = a.firstChild;
  }
  return null;
}
function Xb(a, b, c) {
  let d = gb[b];
  if (null !== c && (a & d) === (c & d)) return a;
  a ^= d;
  "subscript" === b ? a &= ~gb.superscript : "superscript" === b && (a &= ~gb.subscript);
  return a;
}
function Yb(a, b) {
  if (null != b) a.__key = b;else {
    G();
    99 < Zb && t(14);
    b = F();
    var c = $b(),
      d = "" + Jb++;
    c._nodeMap.set(d, a);
    E(a) ? b._dirtyElements.set(d, !0) : b._dirtyLeaves.add(d);
    b._cloneNotNeeded.add(d);
    b._dirtyType = 1;
    a.__key = d;
  }
}
function ac(a) {
  var b = a.getParent();
  if (null !== b) {
    let e = a.getWritable();
    b = b.getWritable();
    var c = a.getPreviousSibling();
    a = a.getNextSibling();
    if (null === c) {
      if (null !== a) {
        var d = a.getWritable();
        b.__first = a.__key;
        d.__prev = null;
      } else b.__first = null;
    } else {
      d = c.getWritable();
      if (null !== a) {
        let f = a.getWritable();
        f.__prev = d.__key;
        d.__next = f.__key;
      } else d.__next = null;
      e.__prev = null;
    }
    null === a ? null !== c ? (a = c.getWritable(), b.__last = c.__key, a.__next = null) : b.__last = null : (a = a.getWritable(), null !== c ? (c = c.getWritable(), c.__next = a.__key, a.__prev = c.__key) : a.__prev = null, e.__next = null);
    b.__size--;
    e.__parent = null;
  }
}
function bc(a) {
  99 < Zb && t(14);
  var b = a.getLatest(),
    c = b.__parent,
    d = $b();
  let e = F(),
    f = d._nodeMap;
  d = e._dirtyElements;
  if (null !== c) a: for (; null !== c;) {
    if (d.has(c)) break a;
    let g = f.get(c);
    if (void 0 === g) break;
    d.set(c, !1);
    c = g.__parent;
  }
  b = b.__key;
  e._dirtyType = 1;
  E(a) ? d.set(b, !0) : e._dirtyLeaves.add(b);
}
function H(a) {
  G();
  var b = F();
  let c = b._compositionKey;
  a !== c && (b._compositionKey = a, null !== c && (b = I(c), null !== b && b.getWritable()), null !== a && (a = I(a), null !== a && a.getWritable()));
}
function cc() {
  return dc() ? null : F()._compositionKey;
}
function I(a, b) {
  a = (b || $b())._nodeMap.get(a);
  return void 0 === a ? null : a;
}
function yb(a, b) {
  let c = F();
  a = a[`__lexicalKey_${c._key}`];
  return void 0 !== a ? I(a, b) : null;
}
function vb(a, b) {
  for (; null != a;) {
    let c = yb(a, b);
    if (null !== c) return c;
    a = Ub(a);
  }
  return null;
}
function ec(a) {
  let b = Object.assign({}, a._decorators);
  return a._pendingDecorators = b;
}
function fc(a) {
  return a.read(() => J().getTextContent());
}
function gc(a, b) {
  v(a, () => {
    var c = $b();
    if (!c.isEmpty()) if ("root" === b) J().markDirty();else {
      c = c._nodeMap;
      for (let [, d] of c) d.markDirty();
    }
  }, null === a._pendingEditorState ? {
    tag: "history-merge"
  } : void 0);
}
function J() {
  return $b()._nodeMap.get("root");
}
function zb(a) {
  G();
  let b = $b();
  null !== a && (a.dirty = !0, a.setCachedNodes(null));
  b._selection = a;
}
function hc(a) {
  var b = F(),
    c;
  a: {
    for (c = a; null != c;) {
      let d = c[`__lexicalKey_${b._key}`];
      if (void 0 !== d) {
        c = d;
        break a;
      }
      c = Ub(c);
    }
    c = null;
  }
  return null === c ? (b = b.getRootElement(), a === b ? I("root") : null) : I(c);
}
function ic(a) {
  return /[\uD800-\uDBFF][\uDC00-\uDFFF]/g.test(a);
}
function jc(a) {
  let b = [];
  for (; null !== a;) b.push(a), a = a._parentEditor;
  return b;
}
function kc() {
  return Math.random().toString(36).replace(/[^a-z]+/g, "").substr(0, 5);
}
function lc(a, b, c) {
  b = wb(b._window);
  if (null !== b) {
    var d = b.anchorNode,
      {
        anchorOffset: e,
        focusOffset: f
      } = b;
    if (null !== d && (b = 3 === d.nodeType ? d.nodeValue : null, d = vb(d), null !== b && B(d))) {
      if (b === cb && c) {
        let g = c.length;
        b = c;
        f = e = g;
      }
      null !== b && xb(d, b, e, f, a);
    }
  }
}
function xb(a, b, c, d, e) {
  let f = a;
  if (f.isAttached() && (e || !f.isDirty())) {
    let m = f.isComposing(),
      q = b;
    (m || e) && b[b.length - 1] === cb && (q = b.slice(0, -1));
    b = f.getTextContent();
    if (e || q !== b) if ("" === q) {
      if (H(null), Ya || Za || bb) f.remove();else {
        let n = F();
        setTimeout(() => {
          n.update(() => {
            f.isAttached() && f.remove();
          });
        }, 20);
      }
    } else {
      e = f.getParent();
      b = mc();
      var g = f.getTextContentSize(),
        h = cc(),
        k = f.getKey();
      f.isToken() || null !== h && k === h && !m || C(b) && (null !== e && !e.canInsertTextBefore() && 0 === b.anchor.offset || b.anchor.key === a.__key && 0 === b.anchor.offset && !f.canInsertTextBefore() && !m || b.focus.key === a.__key && b.focus.offset === g && !f.canInsertTextAfter() && !m) ? f.markDirty() : (a = u(), C(a) && null !== c && null !== d && (a.setTextNodeRange(f, c, f, d), f.isSegmented() && (c = f.getTextContent(), c = K(c), f.replace(c), f = c)), f.setTextContent(q));
    }
  }
}
function nc(a, b) {
  if (b.isSegmented()) return !0;
  if (!a.isCollapsed()) return !1;
  a = a.anchor.offset;
  let c = b.getParentOrThrow(),
    d = b.isToken();
  return 0 === a ? ((a = !b.canInsertTextBefore() || !c.canInsertTextBefore() || d) || (b = b.getPreviousSibling(), a = (B(b) || E(b) && b.isInline()) && !b.canInsertTextAfter()), a) : a === b.getTextContentSize() ? !b.canInsertTextAfter() || !c.canInsertTextAfter() || d : !1;
}
function oc(a, b) {
  void 0 === a.__lexicalClassNameCache && (a.__lexicalClassNameCache = {});
  let c = a.__lexicalClassNameCache,
    d = c[b];
  if (void 0 !== d) return d;
  a = a[b];
  return "string" === typeof a ? (a = a.split(" "), c[b] = a) : a;
}
function pc(a, b, c, d, e) {
  if (0 !== c.size) {
    var f = d.__type;
    c = d.__key;
    console.log("2.[lexical][setMutatedNode] nodeType:", {
      mutation: e,
      node: d
    });
    b = b.get(f);
    void 0 === b && t(33, f);
    d = b.klass;
    b = a.get(d);
    void 0 === b && (b = new Map(), a.set(d, b));
    a = b.get(c);
    d = "destroyed" === a && "created" === e;
    (void 0 === a || d) && b.set(c, d ? "updated" : e);
  }
}
function qc(a, b, c) {
  let d = a.getParent(),
    e = c;
  null !== d && (b && 0 === c ? (e = a.getIndexWithinParent(), a = d) : b || c !== a.getChildrenSize() || (e = a.getIndexWithinParent() + 1, a = d));
  return a.getChildAtIndex(b ? e - 1 : e);
}
function rc(a, b) {
  var c = a.offset;
  if ("element" === a.type) return a = a.getNode(), qc(a, b, c);
  a = a.getNode();
  return b && 0 === c || !b && c === a.getTextContentSize() ? (c = b ? a.getPreviousSibling() : a.getNextSibling(), null === c ? qc(a.getParentOrThrow(), b, a.getIndexWithinParent() + (b ? 0 : 1)) : c) : null;
}
function Ab(a) {
  a = (a = Db(a).event) && a.inputType;
  return "insertFromPaste" === a || "insertFromPasteAsQuotation" === a;
}
function sc(a) {
  return !L(a) && !a.isLastChild() && !a.isInline();
}
function tc(a, b) {
  a = a._keyToDOMMap.get(b);
  void 0 === a && t(75, b);
  return a;
}
function Ub(a) {
  a = a.assignedSlot || a.parentElement;
  return null !== a && 11 === a.nodeType ? a.host : a;
}
function uc(a, b) {
  for (a = a.getParent(); null !== a;) {
    if (a.is(b)) return !0;
    a = a.getParent();
  }
  return !1;
}
function Db(a) {
  a = a._window;
  null === a && t(78);
  return a;
}
function vc(a) {
  for (a = a.getParentOrThrow(); null !== a && !wc(a);) a = a.getParentOrThrow();
  return a;
}
function wc(a) {
  return L(a) || E(a) && a.isShadowRoot();
}
function xc(a) {
  a = a.constructor.clone(a);
  Yb(a, null);
  return a;
}
function yc(a) {
  var b = F();
  let c = a.constructor.getType();
  b = b._nodes.get(c);
  void 0 === b && t(97);
  b = b.replace;
  return null !== b ? (b = b(a), b instanceof a.constructor || t(98), b) : a;
}
function zc(a, b) {
  a = a.getParent();
  !L(a) || E(b) || y(b) || t(99);
}
function Ac(a) {
  return (y(a) || E(a) && !a.canBeEmpty()) && !a.isInline();
}
function Bc(a, b, c) {
  c.style.removeProperty("caret-color");
  b._blockCursorElement = null;
  b = a.parentElement;
  null !== b && b.removeChild(a);
}
function wb(a) {
  return Ta ? (a || window).getSelection() : null;
}
function Cc(a) {
  return 1 === a.nodeType;
}
function Dc(a) {
  if (y(a) && !a.isInline()) return !0;
  if (!E(a) || wc(a)) return !1;
  var b = a.getFirstChild();
  b = null === b || Ec(b) || B(b) || b.isInline();
  return !a.isInline() && !1 !== a.canBeEmpty() && b;
}
function Fc(a, b) {
  for (; null !== a && null !== a.getParent() && !b(a);) a = a.getParentOrThrow();
  return b(a) ? a : null;
}
function Gc(a, b, c, d, e, f) {
  for (a = a.getFirstChild(); null !== a;) {
    let g = a.__key;
    a.__parent === b && (E(a) && Gc(a, g, c, d, e, f), c.has(g) || f.delete(g), e.push(g));
    a = a.getNextSibling();
  }
}
function Hc(a, b, c, d) {
  a = a._nodeMap;
  b = b._nodeMap;
  let e = [];
  for (let [f] of d) {
    let g = b.get(f);
    void 0 === g || g.isAttached() || (E(g) && Gc(g, f, a, b, e, d), a.has(f) || d.delete(f), e.push(f));
  }
  for (let f of e) b.delete(f);
  for (let f of c) d = b.get(f), void 0 === d || d.isAttached() || (a.has(f) || c.delete(f), b.delete(f));
}
let M = "",
  N = "",
  Ic = "",
  Jc,
  O,
  Kc,
  Lc = !1,
  Mc = !1,
  Nc,
  Oc = null,
  Pc,
  Zc,
  $c,
  ad,
  bd,
  cd;
function dd(a, b) {
  let c = $c.get(a);
  if (null !== b) {
    let d = ed(a);
    d.parentNode === b && b.removeChild(d);
  }
  ad.has(a) || O._keyToDOMMap.delete(a);
  E(c) && (a = fd(c, $c), gd(a, 0, a.length - 1, null));
  void 0 !== c && pc(cd, Kc, Nc, c, "destroyed");
}
function gd(a, b, c, d) {
  for (; b <= c; ++b) {
    let e = a[b];
    void 0 !== e && dd(e, d);
  }
}
function hd(a, b) {
  a.setProperty("text-align", b);
}
function id(a, b) {
  var c = Jc.theme.indent;
  if ("string" === typeof c) {
    let d = a.classList.contains(c);
    0 < b && !d ? a.classList.add(c) : 1 > b && d && a.classList.remove(c);
  }
  c = getComputedStyle(a).getPropertyValue("--lexical-indent-base-value") || "40px";
  a.style.setProperty("padding-inline-start", 0 === b ? "" : `calc(${b} * ${c})`);
}
function jd(a, b) {
  a = a.style;
  0 === b ? hd(a, "") : 1 === b ? hd(a, "left") : 2 === b ? hd(a, "center") : 3 === b ? hd(a, "right") : 4 === b ? hd(a, "justify") : 5 === b ? hd(a, "start") : 6 === b && hd(a, "end");
}
function kd(a, b, c) {
  let d = ad.get(a);
  void 0 === d && t(60);
  let e = d.createDOM(Jc, O);
  ld(a, e, O);
  B(d) ? e.setAttribute("data-lexical-text", "true") : y(d) && e.setAttribute("data-lexical-decorator", "true");
  if (E(d)) {
    a = d.__indent;
    var f = d.__size;
    0 !== a && id(e, a);
    0 !== f && (a = f - 1, f = fd(d, ad), md(f, a, d, e));
    a = d.__format;
    ["__fontColor", "__textFormat"].forEach(g => {
      g in d && "undefined" !== typeof d[g] && "__fontColor" === g && (e.style.color = d[g]);
    });
    0 !== a && jd(e, a);
    d.isInline() || nd(null, d, e);
    sc(d) && (M += "\n\n", Ic += "\n\n");
  } else {
    f = d.getTextContent();
    if (y(d)) {
      let g = d.decorate(O, Jc);
      null !== g && od(a, g);
      e.contentEditable = "false";
    } else B(d) && (d.isDirectionless() || (N += f));
    M += f;
    Ic += f;
  }
  null !== b && (null != c ? b.insertBefore(e, c) : (c = b.__lexicalLineBreak, null != c ? b.insertBefore(e, c) : b.appendChild(e)));
  pc(cd, Kc, Nc, d, "created");
  return e;
}
function md(a, b, c, d) {
  let e = N;
  N = "";
  pd(a, c, 0, b, d, null);
  qd(c, d);
  N = e;
}
function pd(a, b, c, d, e, f) {
  let g = M;
  for (M = ""; c <= d; ++c) kd(a[c], e, f);
  sc(b) && (M += "\n\n");
  e.__lexicalTextContent = M;
  M = g + M;
}
function rd(a, b) {
  a = b.get(a);
  return Ec(a) || y(a) && a.isInline();
}
function nd(a, b, c) {
  a = null !== a && (0 === a.__size || rd(a.__last, $c));
  b = 0 === b.__size || rd(b.__last, ad);
  a ? b || (b = c.__lexicalLineBreak, null != b && c.removeChild(b), c.__lexicalLineBreak = null) : b && (b = document.createElement("br"), c.__lexicalLineBreak = b, c.appendChild(b));
}
function qd(a, b) {
  var c = b.__lexicalDir;
  if (b.__lexicalDirTextContent !== N || c !== Oc) {
    let f = "" === N;
    if (f) var d = Oc;else d = N, d = eb.test(d) ? "rtl" : fb.test(d) ? "ltr" : null;
    if (d !== c) {
      let g = b.classList,
        h = Jc.theme;
      var e = null !== c ? h[c] : void 0;
      let k = null !== d ? h[d] : void 0;
      void 0 !== e && ("string" === typeof e && (e = e.split(" "), e = h[c] = e), g.remove(...e));
      null === d || f && "ltr" === d ? b.removeAttribute("dir") : (void 0 !== k && ("string" === typeof k && (c = k.split(" "), k = h[d] = c), void 0 !== k && g.add(...k)), b.dir = d);
      Mc || (a.getWritable().__dir = d);
    }
    Oc = d;
    b.__lexicalDirTextContent = N;
    b.__lexicalDir = d;
  }
}
function sd(a, b, c) {
  let d = N;
  N = "";
  console.log("2.[lexical][reconcileChildrenWithDirection]", {
    dom: c,
    nextElement: b,
    prevElement: a
  });
  let e = M;
  var f = a.__size,
    g = b.__size;
  M = "";
  if (1 === f && 1 === g) {
    a = a.__first;
    var h = b.__first;
    if (a === h) td(a, c);else {
      var k = ed(a);
      h = kd(h, null, null);
      c.replaceChild(h, k);
      dd(a, null);
    }
  } else {
    a = fd(a, $c);
    var m = fd(b, ad);
    if (0 === f) 0 !== g && pd(m, b, 0, g - 1, c, null);else if (0 === g) 0 !== f && (k = null == c.__lexicalLineBreak, gd(a, 0, f - 1, k ? null : c), k && (c.textContent = ""));else {
      k = a;
      a = m;
      m = f - 1;
      f = g - 1;
      var q;
      let l = c.firstChild,
        r = 0;
      for (g = 0; r <= m && g <= f;) {
        var n = k[r];
        let w = a[g];
        if (n === w) l = ud(td(w, c)), r++, g++;else {
          void 0 === h && (h = new Set(k));
          void 0 === q && (q = new Set(a));
          let A = q.has(n),
            x = h.has(w);
          A ? (x ? (n = tc(O, w), n === l ? l = ud(td(w, c)) : (null != l ? c.insertBefore(n, l) : c.appendChild(n), td(w, c)), r++) : kd(w, c, l), g++) : (l = ud(ed(n)), dd(n, c), r++);
        }
      }
      h = r > m;
      q = g > f;
      h && !q ? (k = a[f + 1], k = void 0 === k ? null : O.getElementByKey(k), pd(a, b, g, f, c, k)) : q && !h && gd(k, r, m, c);
    }
  }
  sc(b) && (M += "\n\n");
  c.__lexicalTextContent = M;
  M = e + M;
  qd(b, c);
  N = d;
}
function fd(a, b) {
  let c = [];
  for (a = a.__first; null !== a;) {
    let d = b.get(a);
    void 0 === d && t(101);
    c.push(a);
    a = d.__next;
  }
  return c;
}
function td(a, b) {
  let c = $c.get(a),
    d = ad.get(a);
  void 0 !== c && void 0 !== d || t(61);
  var e = Lc || Zc.has(a) || Pc.has(a);
  let f = tc(O, a);
  console.log("2.[lexical][reconcileNode] dom:", f);
  if (c === d && !e) return console.log("2.[lexical][reconcileNode] prevNode === nextNode && !isDirty:", f), E(c) ? (a = f.__lexicalTextContent, void 0 !== a && (M += a, Ic += a), a = f.__lexicalDirTextContent, void 0 !== a && (N += a)) : (a = c.getTextContent(), B(c) && !c.isDirectionless() && (N += a), Ic += a, M += a), f;
  c !== d && e && (console.log("2.[lexical][reconcileNode] prevNode !== nextNode && isDirty"), pc(cd, Kc, Nc, d, "updated"));
  if (d.updateDOM(c, f, Jc)) return console.log("2.[lexical][reconcileNode] nextNode.updateDOM:", f), e = kd(a, null, null), null === b && t(62), b.replaceChild(e, f), dd(a, null), e;
  E(c) && E(d) ? (console.log("2.[lexical][reconcileNode] Reconcile element children"), a = d.__indent, a !== c.__indent && id(f, a), a = d.__format, a !== c.__format && jd(f, a), ["__fontColor", "__textFormat"].forEach(g => {
    if (d) {
      var h = d[g];
      h !== c[g] && (d[g] = h);
    }
  }), e && (sd(c, d, f), L(d) || d.isInline() || nd(c, d, f)), sc(d) && (M += "\n\n", Ic += "\n\n")) : (e = d.getTextContent(), y(d) ? (b = d.decorate(O, Jc), null !== b && od(a, b)) : B(d) && !d.isDirectionless() && (N += e), M += e, Ic += e);
  !Mc && L(d) && d.__cachedText !== Ic && (a = d.getWritable(), a.__cachedText = Ic, d = a);
  return f;
}
function od(a, b) {
  let c = O._pendingDecorators,
    d = O._decorators;
  if (null === c) {
    if (d[a] === b) return;
    c = ec(O);
  }
  c[a] = b;
}
function ud(a) {
  a = a.nextSibling;
  null !== a && a === O._blockCursorElement && (a = a.nextSibling);
  return a;
}
function ld(a, b, c) {
  let d = c._keyToDOMMap;
  b["__lexicalKey_" + c._key] = a;
  d.set(a, b);
}
function ed(a) {
  let b = bd.get(a);
  void 0 === b && t(75, a);
  return b;
}
let vd = Object.freeze({}),
  Cd = [["keydown", wd], ["pointerdown", xd], ["compositionstart", yd], ["compositionend", zd], ["input", Ad], ["click", Bd], ["cut", vd], ["copy", vd], ["dragstart", vd], ["dragover", vd], ["dragend", vd], ["paste", vd], ["focus", vd], ["blur", vd], ["drop", vd]];
Xa && Cd.push(["beforeinput", (a, b) => Dd(a, b)]);
let Ed = 0,
  Fd = 0,
  Gd = 0,
  Hd = null,
  Id = 0,
  Jd = !1,
  Kd = !1,
  Ld = !1,
  Md = !1,
  Nd = [0, "", 0, "root", 0];
function Od(a, b, c, d, e) {
  let f = a.anchor,
    g = a.focus,
    h = f.getNode();
  var k = F();
  let m = wb(k._window),
    q = null !== m ? m.anchorNode : null,
    n = f.key;
  k = k.getElementByKey(n);
  let l = c.length;
  return n !== g.key || !B(h) || (!e && (!Xa || Gd < d + 50) || h.isDirty() && 2 > l || ic(c)) && f.offset !== g.offset && !h.isComposing() || Vb(h) || h.isDirty() && 1 < l || (e || !Xa) && null !== k && !h.isComposing() && q !== Wb(k) || null !== m && null !== b && (!b.collapsed || b.startContainer !== m.anchorNode || b.startOffset !== m.anchorOffset) || h.getFormat() !== a.format || h.getStyle() !== a.style || nc(a, h);
}
function Pd(a, b) {
  return null !== a && null !== a.nodeValue && 3 === a.nodeType && 0 !== b && b !== a.nodeValue.length;
}
function Qd(a, b, c) {
  let {
    anchorNode: d,
    anchorOffset: e,
    focusNode: f,
    focusOffset: g
  } = a;
  if (Jd && (Jd = !1, Pd(d, e) && Pd(f, g))) return;
  v(b, () => {
    if (!c) zb(null);else if (Sb(b, d, f)) {
      var h = u();
      if (C(h)) {
        var k = h.anchor,
          m = k.getNode();
        if (h.isCollapsed()) {
          "Range" === a.type && a.anchorNode === a.focusNode && (h.dirty = !0);
          var q = Db(b).event;
          q = q ? q.timeStamp : performance.now();
          let [A, x, z, aa, W] = Nd;
          var n = J();
          n = !1 === b.isComposing() && "" === n.getTextContent();
          q < W + 200 && k.offset === z && k.key === aa ? (h.format = A, h.style = x) : "text" === k.type ? (B(m) || t(141), h.format = m.getFormat(), h.style = m.getStyle()) : "element" !== k.type || n || (h.format = 0, h.style = "");
        } else {
          var l = k.key,
            r = h.focus.key;
          k = h.getNodes();
          m = k.length;
          var w = h.isBackward();
          q = w ? g : e;
          n = w ? e : g;
          let A = w ? r : l;
          l = w ? l : r;
          r = 255;
          w = !1;
          for (let x = 0; x < m; x++) {
            let z = k[x],
              aa = z.getTextContentSize();
            if (B(z) && 0 !== aa && !(0 === x && z.__key === A && q === aa || x === m - 1 && z.__key === l && 0 === n) && (w = !0, r &= z.getFormat(), 0 === r)) break;
          }
          h.format = w ? r : 0;
        }
      }
      R(b, ba, void 0);
    }
  });
}
function Bd(a, b) {
  v(b, () => {
    let c = u();
    var d = wb(b._window);
    let e = mc();
    if (d) if (C(c)) {
      let g = c.anchor;
      var f = g.getNode();
      "element" === g.type && 0 === g.offset && c.isCollapsed() && !L(f) && 1 === J().getChildrenSize() && f.getTopLevelElementOrThrow().isEmpty() && null !== e && c.is(e) ? (d.removeAllRanges(), c.dirty = !0) : 3 !== a.detail || c.isCollapsed() || (d = c.focus.getNode(), f !== d && (E(f) ? f.select(0) : f.getParentOrThrow().select(0)));
    } else "touch" === a.pointerType && (f = d.anchorNode, null !== f && (f = f.nodeType, 1 === f || 3 === f)) && (d = Rd(e, d, b, a), zb(d));
    R(b, ca, a);
  });
}
function xd(a, b) {
  let c = a.target;
  a = a.pointerType;
  c instanceof Node && "touch" !== a && v(b, () => {
    y(vb(c)) || (Kd = !0);
  });
}
function Sd(a) {
  if (!a.getTargetRanges) return null;
  a = a.getTargetRanges();
  return 0 === a.length ? null : a[0];
}
function Td(a, b) {
  return a !== b || E(a) || E(b) || !a.isToken() || !b.isToken();
}
function Dd(a, b) {
  let c = a.inputType,
    d = Sd(a);
  "deleteCompositionText" === c || Va && Ab(b) || "insertCompositionText" !== c && v(b, () => {
    let e = u();
    if ("deleteContentBackward" === c) {
      if (null === e) {
        var f = mc();
        if (!C(f)) return;
        zb(f.clone());
      }
      if (C(e)) {
        $a && H(e.anchor.key);
        229 === Fd && a.timeStamp < Ed + 30 && b.isComposing() && e.anchor.key === e.focus.key ? (H(null), Ed = 0, setTimeout(() => {
          v(b, () => {
            H(null);
          });
        }, 30), C(e) && (f = e.anchor.getNode(), f.markDirty(), e.format = f.getFormat(), B(f) || t(142), e.style = f.getStyle()), 1 >= e.anchor.getNode().getTextContent().length && (a.preventDefault(), R(b, da, !0))) : (H(null), a.preventDefault(), R(b, da, !0));
        return;
      }
    }
    if (C(e)) {
      f = a.data;
      null !== Hd && lc(!1, b, Hd);
      e.dirty && null === Hd || !e.isCollapsed() || L(e.anchor.getNode()) || null === d || e.applyDOMRange(d);
      Hd = null;
      var g = e.focus,
        h = e.anchor.getNode();
      g = g.getNode();
      if ("insertText" === c || "insertTranspose" === c) "\n" === f ? (a.preventDefault(), R(b, ea, !1)) : "\n\n" === f ? (a.preventDefault(), R(b, fa, void 0)) : null == f && a.dataTransfer ? (f = a.dataTransfer.getData("text/plain"), a.preventDefault(), e.insertRawText(f)) : null != f && Od(e, d, f, a.timeStamp, !0) ? (a.preventDefault(), R(b, ka, f)) : Hd = f, Gd = a.timeStamp;else switch (a.preventDefault(), c) {
        case "insertFromYank":
        case "insertFromDrop":
        case "insertReplacementText":
          R(b, ka, a);
          break;
        case "insertFromComposition":
          H(null);
          R(b, ka, a);
          break;
        case "insertLineBreak":
          H(null);
          R(b, ea, !1);
          break;
        case "insertParagraph":
          H(null);
          Ld && !Za ? (Ld = !1, R(b, ea, !1)) : R(b, fa, void 0);
          break;
        case "insertFromPaste":
        case "insertFromPasteAsQuotation":
          R(b, la, a);
          break;
        case "deleteByComposition":
          Td(h, g) && R(b, ma, a);
          break;
        case "deleteByDrag":
        case "deleteByCut":
          R(b, ma, a);
          break;
        case "deleteContent":
          R(b, da, !1);
          break;
        case "deleteWordBackward":
          R(b, oa, !0);
          break;
        case "deleteWordForward":
          R(b, oa, !1);
          break;
        case "deleteHardLineBackward":
        case "deleteSoftLineBackward":
          R(b, pa, !0);
          break;
        case "deleteContentForward":
        case "deleteHardLineForward":
        case "deleteSoftLineForward":
          R(b, pa, !1);
          break;
        case "formatStrikeThrough":
          R(b, qa, "strikethrough");
          break;
        case "formatBold":
          R(b, qa, "bold");
          break;
        case "formatItalic":
          R(b, qa, "italic");
          break;
        case "formatUnderline":
          R(b, qa, "underline");
          break;
        case "historyUndo":
          R(b, ra, void 0);
          break;
        case "historyRedo":
          R(b, sa, void 0);
      }
    }
  });
}
function Ad(a, b) {
  a.stopPropagation();
  v(b, () => {
    var c = u(),
      d = a.data,
      e = Sd(a);
    if (null != d && C(c) && Od(c, e, d, a.timeStamp, !1)) {
      Md && (Ud(b, d), Md = !1);
      var f = c.anchor,
        g = f.getNode();
      e = wb(b._window);
      if (null === e) return;
      let h = f.offset;
      if (f = Xa && !c.isCollapsed() && B(g) && null !== e.anchorNode) g = g.getTextContent().slice(0, h) + d + g.getTextContent().slice(h + c.focus.offset), e = e.anchorNode, f = g === (3 === e.nodeType ? e.nodeValue : null);
      f || R(b, ka, d);
      d = d.length;
      Va && 1 < d && "insertCompositionText" === a.inputType && !b.isComposing() && (c.anchor.offset -= d);
      Ya || Za || bb || !b.isComposing() || (Ed = 0, H(null));
    } else lc(!1, b, null !== d ? d : void 0), Md && (Ud(b, d || void 0), Md = !1);
    G();
    c = F();
    Bb(c);
  });
  Hd = null;
}
function yd(a, b) {
  v(b, () => {
    let c = u();
    if (C(c) && !b.isComposing()) {
      let d = c.anchor,
        e = c.anchor.getNode();
      H(d.key);
      (a.timeStamp < Ed + 30 || "element" === d.type || !c.isCollapsed() || e.getFormat() !== c.format || B(e) && e.getStyle() !== c.style) && R(b, ka, db);
    }
  });
}
function Ud(a, b) {
  var c = a._compositionKey;
  H(null);
  if (null !== c && null != b) {
    if ("" === b) {
      b = I(c);
      a = Wb(a.getElementByKey(c));
      null !== a && null !== a.nodeValue && B(b) && xb(b, a.nodeValue, null, null, !0);
      return;
    }
    if ("\n" === b[b.length - 1] && (c = u(), C(c))) {
      b = c.focus;
      c.anchor.set(b.key, b.offset, b.type);
      R(a, Ba, null);
      return;
    }
  }
  lc(!0, a, b);
}
function zd(a, b) {
  Va ? Md = !0 : v(b, () => {
    Ud(b, a.data);
  });
}
function wd(a, b) {
  Ed = a.timeStamp;
  Fd = a.keyCode;
  if (!b.isComposing()) {
    var {
      keyCode: c,
      shiftKey: d,
      ctrlKey: e,
      metaKey: f,
      altKey: g
    } = a;
    if (!R(b, ta, a)) {
      if (39 !== c || e || f || g) {
        if (39 !== c || g || d || !e && !f) {
          if (37 !== c || e || f || g) {
            if (37 !== c || g || d || !e && !f) {
              if (38 !== c || e || f) {
                if (40 !== c || e || f) {
                  if (13 === c && d) Ld = !0, R(b, Ba, a);else if (32 === c) R(b, Ca, a);else if (p && e && 79 === c) a.preventDefault(), Ld = !0, R(b, ea, !0);else if (13 !== c || d) {
                    var h = p ? g || f ? !1 : 8 === c || 72 === c && e : e || g || f ? !1 : 8 === c;
                    h ? 8 === c ? R(b, Da, a) : (a.preventDefault(), R(b, da, !0)) : 27 === c ? R(b, Ga, a) : (h = p ? d || g || f ? !1 : 46 === c || 68 === c && e : e || g || f ? !1 : 46 === c, h ? 46 === c ? R(b, Ha, a) : (a.preventDefault(), R(b, da, !1)) : 8 === c && (p ? g : e) ? (a.preventDefault(), R(b, oa, !0)) : 46 === c && (p ? g : e) ? (a.preventDefault(), R(b, oa, !1)) : p && f && 8 === c ? (a.preventDefault(), R(b, pa, !0)) : p && f && 46 === c ? (a.preventDefault(), R(b, pa, !1)) : 66 === c && !g && (p ? f : e) ? (a.preventDefault(), R(b, qa, "bold")) : 85 === c && !g && (p ? f : e) ? (a.preventDefault(), R(b, qa, "underline")) : 73 === c && !g && (p ? f : e) ? (a.preventDefault(), R(b, qa, "italic")) : 9 !== c || g || e || f ? 90 === c && !d && (p ? f : e) ? (a.preventDefault(), R(b, ra, void 0)) : (h = p ? 90 === c && f && d : 89 === c && e || 90 === c && e && d, h ? (a.preventDefault(), R(b, sa, void 0)) : Vd(b._editorState._selection) ? (h = d ? !1 : 67 === c ? p ? f : e : !1, h ? (a.preventDefault(), R(b, Na, a)) : (h = d ? !1 : 88 === c ? p ? f : e : !1, h ? (a.preventDefault(), R(b, Oa, a)) : 65 === c && (p ? f : e) && (a.preventDefault(), R(b, Pa, a)))) : !Va && 65 === c && (p ? f : e) && (a.preventDefault(), R(b, Pa, a))) : R(b, Ia, a));
                  } else Ld = !1, R(b, Ba, a);
                } else R(b, Aa, a);
              } else R(b, za, a);
            } else R(b, ya, a);
          } else R(b, wa, a);
        } else R(b, va, a);
      } else R(b, ua, a);
      (e || d || g || f) && R(b, Sa, a);
    }
  }
}
function Wd(a) {
  let b = a.__lexicalEventHandles;
  void 0 === b && (b = [], a.__lexicalEventHandles = b);
  return b;
}
let Xd = new Map();
function Yd(a) {
  var b = a.target;
  let c = wb(null == b ? null : 9 === b.nodeType ? b.defaultView : b.ownerDocument.defaultView);
  if (null !== c) {
    var d = Tb(c.anchorNode);
    if (null !== d) {
      Kd && (Kd = !1, v(d, () => {
        var h = mc(),
          k = c.anchorNode;
        null !== k && (k = k.nodeType, 1 === k || 3 === k) && (h = Rd(h, c, d, a), zb(h));
      }));
      b = jc(d);
      b = b[b.length - 1];
      var e = b._key,
        f = Xd.get(e),
        g = f || b;
      g !== d && Qd(c, g, !1);
      Qd(c, d, !0);
      d !== b ? Xd.set(e, d) : f && Xd.delete(e);
    }
  }
}
function Zd(a, b) {
  0 === Id && a.ownerDocument.addEventListener("selectionchange", Yd);
  Id++;
  a.__lexicalEditor = b;
  let c = Wd(a);
  for (let d = 0; d < Cd.length; d++) {
    let [e, f] = Cd[d],
      g = "function" === typeof f ? h => {
        !0 !== h._lexicalHandled && (h._lexicalHandled = !0, b.isEditable() && f(h, b));
      } : h => {
        if (!0 !== h._lexicalHandled && (h._lexicalHandled = !0, b.isEditable())) switch (e) {
          case "cut":
            return R(b, Oa, h);
          case "copy":
            return R(b, Na, h);
          case "paste":
            return R(b, la, h);
          case "dragstart":
            return R(b, Ka, h);
          case "dragover":
            return R(b, La, h);
          case "dragend":
            return R(b, Ma, h);
          case "focus":
            return R(b, Qa, h);
          case "blur":
            return R(b, Ra, h);
          case "drop":
            return R(b, Ja, h);
        }
      };
    a.addEventListener(e, g);
    c.push(() => {
      a.removeEventListener(e, g);
    });
  }
}
function $d(a, b, c) {
  G();
  var d = a.__key;
  let e = a.getParent();
  if (null !== e) {
    var f = u();
    if (C(f) && E(a)) {
      var {
        anchor: g,
        focus: h
      } = f;
      var k = g.getNode();
      var m = h.getNode();
      uc(k, a) && g.set(a.__key, 0, "element");
      uc(m, a) && h.set(a.__key, 0, "element");
    }
    k = f;
    m = !1;
    if (C(k) && b) {
      f = k.anchor;
      let q = k.focus;
      f.key === d && (ae(f, a, e, a.getPreviousSibling(), a.getNextSibling()), m = !0);
      q.key === d && (ae(q, a, e, a.getPreviousSibling(), a.getNextSibling()), m = !0);
    } else Vd(k) && b && a.isSelected() && a.selectPrevious();
    C(k) && b && !m ? (d = a.getIndexWithinParent(), ac(a), be(k, e, d, -1)) : ac(a);
    c || wc(e) || e.canBeEmpty() || !e.isEmpty() || $d(e, b);
    b && L(e) && e.isEmpty() && e.selectEnd();
  }
}
class ce {
  static getType() {
    t(64, this.name);
  }
  static clone() {
    t(65, this.name);
  }
  constructor(a) {
    this.__type = this.constructor.getType();
    this.__next = this.__prev = this.__parent = null;
    Yb(this, a);
  }
  getType() {
    return this.__type;
  }
  isInline() {
    t(137, this.constructor.name);
  }
  isAttached() {
    for (var a = this.__key; null !== a;) {
      if ("root" === a) return !0;
      a = I(a);
      if (null === a) break;
      a = a.__parent;
    }
    return !1;
  }
  isSelected(a) {
    a = a || u();
    if (null == a) return !1;
    let b = a.getNodes().some(c => c.__key === this.__key);
    return B(this) ? b : C(a) && "element" === a.anchor.type && "element" === a.focus.type && a.anchor.key === a.focus.key && a.anchor.offset === a.focus.offset ? !1 : b;
  }
  getKey() {
    return this.__key;
  }
  getIndexWithinParent() {
    var a = this.getParent();
    if (null === a) return -1;
    a = a.getFirstChild();
    let b = 0;
    for (; null !== a;) {
      if (this.is(a)) return b;
      b++;
      a = a.getNextSibling();
    }
    return -1;
  }
  getParent() {
    let a = this.getLatest().__parent;
    return null === a ? null : I(a);
  }
  getParentOrThrow() {
    let a = this.getParent();
    null === a && t(66, this.__key);
    return a;
  }
  getTopLevelElement() {
    let a = this;
    for (; null !== a;) {
      let b = a.getParent();
      if (wc(b)) return E(a) || t(138), a;
      a = b;
    }
    return null;
  }
  getTopLevelElementOrThrow() {
    let a = this.getTopLevelElement();
    null === a && t(67, this.__key);
    return a;
  }
  getParents() {
    let a = [],
      b = this.getParent();
    for (; null !== b;) a.push(b), b = b.getParent();
    return a;
  }
  getParentKeys() {
    let a = [],
      b = this.getParent();
    for (; null !== b;) a.push(b.__key), b = b.getParent();
    return a;
  }
  getPreviousSibling() {
    let a = this.getLatest().__prev;
    return null === a ? null : I(a);
  }
  getPreviousSiblings() {
    let a = [];
    var b = this.getParent();
    if (null === b) return a;
    for (b = b.getFirstChild(); null !== b && !b.is(this);) a.push(b), b = b.getNextSibling();
    return a;
  }
  getNextSibling() {
    let a = this.getLatest().__next;
    return null === a ? null : I(a);
  }
  getNextSiblings() {
    let a = [],
      b = this.getNextSibling();
    for (; null !== b;) a.push(b), b = b.getNextSibling();
    return a;
  }
  getCommonAncestor(a) {
    let b = this.getParents();
    var c = a.getParents();
    E(this) && b.unshift(this);
    E(a) && c.unshift(a);
    a = b.length;
    var d = c.length;
    if (0 === a || 0 === d || b[a - 1] !== c[d - 1]) return null;
    c = new Set(c);
    for (d = 0; d < a; d++) {
      let e = b[d];
      if (c.has(e)) return e;
    }
    return null;
  }
  is(a) {
    return null == a ? !1 : this.__key === a.__key;
  }
  isBefore(a) {
    if (this === a) return !1;
    if (a.isParentOf(this)) return !0;
    if (this.isParentOf(a)) return !1;
    var b = this.getCommonAncestor(a);
    let c = this;
    for (;;) {
      var d = c.getParentOrThrow();
      if (d === b) {
        d = c.getIndexWithinParent();
        break;
      }
      c = d;
    }
    for (c = a;;) {
      a = c.getParentOrThrow();
      if (a === b) {
        b = c.getIndexWithinParent();
        break;
      }
      c = a;
    }
    return d < b;
  }
  isParentOf(a) {
    let b = this.__key;
    if (b === a.__key) return !1;
    for (; null !== a;) {
      if (a.__key === b) return !0;
      a = a.getParent();
    }
    return !1;
  }
  getNodesBetween(a) {
    let b = this.isBefore(a),
      c = [],
      d = new Set();
    for (var e = this;;) {
      var f = e.__key;
      d.has(f) || (d.add(f), c.push(e));
      if (e === a) break;
      f = E(e) ? b ? e.getFirstChild() : e.getLastChild() : null;
      if (null !== f) e = f;else if (f = b ? e.getNextSibling() : e.getPreviousSibling(), null !== f) e = f;else {
        e = e.getParentOrThrow();
        d.has(e.__key) || c.push(e);
        if (e === a) break;
        f = e;
        do null === f && t(68), e = b ? f.getNextSibling() : f.getPreviousSibling(), f = f.getParent(), null !== f && (null !== e || d.has(f.__key) || c.push(f)); while (null === e);
      }
    }
    b || c.reverse();
    return c;
  }
  isDirty() {
    let a = F()._dirtyLeaves;
    return null !== a && a.has(this.__key);
  }
  getLatest() {
    let a = I(this.__key);
    null === a && t(113);
    return a;
  }
  getWritable() {
    G();
    var a = $b(),
      b = F();
    a = a._nodeMap;
    let c = this.__key,
      d = this.getLatest(),
      e = d.__parent;
    b = b._cloneNotNeeded;
    var f = u();
    null !== f && f.setCachedNodes(null);
    if (b.has(c)) return bc(d), d;
    f = d.constructor.clone(d);
    f.__parent = e;
    f.__next = d.__next;
    f.__prev = d.__prev;
    E(d) && E(f) ? (f.__first = d.__first, f.__last = d.__last, f.__size = d.__size, f.__indent = d.__indent, f.__format = d.__format, f.__dir = d.__dir) : B(d) && B(f) && (f.__format = d.__format, f.__style = d.__style, f.__mode = d.__mode, f.__detail = d.__detail);
    b.add(c);
    f.__key = c;
    bc(f);
    a.set(c, f);
    return f;
  }
  getTextContent() {
    return "";
  }
  getTextContentSize() {
    return this.getTextContent().length;
  }
  createDOM() {
    t(70);
  }
  updateDOM() {
    t(71);
  }
  exportDOM(a) {
    return {
      element: this.createDOM(a._config, a)
    };
  }
  exportJSON() {
    t(72);
  }
  static importJSON() {
    t(18, this.name);
  }
  static transform() {
    return null;
  }
  remove(a) {
    $d(this, !0, a);
  }
  replace(a, b) {
    G();
    var c = u();
    null !== c && (c = c.clone());
    zc(this, a);
    let d = this.getLatest(),
      e = this.__key,
      f = a.__key,
      g = a.getWritable();
    a = this.getParentOrThrow().getWritable();
    let h = a.__size;
    ac(g);
    let k = d.getPreviousSibling(),
      m = d.getNextSibling(),
      q = d.__prev,
      n = d.__next,
      l = d.__parent;
    $d(d, !1, !0);
    null === k ? a.__first = f : k.getWritable().__next = f;
    g.__prev = q;
    null === m ? a.__last = f : m.getWritable().__prev = f;
    g.__next = n;
    g.__parent = l;
    a.__size = h;
    b && (E(this) && E(g) || t(139), this.getChildren().forEach(r => {
      g.append(r);
    }));
    C(c) && (zb(c), b = c.anchor, c = c.focus, b.key === e && de(b, g), c.key === e && de(c, g));
    cc() === e && H(f);
    return g;
  }
  insertAfter(a, b = !0) {
    G();
    zc(this, a);
    var c = this.getWritable();
    let d = a.getWritable();
    var e = d.getParent();
    let f = u();
    var g = !1,
      h = !1;
    if (null !== e) {
      var k = a.getIndexWithinParent();
      ac(d);
      C(f) && (h = e.__key, g = f.anchor, e = f.focus, g = "element" === g.type && g.key === h && g.offset === k + 1, h = "element" === e.type && e.key === h && e.offset === k + 1);
    }
    e = this.getNextSibling();
    k = this.getParentOrThrow().getWritable();
    let m = d.__key,
      q = c.__next;
    null === e ? k.__last = m : e.getWritable().__prev = m;
    k.__size++;
    c.__next = m;
    d.__next = q;
    d.__prev = c.__key;
    d.__parent = c.__parent;
    b && C(f) && (b = this.getIndexWithinParent(), be(f, k, b + 1), c = k.__key, g && f.anchor.set(c, b + 2, "element"), h && f.focus.set(c, b + 2, "element"));
    return a;
  }
  insertBefore(a, b = !0) {
    G();
    zc(this, a);
    var c = this.getWritable();
    let d = a.getWritable(),
      e = d.__key;
    ac(d);
    let f = this.getPreviousSibling(),
      g = this.getParentOrThrow().getWritable(),
      h = c.__prev,
      k = this.getIndexWithinParent();
    null === f ? g.__first = e : f.getWritable().__next = e;
    g.__size++;
    c.__prev = e;
    d.__prev = h;
    d.__next = c.__key;
    d.__parent = c.__parent;
    c = u();
    b && C(c) && (b = this.getParentOrThrow(), be(c, b, k));
    return a;
  }
  isParentRequired() {
    return !1;
  }
  createParentElementNode() {
    return ee();
  }
  selectStart() {
    return this.selectPrevious();
  }
  selectEnd() {
    return this.selectNext(0, 0);
  }
  selectPrevious(a, b) {
    G();
    let c = this.getPreviousSibling(),
      d = this.getParentOrThrow();
    return null === c ? d.select(0, 0) : E(c) ? c.select() : B(c) ? c.select(a, b) : (a = c.getIndexWithinParent() + 1, d.select(a, a));
  }
  selectNext(a, b) {
    G();
    let c = this.getNextSibling(),
      d = this.getParentOrThrow();
    return null === c ? d.select() : E(c) ? c.select(0, 0) : B(c) ? c.select(a, b) : (a = c.getIndexWithinParent(), d.select(a, a));
  }
  markDirty() {
    this.getWritable();
  }
}
function fe(a, b, c) {
  c = c || b.getParentOrThrow().getLastChild();
  let d = b;
  for (b = [b]; d !== c;) d.getNextSibling() || t(140), d = d.getNextSibling(), b.push(d);
  for (let e of b) a = a.insertAfter(e);
}
class ge extends ce {
  static getType() {
    return "linebreak";
  }
  static clone(a) {
    return new ge(a.__key);
  }
  constructor(a) {
    super(a);
  }
  getTextContent() {
    return "\n";
  }
  createDOM() {
    return document.createElement("br");
  }
  updateDOM() {
    return !1;
  }
  static importDOM() {
    return {
      br: a => {
        a: {
          var b = a.parentElement;
          if (null !== b) {
            let c = b.firstChild;
            if (c === a || c.nextSibling === a && he(c)) if (b = b.lastChild, b === a || b.previousSibling === a && he(b)) {
              a = !0;
              break a;
            }
          }
          a = !1;
        }
        return a ? null : {
          conversion: ie,
          priority: 0
        };
      }
    };
  }
  static importJSON() {
    return je();
  }
  exportJSON() {
    return {
      type: "linebreak",
      version: 1
    };
  }
}
function ie() {
  return {
    node: je()
  };
}
function je() {
  return yc(new ge());
}
function Ec(a) {
  return a instanceof ge;
}
function he(a) {
  return 3 === a.nodeType && /^( |\t|\r?\n)+$/.test(a.textContent || "");
}
function ke(a, b) {
  return b & 16 ? "code" : b & 128 ? "mark" : b & 32 ? "sub" : b & 64 ? "sup" : null;
}
function le(a, b) {
  return b & 1 ? "strong" : b & 2 ? "em" : "span";
}
function me(a, b, c, d, e) {
  a = d.classList;
  d = oc(e, "base");
  void 0 !== d && a.add(...d);
  d = oc(e, "underlineStrikethrough");
  let f = !1,
    g = b & 8 && b & 4;
  var h = c & 8 && c & 4;
  void 0 !== d && (h ? (f = !0, g || a.add(...d)) : g && a.remove(...d));
  for (let k in gb) h = gb[k], d = oc(e, k), void 0 !== d && (c & h ? !f || "underline" !== k && "strikethrough" !== k ? (0 === (b & h) || g && "underline" === k || "strikethrough" === k) && a.add(...d) : b & h && a.remove(...d) : b & h && a.remove(...d));
}
function ne(a, b, c) {
  let d = b.firstChild;
  c = c.isComposing();
  a += c ? cb : "";
  if (null == d) b.textContent = a;else if (b = d.nodeValue, b !== a) if (c || Va) {
    c = b.length;
    let e = a.length,
      f = 0,
      g = 0;
    for (; f < c && f < e && b[f] === a[f];) f++;
    for (; g + f < c && g + f < e && b[c - g - 1] === a[e - g - 1];) g++;
    a = [f, c - f - g, a.slice(f, e - g)];
    let [h, k, m] = a;
    0 !== k && d.deleteData(h, k);
    d.insertData(h, m);
  } else d.nodeValue = a;
}
function oe(a, b) {
  b = document.createElement(b);
  b.appendChild(a);
  return b;
}
class pe extends ce {
  static getType() {
    return "text";
  }
  static clone(a) {
    return new pe(a.__text, a.__key);
  }
  constructor(a, b) {
    super(b);
    this.__text = a;
    this.__format = 0;
    this.__style = "";
    this.__detail = this.__mode = 0;
  }
  getFormat() {
    return this.getLatest().__format;
  }
  getDetail() {
    return this.getLatest().__detail;
  }
  getMode() {
    let a = this.getLatest();
    return ob[a.__mode];
  }
  getStyle() {
    return this.getLatest().__style;
  }
  isToken() {
    return 1 === this.getLatest().__mode;
  }
  isComposing() {
    return this.__key === cc();
  }
  isSegmented() {
    return 2 === this.getLatest().__mode;
  }
  isDirectionless() {
    return 0 !== (this.getLatest().__detail & 1);
  }
  isUnmergeable() {
    return 0 !== (this.getLatest().__detail & 2);
  }
  hasFormat(a) {
    a = gb[a];
    return 0 !== (this.getFormat() & a);
  }
  isSimpleText() {
    return "text" === this.__type && 0 === this.__mode;
  }
  getTextContent() {
    return this.getLatest().__text;
  }
  getFormatFlags(a, b) {
    let c = this.getLatest().__format;
    return Xb(c, a, b);
  }
  canHaveFormat() {
    return !0;
  }
  createDOM(a) {
    var b = this.__format,
      c = ke(this, b);
    let d = le(this, b),
      e = document.createElement(null === c ? d : c),
      f = e;
    this.hasFormat("code") && e.setAttribute("spellcheck", "false");
    null !== c && (f = document.createElement(d), e.appendChild(f));
    c = f;
    ne(this.__text, c, this);
    a = a.theme.text;
    void 0 !== a && me(d, 0, b, c, a);
    b = this.__style;
    "" !== b && (e.style.cssText = b);
    return e;
  }
  updateDOM(a, b, c) {
    let d = this.__text;
    var e = a.__format,
      f = this.__format,
      g = ke(this, e);
    let h = ke(this, f);
    var k = le(this, e);
    let m = le(this, f);
    if ((null === g ? k : g) !== (null === h ? m : h)) return !0;
    if (g === h && k !== m) return e = b.firstChild, null == e && t(48), a = g = document.createElement(m), ne(d, a, this), c = c.theme.text, void 0 !== c && me(m, 0, f, a, c), b.replaceChild(g, e), !1;
    k = b;
    null !== h && null !== g && (k = b.firstChild, null == k && t(49));
    ne(d, k, this);
    c = c.theme.text;
    void 0 !== c && e !== f && me(m, e, f, k, c);
    f = this.__style;
    a.__style !== f && (b.style.cssText = f);
    return !1;
  }
  static importDOM() {
    return {
      "#text": () => ({
        conversion: qe,
        priority: 0
      }),
      b: () => ({
        conversion: re,
        priority: 0
      }),
      code: () => ({
        conversion: se,
        priority: 0
      }),
      em: () => ({
        conversion: se,
        priority: 0
      }),
      i: () => ({
        conversion: se,
        priority: 0
      }),
      s: () => ({
        conversion: se,
        priority: 0
      }),
      span: () => ({
        conversion: te,
        priority: 0
      }),
      strong: () => ({
        conversion: se,
        priority: 0
      }),
      sub: () => ({
        conversion: se,
        priority: 0
      }),
      sup: () => ({
        conversion: se,
        priority: 0
      }),
      u: () => ({
        conversion: se,
        priority: 0
      })
    };
  }
  static importJSON(a) {
    let b = K(a.text);
    b.setFormat(a.format);
    b.setDetail(a.detail);
    b.setMode(a.mode);
    b.setStyle(a.style);
    return b;
  }
  exportDOM(a) {
    ({
      element: a
    } = super.exportDOM(a));
    null !== a && Cc(a) || t(132);
    a.style.whiteSpace = "pre-wrap";
    this.hasFormat("bold") && (a = oe(a, "b"));
    this.hasFormat("italic") && (a = oe(a, "i"));
    this.hasFormat("strikethrough") && (a = oe(a, "s"));
    this.hasFormat("underline") && (a = oe(a, "u"));
    return {
      element: a
    };
  }
  exportJSON() {
    return {
      detail: this.getDetail(),
      format: this.getFormat(),
      mode: this.getMode(),
      style: this.getStyle(),
      text: this.getTextContent(),
      type: "text",
      version: 1
    };
  }
  selectionTransform() {}
  setFormat(a) {
    let b = this.getWritable();
    b.__format = "string" === typeof a ? gb[a] : a;
    return b;
  }
  setDetail(a) {
    let b = this.getWritable();
    b.__detail = "string" === typeof a ? hb[a] : a;
    return b;
  }
  setStyle(a) {
    let b = this.getWritable();
    b.__style = a;
    return b;
  }
  toggleFormat(a) {
    let b = this.getFormat();
    a = Xb(b, a, null);
    return this.setFormat(a);
  }
  toggleDirectionless() {
    let a = this.getWritable();
    a.__detail ^= 1;
    return a;
  }
  toggleUnmergeable() {
    let a = this.getWritable();
    a.__detail ^= 2;
    return a;
  }
  setMode(a) {
    a = nb[a];
    if (this.__mode === a) return this;
    let b = this.getWritable();
    b.__mode = a;
    return b;
  }
  setTextContent(a) {
    if (this.__text === a) return this;
    let b = this.getWritable();
    b.__text = a;
    return b;
  }
  select(a, b) {
    G();
    let c = u();
    var d = this.getTextContent();
    let e = this.__key;
    "string" === typeof d ? (d = d.length, void 0 === a && (a = d), void 0 === b && (b = d)) : b = a = 0;
    if (C(c)) d = cc(), d !== c.anchor.key && d !== c.focus.key || H(e), c.setTextNodeRange(this, a, this, b);else return ue(e, a, e, b, "text", "text");
    return c;
  }
  selectStart() {
    return this.select(0, 0);
  }
  selectEnd() {
    let a = this.getTextContentSize();
    return this.select(a, a);
  }
  spliceText(a, b, c, d) {
    let e = this.getWritable(),
      f = e.__text,
      g = c.length,
      h = a;
    0 > h && (h = g + h, 0 > h && (h = 0));
    let k = u();
    d && C(k) && (a += g, k.setTextNodeRange(e, a, e, a));
    b = f.slice(0, h) + c + f.slice(h + b);
    e.__text = b;
    return e;
  }
  canInsertTextBefore() {
    return !0;
  }
  canInsertTextAfter() {
    return !0;
  }
  splitText(...a) {
    G();
    var b = this.getLatest(),
      c = b.getTextContent(),
      d = b.__key,
      e = cc(),
      f = new Set(a);
    a = [];
    var g = c.length,
      h = "";
    for (var k = 0; k < g; k++) "" !== h && f.has(k) && (a.push(h), h = ""), h += c[k];
    "" !== h && a.push(h);
    f = a.length;
    if (0 === f) return [];
    if (a[0] === c) return [b];
    var m = a[0];
    c = b.getParentOrThrow();
    k = b.getFormat();
    let q = b.getStyle(),
      n = b.__detail;
    g = !1;
    b.isSegmented() ? (h = K(m), h.__format = k, h.__style = q, h.__detail = n, g = !0) : (h = b.getWritable(), h.__text = m);
    b = u();
    h = [h];
    m = m.length;
    for (let w = 1; w < f; w++) {
      var l = a[w],
        r = l.length;
      l = K(l).getWritable();
      l.__format = k;
      l.__style = q;
      l.__detail = n;
      let A = l.__key;
      r = m + r;
      if (C(b)) {
        let x = b.anchor,
          z = b.focus;
        x.key === d && "text" === x.type && x.offset > m && x.offset <= r && (x.key = A, x.offset -= m, b.dirty = !0);
        z.key === d && "text" === z.type && z.offset > m && z.offset <= r && (z.key = A, z.offset -= m, b.dirty = !0);
      }
      e === d && H(A);
      m = r;
      h.push(l);
    }
    d = this.getPreviousSibling();
    e = this.getNextSibling();
    null !== d && bc(d);
    null !== e && bc(e);
    d = c.getWritable();
    e = this.getIndexWithinParent();
    g ? (d.splice(e, 0, h), this.remove()) : d.splice(e, 1, h);
    C(b) && be(b, c, e, f - 1);
    return h;
  }
  mergeWithSibling(a) {
    var b = a === this.getPreviousSibling();
    b || a === this.getNextSibling() || t(50);
    var c = this.__key;
    let d = a.__key,
      e = this.__text,
      f = e.length;
    cc() === d && H(c);
    let g = u();
    if (C(g)) {
      let h = g.anchor,
        k = g.focus;
      null !== h && h.key === d && (ve(h, b, c, a, f), g.dirty = !0);
      null !== k && k.key === d && (ve(k, b, c, a, f), g.dirty = !0);
    }
    c = a.__text;
    this.setTextContent(b ? c + e : e + c);
    b = this.getWritable();
    a.remove();
    return b;
  }
  isTextEntity() {
    return !1;
  }
}
function te(a) {
  let b = "700" === a.style.fontWeight,
    c = "line-through" === a.style.textDecoration,
    d = "italic" === a.style.fontStyle,
    e = "underline" === a.style.textDecoration,
    f = a.style.verticalAlign;
  return {
    forChild: g => {
      if (!B(g)) return g;
      b && g.toggleFormat("bold");
      c && g.toggleFormat("strikethrough");
      d && g.toggleFormat("italic");
      e && g.toggleFormat("underline");
      "sub" === f && g.toggleFormat("subscript");
      "super" === f && g.toggleFormat("superscript");
      return g;
    },
    node: null
  };
}
function re(a) {
  let b = "normal" === a.style.fontWeight;
  return {
    forChild: c => {
      B(c) && !b && c.toggleFormat("bold");
      return c;
    },
    node: null
  };
}
let we = new WeakMap();
function Ge(a) {
  var b,
    c = a.parentNode;
  for (a = [a]; null !== c && void 0 === (b = we.get(c)) && !("PRE" === c.nodeName || 1 === c.nodeType && void 0 !== c.style && void 0 !== c.style.whiteSpace && c.style.whiteSpace.startsWith("pre"));) a.push(c), c = c.parentNode;
  b = void 0 === b ? c : b;
  for (c = 0; c < a.length; c++) we.set(a[c], b);
  return b;
}
function qe(a) {
  null === a.parentElement && t(129);
  var b = a.textContent || "";
  if (null !== Ge(a)) {
    b = b.split(/(\r?\n|\t)/);
    a = [];
    var c = b.length;
    for (var d = 0; d < c; d++) {
      var e = b[d];
      "\n" === e || "\r\n" === e ? a.push(je()) : "\t" === e ? a.push(He()) : "" !== e && a.push(K(e));
    }
    return {
      node: a
    };
  }
  b = b.replace(/\r/g, "").replace(/[ \t\n]+/g, " ");
  if ("" === b) return {
    node: null
  };
  if (" " === b[0]) {
    c = a;
    for (d = !0; null !== c && null !== (c = Ie(c, !1));) if (e = c.textContent || "", 0 < e.length) {
      /[ \t\n]$/.test(e) && (b = b.slice(1));
      d = !1;
      break;
    }
    d && (b = b.slice(1));
  }
  if (" " === b[b.length - 1]) {
    for (c = !0; null !== a && null !== (a = Ie(a, !0));) if (0 < (a.textContent || "").replace(/^( |\t|\r?\n)+/, "").length) {
      c = !1;
      break;
    }
    c && (b = b.slice(0, b.length - 1));
  }
  return "" === b ? {
    node: null
  } : {
    node: K(b)
  };
}
let Je = new RegExp(/^(a|abbr|acronym|b|cite|code|del|em|i|ins|kbd|label|output|q|ruby|s|samp|span|strong|sub|sup|time|u|tt|var)$/, "i");
function Ie(a, b) {
  for (;;) {
    for (var c = void 0; null === (c = b ? a.nextSibling : a.previousSibling);) if (a = a.parentElement, null === a) return null;
    a = c;
    if (1 === a.nodeType && (c = a.style.display, "" === c && null === a.nodeName.match(Je) || "" !== c && !c.startsWith("inline"))) return null;
    for (; null !== (c = b ? a.firstChild : a.lastChild);) a = c;
    if (3 === a.nodeType) return a;
    if ("BR" === a.nodeName) return null;
  }
}
let Ke = {
  code: "code",
  em: "italic",
  i: "italic",
  s: "strikethrough",
  strong: "bold",
  sub: "subscript",
  sup: "superscript",
  u: "underline"
};
function se(a) {
  let b = Ke[a.nodeName.toLowerCase()];
  return void 0 === b ? {
    node: null
  } : {
    forChild: c => {
      B(c) && !c.hasFormat(b) && c.toggleFormat(b);
      return c;
    },
    node: null
  };
}
function K(a = "") {
  return yc(new pe(a));
}
function B(a) {
  return a instanceof pe;
}
class Le extends pe {
  static getType() {
    return "tab";
  }
  static clone(a) {
    let b = new Le(a.__key);
    b.__text = a.__text;
    b.__format = a.__format;
    b.__style = a.__style;
    return b;
  }
  constructor(a) {
    super("\t", a);
    this.__detail = 2;
  }
  static importDOM() {
    return null;
  }
  static importJSON(a) {
    let b = He();
    b.setFormat(a.format);
    b.setStyle(a.style);
    return b;
  }
  exportJSON() {
    return {
      ...super.exportJSON(),
      type: "tab",
      version: 1
    };
  }
  setTextContent() {
    t(126);
  }
  setDetail() {
    t(127);
  }
  setMode() {
    t(128);
  }
  canInsertTextBefore() {
    return !1;
  }
  canInsertTextAfter() {
    return !1;
  }
}
function He() {
  return yc(new Le());
}
function Me(a) {
  return a instanceof Le;
}
class Ne {
  constructor(a, b, c) {
    this._selection = null;
    this.key = a;
    this.offset = b;
    this.type = c;
  }
  is(a) {
    return this.key === a.key && this.offset === a.offset && this.type === a.type;
  }
  isBefore(a) {
    let b = this.getNode(),
      c = a.getNode(),
      d = this.offset;
    a = a.offset;
    if (E(b)) {
      var e = b.getDescendantByIndex(d);
      b = null != e ? e : b;
    }
    E(c) && (e = c.getDescendantByIndex(a), c = null != e ? e : c);
    return b === c ? d < a : b.isBefore(c);
  }
  getNode() {
    let a = I(this.key);
    null === a && t(20);
    return a;
  }
  set(a, b, c) {
    let d = this._selection,
      e = this.key;
    this.key = a;
    this.offset = b;
    this.type = c;
    dc() || (cc() === e && H(a), null !== d && (d.setCachedNodes(null), d.dirty = !0));
  }
}
function Oe(a, b, c) {
  return new Ne(a, b, c);
}
function Pe(a, b) {
  let c = b.__key,
    d = a.offset,
    e = "element";
  if (B(b)) e = "text", b = b.getTextContentSize(), d > b && (d = b);else if (!E(b)) {
    var f = b.getNextSibling();
    if (B(f)) c = f.__key, d = 0, e = "text";else if (f = b.getParent()) c = f.__key, d = b.getIndexWithinParent() + 1;
  }
  a.set(c, d, e);
}
function de(a, b) {
  if (E(b)) {
    let c = b.getLastDescendant();
    E(c) || B(c) ? Pe(a, c) : Pe(a, b);
  } else Pe(a, b);
}
function Qe(a, b, c, d) {
  let e = a.getNode(),
    f = e.getChildAtIndex(a.offset),
    g = K(),
    h = L(e) ? ee().append(g) : g;
  g.setFormat(c);
  g.setStyle(d);
  null === f ? e.append(h) : f.insertBefore(h);
  a.is(b) && b.set(g.__key, 0, "text");
  a.set(g.__key, 0, "text");
}
function Re(a, b, c, d) {
  a.key = b;
  a.offset = c;
  a.type = d;
}
class Se {
  constructor(a) {
    this._cachedNodes = null;
    this._nodes = a;
    this.dirty = !1;
  }
  getCachedNodes() {
    return this._cachedNodes;
  }
  setCachedNodes(a) {
    this._cachedNodes = a;
  }
  is(a) {
    if (!Vd(a)) return !1;
    let b = this._nodes,
      c = a._nodes;
    return b.size === c.size && Array.from(b).every(d => c.has(d));
  }
  isCollapsed() {
    return !1;
  }
  isBackward() {
    return !1;
  }
  getStartEndPoints() {
    return null;
  }
  add(a) {
    this.dirty = !0;
    this._nodes.add(a);
    this._cachedNodes = null;
  }
  delete(a) {
    this.dirty = !0;
    this._nodes.delete(a);
    this._cachedNodes = null;
  }
  clear() {
    this.dirty = !0;
    this._nodes.clear();
    this._cachedNodes = null;
  }
  has(a) {
    return this._nodes.has(a);
  }
  clone() {
    return new Se(new Set(this._nodes));
  }
  extract() {
    return this.getNodes();
  }
  insertRawText() {}
  insertText() {}
  insertNodes(a) {
    let b = this.getNodes(),
      c = b.length;
    var d = b[c - 1];
    if (B(d)) d = d.select();else {
      let e = d.getIndexWithinParent() + 1;
      d = d.getParentOrThrow().select(e, e);
    }
    d.insertNodes(a);
    for (a = 0; a < c; a++) b[a].remove();
  }
  getNodes() {
    var a = this._cachedNodes;
    if (null !== a) return a;
    var b = this._nodes;
    a = [];
    for (let c of b) b = I(c), null !== b && a.push(b);
    dc() || (this._cachedNodes = a);
    return a;
  }
  getTextContent() {
    let a = this.getNodes(),
      b = "";
    for (let c = 0; c < a.length; c++) b += a[c].getTextContent();
    return b;
  }
}
function C(a) {
  return a instanceof Te;
}
class Te {
  constructor(a, b, c, d) {
    this.anchor = a;
    this.focus = b;
    a._selection = this;
    b._selection = this;
    this._cachedNodes = null;
    this.format = c;
    this.style = d;
    this.dirty = !1;
  }
  getCachedNodes() {
    return this._cachedNodes;
  }
  setCachedNodes(a) {
    this._cachedNodes = a;
  }
  is(a) {
    return C(a) ? this.anchor.is(a.anchor) && this.focus.is(a.focus) && this.format === a.format && this.style === a.style : !1;
  }
  isCollapsed() {
    return this.anchor.is(this.focus);
  }
  getNodes() {
    var a = this._cachedNodes;
    if (null !== a) return a;
    a = this.anchor;
    var b = this.focus,
      c = a.isBefore(b),
      d = c ? a : b;
    c = c ? b : a;
    a = d.getNode();
    b = c.getNode();
    let e = d.offset;
    d = c.offset;
    E(a) && (c = a.getDescendantByIndex(e), a = null != c ? c : a);
    E(b) && (c = b.getDescendantByIndex(d), null !== c && c !== a && b.getChildAtIndex(d) === c && (c = c.getPreviousSibling()), b = null != c ? c : b);
    a = a.is(b) ? E(a) && 0 < a.getChildrenSize() ? [] : [a] : a.getNodesBetween(b);
    dc() || (this._cachedNodes = a);
    return a;
  }
  setTextNodeRange(a, b, c, d) {
    Re(this.anchor, a.__key, b, "text");
    Re(this.focus, c.__key, d, "text");
    this._cachedNodes = null;
    this.dirty = !0;
  }
  getTextContent() {
    let a = this.getNodes();
    if (0 === a.length) return "";
    let b = a[0],
      c = a[a.length - 1],
      d = this.anchor,
      e = this.focus,
      f = d.isBefore(e),
      [g, h] = Ue(this),
      k = "",
      m = !0;
    for (let q = 0; q < a.length; q++) {
      let n = a[q];
      if (E(n) && !n.isInline()) m || (k += "\n"), m = n.isEmpty() ? !1 : !0;else if (m = !1, B(n)) {
        let l = n.getTextContent();
        if (n === b) {
          if (n === c) {
            if ("element" !== d.type || "element" !== e.type || e.offset === d.offset) l = g < h ? l.slice(g, h) : l.slice(h, g);
          } else l = f ? l.slice(g) : l.slice(h);
        } else n === c && (l = f ? l.slice(0, h) : l.slice(0, g));
        k += l;
      } else !y(n) && !Ec(n) || n === c && this.isCollapsed() || (k += n.getTextContent());
    }
    return k;
  }
  applyDOMRange(a) {
    let b = F(),
      c = b.getEditorState()._selection;
    a = Ve(a.startContainer, a.startOffset, a.endContainer, a.endOffset, b, c);
    if (null !== a) {
      var [d, e] = a;
      Re(this.anchor, d.key, d.offset, d.type);
      Re(this.focus, e.key, e.offset, e.type);
      this._cachedNodes = null;
    }
  }
  clone() {
    let a = this.anchor,
      b = this.focus;
    return new Te(Oe(a.key, a.offset, a.type), Oe(b.key, b.offset, b.type), this.format, this.style);
  }
  toggleFormat(a) {
    this.format = Xb(this.format, a, null);
    this.dirty = !0;
  }
  setStyle(a) {
    this.style = a;
    this.dirty = !0;
  }
  hasFormat(a) {
    return 0 !== (this.format & gb[a]);
  }
  insertRawText(a) {
    a = a.split(/(\r?\n|\t)/);
    let b = [],
      c = a.length;
    for (let d = 0; d < c; d++) {
      let e = a[d];
      "\n" === e || "\r\n" === e ? b.push(je()) : "\t" === e ? b.push(He()) : b.push(K(e));
    }
    this.insertNodes(b);
  }
  insertText(a) {
    var b = this.anchor,
      c = this.focus,
      d = this.isCollapsed() || b.isBefore(c),
      e = this.format,
      f = this.style;
    d && "element" === b.type ? Qe(b, c, e, f) : d || "element" !== c.type || Qe(c, b, e, f);
    var g = this.getNodes(),
      h = g.length,
      k = d ? c : b;
    c = (d ? b : c).offset;
    var m = k.offset;
    b = g[0];
    B(b) || t(26);
    d = b.getTextContent().length;
    var q = b.getParentOrThrow(),
      n = g[h - 1];
    if (this.isCollapsed() && c === d && (b.isSegmented() || b.isToken() || !b.canInsertTextAfter() || !q.canInsertTextAfter() && null === b.getNextSibling())) {
      var l = b.getNextSibling();
      B(l) && l.canInsertTextBefore() && !Vb(l) || (l = K(), l.setFormat(e), q.canInsertTextAfter() ? b.insertAfter(l) : q.insertAfter(l));
      l.select(0, 0);
      b = l;
      if ("" !== a) {
        this.insertText(a);
        return;
      }
    } else if (this.isCollapsed() && 0 === c && (b.isSegmented() || b.isToken() || !b.canInsertTextBefore() || !q.canInsertTextBefore() && null === b.getPreviousSibling())) {
      l = b.getPreviousSibling();
      if (!B(l) || Vb(l)) l = K(), l.setFormat(e), q.canInsertTextBefore() ? b.insertBefore(l) : q.insertBefore(l);
      l.select();
      b = l;
      if ("" !== a) {
        this.insertText(a);
        return;
      }
    } else if (b.isSegmented() && c !== d) q = K(b.getTextContent()), q.setFormat(e), b.replace(q), b = q;else if (!(this.isCollapsed() || "" === a || (l = n.getParent(), q.canInsertTextBefore() && q.canInsertTextAfter() && (!E(l) || l.canInsertTextBefore() && l.canInsertTextAfter())))) {
      this.insertText("");
      We(this.anchor, this.focus, null);
      this.insertText(a);
      return;
    }
    if (1 === h) {
      if (b.isToken()) a = K(a), a.select(), b.replace(a);else {
        g = b.getFormat();
        h = b.getStyle();
        if (c === m && (g !== e || h !== f)) {
          if ("" === b.getTextContent()) b.setFormat(e), b.setStyle(f);else {
            g = K(a);
            g.setFormat(e);
            g.setStyle(f);
            g.select();
            0 === c ? b.insertBefore(g, !1) : ([h] = b.splitText(c), h.insertAfter(g, !1));
            g.isComposing() && "text" === this.anchor.type && (this.anchor.offset -= a.length);
            return;
          }
        } else if (Me(b)) {
          a = K(a);
          a.setFormat(e);
          a.setStyle(f);
          a.select();
          b.replace(a);
          return;
        }
        b = b.spliceText(c, m - c, a, !0);
        "" === b.getTextContent() ? b.remove() : "text" === this.anchor.type && (b.isComposing() ? this.anchor.offset -= a.length : (this.format = g, this.style = h));
      }
    } else {
      e = new Set([...b.getParentKeys(), ...n.getParentKeys()]);
      l = E(b) ? b : b.getParentOrThrow();
      f = E(n) ? n : n.getParentOrThrow();
      q = n;
      if (!l.is(f) && f.isInline()) {
        do q = f, f = f.getParentOrThrow(); while (f.isInline());
      }
      if ("text" === k.type && (0 !== m || "" === n.getTextContent()) || "element" === k.type && n.getIndexWithinParent() < m) {
        if (B(n) && !n.isToken() && m !== n.getTextContentSize()) {
          if (n.isSegmented()) {
            var r = K(n.getTextContent());
            n.replace(r);
            n = r;
          }
          L(k.getNode()) || "text" !== k.type || (n = n.spliceText(0, m, ""));
          e.add(n.__key);
        } else k = n.getParentOrThrow(), k.canBeEmpty() || 1 !== k.getChildrenSize() ? n.remove() : k.remove();
      } else e.add(n.__key);
      k = f.getChildren();
      m = new Set(g);
      n = l.is(f);
      l = l.isInline() && null === b.getNextSibling() ? l : b;
      for (r = k.length - 1; 0 <= r; r--) {
        let w = k[r];
        if (w.is(b) || E(w) && w.isParentOf(b)) break;
        w.isAttached() && (!m.has(w) || w.is(q) ? n || l.insertAfter(w, !1) : w.remove());
      }
      if (!n) for (k = f, f = null; null !== k;) {
        m = k.getChildren();
        n = m.length;
        if (0 === n || m[n - 1].is(f)) e.delete(k.__key), f = k;
        k = k.getParent();
      }
      b.isToken() ? c === d ? b.select() : (a = K(a), a.select(), b.replace(a)) : (b = b.spliceText(c, d - c, a, !0), "" === b.getTextContent() ? b.remove() : b.isComposing() && "text" === this.anchor.type && (this.anchor.offset -= a.length));
      for (a = 1; a < h; a++) b = g[a], e.has(b.__key) || b.remove();
    }
  }
  removeText() {
    this.insertText("");
  }
  formatText(a) {
    if (this.isCollapsed()) this.toggleFormat(a), H(null);else {
      var b = this.getNodes(),
        c = [];
      for (var d of b) B(d) && c.push(d);
      var e = c.length;
      if (0 === e) this.toggleFormat(a), H(null);else {
        d = this.anchor;
        var f = this.focus,
          g = this.isBackward();
        b = g ? f : d;
        d = g ? d : f;
        var h = 0,
          k = c[0];
        f = "element" === b.type ? 0 : b.offset;
        "text" === b.type && f === k.getTextContentSize() && (h = 1, k = c[1], f = 0);
        if (null != k) {
          g = k.getFormatFlags(a, null);
          var m = e - 1,
            q = c[m];
          e = "text" === d.type ? d.offset : q.getTextContentSize();
          if (k.is(q)) f !== e && (0 === f && e === k.getTextContentSize() ? k.setFormat(g) : (a = k.splitText(f, e), a = 0 === f ? a[0] : a[1], a.setFormat(g), "text" === b.type && b.set(a.__key, 0, "text"), "text" === d.type && d.set(a.__key, e - f, "text")), this.format = g);else {
            0 !== f && ([, k] = k.splitText(f), f = 0);
            k.setFormat(g);
            var n = q.getFormatFlags(a, g);
            0 < e && (e !== q.getTextContentSize() && ([q] = q.splitText(e)), q.setFormat(n));
            for (h += 1; h < m; h++) {
              let l = c[h];
              if (!l.isToken()) {
                let r = l.getFormatFlags(a, n);
                l.setFormat(r);
              }
            }
            "text" === b.type && b.set(k.__key, f, "text");
            "text" === d.type && d.set(q.__key, e, "text");
            this.format = g | n;
          }
        }
      }
    }
  }
  insertNodes(a) {
    if (0 !== a.length) {
      if ("root" === this.anchor.key) {
        this.insertParagraph();
        var b = u();
        C(b) || t(134);
        return b.insertNodes(a);
      }
      b = this.isBackward() ? this.focus : this.anchor;
      var c = Fc(b.getNode(), Dc);
      b = a[a.length - 1];
      if ("__language" in c && E(c)) {
        if ("__language" in a[0]) this.insertText(a[0].getTextContent());else {
          var d = Xe(this);
          c.splice(d, 0, a);
          b.selectEnd();
        }
      } else if (a.some(g => (E(g) || y(g)) && !g.isInline())) {
        b = Ye(a);
        a = b.getLastDescendant();
        var e = b.getChildren();
        b = E(c) && c.isEmpty() ? null : this.insertParagraph();
        d = e[e.length - 1];
        var f = e[0];
        (g => E(g) && Dc(g) && !g.isEmpty() && E(c) && (!c.isEmpty() || "__value" in c && "__checked" in c))(f) && (E(c) || t(135), c.append(...f.getChildren()), f = e[1]);
        f && fe(c, f);
        e = Fc(a, Dc);
        b && E(e) && ("__value" in b && "__checked" in b || Dc(d)) && (e.append(...b.getChildren()), b.remove());
        E(c) && c.isEmpty() && c.remove();
        a.selectEnd();
        a = E(c) ? c.getLastChild() : null;
        Ec(a) && e !== c && a.remove();
      } else E(c) || t(135), d = Xe(this), c.splice(d, 0, a), b.selectEnd();
    }
  }
  insertParagraph() {
    if ("root" === this.anchor.key) {
      var a = ee();
      J().splice(this.anchor.offset, 0, [a]);
      a.select();
      return a;
    }
    var b = Xe(this);
    a = Fc(this.anchor.getNode(), Dc);
    E(a) || t(136);
    b = (b = a.getChildAtIndex(b)) ? [b, ...b.getNextSiblings()] : [];
    return (a = a.insertNewAfter(this, !1)) ? (a.append(...b), a.selectStart(), a) : null;
  }
  insertLineBreak(a) {
    var b = je();
    this.insertNodes([b]);
    a && (a = b.getParentOrThrow(), b = b.getIndexWithinParent(), a.select(b, b));
  }
  extract() {
    var a = this.getNodes(),
      b = a.length,
      c = b - 1,
      d = this.anchor;
    let e = this.focus;
    var f = a[0];
    let g = a[c],
      [h, k] = Ue(this);
    if (0 === b) return [];
    if (1 === b) return B(f) && !this.isCollapsed() ? (a = h > k ? k : h, c = f.splitText(a, h > k ? h : k), a = 0 === a ? c[0] : c[1], null != a ? [a] : []) : [f];
    b = d.isBefore(e);
    B(f) && (d = b ? h : k, d === f.getTextContentSize() ? a.shift() : 0 !== d && ([, f] = f.splitText(d), a[0] = f));
    B(g) && (f = g.getTextContent().length, b = b ? k : h, 0 === b ? a.pop() : b !== f && ([g] = g.splitText(b), a[c] = g));
    return a;
  }
  modify(a, b, c) {
    var d = this.focus,
      e = this.anchor,
      f = "move" === a,
      g = rc(d, b);
    if (y(g) && !g.isIsolated()) f && g.isKeyboardSelectable() ? (b = Ze(), b.add(g.__key), zb(b)) : (a = b ? g.getPreviousSibling() : g.getNextSibling(), B(a) ? (g = a.__key, b = b ? a.getTextContent().length : 0, d.set(g, b, "text"), f && e.set(g, b, "text")) : (c = g.getParentOrThrow(), E(a) ? (c = a.__key, g = b ? a.getChildrenSize() : 0) : (g = g.getIndexWithinParent(), c = c.__key, b || g++), d.set(c, g, "element"), f && e.set(c, g, "element")));else if (e = F(), d = wb(e._window)) {
      var h = e._blockCursorElement,
        k = e._rootElement;
      null === k || null === h || !E(g) || g.isInline() || g.canBeEmpty() || Bc(h, e, k);
      d.modify(a, b ? "backward" : "forward", c);
      if (0 < d.rangeCount && (g = d.getRangeAt(0), e = this.anchor.getNode(), e = L(e) ? e : vc(e), this.applyDOMRange(g), this.dirty = !0, !f)) {
        f = this.getNodes();
        a = [];
        c = !1;
        for (h = 0; h < f.length; h++) k = f[h], uc(k, e) ? a.push(k) : c = !0;
        c && 0 < a.length && (b ? (b = a[0], E(b) ? b.selectStart() : b.getParentOrThrow().selectStart()) : (b = a[a.length - 1], E(b) ? b.selectEnd() : b.getParentOrThrow().selectEnd()));
        if (d.anchorNode !== g.startContainer || d.anchorOffset !== g.startOffset) b = this.focus, f = this.anchor, d = f.key, g = f.offset, e = f.type, Re(f, b.key, b.offset, b.type), Re(b, d, g, e), this._cachedNodes = null;
      }
    }
  }
  deleteCharacter(a) {
    let b = this.isCollapsed();
    if (this.isCollapsed()) {
      var c = this.anchor,
        d = this.focus,
        e = c.getNode();
      if (!a && ("element" === c.type && E(e) && c.offset === e.getChildrenSize() || "text" === c.type && c.offset === e.getTextContentSize())) {
        var f = e.getParent();
        f = e.getNextSibling() || (null === f ? null : f.getNextSibling());
        if (E(f) && f.isShadowRoot()) return;
      }
      f = rc(d, a);
      if (y(f) && !f.isIsolated()) {
        f.isKeyboardSelectable() && E(e) && 0 === e.getChildrenSize() ? (e.remove(), a = Ze(), a.add(f.__key), zb(a)) : (f.remove(), F().dispatchCommand(ba, void 0));
        return;
      }
      if (!a && E(f) && E(e) && e.isEmpty()) {
        e.remove();
        f.selectStart();
        return;
      }
      this.modify("extend", a, "character");
      if (!this.isCollapsed()) {
        f = "text" === d.type ? d.getNode() : null;
        e = "text" === c.type ? c.getNode() : null;
        if (null !== f && f.isSegmented()) {
          if (c = d.offset, d = f.getTextContentSize(), f.is(e) || a && c !== d || !a && 0 !== c) {
            $e(f, a, c);
            return;
          }
        } else if (null !== e && e.isSegmented() && (c = c.offset, d = e.getTextContentSize(), e.is(f) || a && 0 !== c || !a && c !== d)) {
          $e(e, a, c);
          return;
        }
        e = this.anchor;
        f = this.focus;
        c = e.getNode();
        d = f.getNode();
        if (c === d && "text" === e.type && "text" === f.type) {
          var g = e.offset,
            h = f.offset;
          let k = g < h;
          d = k ? g : h;
          h = k ? h : g;
          g = h - 1;
          d !== g && (c = c.getTextContent().slice(d, h), ic(c) || (a ? f.offset = g : e.offset = g));
        }
      } else if (a && 0 === c.offset && ("element" === c.type ? c.getNode() : c.getNode().getParentOrThrow()).collapseAtStart(this)) return;
    }
    this.removeText();
    a && !b && this.isCollapsed() && "element" === this.anchor.type && 0 === this.anchor.offset && (a = this.anchor.getNode(), a.isEmpty() && L(a.getParent()) && 0 === a.getIndexWithinParent() && a.collapseAtStart(this));
  }
  deleteLine(a) {
    this.isCollapsed() && ("text" === this.anchor.type && this.modify("extend", a, "lineboundary"), 0 === (a ? this.focus : this.anchor).offset && this.modify("extend", a, "character"));
    this.removeText();
  }
  deleteWord(a) {
    this.isCollapsed() && this.modify("extend", a, "word");
    this.removeText();
  }
  isBackward() {
    return this.focus.isBefore(this.anchor);
  }
  getStartEndPoints() {
    return [this.anchor, this.focus];
  }
}
function Vd(a) {
  return a instanceof Se;
}
function af(a) {
  let b = a.offset;
  if ("text" === a.type) return b;
  a = a.getNode();
  return b === a.getChildrenSize() ? a.getTextContent().length : 0;
}
function Ue(a) {
  a = a.getStartEndPoints();
  if (null === a) return [0, 0];
  let [b, c] = a;
  return "element" === b.type && "element" === c.type && b.key === c.key && b.offset === c.offset ? [0, 0] : [af(b), af(c)];
}
function $e(a, b, c) {
  let d = a.getTextContent().split(/(?=\s)/g),
    e = d.length,
    f = 0,
    g = 0;
  for (let h = 0; h < e; h++) {
    let k = d[h],
      m = h === e - 1;
    g = f;
    f += k.length;
    if (b && f === c || f > c || m) {
      d.splice(h, 1);
      m && (g = void 0);
      break;
    }
  }
  b = d.join("").trim();
  "" === b ? a.remove() : (a.setTextContent(b), a.select(g, g));
}
function bf(a, b, c, d) {
  var e = b;
  if (1 === a.nodeType) {
    let h = !1;
    var f = a.childNodes,
      g = f.length;
    e === g && (h = !0, e = g - 1);
    let k = f[e];
    g = !1;
    k === d._blockCursorElement ? (k = f[e + 1], g = !0) : null !== d._blockCursorElement && e--;
    d = hc(k);
    if (B(d)) e = h ? d.getTextContentSize() : 0;else {
      f = hc(a);
      if (null === f) return null;
      if (E(f)) {
        a = f.getChildAtIndex(e);
        if (b = E(a)) b = a.getParent(), b = null === c || null === b || !b.canBeEmpty() || b !== c.getNode();
        b && (c = h ? a.getLastDescendant() : a.getFirstDescendant(), null === c ? (f = a, e = 0) : (a = c, f = E(a) ? a : a.getParentOrThrow()));
        B(a) ? (d = a, f = null, e = h ? a.getTextContentSize() : 0) : a !== f && h && !g && e++;
      } else e = f.getIndexWithinParent(), e = 0 === b && y(f) && hc(a) === f ? e : e + 1, f = f.getParentOrThrow();
      if (E(f)) return Oe(f.__key, e, "element");
    }
  } else d = hc(a);
  return B(d) ? Oe(d.__key, e, "text") : null;
}
function cf(a, b, c) {
  var d = a.offset,
    e = a.getNode();
  0 === d ? (d = e.getPreviousSibling(), e = e.getParent(), b) ? (c || !b) && null === d && E(e) && e.isInline() && (b = e.getPreviousSibling(), B(b) && (a.key = b.__key, a.offset = b.getTextContent().length)) : E(d) && !c && d.isInline() ? (a.key = d.__key, a.offset = d.getChildrenSize(), a.type = "element") : B(d) && (a.key = d.__key, a.offset = d.getTextContent().length) : d === e.getTextContent().length && (d = e.getNextSibling(), e = e.getParent(), b && E(d) && d.isInline() ? (a.key = d.__key, a.offset = 0, a.type = "element") : (c || b) && null === d && E(e) && e.isInline() && !e.canInsertTextAfter() && (b = e.getNextSibling(), B(b) && (a.key = b.__key, a.offset = 0)));
}
function We(a, b, c) {
  if ("text" === a.type && "text" === b.type) {
    var d = a.isBefore(b);
    let e = a.is(b);
    cf(a, d, e);
    cf(b, !d, e);
    e && (b.key = a.key, b.offset = a.offset, b.type = a.type);
    d = F();
    d.isComposing() && d._compositionKey !== a.key && C(c) && (d = c.anchor, c = c.focus, Re(a, d.key, d.offset, d.type), Re(b, c.key, c.offset, c.type));
  }
}
function Ve(a, b, c, d, e, f) {
  if (null === a || null === c || !Sb(e, a, c)) return null;
  b = bf(a, b, C(f) ? f.anchor : null, e);
  if (null === b) return null;
  d = bf(c, d, C(f) ? f.focus : null, e);
  if (null === d || "element" === b.type && "element" === d.type && (a = hc(a), c = hc(c), y(a) && y(c))) return null;
  We(b, d, f);
  return [b, d];
}
function ue(a, b, c, d, e, f) {
  let g = $b();
  a = new Te(Oe(a, b, e), Oe(c, d, f), 0, "");
  a.dirty = !0;
  return g._selection = a;
}
function Ze() {
  return new Se(new Set());
}
function df(a) {
  let b = a.getEditorState()._selection,
    c = wb(a._window);
  return C(b) || null == b ? Rd(b, c, a, null) : b.clone();
}
function Rd(a, b, c, d) {
  var e = c._window;
  if (null === e) return null;
  var f = (e = d || e.event) ? e.type : void 0;
  d = "selectionchange" === f;
  e = !pb && (d || "beforeinput" === f || "compositionstart" === f || "compositionend" === f || "click" === f && e && 3 === e.detail || "drop" === f || void 0 === f);
  let g;
  if (!C(a) || e) {
    if (null === b) return null;
    e = b.anchorNode;
    f = b.focusNode;
    g = b.anchorOffset;
    b = b.focusOffset;
    if (d && C(a) && !Sb(c, e, f)) return a.clone();
  } else return a.clone();
  c = Ve(e, g, f, b, c, a);
  if (null === c) return null;
  let [h, k] = c;
  return new Te(h, k, C(a) ? a.format : 0, C(a) ? a.style : "");
}
function u() {
  return $b()._selection;
}
function mc() {
  return F()._editorState._selection;
}
function be(a, b, c, d = 1) {
  var e = a.anchor,
    f = a.focus,
    g = e.getNode(),
    h = f.getNode();
  if (b.is(g) || b.is(h)) {
    g = b.__key;
    if (a.isCollapsed()) {
      if (b = e.offset, c <= b && 0 < d || c < b && 0 > d) c = Math.max(0, b + d), e.set(g, c, "element"), f.set(g, c, "element"), ef(a);
    } else {
      let m = a.isBackward();
      h = m ? f : e;
      var k = h.getNode();
      e = m ? e : f;
      f = e.getNode();
      b.is(k) && (k = h.offset, (c <= k && 0 < d || c < k && 0 > d) && h.set(g, Math.max(0, k + d), "element"));
      b.is(f) && (b = e.offset, (c <= b && 0 < d || c < b && 0 > d) && e.set(g, Math.max(0, b + d), "element"));
    }
    ef(a);
  }
}
function ef(a) {
  var b = a.anchor,
    c = b.offset;
  let d = a.focus;
  var e = d.offset,
    f = b.getNode(),
    g = d.getNode();
  if (a.isCollapsed()) E(f) && (g = f.getChildrenSize(), g = (e = c >= g) ? f.getChildAtIndex(g - 1) : f.getChildAtIndex(c), B(g) && (c = 0, e && (c = g.getTextContentSize()), b.set(g.__key, c, "text"), d.set(g.__key, c, "text")));else {
    if (E(f)) {
      let h = f.getChildrenSize();
      c = (a = c >= h) ? f.getChildAtIndex(h - 1) : f.getChildAtIndex(c);
      B(c) && (f = 0, a && (f = c.getTextContentSize()), b.set(c.__key, f, "text"));
    }
    E(g) && (c = g.getChildrenSize(), e = (b = e >= c) ? g.getChildAtIndex(c - 1) : g.getChildAtIndex(e), B(e) && (g = 0, b && (g = e.getTextContentSize()), d.set(e.__key, g, "text")));
  }
}
function ff(a, b) {
  b = b.getEditorState()._selection;
  a = a._selection;
  if (C(a)) {
    var c = a.anchor;
    let d = a.focus,
      e;
    "text" === c.type && (e = c.getNode(), e.selectionTransform(b, a));
    "text" === d.type && (c = d.getNode(), e !== c && c.selectionTransform(b, a));
  }
}
function ae(a, b, c, d, e) {
  let f = null,
    g = 0,
    h = null;
  null !== d ? (f = d.__key, B(d) ? (g = d.getTextContentSize(), h = "text") : E(d) && (g = d.getChildrenSize(), h = "element")) : null !== e && (f = e.__key, B(e) ? h = "text" : E(e) && (h = "element"));
  null !== f && null !== h ? a.set(f, g, h) : (g = b.getIndexWithinParent(), -1 === g && (g = c.getChildrenSize()), a.set(c.__key, g, "element"));
}
function ve(a, b, c, d, e) {
  "text" === a.type ? (a.key = c, b || (a.offset += e)) : a.offset > d.getIndexWithinParent() && --a.offset;
}
function Xe(a) {
  a.isCollapsed() || a.removeText();
  var b = a.anchor;
  a = b.getNode();
  for (b = b.offset; !Dc(a);) [a, b] = gf(a, b);
  return b;
}
function gf(a, b) {
  var c = a.getParent();
  if (!c) return c = ee(), J().append(c), c.select(), [J(), 0];
  if (B(a)) {
    var d = a.splitText(b);
    if (0 === d.length) return [c, a.getIndexWithinParent()];
    a = 0 === b ? 0 : 1;
    a = d[0].getIndexWithinParent() + a;
    return [c, a];
  }
  if (!E(a) || 0 === b) return [c, a.getIndexWithinParent()];
  if (d = a.getChildAtIndex(b)) b = new Te(Oe(a.__key, b, "element"), Oe(a.__key, b, "element"), 0, ""), (b = a.insertNewAfter(b)) && b.append(d, ...d.getNextSiblings());
  return [c, a.getIndexWithinParent() + 1];
}
function Ye(a) {
  let b = ee(),
    c = null;
  for (let d = 0; d < a.length; d++) {
    let e = a[d],
      f = Ec(e);
    if (f || y(e) && e.isInline() || E(e) && e.isInline() || B(e) || e.isParentRequired()) {
      if (null === c && (c = e.createParentElementNode(), b.append(c), f)) continue;
      null !== c && c.append(e);
    } else b.append(e), c = null;
  }
  return b;
}
let S = null,
  T = null,
  U = !1,
  hf = !1,
  Zb = 0,
  jf = {
    characterData: !0,
    childList: !0,
    subtree: !0
  };
function dc() {
  return U || null !== S && S._readOnly;
}
function G() {
  U && t(13);
}
function $b() {
  null === S && t(15);
  return S;
}
function F() {
  null === T && t(16);
  return T;
}
function kf(a, b, c) {
  var d = b.__type;
  let e = a._nodes.get(d);
  void 0 === e && t(30, d);
  a = c.get(d);
  void 0 === a && (a = Array.from(e.transforms), c.set(d, a));
  c = a.length;
  for (d = 0; d < c && (a[d](b), b.isAttached()); d++);
}
function lf(a, b) {
  b = b._dirtyLeaves;
  a = a._nodeMap;
  for (let c of b) b = a.get(c), B(b) && b.isAttached() && b.isSimpleText() && !b.isUnmergeable() && Gb(b);
}
function mf(a, b) {
  let c = b._dirtyLeaves,
    d = b._dirtyElements;
  a = a._nodeMap;
  let e = cc(),
    f = new Map();
  var g = c;
  let h = g.size;
  for (var k = d, m = k.size; 0 < h || 0 < m;) {
    if (0 < h) {
      b._dirtyLeaves = new Set();
      for (let q of g) g = a.get(q), B(g) && g.isAttached() && g.isSimpleText() && !g.isUnmergeable() && Gb(g), void 0 !== g && void 0 !== g && g.__key !== e && g.isAttached() && kf(b, g, f), c.add(q);
      g = b._dirtyLeaves;
      h = g.size;
      if (0 < h) {
        Zb++;
        continue;
      }
    }
    b._dirtyLeaves = new Set();
    b._dirtyElements = new Map();
    for (let q of k) if (k = q[0], m = q[1], "root" === k || m) g = a.get(k), void 0 !== g && void 0 !== g && g.__key !== e && g.isAttached() && kf(b, g, f), d.set(k, m);
    g = b._dirtyLeaves;
    h = g.size;
    k = b._dirtyElements;
    m = k.size;
    Zb++;
  }
  b._dirtyLeaves = c;
  b._dirtyElements = d;
}
function nf(a, b) {
  var c = a.type,
    d = b.get(c);
  void 0 === d && t(17, c);
  c = d.klass;
  a.type !== c.getType() && t(18, c.name);
  c = c.importJSON(a);
  a = a.children;
  if (E(c) && Array.isArray(a)) for (d = 0; d < a.length; d++) {
    let e = nf(a[d], b);
    c.append(e);
  }
  return c;
}
function of(a, b) {
  let c = S,
    d = U,
    e = T;
  S = a;
  U = !0;
  T = null;
  try {
    return b();
  } finally {
    S = c, U = d, T = e;
  }
}
function pf(a, b) {
  let c = a._pendingEditorState,
    d = a._rootElement,
    e = a._headless || null === d;
  if (null !== c) {
    console.log("2.[lexical][commitPendingUpdates]");
    var f = a._editorState,
      g = f._selection,
      h = c._selection,
      k = 0 !== a._dirtyType,
      m = S,
      q = U,
      n = T,
      l = a._updating,
      r = a._observer,
      w = null;
    a._pendingEditorState = null;
    a._editorState = c;
    if (!e && k && null !== r) {
      console.log("2.1.[lexical][commitPendingUpdates] observer.disconnect()");
      T = a;
      S = c;
      U = !1;
      a._updating = !0;
      try {
        let D = a._dirtyType,
          P = a._dirtyElements,
          Q = a._dirtyLeaves;
        r.disconnect();
        var A = D,
          x = P,
          z = Q;
        N = Ic = M = "";
        Lc = 2 === A;
        Oc = null;
        O = a;
        Jc = a._config;
        Kc = a._nodes;
        Nc = O._listeners.mutation;
        Pc = x;
        Zc = z;
        $c = f._nodeMap;
        ad = c._nodeMap;
        Mc = c._readOnly;
        bd = new Map(a._keyToDOMMap);
        let ha = new Map();
        cd = ha;
        td("root", null);
        cd = bd = Jc = ad = $c = Zc = Pc = Kc = O = void 0;
        w = ha;
      } catch (D) {
        D instanceof Error && a._onError(D);
        if (hf) throw D;
        console.log("2.[lexical][commitPendingUpdates] resetEditor and restore incoming editor state to the DOM");
        qf(a, null, d, c);
        Cb(a);
        a._dirtyType = 2;
        hf = !0;
        pf(a, f);
        hf = !1;
        return;
      } finally {
        r.observe(d, jf), a._updating = l, S = m, U = q, T = n;
      }
    }
    c._readOnly || (c._readOnly = !0);
    var aa = a._dirtyLeaves,
      W = a._dirtyElements,
      Wa = a._normalizedNodes,
      ja = a._updateTags,
      Qc = a._deferred;
    k && (a._dirtyType = 0, a._cloneNotNeeded.clear(), a._dirtyLeaves = new Set(), a._dirtyElements = new Map(), a._normalizedNodes = new Set(), a._updateTags = new Set());
    console.log("2.2.[lexical][commitPendingUpdates] $garbageCollectDetachedDecorators");
    var xe = a._decorators,
      Lb = a._pendingDecorators || xe,
      Cf = c._nodeMap,
      Rc;
    for (Rc in Lb) Cf.has(Rc) || (Lb === xe && (Lb = ec(a)), delete Lb[Rc]);
    var ia = e ? null : wb(a._window);
    if (a._editable && null !== ia && (k || null === h || h.dirty)) {
      T = a;
      S = c;
      try {
        null !== r && r.disconnect();
        if (k || null === h || h.dirty) {
          console.log("2.[lexical][commitPendingUpdates] updateDOMSelection");
          let D = a._blockCursorElement;
          null !== D && Bc(D, a, d);
          a: {
            let P = ia.anchorNode,
              Q = ia.focusNode,
              ha = ia.anchorOffset,
              jb = ia.focusOffset,
              X = document.activeElement;
            if (!(ja.has("collaboration") && X !== d || null !== X && Rb(X))) if (C(h)) {
              var kb = h.anchor,
                Sc = h.focus,
                ye = kb.key,
                Df = Sc.key,
                ze = tc(a, ye),
                Ae = tc(a, Df),
                Mb = kb.offset,
                Be = Sc.offset,
                Tc = h.format,
                Uc = h.style,
                Ce = h.isCollapsed(),
                lb = ze,
                Nb = Ae,
                Vc = !1;
              if ("text" === kb.type) {
                lb = Wb(ze);
                let Y = kb.getNode();
                Vc = Y.getFormat() !== Tc || Y.getStyle() !== Uc;
              } else C(g) && "text" === g.anchor.type && (Vc = !0);
              "text" === Sc.type && (Nb = Wb(Ae));
              if (null !== lb && null !== Nb) {
                if (Ce && (null === g || Vc || C(g) && (g.format !== Tc || g.style !== Uc))) {
                  var Ef = performance.now();
                  Nd = [Tc, Uc, Mb, ye, Ef];
                }
                if (ha === Mb && jb === Be && P === lb && Q === Nb && ("Range" !== ia.type || !Ce) && (null !== X && d.contains(X) || d.focus({
                  preventScroll: !0
                }), "element" !== kb.type)) break a;
                try {
                  ia.setBaseAndExtent(lb, Mb, Nb, Be);
                } catch (Y) {}
                if (!ja.has("skip-scroll-into-view") && h.isCollapsed() && null !== d && d === document.activeElement) {
                  let Y = h instanceof Te && "element" === h.anchor.type ? lb.childNodes[Mb] || null : 0 < ia.rangeCount ? ia.getRangeAt(0) : null;
                  if (null !== Y) {
                    let Z;
                    if (Y instanceof Text) {
                      let V = document.createRange();
                      V.selectNode(Y);
                      Z = V.getBoundingClientRect();
                    } else Z = Y.getBoundingClientRect();
                    let xa = d.ownerDocument,
                      Ea = xa.defaultView;
                    if (null !== Ea) for (var {
                        top: Wc,
                        bottom: Xc
                      } = Z, Ob, Pb, na = d; null !== na;) {
                      let V = na === xa.body;
                      if (V) Ob = 0, Pb = Db(a).innerHeight;else {
                        let Qb = na.getBoundingClientRect();
                        Ob = Qb.top;
                        Pb = Qb.bottom;
                      }
                      let Fa = 0;
                      Wc < Ob ? Fa = -(Ob - Wc) : Xc > Pb && (Fa = Xc - Pb);
                      if (0 !== Fa) if (V) Ea.scrollBy(0, Fa);else {
                        let Qb = na.scrollTop;
                        na.scrollTop += Fa;
                        let De = na.scrollTop - Qb;
                        Wc -= De;
                        Xc -= De;
                      }
                      if (V) break;
                      na = Ub(na);
                    }
                  }
                }
                Jd = !0;
              }
            } else null !== g && Sb(a, P, Q) && ia.removeAllRanges();
          }
        }
        a: {
          let D = a._blockCursorElement;
          if (C(h) && h.isCollapsed() && "element" === h.anchor.type && d.contains(document.activeElement)) {
            let P = h.anchor,
              Q = P.getNode(),
              ha = P.offset,
              jb = Q.getChildrenSize(),
              X = !1,
              Y = null;
            if (ha === jb) {
              let Z = Q.getChildAtIndex(ha - 1);
              Ac(Z) && (X = !0);
            } else {
              let Z = Q.getChildAtIndex(ha);
              if (Ac(Z)) {
                let xa = Z.getPreviousSibling();
                if (null === xa || Ac(xa)) X = !0, Y = a.getElementByKey(Z.__key);
              }
            }
            if (X) {
              let Z = a.getElementByKey(Q.__key);
              if (null === D) {
                let xa = a._config.theme,
                  Ea = document.createElement("div");
                Ea.contentEditable = "false";
                Ea.setAttribute("data-lexical-cursor", "true");
                let V = xa.blockCursor;
                if (void 0 !== V) {
                  if ("string" === typeof V) {
                    let Fa = V.split(" ");
                    V = xa.blockCursor = Fa;
                  }
                  void 0 !== V && Ea.classList.add(...V);
                }
                a._blockCursorElement = D = Ea;
              }
              d.style.caretColor = "transparent";
              null === Y ? Z.appendChild(D) : Z.insertBefore(D, Y);
              break a;
            }
          }
          null !== D && Bc(D, a, d);
        }
        null !== r && r.observe(d, jf);
      } finally {
        T = n, S = m;
      }
    }
    if (null !== w) {
      var Ff = w;
      let D = Array.from(a._listeners.mutation),
        P = D.length;
      for (let Q = 0; Q < P; Q++) {
        let [ha, jb] = D[Q],
          X = Ff.get(jb);
        void 0 !== X && ha(X, {
          dirtyLeaves: aa,
          prevEditorState: f,
          updateTags: ja
        });
      }
    }
    C(h) || null === h || null !== g && g.is(h) || a.dispatchCommand(ba, void 0);
    var Yc = a._pendingDecorators;
    null !== Yc && (a._decorators = Yc, a._pendingDecorators = null, rf("decorator", a, !0, Yc));
    var Gf = fc(b || f),
      Ee = fc(c);
    Gf !== Ee && rf("textcontent", a, !0, Ee);
    rf("update", a, !0, {
      dirtyElements: W,
      dirtyLeaves: aa,
      editorState: c,
      normalizedNodes: Wa,
      prevEditorState: b || f,
      tags: ja
    });
    a._deferred = [];
    if (0 !== Qc.length) {
      let D = a._updating;
      a._updating = !0;
      try {
        for (let P = 0; P < Qc.length; P++) Qc[P]();
      } finally {
        a._updating = D;
      }
    }
    var Fe = a._updates;
    if (0 !== Fe.length) {
      let D = Fe.shift();
      if (D) {
        let [P, Q] = D;
        sf(a, P, Q);
      }
    }
    console.log("2.[lexical][commitPendingUpdates] end");
  }
}
function rf(a, b, c, ...d) {
  let e = b._updating;
  b._updating = c;
  try {
    let f = Array.from(b._listeners[a]);
    for (a = 0; a < f.length; a++) f[a].apply(null, d);
  } finally {
    b._updating = e;
  }
}
function R(a, b, c) {
  if (!1 === a._updating || T !== a) {
    let f = !1;
    a.update(() => {
      f = R(a, b, c);
    });
    return f;
  }
  let d = jc(a);
  for (let f = 4; 0 <= f; f--) for (let g = 0; g < d.length; g++) {
    var e = d[g]._commands.get(b);
    if (void 0 !== e && (e = e[f], void 0 !== e)) {
      e = Array.from(e);
      let h = e.length;
      for (let k = 0; k < h; k++) if (!0 === e[k](c, a)) return !0;
    }
  }
  return !1;
}
function tf(a, b) {
  let c = a._updates;
  for (b = b || !1; 0 !== c.length;) {
    var d = c.shift();
    if (d) {
      let [e, f] = d,
        g;
      void 0 !== f && (d = f.onUpdate, g = f.tag, f.skipTransforms && (b = !0), d && a._deferred.push(d), g && a._updateTags.add(g));
      e();
    }
  }
  return b;
}
function sf(a, b, c) {
  let d = a._updateTags;
  var e,
    f = e = !1;
  if (void 0 !== c) {
    var g = c.onUpdate;
    e = c.tag;
    null != e && d.add(e);
    e = c.skipTransforms || !1;
    f = c.discrete || !1;
  }
  g && a._deferred.push(g);
  c = a._editorState;
  g = a._pendingEditorState;
  let h = !1;
  if (null === g || g._readOnly) g = a._pendingEditorState = new uf(new Map((g || c)._nodeMap)), h = !0;
  g._flushSync = f;
  f = S;
  let k = U,
    m = T,
    q = a._updating;
  S = g;
  U = !1;
  a._updating = !0;
  T = a;
  try {
    h && (a._headless ? null !== c._selection && (g._selection = c._selection.clone()) : g._selection = df(a));
    let n = a._compositionKey;
    b();
    e = tf(a, e);
    ff(g, a);
    0 !== a._dirtyType && (e ? lf(g, a) : mf(g, a), tf(a), Hc(c, g, a._dirtyLeaves, a._dirtyElements));
    n !== a._compositionKey && (g._flushSync = !0);
    let l = g._selection;
    if (C(l)) {
      let r = g._nodeMap,
        w = l.focus.key;
      void 0 !== r.get(l.anchor.key) && void 0 !== r.get(w) || t(19);
    } else Vd(l) && 0 === l._nodes.size && (g._selection = null);
  } catch (n) {
    n instanceof Error && a._onError(n);
    a._pendingEditorState = c;
    a._dirtyType = 2;
    a._cloneNotNeeded.clear();
    a._dirtyLeaves = new Set();
    a._dirtyElements.clear();
    pf(a);
    return;
  } finally {
    S = f, U = k, T = m, a._updating = q, Zb = 0;
  }
  0 !== a._dirtyType || vf(g, a) ? g._flushSync ? (g._flushSync = !1, pf(a)) : h && Kb(() => {
    pf(a);
  }) : (g._flushSync = !1, h && (d.clear(), a._deferred = [], a._pendingEditorState = null));
}
function v(a, b, c) {
  a._updating ? a._updates.push([b, c]) : sf(a, b, c);
}
class wf extends ce {
  constructor(a) {
    super(a);
  }
  decorate() {
    t(47);
  }
  isIsolated() {
    return !1;
  }
  isInline() {
    return !0;
  }
  isKeyboardSelectable() {
    return !0;
  }
}
function y(a) {
  return a instanceof wf;
}
class xf extends ce {
  constructor(a) {
    super(a);
    this.__last = this.__first = null;
    this.__indent = this.__format = this.__size = 0;
    this.__dir = null;
  }
  getFormat() {
    return this.getLatest().__format;
  }
  getFormatType() {
    let a = this.getFormat();
    return mb[a] || "";
  }
  getIndent() {
    return this.getLatest().__indent;
  }
  getChildren() {
    let a = [],
      b = this.getFirstChild();
    for (; null !== b;) a.push(b), b = b.getNextSibling();
    return a;
  }
  getChildrenKeys() {
    let a = [],
      b = this.getFirstChild();
    for (; null !== b;) a.push(b.__key), b = b.getNextSibling();
    return a;
  }
  getChildrenSize() {
    return this.getLatest().__size;
  }
  isEmpty() {
    return 0 === this.getChildrenSize();
  }
  isDirty() {
    let a = F()._dirtyElements;
    return null !== a && a.has(this.__key);
  }
  isLastChild() {
    let a = this.getLatest(),
      b = this.getParentOrThrow().getLastChild();
    return null !== b && b.is(a);
  }
  getAllTextNodes() {
    let a = [],
      b = this.getFirstChild();
    for (; null !== b;) {
      B(b) && a.push(b);
      if (E(b)) {
        let c = b.getAllTextNodes();
        a.push(...c);
      }
      b = b.getNextSibling();
    }
    return a;
  }
  getFirstDescendant() {
    let a = this.getFirstChild();
    for (; null !== a;) {
      if (E(a)) {
        let b = a.getFirstChild();
        if (null !== b) {
          a = b;
          continue;
        }
      }
      break;
    }
    return a;
  }
  getLastDescendant() {
    let a = this.getLastChild();
    for (; null !== a;) {
      if (E(a)) {
        let b = a.getLastChild();
        if (null !== b) {
          a = b;
          continue;
        }
      }
      break;
    }
    return a;
  }
  getDescendantByIndex(a) {
    let b = this.getChildren(),
      c = b.length;
    if (a >= c) return a = b[c - 1], E(a) && a.getLastDescendant() || a || null;
    a = b[a];
    return E(a) && a.getFirstDescendant() || a || null;
  }
  getFirstChild() {
    let a = this.getLatest().__first;
    return null === a ? null : I(a);
  }
  getFirstChildOrThrow() {
    let a = this.getFirstChild();
    null === a && t(45, this.__key);
    return a;
  }
  getLastChild() {
    let a = this.getLatest().__last;
    return null === a ? null : I(a);
  }
  getLastChildOrThrow() {
    let a = this.getLastChild();
    null === a && t(96, this.__key);
    return a;
  }
  getChildAtIndex(a) {
    var b = this.getChildrenSize();
    let c;
    if (a < b / 2) {
      c = this.getFirstChild();
      for (b = 0; null !== c && b <= a;) {
        if (b === a) return c;
        c = c.getNextSibling();
        b++;
      }
      return null;
    }
    c = this.getLastChild();
    for (--b; null !== c && b >= a;) {
      if (b === a) return c;
      c = c.getPreviousSibling();
      b--;
    }
    return null;
  }
  getTextContent() {
    let a = "",
      b = this.getChildren(),
      c = b.length;
    for (let d = 0; d < c; d++) {
      let e = b[d];
      a += e.getTextContent();
      E(e) && d !== c - 1 && !e.isInline() && (a += "\n\n");
    }
    return a;
  }
  getTextContentSize() {
    let a = 0,
      b = this.getChildren(),
      c = b.length;
    for (let d = 0; d < c; d++) {
      let e = b[d];
      a += e.getTextContentSize();
      E(e) && d !== c - 1 && !e.isInline() && (a += 2);
    }
    return a;
  }
  getDirection() {
    return this.getLatest().__dir;
  }
  hasFormat(a) {
    return "" !== a ? (a = ib[a], 0 !== (this.getFormat() & a)) : !1;
  }
  select(a, b) {
    G();
    let c = u(),
      d = a,
      e = b;
    var f = this.getChildrenSize();
    if (!this.canBeEmpty()) if (0 === a && 0 === b) {
      if (a = this.getFirstChild(), B(a) || E(a)) return a.select(0, 0);
    } else if (!(void 0 !== a && a !== f || void 0 !== b && b !== f) && (a = this.getLastChild(), B(a) || E(a))) return a.select();
    void 0 === d && (d = f);
    void 0 === e && (e = f);
    f = this.__key;
    if (C(c)) c.anchor.set(f, d, "element"), c.focus.set(f, e, "element"), c.dirty = !0;else return ue(f, d, f, e, "element", "element");
    return c;
  }
  selectStart() {
    let a = this.getFirstDescendant();
    return a ? a.selectStart() : this.select();
  }
  selectEnd() {
    let a = this.getLastDescendant();
    return a ? a.selectEnd() : this.select();
  }
  clear() {
    let a = this.getWritable();
    this.getChildren().forEach(b => b.remove());
    return a;
  }
  append(...a) {
    return this.splice(this.getChildrenSize(), 0, a);
  }
  setDirection(a) {
    let b = this.getWritable();
    b.__dir = a;
    return b;
  }
  setFormat(a) {
    this.getWritable().__format = "" !== a ? ib[a] : 0;
    return this;
  }
  setIndent(a) {
    this.getWritable().__indent = a;
    return this;
  }
  splice(a, b, c) {
    let d = c.length,
      e = this.getChildrenSize(),
      f = this.getWritable(),
      g = f.__key;
    var h = [],
      k = [];
    let m = this.getChildAtIndex(a + b),
      q = null,
      n = e - b + d;
    if (0 !== a) if (a === e) q = this.getLastChild();else {
      var l = this.getChildAtIndex(a);
      null !== l && (q = l.getPreviousSibling());
    }
    if (0 < b) {
      var r = null === q ? this.getFirstChild() : q.getNextSibling();
      for (l = 0; l < b; l++) {
        null === r && t(100);
        var w = r.getNextSibling(),
          A = r.__key;
        r = r.getWritable();
        ac(r);
        k.push(A);
        r = w;
      }
    }
    l = q;
    for (w = 0; w < d; w++) {
      A = c[w];
      null !== l && A.is(l) && (q = l = l.getPreviousSibling());
      r = A.getWritable();
      r.__parent === g && n--;
      ac(r);
      let x = A.__key;
      null === l ? (f.__first = x, r.__prev = null) : (l = l.getWritable(), l.__next = x, r.__prev = l.__key);
      A.__key === g && t(76);
      r.__parent = g;
      h.push(x);
      l = A;
    }
    a + b === e ? null !== l && (l.getWritable().__next = null, f.__last = l.__key) : null !== m && (a = m.getWritable(), null !== l ? (b = l.getWritable(), a.__prev = l.__key, b.__next = m.__key) : a.__prev = null);
    f.__size = n;
    if (k.length && (a = u(), C(a))) {
      k = new Set(k);
      h = new Set(h);
      let {
        anchor: x,
        focus: z
      } = a;
      yf(x, k, h) && ae(x, x.getNode(), this, q, m);
      yf(z, k, h) && ae(z, z.getNode(), this, q, m);
      0 !== n || this.canBeEmpty() || wc(this) || this.remove();
    }
    return f;
  }
  exportJSON() {
    return {
      children: [],
      direction: this.getDirection(),
      format: this.getFormatType(),
      indent: this.getIndent(),
      type: "element",
      version: 1
    };
  }
  insertNewAfter() {
    return null;
  }
  canIndent() {
    return !0;
  }
  collapseAtStart() {
    return !1;
  }
  excludeFromCopy() {
    return !1;
  }
  canExtractContents() {
    return !0;
  }
  canReplaceWith() {
    return !0;
  }
  canInsertAfter() {
    return !0;
  }
  canBeEmpty() {
    return !0;
  }
  canInsertTextBefore() {
    return !0;
  }
  canInsertTextAfter() {
    return !0;
  }
  isInline() {
    return !1;
  }
  isShadowRoot() {
    return !1;
  }
  canMergeWith() {
    return !1;
  }
  extractWithChild() {
    return !1;
  }
}
function E(a) {
  return a instanceof xf;
}
function yf(a, b, c) {
  for (a = a.getNode(); a;) {
    let d = a.__key;
    if (b.has(d) && !c.has(d)) return !0;
    a = a.getParent();
  }
  return !1;
}
class zf extends xf {
  static getType() {
    return "root";
  }
  static clone() {
    return new zf();
  }
  constructor() {
    super("root");
    this.__cachedText = null;
  }
  getTopLevelElementOrThrow() {
    t(51);
  }
  getTextContent() {
    let a = this.__cachedText;
    return !dc() && 0 !== F()._dirtyType || null === a ? super.getTextContent() : a;
  }
  remove() {
    t(52);
  }
  replace() {
    t(53);
  }
  insertBefore() {
    t(54);
  }
  insertAfter() {
    t(55);
  }
  updateDOM() {
    return !1;
  }
  append(...a) {
    for (let b = 0; b < a.length; b++) {
      let c = a[b];
      E(c) || y(c) || t(56);
    }
    return super.append(...a);
  }
  static importJSON(a) {
    let b = J();
    b.setFormat(a.format);
    b.setIndent(a.indent);
    b.setDirection(a.direction);
    return b;
  }
  exportJSON() {
    return {
      children: [],
      direction: this.getDirection(),
      format: this.getFormatType(),
      indent: this.getIndent(),
      type: "root",
      version: 1
    };
  }
  collapseAtStart() {
    return !0;
  }
}
function L(a) {
  return a instanceof zf;
}
function vf(a, b) {
  b = b.getEditorState()._selection;
  a = a._selection;
  if (null !== a) {
    if (a.dirty || !a.is(b)) return !0;
  } else if (null !== b) return !0;
  return !1;
}
function Af() {
  return new uf(new Map([["root", new zf()]]));
}
function Bf(a) {
  let b = a.exportJSON();
  var c = a.constructor;
  b.type !== c.getType() && t(130, c.name);
  if (E(a)) {
    let d = b.children;
    Array.isArray(d) || t(59, c.name);
    a = a.getChildren();
    for (c = 0; c < a.length; c++) {
      let e = Bf(a[c]);
      d.push(e);
    }
  }
  return b;
}
class uf {
  constructor(a, b) {
    this._nodeMap = a;
    this._selection = b || null;
    this._readOnly = this._flushSync = !1;
  }
  isEmpty() {
    return 1 === this._nodeMap.size && null === this._selection;
  }
  read(a) {
    return of(this, a);
  }
  clone(a) {
    a = new uf(this._nodeMap, void 0 === a ? this._selection : a);
    a._readOnly = !0;
    return a;
  }
  toJSON() {
    return of(this, () => ({
      root: Bf(J())
    }));
  }
}
class Hf extends xf {
  static getType() {
    return "paragraph";
  }
  static clone(a) {
    return new Hf(a.__key);
  }
  createDOM(a) {
    let b = document.createElement("p");
    a = oc(a.theme, "paragraph");
    void 0 !== a && b.classList.add(...a);
    return b;
  }
  updateDOM() {
    return !1;
  }
  static importDOM() {
    return {
      p: () => ({
        conversion: If,
        priority: 0
      })
    };
  }
  exportDOM(a) {
    ({
      element: a
    } = super.exportDOM(a));
    if (a && Cc(a)) {
      this.isEmpty() && a.append(document.createElement("br"));
      var b = this.getFormatType();
      a.style.textAlign = b;
      if (b = this.getDirection()) a.dir = b;
      b = this.getIndent();
      0 < b && (a.style.textIndent = `${20 * b}px`);
    }
    return {
      element: a
    };
  }
  static importJSON(a) {
    let b = ee();
    b.setFormat(a.format);
    b.setIndent(a.indent);
    b.setDirection(a.direction);
    return b;
  }
  exportJSON() {
    return {
      ...super.exportJSON(),
      type: "paragraph",
      version: 1
    };
  }
  insertNewAfter(a, b) {
    a = ee();
    let c = this.getDirection();
    a.setDirection(c);
    this.insertAfter(a, b);
    return a;
  }
  collapseAtStart() {
    let a = this.getChildren();
    if (0 === a.length || B(a[0]) && "" === a[0].getTextContent().trim()) {
      if (null !== this.getNextSibling()) return this.selectNext(), this.remove(), !0;
      if (null !== this.getPreviousSibling()) return this.selectPrevious(), this.remove(), !0;
    }
    return !1;
  }
}
function If(a) {
  let b = ee();
  a.style && (b.setFormat(a.style.textAlign), a = parseInt(a.style.textIndent, 10) / 20, 0 < a && b.setIndent(a));
  return {
    node: b
  };
}
function ee() {
  return yc(new Hf());
}
function qf(a, b, c, d, e) {
  console.log("resetEditor 29/01");
  let f = a._keyToDOMMap;
  f.clear();
  a._editorState = Af();
  a._pendingEditorState = d;
  a._compositionKey = null;
  a._dirtyType = 0;
  a._cloneNotNeeded.clear();
  a._dirtyLeaves = new Set();
  a._dirtyElements.clear();
  a._normalizedNodes = new Set();
  a._updateTags = new Set();
  a._updates = [];
  a._blockCursorElement = null;
  d = a._observer;
  null !== d && (d.disconnect(), a._observer = null);
  null === b || e || (b.textContent = "");
  null !== c && (c.textContent = "", f.set("root", c));
}
function Jf(a, b) {
  let c = new Map(),
    d = new Set(),
    e = f => {
      Object.keys(f).forEach(g => {
        let h = c.get(g);
        void 0 === h && (h = [], c.set(g, h));
        h.push(f[g]);
      });
    };
  a.forEach(f => {
    f = null != f.klass.importDOM ? f.klass.importDOM.bind(f.klass) : null;
    null == f || d.has(f) || (d.add(f), f = f(), null !== f && e(f));
  });
  b && e(b);
  return c;
}
class Kf {
  constructor(a, b, c, d, e, f, g) {
    this._parentEditor = b;
    this._rootElement = null;
    this._editorState = a;
    this._compositionKey = this._pendingEditorState = null;
    this._deferred = [];
    this._keyToDOMMap = new Map();
    this._updates = [];
    this._updating = !1;
    this._listeners = {
      decorator: new Set(),
      editable: new Set(),
      mutation: new Map(),
      root: new Set(),
      textcontent: new Set(),
      update: new Set()
    };
    this._commands = new Map();
    this._config = d;
    this._nodes = c;
    this._decorators = {};
    this._pendingDecorators = null;
    this._dirtyType = 0;
    this._cloneNotNeeded = new Set();
    this._dirtyLeaves = new Set();
    this._dirtyElements = new Map();
    this._normalizedNodes = new Set();
    this._updateTags = new Set();
    this._observer = null;
    this._key = kc();
    this._onError = e;
    this._htmlConversions = f;
    this._editable = g;
    this._headless = null !== b && b._headless;
    this._blockCursorElement = this._window = null;
  }
  isComposing() {
    return null != this._compositionKey;
  }
  registerUpdateListener(a) {
    let b = this._listeners.update;
    b.add(a);
    return () => {
      b.delete(a);
    };
  }
  registerEditableListener(a) {
    let b = this._listeners.editable;
    b.add(a);
    return () => {
      b.delete(a);
    };
  }
  registerDecoratorListener(a) {
    let b = this._listeners.decorator;
    b.add(a);
    return () => {
      b.delete(a);
    };
  }
  registerTextContentListener(a) {
    let b = this._listeners.textcontent;
    b.add(a);
    return () => {
      b.delete(a);
    };
  }
  registerRootListener(a) {
    let b = this._listeners.root;
    a(this._rootElement, null);
    b.add(a);
    return () => {
      a(null, this._rootElement);
      b.delete(a);
    };
  }
  registerCommand(a, b, c) {
    void 0 === c && t(35);
    let d = this._commands;
    d.has(a) || d.set(a, [new Set(), new Set(), new Set(), new Set(), new Set()]);
    let e = d.get(a);
    void 0 === e && t(36, String(a));
    let f = e[c];
    f.add(b);
    return () => {
      f.delete(b);
      e.every(g => 0 === g.size) && d.delete(a);
    };
  }
  registerMutationListener(a, b) {
    void 0 === this._nodes.get(a.getType()) && t(37, a.name);
    let c = this._listeners.mutation;
    c.set(b, a);
    return () => {
      c.delete(b);
    };
  }
  registerNodeTransformToKlass(a, b) {
    var c = a.getType();
    c = this._nodes.get(c);
    void 0 === c && t(37, a.name);
    c.transforms.add(b);
    return c;
  }
  registerNodeTransform(a, b) {
    var c = this.registerNodeTransformToKlass(a, b);
    let d = [c];
    c = c.replaceWithKlass;
    null != c && (c = this.registerNodeTransformToKlass(c, b), d.push(c));
    gc(this, a.getType());
    return () => {
      d.forEach(e => e.transforms.delete(b));
    };
  }
  hasNode(a) {
    return this._nodes.has(a.getType());
  }
  hasNodes(a) {
    return a.every(this.hasNode.bind(this));
  }
  dispatchCommand(a, b) {
    return R(this, a, b);
  }
  getDecorators() {
    return this._decorators;
  }
  getRootElement() {
    return this._rootElement;
  }
  getKey() {
    return this._key;
  }
  setRootElement(a, b) {
    let c = this._rootElement;
    if (a !== c) {
      let f = oc(this._config.theme, "root");
      var d = this._pendingEditorState || this._editorState;
      this._rootElement = a;
      qf(this, c, a, d, b && b.ignoreDom);
      if (null !== c) {
        if (!this._config.disableEvents) {
          0 !== Id && (Id--, 0 === Id && c.ownerDocument.removeEventListener("selectionchange", Yd));
          b = c.__lexicalEditor;
          if (null !== b && void 0 !== b) {
            if (null !== b._parentEditor) {
              var e = jc(b);
              e = e[e.length - 1]._key;
              Xd.get(e) === b && Xd.delete(e);
            } else Xd.delete(b._key);
            c.__lexicalEditor = null;
          }
          b = Wd(c);
          for (e = 0; e < b.length; e++) b[e]();
          c.__lexicalEventHandles = [];
        }
        null != f && c.classList.remove(...f);
      }
      null !== a ? (d = (d = a.ownerDocument) && d.defaultView || null, b = a.style, b.userSelect = "text", b.whiteSpace = "pre-wrap", b.wordBreak = "break-word", a.setAttribute("data-lexical-editor", "true"), this._window = d, this._dirtyType = 2, Cb(this), this._updateTags.add("history-merge"), pf(this), this._config.disableEvents || Zd(a, this), null != f && a.classList.add(...f)) : (this._editorState = d, this._window = this._pendingEditorState = null);
      rf("root", this, !1, a, c);
    }
  }
  getElementByKey(a) {
    return this._keyToDOMMap.get(a) || null;
  }
  getEditorState() {
    return this._editorState;
  }
  setEditorState(a, b) {
    a.isEmpty() && t(38);
    Bb(this);
    let c = this._pendingEditorState,
      d = this._updateTags;
    b = void 0 !== b ? b.tag : null;
    null === c || c.isEmpty() || (null != b && d.add(b), pf(this));
    this._pendingEditorState = a;
    this._dirtyType = 2;
    this._dirtyElements.set("root", !1);
    this._compositionKey = null;
    null != b && d.add(b);
    pf(this);
  }
  parseEditorState(a, b) {
    a = "string" === typeof a ? JSON.parse(a) : a;
    let c = Af(),
      d = S,
      e = U,
      f = T,
      g = this._dirtyElements,
      h = this._dirtyLeaves,
      k = this._cloneNotNeeded,
      m = this._dirtyType;
    this._dirtyElements = new Map();
    this._dirtyLeaves = new Set();
    this._cloneNotNeeded = new Set();
    this._dirtyType = 0;
    S = c;
    U = !1;
    T = this;
    try {
      nf(a.root, this._nodes), b && b(), c._readOnly = !0;
    } catch (q) {
      q instanceof Error && this._onError(q);
    } finally {
      this._dirtyElements = g, this._dirtyLeaves = h, this._cloneNotNeeded = k, this._dirtyType = m, S = d, U = e, T = f;
    }
    return c;
  }
  update(a, b) {
    v(this, a, b);
  }
  focus(a, b = {}) {
    let c = this._rootElement;
    null !== c && (c.setAttribute("autocapitalize", "off"), v(this, () => {
      let d = u(),
        e = J();
      null !== d ? d.dirty = !0 : 0 !== e.getChildrenSize() && ("rootStart" === b.defaultSelection ? e.selectStart() : e.selectEnd());
    }, {
      onUpdate: () => {
        c.removeAttribute("autocapitalize");
        a && a();
      },
      tag: "focus"
    }), null === this._pendingEditorState && c.removeAttribute("autocapitalize"));
  }
  blur() {
    var a = this._rootElement;
    null !== a && a.blur();
    a = wb(this._window);
    null !== a && a.removeAllRanges();
  }
  isEditable() {
    return this._editable;
  }
  setEditable(a) {
    this._editable !== a && (this._editable = a, rf("editable", this, !0, a));
  }
  toJSON() {
    return {
      editorState: this._editorState.toJSON()
    };
  }
}
Lexical_prod.$addUpdateTag = function (a) {
  G();
  F()._updateTags.add(a);
};
Lexical_prod.$applyNodeReplacement = yc;
Lexical_prod.$copyNode = xc;
Lexical_prod.$createLineBreakNode = je;
Lexical_prod.$createNodeSelection = Ze;
Lexical_prod.$createParagraphNode = ee;
Lexical_prod.$createPoint = Oe;
Lexical_prod.$createRangeSelection = function () {
  let a = Oe("root", 0, "element"),
    b = Oe("root", 0, "element");
  return new Te(a, b, 0, "");
};
Lexical_prod.$createTabNode = He;
Lexical_prod.$createTextNode = K;
Lexical_prod.$getAdjacentNode = rc;
Lexical_prod.$getCharacterOffsets = Ue;
Lexical_prod.$getEditor = function () {
  return F();
};
Lexical_prod.$getNearestNodeFromDOMNode = vb;
Lexical_prod.$getNearestRootOrShadowRoot = vc;
Lexical_prod.$getNodeByKey = I;
Lexical_prod.$getPreviousSelection = mc;
Lexical_prod.$getRoot = J;
Lexical_prod.$getSelection = u;
Lexical_prod.$getTextContent = function () {
  let a = u();
  return null === a ? "" : a.getTextContent();
};
Lexical_prod.$hasAncestor = uc;
Lexical_prod.$hasUpdateTag = function (a) {
  return F()._updateTags.has(a);
};
Lexical_prod.$insertNodes = function (a) {
  let b = u() || mc();
  null === b && (b = J().selectEnd());
  b.insertNodes(a);
};
Lexical_prod.$isBlockElementNode = function (a) {
  return E(a) && !a.isInline();
};
Lexical_prod.$isDecoratorNode = y;
Lexical_prod.$isElementNode = E;
Lexical_prod.$isInlineElementOrDecoratorNode = function (a) {
  return E(a) && a.isInline() || y(a) && a.isInline();
};
Lexical_prod.$isLeafNode = function (a) {
  return B(a) || Ec(a) || y(a);
};
Lexical_prod.$isLineBreakNode = Ec;
Lexical_prod.$isNodeSelection = Vd;
Lexical_prod.$isParagraphNode = function (a) {
  return a instanceof Hf;
};
Lexical_prod.$isRangeSelection = C;
Lexical_prod.$isRootNode = L;
Lexical_prod.$isRootOrShadowRoot = wc;
Lexical_prod.$isTabNode = Me;
Lexical_prod.$isTextNode = B;
Lexical_prod.$nodesOfType = function (a) {
  var b = $b();
  let c = b._readOnly,
    d = a.getType();
  b = b._nodeMap;
  let e = [];
  for (let [, f] of b) f instanceof a && f.__type === d && (c || f.isAttached()) && e.push(f);
  return e;
};
Lexical_prod.$normalizeSelection__EXPERIMENTAL = Hb;
Lexical_prod.$parseSerializedNode = function (a) {
  return nf(a, F()._nodes);
};
Lexical_prod.$selectAll = function () {
  var a = J();
  a = a.select(0, a.getChildrenSize());
  zb(Hb(a));
};
Lexical_prod.$setCompositionKey = H;
Lexical_prod.$setSelection = zb;
Lexical_prod.$splitNode = function (a, b) {
  let c = a.getChildAtIndex(b);
  null == c && (c = a);
  wc(a) && t(102);
  let d = g => {
      const h = g.getParentOrThrow(),
        k = wc(h),
        m = g !== c || k ? xc(g) : g;
      if (k) return E(g) && E(m) || t(133), g.insertAfter(m), [g, m, m];
      const [q, n, l] = d(h);
      g = g.getNextSiblings();
      l.append(m, ...g);
      return [q, n, m];
    },
    [e, f] = d(c);
  return [e, f];
};
Lexical_prod.BLUR_COMMAND = Ra;
Lexical_prod.CAN_REDO_COMMAND = {};
Lexical_prod.CAN_UNDO_COMMAND = {};
Lexical_prod.CLEAR_EDITOR_COMMAND = {};
Lexical_prod.CLEAR_HISTORY_COMMAND = {};
Lexical_prod.CLICK_COMMAND = ca;
Lexical_prod.COMMAND_PRIORITY_CRITICAL = 4;
Lexical_prod.COMMAND_PRIORITY_EDITOR = 0;
Lexical_prod.COMMAND_PRIORITY_HIGH = 3;
Lexical_prod.COMMAND_PRIORITY_LOW = 1;
Lexical_prod.COMMAND_PRIORITY_NORMAL = 2;
Lexical_prod.COMPOSITION_SUFFIX = cb;
Lexical_prod.CONTROLLED_TEXT_INSERTION_COMMAND = ka;
Lexical_prod.COPY_COMMAND = Na;
Lexical_prod.CUT_COMMAND = Oa;
Lexical_prod.DELETE_CHARACTER_COMMAND = da;
Lexical_prod.DELETE_LINE_COMMAND = pa;
Lexical_prod.DELETE_WORD_COMMAND = oa;
Lexical_prod.DOM_ELEMENT_TYPE = 1;
Lexical_prod.DOM_TEXT_TYPE = 3;
Lexical_prod.DRAGEND_COMMAND = Ma;
Lexical_prod.DRAGOVER_COMMAND = La;
Lexical_prod.DRAGSTART_COMMAND = Ka;
Lexical_prod.DROP_COMMAND = Ja;
Lexical_prod.DecoratorNode = wf;
Lexical_prod.ElementNode = xf;
Lexical_prod.FOCUS_COMMAND = Qa;
Lexical_prod.FORMAT_ELEMENT_COMMAND = {};
Lexical_prod.FORMAT_TEXT_COMMAND = qa;
Lexical_prod.INDENT_CONTENT_COMMAND = {};
Lexical_prod.INSERT_LINE_BREAK_COMMAND = ea;
Lexical_prod.INSERT_PARAGRAPH_COMMAND = fa;
Lexical_prod.INSERT_TAB_COMMAND = {};
Lexical_prod.KEY_ARROW_DOWN_COMMAND = Aa;
Lexical_prod.KEY_ARROW_LEFT_COMMAND = wa;
Lexical_prod.KEY_ARROW_RIGHT_COMMAND = ua;
Lexical_prod.KEY_ARROW_UP_COMMAND = za;
Lexical_prod.KEY_BACKSPACE_COMMAND = Da;
Lexical_prod.KEY_DELETE_COMMAND = Ha;
Lexical_prod.KEY_DOWN_COMMAND = ta;
Lexical_prod.KEY_ENTER_COMMAND = Ba;
Lexical_prod.KEY_ESCAPE_COMMAND = Ga;
Lexical_prod.KEY_MODIFIER_COMMAND = Sa;
Lexical_prod.KEY_SPACE_COMMAND = Ca;
Lexical_prod.KEY_TAB_COMMAND = Ia;
Lexical_prod.LineBreakNode = ge;
Lexical_prod.MOVE_TO_END = va;
Lexical_prod.MOVE_TO_START = ya;
Lexical_prod.OUTDENT_CONTENT_COMMAND = {};
Lexical_prod.PASTE_COMMAND = la;
Lexical_prod.ParagraphNode = Hf;
Lexical_prod.REDO_COMMAND = sa;
Lexical_prod.REMOVE_TEXT_COMMAND = ma;
Lexical_prod.RootNode = zf;
Lexical_prod.SELECTION_CHANGE_COMMAND = ba;
Lexical_prod.SELECTION_INSERT_CLIPBOARD_NODES_COMMAND = {};
Lexical_prod.SELECT_ALL_COMMAND = Pa;
Lexical_prod.TabNode = Le;
Lexical_prod.TextNode = pe;
Lexical_prod.UNDO_COMMAND = ra;
Lexical_prod.createCommand = function () {
  return {};
};
Lexical_prod.createEditor = function (a) {
  var b = a || {},
    c = T,
    d = b.theme || {};
  let e = void 0 === a ? c : b.parentEditor || null,
    f = b.disableEvents || !1,
    g = Af(),
    h = b.namespace || (null !== e ? e._config.namespace : kc()),
    k = b.editorState,
    m = [zf, pe, ge, Le, Hf, ...(b.nodes || [])],
    {
      onError: q,
      html: n
    } = b;
  b = void 0 !== b.editable ? b.editable : !0;
  if (void 0 === a && null !== c) a = c._nodes;else for (a = new Map(), c = 0; c < m.length; c++) {
    let r = m[c],
      w = null;
    var l = null;
    "function" !== typeof r && (l = r, r = l.replace, w = l.with, l = l.withKlass || null);
    let A = r.getType(),
      x = r.transform(),
      z = new Set();
    null !== x && z.add(x);
    a.set(A, {
      exportDOM: n && n.export ? n.export.get(r) : void 0,
      klass: r,
      replace: w,
      replaceWithKlass: l,
      transforms: z
    });
  }
  d = new Kf(g, e, a, {
    disableEvents: f,
    namespace: h,
    theme: d
  }, q ? q : console.error, Jf(a, n ? n.import : void 0), b);
  void 0 !== k && (d._pendingEditorState = k, d._dirtyType = 2);
  return d;
};
Lexical_prod.findParentPreDOMNode = Ge;
Lexical_prod.getCachedClassNameArray = oc;
Lexical_prod.getNearestEditorFromDOMNode = Tb;
Lexical_prod.isCurrentlyReadOnlyMode = dc;
Lexical_prod.isHTMLAnchorElement = function (a) {
  return Cc(a) && "A" === a.tagName;
};
Lexical_prod.isHTMLElement = Cc;
Lexical_prod.isSelectionCapturedInDecoratorInput = Rb;
Lexical_prod.isSelectionWithinEditor = Sb;

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

const Lexical$1 = process.env.NODE_ENV === 'development' ? Lexical_dev : Lexical_prod;
var Lexical_1 = Lexical$1;

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */

var Lexical = Lexical_1;

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
const mapToPrismLanguage = language => {
  // eslint-disable-next-line no-prototype-builtins
  return language != null && Prism.languages.hasOwnProperty(language) ? language : undefined;
};
function hasChildDOMNodeTag(node, tagName) {
  for (const child of node.childNodes) {
    if (utils.isHTMLElement(child) && child.tagName === tagName) {
      return true;
    }
    hasChildDOMNodeTag(child, tagName);
  }
  return false;
}
const LANGUAGE_DATA_ATTRIBUTE = 'data-highlight-language';

/** @noInheritDoc */
class CodeNode extends Lexical.ElementNode {
  /** @internal */

  static getType() {
    return 'code';
  }
  static clone(node) {
    return new CodeNode(node.__language, node.__key);
  }
  constructor(language, key) {
    super(key);
    this.__language = mapToPrismLanguage(language);
  }

  // View
  createDOM(config) {
    const element = document.createElement('code');
    utils.addClassNamesToElement(element, config.theme.code);
    element.setAttribute('spellcheck', 'false');
    const language = this.getLanguage();
    if (language) {
      element.setAttribute(LANGUAGE_DATA_ATTRIBUTE, language);
    }
    return element;
  }
  updateDOM(prevNode, dom, config) {
    const language = this.__language;
    const prevLanguage = prevNode.__language;
    if (language) {
      if (language !== prevLanguage) {
        dom.setAttribute(LANGUAGE_DATA_ATTRIBUTE, language);
      }
    } else if (prevLanguage) {
      dom.removeAttribute(LANGUAGE_DATA_ATTRIBUTE);
    }
    return false;
  }
  exportDOM(editor) {
    const element = document.createElement('pre');
    utils.addClassNamesToElement(element, editor._config.theme.code);
    element.setAttribute('spellcheck', 'false');
    const language = this.getLanguage();
    if (language) {
      element.setAttribute(LANGUAGE_DATA_ATTRIBUTE, language);
    }
    return {
      element
    };
  }
  static importDOM() {
    return {
      // Typically <pre> is used for code blocks, and <code> for inline code styles
      // but if it's a multi line <code> we'll create a block. Pass through to
      // inline format handled by TextNode otherwise.
      code: node => {
        const isMultiLine = node.textContent != null && (/\r?\n/.test(node.textContent) || hasChildDOMNodeTag(node, 'BR'));
        return isMultiLine ? {
          conversion: convertPreElement,
          priority: 1
        } : null;
      },
      div: node => ({
        conversion: convertDivElement,
        priority: 1
      }),
      pre: node => ({
        conversion: convertPreElement,
        priority: 0
      }),
      table: node => {
        const table = node;
        // domNode is a <table> since we matched it by nodeName
        if (isGitHubCodeTable(table)) {
          return {
            conversion: convertTableElement,
            priority: 3
          };
        }
        return null;
      },
      td: node => {
        // element is a <td> since we matched it by nodeName
        const td = node;
        const table = td.closest('table');
        if (isGitHubCodeCell(td)) {
          return {
            conversion: convertTableCellElement,
            priority: 3
          };
        }
        if (table && isGitHubCodeTable(table)) {
          // Return a no-op if it's a table cell in a code table, but not a code line.
          // Otherwise it'll fall back to the T
          return {
            conversion: convertCodeNoop,
            priority: 3
          };
        }
        return null;
      },
      tr: node => {
        // element is a <tr> since we matched it by nodeName
        const tr = node;
        const table = tr.closest('table');
        if (table && isGitHubCodeTable(table)) {
          return {
            conversion: convertCodeNoop,
            priority: 3
          };
        }
        return null;
      }
    };
  }
  static importJSON(serializedNode) {
    const node = $createCodeNode(serializedNode.language);
    node.setFormat(serializedNode.format);
    node.setIndent(serializedNode.indent);
    node.setDirection(serializedNode.direction);
    return node;
  }
  exportJSON() {
    return {
      ...super.exportJSON(),
      language: this.getLanguage(),
      type: 'code',
      version: 1
    };
  }

  // Mutation
  insertNewAfter(selection, restoreSelection = true) {
    const children = this.getChildren();
    const childrenLength = children.length;
    if (childrenLength >= 2 && children[childrenLength - 1].getTextContent() === '\n' && children[childrenLength - 2].getTextContent() === '\n' && selection.isCollapsed() && selection.anchor.key === this.__key && selection.anchor.offset === childrenLength) {
      children[childrenLength - 1].remove();
      children[childrenLength - 2].remove();
      const newElement = Lexical.$createParagraphNode();
      this.insertAfter(newElement, restoreSelection);
      return newElement;
    }

    // If the selection is within the codeblock, find all leading tabs and
    // spaces of the current line. Create a new line that has all those
    // tabs and spaces, such that leading indentation is preserved.
    const {
      anchor,
      focus
    } = selection;
    const firstPoint = anchor.isBefore(focus) ? anchor : focus;
    const firstSelectionNode = firstPoint.getNode();
    if (Lexical.$isTextNode(firstSelectionNode)) {
      let node = getFirstCodeNodeOfLine(firstSelectionNode);
      const insertNodes = [];
      // eslint-disable-next-line no-constant-condition
      while (true) {
        if (Lexical.$isTabNode(node)) {
          insertNodes.push(Lexical.$createTabNode());
          node = node.getNextSibling();
        } else if ($isCodeHighlightNode(node)) {
          let spaces = 0;
          const text = node.getTextContent();
          const textSize = node.getTextContentSize();
          for (; spaces < textSize && text[spaces] === ' '; spaces++);
          if (spaces !== 0) {
            insertNodes.push($createCodeHighlightNode(' '.repeat(spaces)));
          }
          if (spaces !== textSize) {
            break;
          }
          node = node.getNextSibling();
        } else {
          break;
        }
      }
      const split = firstSelectionNode.splitText(anchor.offset)[0];
      const x = anchor.offset === 0 ? 0 : 1;
      const index = split.getIndexWithinParent() + x;
      const codeNode = firstSelectionNode.getParentOrThrow();
      const nodesToInsert = [Lexical.$createLineBreakNode(), ...insertNodes];
      codeNode.splice(index, 0, nodesToInsert);
      const last = insertNodes[insertNodes.length - 1];
      if (last) {
        last.select();
      } else if (anchor.offset === 0) {
        split.selectPrevious();
      } else {
        split.getNextSibling().selectNext(0, 0);
      }
    }
    if ($isCodeNode(firstSelectionNode)) {
      const {
        offset
      } = selection.anchor;
      firstSelectionNode.splice(offset, 0, [Lexical.$createLineBreakNode()]);
      firstSelectionNode.select(offset + 1, offset + 1);
    }
    return null;
  }
  canIndent() {
    return false;
  }
  collapseAtStart() {
    const paragraph = Lexical.$createParagraphNode();
    const children = this.getChildren();
    children.forEach(child => paragraph.append(child));
    this.replace(paragraph);
    return true;
  }
  setLanguage(language) {
    const writable = this.getWritable();
    writable.__language = mapToPrismLanguage(language);
  }
  getLanguage() {
    return this.getLatest().__language;
  }
}
function $createCodeNode(language) {
  return Lexical.$applyNodeReplacement(new CodeNode(language));
}
function $isCodeNode(node) {
  return node instanceof CodeNode;
}
function convertPreElement(domNode) {
  let language;
  if (utils.isHTMLElement(domNode)) {
    language = domNode.getAttribute(LANGUAGE_DATA_ATTRIBUTE);
  }
  return {
    node: $createCodeNode(language)
  };
}
function convertDivElement(domNode) {
  // domNode is a <div> since we matched it by nodeName
  const div = domNode;
  const isCode = isCodeElement(div);
  if (!isCode && !isCodeChildElement(div)) {
    return {
      node: null
    };
  }
  return {
    after: childLexicalNodes => {
      const domParent = domNode.parentNode;
      if (domParent != null && domNode !== domParent.lastChild) {
        childLexicalNodes.push(Lexical.$createLineBreakNode());
      }
      return childLexicalNodes;
    },
    node: isCode ? $createCodeNode() : null
  };
}
function convertTableElement() {
  return {
    node: $createCodeNode()
  };
}
function convertCodeNoop() {
  return {
    node: null
  };
}
function convertTableCellElement(domNode) {
  // domNode is a <td> since we matched it by nodeName
  const cell = domNode;
  return {
    after: childLexicalNodes => {
      if (cell.parentNode && cell.parentNode.nextSibling) {
        // Append newline between code lines
        childLexicalNodes.push(Lexical.$createLineBreakNode());
      }
      return childLexicalNodes;
    },
    node: null
  };
}
function isCodeElement(div) {
  return div.style.fontFamily.match('monospace') !== null;
}
function isCodeChildElement(node) {
  let parent = node.parentElement;
  while (parent !== null) {
    if (isCodeElement(parent)) {
      return true;
    }
    parent = parent.parentElement;
  }
  return false;
}
function isGitHubCodeCell(cell) {
  return cell.classList.contains('js-file-line');
}
function isGitHubCodeTable(table) {
  return table.classList.contains('js-file-line-container');
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
const DEFAULT_CODE_LANGUAGE = 'javascript';
const CODE_LANGUAGE_FRIENDLY_NAME_MAP = {
  c: 'C',
  clike: 'C-like',
  cpp: 'C++',
  css: 'CSS',
  html: 'HTML',
  java: 'Java',
  js: 'JavaScript',
  markdown: 'Markdown',
  objc: 'Objective-C',
  plain: 'Plain Text',
  py: 'Python',
  rust: 'Rust',
  sql: 'SQL',
  swift: 'Swift',
  typescript: 'TypeScript',
  xml: 'XML'
};
const CODE_LANGUAGE_MAP = {
  cpp: 'cpp',
  java: 'java',
  javascript: 'js',
  md: 'markdown',
  plaintext: 'plain',
  python: 'py',
  text: 'plain',
  ts: 'typescript'
};
function normalizeCodeLang(lang) {
  return CODE_LANGUAGE_MAP[lang] || lang;
}
function getLanguageFriendlyName(lang) {
  const _lang = normalizeCodeLang(lang);
  return CODE_LANGUAGE_FRIENDLY_NAME_MAP[_lang] || _lang;
}
const getDefaultCodeLanguage = () => DEFAULT_CODE_LANGUAGE;
const getCodeLanguages = () => Object.keys(Prism.languages).filter(
// Prism has several language helpers mixed into languages object
// so filtering them out here to get langs list
language => typeof Prism.languages[language] !== 'function').sort();

/** @noInheritDoc */
class CodeHighlightNode extends Lexical.TextNode {
  /** @internal */

  constructor(text, highlightType, key) {
    super(text, key);
    this.__highlightType = highlightType;
  }
  static getType() {
    return 'code-highlight';
  }
  static clone(node) {
    return new CodeHighlightNode(node.__text, node.__highlightType || undefined, node.__key);
  }
  getHighlightType() {
    const self = this.getLatest();
    return self.__highlightType;
  }
  canHaveFormat() {
    return false;
  }
  createDOM(config) {
    const element = super.createDOM(config);
    const className = getHighlightThemeClass(config.theme, this.__highlightType);
    utils.addClassNamesToElement(element, className);
    return element;
  }
  updateDOM(prevNode, dom, config) {
    const update = super.updateDOM(prevNode, dom, config);
    const prevClassName = getHighlightThemeClass(config.theme, prevNode.__highlightType);
    const nextClassName = getHighlightThemeClass(config.theme, this.__highlightType);
    if (prevClassName !== nextClassName) {
      if (prevClassName) {
        utils.removeClassNamesFromElement(dom, prevClassName);
      }
      if (nextClassName) {
        utils.addClassNamesToElement(dom, nextClassName);
      }
    }
    return update;
  }
  static importJSON(serializedNode) {
    const node = $createCodeHighlightNode(serializedNode.text, serializedNode.highlightType);
    node.setFormat(serializedNode.format);
    node.setDetail(serializedNode.detail);
    node.setMode(serializedNode.mode);
    node.setStyle(serializedNode.style);
    return node;
  }
  exportJSON() {
    return {
      ...super.exportJSON(),
      highlightType: this.getHighlightType(),
      type: 'code-highlight',
      version: 1
    };
  }

  // Prevent formatting (bold, underline, etc)
  setFormat(format) {
    return this;
  }
  isParentRequired() {
    return true;
  }
  createParentElementNode() {
    return $createCodeNode();
  }
}
function getHighlightThemeClass(theme, highlightType) {
  return highlightType && theme && theme.codeHighlight && theme.codeHighlight[highlightType];
}
function $createCodeHighlightNode(text, highlightType) {
  return Lexical.$applyNodeReplacement(new CodeHighlightNode(text, highlightType));
}
function $isCodeHighlightNode(node) {
  return node instanceof CodeHighlightNode;
}
function getFirstCodeNodeOfLine(anchor) {
  let previousNode = anchor;
  let node = anchor;
  while ($isCodeHighlightNode(node) || Lexical.$isTabNode(node)) {
    previousNode = node;
    node = node.getPreviousSibling();
  }
  return previousNode;
}
function getLastCodeNodeOfLine(anchor) {
  let nextNode = anchor;
  let node = anchor;
  while ($isCodeHighlightNode(node) || Lexical.$isTabNode(node)) {
    nextNode = node;
    node = node.getNextSibling();
  }
  return nextNode;
}

/**
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 */
const PrismTokenizer = {
  defaultLanguage: DEFAULT_CODE_LANGUAGE,
  tokenize(code, language) {
    return Prism.tokenize(code, Prism.languages[language || ''] || Prism.languages[this.defaultLanguage]);
  }
};
function getStartOfCodeInLine(anchor, offset) {
  let last = null;
  let lastNonBlank = null;
  let node = anchor;
  let nodeOffset = offset;
  let nodeTextContent = anchor.getTextContent();
  // eslint-disable-next-line no-constant-condition
  while (true) {
    if (nodeOffset === 0) {
      node = node.getPreviousSibling();
      if (node === null) {
        break;
      }
      if (!($isCodeHighlightNode(node) || Lexical.$isTabNode(node) || Lexical.$isLineBreakNode(node))) {
        throw Error(`Expected a valid Code Node: CodeHighlightNode, TabNode, LineBreakNode`);
      }
      if (Lexical.$isLineBreakNode(node)) {
        last = {
          node,
          offset: 1
        };
        break;
      }
      nodeOffset = Math.max(0, node.getTextContentSize() - 1);
      nodeTextContent = node.getTextContent();
    } else {
      nodeOffset--;
    }
    const character = nodeTextContent[nodeOffset];
    if ($isCodeHighlightNode(node) && character !== ' ') {
      lastNonBlank = {
        node,
        offset: nodeOffset
      };
    }
  }
  // lastNonBlank !== null: anchor in the middle of code; move to line beginning
  if (lastNonBlank !== null) {
    return lastNonBlank;
  }
  // Spaces, tabs or nothing ahead of anchor
  let codeCharacterAtAnchorOffset = null;
  if (offset < anchor.getTextContentSize()) {
    if ($isCodeHighlightNode(anchor)) {
      codeCharacterAtAnchorOffset = anchor.getTextContent()[offset];
    }
  } else {
    const nextSibling = anchor.getNextSibling();
    if ($isCodeHighlightNode(nextSibling)) {
      codeCharacterAtAnchorOffset = nextSibling.getTextContent()[0];
    }
  }
  if (codeCharacterAtAnchorOffset !== null && codeCharacterAtAnchorOffset !== ' ') {
    // Borderline whitespace and code, move to line beginning
    return last;
  } else {
    const nextNonBlank = findNextNonBlankInLine(anchor, offset);
    if (nextNonBlank !== null) {
      return nextNonBlank;
    } else {
      return last;
    }
  }
}
function findNextNonBlankInLine(anchor, offset) {
  let node = anchor;
  let nodeOffset = offset;
  let nodeTextContent = anchor.getTextContent();
  let nodeTextContentSize = anchor.getTextContentSize();
  // eslint-disable-next-line no-constant-condition
  while (true) {
    if (!$isCodeHighlightNode(node) || nodeOffset === nodeTextContentSize) {
      node = node.getNextSibling();
      if (node === null || Lexical.$isLineBreakNode(node)) {
        return null;
      }
      if ($isCodeHighlightNode(node)) {
        nodeOffset = 0;
        nodeTextContent = node.getTextContent();
        nodeTextContentSize = node.getTextContentSize();
      }
    }
    if ($isCodeHighlightNode(node)) {
      if (nodeTextContent[nodeOffset] !== ' ') {
        return {
          node,
          offset: nodeOffset
        };
      }
      nodeOffset++;
    }
  }
}
function getEndOfCodeInLine(anchor) {
  const lastNode = getLastCodeNodeOfLine(anchor);
  if (!!Lexical.$isLineBreakNode(lastNode)) {
    throw Error(`Unexpected lineBreakNode in getEndOfCodeInLine`);
  }
  return lastNode;
}
function textNodeTransform(node, editor, tokenizer) {
  // Since CodeNode has flat children structure we only need to check
  // if node's parent is a code node and run highlighting if so
  const parentNode = node.getParent();
  if ($isCodeNode(parentNode)) {
    codeNodeTransform(parentNode, editor, tokenizer);
  } else if ($isCodeHighlightNode(node)) {
    // When code block converted into paragraph or other element
    // code highlight nodes converted back to normal text
    node.replace(Lexical.$createTextNode(node.__text));
  }
}
function updateCodeGutter(node, editor) {
  const codeElement = editor.getElementByKey(node.getKey());
  if (codeElement === null) {
    return;
  }
  const children = node.getChildren();
  const childrenLength = children.length;
  // @ts-ignore: internal field
  if (childrenLength === codeElement.__cachedChildrenLength) {
    // Avoid updating the attribute if the children length hasn't changed.
    return;
  }
  // @ts-ignore:: internal field
  codeElement.__cachedChildrenLength = childrenLength;
  let gutter = '1';
  let count = 1;
  for (let i = 0; i < childrenLength; i++) {
    if (Lexical.$isLineBreakNode(children[i])) {
      gutter += '\n' + ++count;
    }
  }
  codeElement.setAttribute('data-gutter', gutter);
}

// Using `skipTransforms` to prevent extra transforms since reformatting the code
// will not affect code block content itself.
//
// Using extra cache (`nodesCurrentlyHighlighting`) since both CodeNode and CodeHighlightNode
// transforms might be called at the same time (e.g. new CodeHighlight node inserted) and
// in both cases we'll rerun whole reformatting over CodeNode, which is redundant.
// Especially when pasting code into CodeBlock.

const nodesCurrentlyHighlighting = new Set();
function codeNodeTransform(node, editor, tokenizer) {
  const nodeKey = node.getKey();
  if (nodesCurrentlyHighlighting.has(nodeKey)) {
    return;
  }
  nodesCurrentlyHighlighting.add(nodeKey);

  // When new code block inserted it might not have language selected
  if (node.getLanguage() === undefined) {
    node.setLanguage(tokenizer.defaultLanguage);
  }

  // Using nested update call to pass `skipTransforms` since we don't want
  // each individual codehighlight node to be transformed again as it's already
  // in its final state
  editor.update(() => {
    updateAndRetainSelection(nodeKey, () => {
      const currentNode = Lexical.$getNodeByKey(nodeKey);
      if (!$isCodeNode(currentNode) || !currentNode.isAttached()) {
        return false;
      }
      const code = currentNode.getTextContent();
      const tokens = tokenizer.tokenize(code, currentNode.getLanguage() || tokenizer.defaultLanguage);
      const highlightNodes = getHighlightNodes(tokens);
      const diffRange = getDiffRange(currentNode.getChildren(), highlightNodes);
      const {
        from,
        to,
        nodesForReplacement
      } = diffRange;
      if (from !== to || nodesForReplacement.length) {
        node.splice(from, to - from, nodesForReplacement);
        return true;
      }
      return false;
    });
  }, {
    onUpdate: () => {
      nodesCurrentlyHighlighting.delete(nodeKey);
    },
    skipTransforms: true
  });
}
function getHighlightNodes(tokens, type) {
  const nodes = [];
  for (const token of tokens) {
    if (typeof token === 'string') {
      const partials = token.split(/(\n|\t)/);
      const partialsLength = partials.length;
      for (let i = 0; i < partialsLength; i++) {
        const part = partials[i];
        if (part === '\n' || part === '\r\n') {
          nodes.push(Lexical.$createLineBreakNode());
        } else if (part === '\t') {
          nodes.push(Lexical.$createTabNode());
        } else if (part.length > 0) {
          nodes.push($createCodeHighlightNode(part, type));
        }
      }
    } else {
      const {
        content
      } = token;
      if (typeof content === 'string') {
        nodes.push(...getHighlightNodes([content], token.type));
      } else if (Array.isArray(content)) {
        nodes.push(...getHighlightNodes(content, token.type));
      }
    }
  }
  return nodes;
}

// Wrapping update function into selection retainer, that tries to keep cursor at the same
// position as before.
function updateAndRetainSelection(nodeKey, updateFn) {
  const node = Lexical.$getNodeByKey(nodeKey);
  if (!$isCodeNode(node) || !node.isAttached()) {
    return;
  }
  const selection = Lexical.$getSelection();
  // If it's not range selection (or null selection) there's no need to change it,
  // but we can still run highlighting logic
  if (!Lexical.$isRangeSelection(selection)) {
    updateFn();
    return;
  }
  const anchor = selection.anchor;
  const anchorOffset = anchor.offset;
  const isNewLineAnchor = anchor.type === 'element' && Lexical.$isLineBreakNode(node.getChildAtIndex(anchor.offset - 1));
  let textOffset = 0;

  // Calculating previous text offset (all text node prior to anchor + anchor own text offset)
  if (!isNewLineAnchor) {
    const anchorNode = anchor.getNode();
    textOffset = anchorOffset + anchorNode.getPreviousSiblings().reduce((offset, _node) => {
      return offset + _node.getTextContentSize();
    }, 0);
  }
  const hasChanges = updateFn();
  if (!hasChanges) {
    return;
  }

  // Non-text anchors only happen for line breaks, otherwise
  // selection will be within text node (code highlight node)
  if (isNewLineAnchor) {
    anchor.getNode().select(anchorOffset, anchorOffset);
    return;
  }

  // If it was non-element anchor then we walk through child nodes
  // and looking for a position of original text offset
  node.getChildren().some(_node => {
    const isText = Lexical.$isTextNode(_node);
    if (isText || Lexical.$isLineBreakNode(_node)) {
      const textContentSize = _node.getTextContentSize();
      if (isText && textContentSize >= textOffset) {
        _node.select(textOffset, textOffset);
        return true;
      }
      textOffset -= textContentSize;
    }
    return false;
  });
}

// Finds minimal diff range between two nodes lists. It returns from/to range boundaries of prevNodes
// that needs to be replaced with `nodes` (subset of nextNodes) to make prevNodes equal to nextNodes.
function getDiffRange(prevNodes, nextNodes) {
  let leadingMatch = 0;
  while (leadingMatch < prevNodes.length) {
    if (!isEqual(prevNodes[leadingMatch], nextNodes[leadingMatch])) {
      break;
    }
    leadingMatch++;
  }
  const prevNodesLength = prevNodes.length;
  const nextNodesLength = nextNodes.length;
  const maxTrailingMatch = Math.min(prevNodesLength, nextNodesLength) - leadingMatch;
  let trailingMatch = 0;
  while (trailingMatch < maxTrailingMatch) {
    trailingMatch++;
    if (!isEqual(prevNodes[prevNodesLength - trailingMatch], nextNodes[nextNodesLength - trailingMatch])) {
      trailingMatch--;
      break;
    }
  }
  const from = leadingMatch;
  const to = prevNodesLength - trailingMatch;
  const nodesForReplacement = nextNodes.slice(leadingMatch, nextNodesLength - trailingMatch);
  return {
    from,
    nodesForReplacement,
    to
  };
}
function isEqual(nodeA, nodeB) {
  // Only checking for code higlight nodes, tabs and linebreaks. If it's regular text node
  // returning false so that it's transformed into code highlight node
  return $isCodeHighlightNode(nodeA) && $isCodeHighlightNode(nodeB) && nodeA.__text === nodeB.__text && nodeA.__highlightType === nodeB.__highlightType || Lexical.$isTabNode(nodeA) && Lexical.$isTabNode(nodeB) || Lexical.$isLineBreakNode(nodeA) && Lexical.$isLineBreakNode(nodeB);
}
function $isSelectionInCode(selection) {
  if (!Lexical.$isRangeSelection(selection)) {
    return false;
  }
  const anchorNode = selection.anchor.getNode();
  const focusNode = selection.focus.getNode();
  if (anchorNode.is(focusNode) && $isCodeNode(anchorNode)) {
    return true;
  }
  const anchorParent = anchorNode.getParent();
  return $isCodeNode(anchorParent) && anchorParent.is(focusNode.getParent());
}
function $getCodeLines(selection) {
  const nodes = selection.getNodes();
  const lines = [[]];
  if (nodes.length === 1 && $isCodeNode(nodes[0])) {
    return lines;
  }
  let lastLine = lines[0];
  for (let i = 0; i < nodes.length; i++) {
    const node = nodes[i];
    if (!($isCodeHighlightNode(node) || Lexical.$isTabNode(node) || Lexical.$isLineBreakNode(node))) {
      throw Error(`Expected selection to be inside CodeBlock and consisting of CodeHighlightNode, TabNode and LineBreakNode`);
    }
    if (Lexical.$isLineBreakNode(node)) {
      if (i !== 0 && lastLine.length > 0) {
        lastLine = [];
        lines.push(lastLine);
      }
    } else {
      lastLine.push(node);
    }
  }
  return lines;
}
function handleTab(shiftKey) {
  const selection = Lexical.$getSelection();
  if (!Lexical.$isRangeSelection(selection) || !$isSelectionInCode(selection)) {
    return null;
  }
  const indentOrOutdent = !shiftKey ? Lexical.INDENT_CONTENT_COMMAND : Lexical.OUTDENT_CONTENT_COMMAND;
  const tabOrOutdent = !shiftKey ? Lexical.INSERT_TAB_COMMAND : Lexical.OUTDENT_CONTENT_COMMAND;
  // 1. If multiple lines selected: indent/outdent
  const codeLines = $getCodeLines(selection);
  if (codeLines.length > 1) {
    return indentOrOutdent;
  }
  // 2. If entire line selected: indent/outdent
  const selectionNodes = selection.getNodes();
  const firstNode = selectionNodes[0];
  if (!($isCodeNode(firstNode) || $isCodeHighlightNode(firstNode) || Lexical.$isTabNode(firstNode) || Lexical.$isLineBreakNode(firstNode))) {
    throw Error(`Expected selection firstNode to be CodeHighlightNode or TabNode`);
  }
  if ($isCodeNode(firstNode)) {
    return indentOrOutdent;
  }
  const firstOfLine = getFirstCodeNodeOfLine(firstNode);
  const lastOfLine = getLastCodeNodeOfLine(firstNode);
  const anchor = selection.anchor;
  const focus = selection.focus;
  let selectionFirst;
  let selectionLast;
  if (focus.isBefore(anchor)) {
    selectionFirst = focus;
    selectionLast = anchor;
  } else {
    selectionFirst = anchor;
    selectionLast = focus;
  }
  if (firstOfLine !== null && lastOfLine !== null && selectionFirst.key === firstOfLine.getKey() && selectionFirst.offset === 0 && selectionLast.key === lastOfLine.getKey() && selectionLast.offset === lastOfLine.getTextContentSize()) {
    return indentOrOutdent;
  }
  // 3. Else: tab/outdent
  return tabOrOutdent;
}
function handleMultilineIndent(type) {
  const selection = Lexical.$getSelection();
  if (!Lexical.$isRangeSelection(selection) || !$isSelectionInCode(selection)) {
    return false;
  }
  const codeLines = $getCodeLines(selection);
  const codeLinesLength = codeLines.length;
  // Multiple lines selection
  if (codeLines.length > 1) {
    for (let i = 0; i < codeLinesLength; i++) {
      const line = codeLines[i];
      if (line.length > 0) {
        let firstOfLine = line[0];
        // First and last lines might not be complete
        if (i === 0) {
          firstOfLine = getFirstCodeNodeOfLine(firstOfLine);
        }
        if (firstOfLine !== null) {
          if (type === Lexical.INDENT_CONTENT_COMMAND) {
            firstOfLine.insertBefore(Lexical.$createTabNode());
          } else if (Lexical.$isTabNode(firstOfLine)) {
            firstOfLine.remove();
          }
        }
      }
    }
    return true;
  }
  // Just one line
  const selectionNodes = selection.getNodes();
  const firstNode = selectionNodes[0];
  if (!($isCodeNode(firstNode) || $isCodeHighlightNode(firstNode) || Lexical.$isTabNode(firstNode) || Lexical.$isLineBreakNode(firstNode))) {
    throw Error(`Expected selection firstNode to be CodeHighlightNode or CodeTabNode`);
  }
  if ($isCodeNode(firstNode)) {
    // CodeNode is empty
    if (type === Lexical.INDENT_CONTENT_COMMAND) {
      selection.insertNodes([Lexical.$createTabNode()]);
    }
    return true;
  }
  const firstOfLine = getFirstCodeNodeOfLine(firstNode);
  if (!(firstOfLine !== null)) {
    throw Error(`Expected getFirstCodeNodeOfLine to return a valid Code Node`);
  }
  if (type === Lexical.INDENT_CONTENT_COMMAND) {
    if (Lexical.$isLineBreakNode(firstOfLine)) {
      firstOfLine.insertAfter(Lexical.$createTabNode());
    } else {
      firstOfLine.insertBefore(Lexical.$createTabNode());
    }
  } else if (Lexical.$isTabNode(firstOfLine)) {
    firstOfLine.remove();
  }
  return true;
}
function handleShiftLines(type, event) {
  // We only care about the alt+arrow keys
  const selection = Lexical.$getSelection();
  if (!Lexical.$isRangeSelection(selection)) {
    return false;
  }

  // I'm not quite sure why, but it seems like calling anchor.getNode() collapses the selection here
  // So first, get the anchor and the focus, then get their nodes
  const {
    anchor,
    focus
  } = selection;
  const anchorOffset = anchor.offset;
  const focusOffset = focus.offset;
  const anchorNode = anchor.getNode();
  const focusNode = focus.getNode();
  const arrowIsUp = type === Lexical.KEY_ARROW_UP_COMMAND;

  // Ensure the selection is within the codeblock
  if (!$isSelectionInCode(selection) || !($isCodeHighlightNode(anchorNode) || Lexical.$isTabNode(anchorNode)) || !($isCodeHighlightNode(focusNode) || Lexical.$isTabNode(focusNode))) {
    return false;
  }
  if (!event.altKey) {
    // Handle moving selection out of the code block, given there are no
    // sibling thats can natively take the selection.
    if (selection.isCollapsed()) {
      const codeNode = anchorNode.getParentOrThrow();
      if (arrowIsUp && anchorOffset === 0 && anchorNode.getPreviousSibling() === null) {
        const codeNodeSibling = codeNode.getPreviousSibling();
        if (codeNodeSibling === null) {
          codeNode.selectPrevious();
          event.preventDefault();
          return true;
        }
      } else if (!arrowIsUp && anchorOffset === anchorNode.getTextContentSize() && anchorNode.getNextSibling() === null) {
        const codeNodeSibling = codeNode.getNextSibling();
        if (codeNodeSibling === null) {
          codeNode.selectNext();
          event.preventDefault();
          return true;
        }
      }
    }
    return false;
  }
  let start;
  let end;
  if (anchorNode.isBefore(focusNode)) {
    start = getFirstCodeNodeOfLine(anchorNode);
    end = getLastCodeNodeOfLine(focusNode);
  } else {
    start = getFirstCodeNodeOfLine(focusNode);
    end = getLastCodeNodeOfLine(anchorNode);
  }
  if (start == null || end == null) {
    return false;
  }
  const range = start.getNodesBetween(end);
  for (let i = 0; i < range.length; i++) {
    const node = range[i];
    if (!$isCodeHighlightNode(node) && !Lexical.$isTabNode(node) && !Lexical.$isLineBreakNode(node)) {
      return false;
    }
  }

  // After this point, we know the selection is within the codeblock. We may not be able to
  // actually move the lines around, but we want to return true either way to prevent
  // the event's default behavior
  event.preventDefault();
  event.stopPropagation(); // required to stop cursor movement under Firefox

  const linebreak = arrowIsUp ? start.getPreviousSibling() : end.getNextSibling();
  if (!Lexical.$isLineBreakNode(linebreak)) {
    return true;
  }
  const sibling = arrowIsUp ? linebreak.getPreviousSibling() : linebreak.getNextSibling();
  if (sibling == null) {
    return true;
  }
  const maybeInsertionPoint = $isCodeHighlightNode(sibling) || Lexical.$isTabNode(sibling) || Lexical.$isLineBreakNode(sibling) ? arrowIsUp ? getFirstCodeNodeOfLine(sibling) : getLastCodeNodeOfLine(sibling) : null;
  let insertionPoint = maybeInsertionPoint != null ? maybeInsertionPoint : sibling;
  linebreak.remove();
  range.forEach(node => node.remove());
  if (type === Lexical.KEY_ARROW_UP_COMMAND) {
    range.forEach(node => insertionPoint.insertBefore(node));
    insertionPoint.insertBefore(linebreak);
  } else {
    insertionPoint.insertAfter(linebreak);
    insertionPoint = linebreak;
    range.forEach(node => {
      insertionPoint.insertAfter(node);
      insertionPoint = node;
    });
  }
  selection.setTextNodeRange(anchorNode, anchorOffset, focusNode, focusOffset);
  return true;
}
function handleMoveTo(type, event) {
  const selection = Lexical.$getSelection();
  if (!Lexical.$isRangeSelection(selection)) {
    return false;
  }
  const {
    anchor,
    focus
  } = selection;
  const anchorNode = anchor.getNode();
  const focusNode = focus.getNode();
  const isMoveToStart = type === Lexical.MOVE_TO_START;
  if (!($isCodeHighlightNode(anchorNode) || Lexical.$isTabNode(anchorNode)) || !($isCodeHighlightNode(focusNode) || Lexical.$isTabNode(focusNode))) {
    return false;
  }
  if (isMoveToStart) {
    const start = getStartOfCodeInLine(focusNode, focus.offset);
    if (start !== null) {
      const {
        node,
        offset
      } = start;
      if (Lexical.$isLineBreakNode(node)) {
        node.selectNext(0, 0);
      } else {
        selection.setTextNodeRange(node, offset, node, offset);
      }
    } else {
      focusNode.getParentOrThrow().selectStart();
    }
  } else {
    const node = getEndOfCodeInLine(focusNode);
    node.select();
  }
  event.preventDefault();
  event.stopPropagation();
  return true;
}
function registerCodeHighlighting(editor, tokenizer) {
  if (!editor.hasNodes([CodeNode, CodeHighlightNode])) {
    throw new Error('CodeHighlightPlugin: CodeNode or CodeHighlightNode not registered on editor');
  }
  if (tokenizer == null) {
    tokenizer = PrismTokenizer;
  }
  return utils.mergeRegister(editor.registerMutationListener(CodeNode, mutations => {
    editor.update(() => {
      for (const [key, type] of mutations) {
        if (type !== 'destroyed') {
          const node = Lexical.$getNodeByKey(key);
          if (node !== null) {
            updateCodeGutter(node, editor);
          }
        }
      }
    });
  }), editor.registerNodeTransform(CodeNode, node => codeNodeTransform(node, editor, tokenizer)), editor.registerNodeTransform(Lexical.TextNode, node => textNodeTransform(node, editor, tokenizer)), editor.registerNodeTransform(CodeHighlightNode, node => textNodeTransform(node, editor, tokenizer)), editor.registerCommand(Lexical.KEY_TAB_COMMAND, event => {
    const command = handleTab(event.shiftKey);
    if (command === null) {
      return false;
    }
    event.preventDefault();
    editor.dispatchCommand(command, undefined);
    return true;
  }, Lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(Lexical.INSERT_TAB_COMMAND, () => {
    const selection = Lexical.$getSelection();
    if (!$isSelectionInCode(selection)) {
      return false;
    }
    Lexical.$insertNodes([Lexical.$createTabNode()]);
    return true;
  }, Lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(Lexical.INDENT_CONTENT_COMMAND, payload => handleMultilineIndent(Lexical.INDENT_CONTENT_COMMAND), Lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(Lexical.OUTDENT_CONTENT_COMMAND, payload => handleMultilineIndent(Lexical.OUTDENT_CONTENT_COMMAND), Lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(Lexical.KEY_ARROW_UP_COMMAND, payload => handleShiftLines(Lexical.KEY_ARROW_UP_COMMAND, payload), Lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(Lexical.KEY_ARROW_DOWN_COMMAND, payload => handleShiftLines(Lexical.KEY_ARROW_DOWN_COMMAND, payload), Lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(Lexical.MOVE_TO_END, payload => handleMoveTo(Lexical.MOVE_TO_END, payload), Lexical.COMMAND_PRIORITY_LOW), editor.registerCommand(Lexical.MOVE_TO_START, payload => handleMoveTo(Lexical.MOVE_TO_START, payload), Lexical.COMMAND_PRIORITY_LOW));
}

exports.$createCodeHighlightNode = $createCodeHighlightNode;
exports.$createCodeNode = $createCodeNode;
exports.$isCodeHighlightNode = $isCodeHighlightNode;
exports.$isCodeNode = $isCodeNode;
exports.CODE_LANGUAGE_FRIENDLY_NAME_MAP = CODE_LANGUAGE_FRIENDLY_NAME_MAP;
exports.CODE_LANGUAGE_MAP = CODE_LANGUAGE_MAP;
exports.CodeHighlightNode = CodeHighlightNode;
exports.CodeNode = CodeNode;
exports.DEFAULT_CODE_LANGUAGE = DEFAULT_CODE_LANGUAGE;
exports.PrismTokenizer = PrismTokenizer;
exports.getCodeLanguages = getCodeLanguages;
exports.getDefaultCodeLanguage = getDefaultCodeLanguage;
exports.getEndOfCodeInLine = getEndOfCodeInLine;
exports.getFirstCodeNodeOfLine = getFirstCodeNodeOfLine;
exports.getLanguageFriendlyName = getLanguageFriendlyName;
exports.getLastCodeNodeOfLine = getLastCodeNodeOfLine;
exports.getStartOfCodeInLine = getStartOfCodeInLine;
exports.normalizeCodeLang = normalizeCodeLang;
exports.registerCodeHighlighting = registerCodeHighlighting;
